#!/usr/bin/python3  
# -*- coding: utf-8 -*-    
#
#       easyIstr_main2.py
#
#   15/04/16    新規作成 ver1.0
#      04/26    塑性解析を追加 ver1.1
#      04/28    並列処理追加   ver1.11
#      05/14    固有値解析追加、出力をvtk形式に変更　ver1.12
#      05/18    周波数応答追加　ver1.13
#      05/21    表面要素取得fistr2vtk.pyに対応
#      05/25    notebookのtabを非表示に設定
#      05/26    警告が多数発生するため元に戻す（tabを表示）
#               stepで計算する境界条件の設定を修正（バグ取り）
#      05/27    postの表記を修正（inp→vtk）
#
#   15/06/07    wxGladeからglade（GTK）に変更 ver2.00
#      06/09    熱伝導を追加 ver2.10
#      06/11    amplitudeを追加
#      06/14    境界条件として、VELOCITY、ACCELERATIONを追加
#               AMPの候補として、STEPを追加　ver2.11
#      06/15    境界条件TEMPERATUREに熱解析結果が使える様に修正
#      06/16    restartが可能になる様に設定
#      06/17    境界条件のfont色を修正 ver2.12
#      06/18    材料定義のバグ修正（同じ材料を定義した時ダブって定義される）
#      06/19    熱解析（動解析）にcheckBtnを追加、!INITIALを追加
#      06/20    solution設定画面に入出力ファイルを表示
#      07/14    バグ修正（anarysis→analysisに修正）
#      08/26    線形solverMUMPS等を追加
#      08/31    $easyIstrUserPath追加の為の修正
#      09/01    windowsに対応させる為、os.sep, os.path.normpathに修正
#      09/02    createPlasticSsDataFile:strain→valueに変更
#               "\n"→os.linesepに修正
#               initialize:materialDBとcurrDirのdirを修正 ver2.13
#      10/13    copyUseCntFile:useCntFileの保存を追加
#      10/18    windows対応用でos.system()部を見直し
#      10/19    osCopyFileを追加。
#      10/20    os毎に異なるappの定義をdata/usingAppファイルで定義 ver2.14
#      10/22    バグ修正。update時、usingAppがcopyされない
#               バグ修正。SPRINGの境界条件が、ステップ解析の現れない。
#               材料の硬化則でmultiLinearを最初に設定
#               バグ修正。周波数応答でsample数が修正できない
#               addDefaultFloadNames:FLOADのdefaultのLOAD_CASEを1:実部に変更
#      10/27    周波数応答で計算終了後、応答結果のcsvファイルを作成
#               動解析のdefaultの運動方程式を「陽解法」に変更
#               os.CopyFile:バグ修正
#               writeFistrModelMsh,writeFistrModelCnt,writeHecmwCtrlDatを修正。
#                 行末を揃える。
#      10/30    loadHcmwPartCtrlDat:fileのコピー方法を修正（読み込み後、書き込み）
#      11/11    材料物性値のページに「DB開く」ボタンを追加
#      11/19    材料物性値_subに「物性値の確認」ボタンを追加
#      12/05    checkSetUserPathFiles:currDir,matDirが存在しない場合、defaultのdir
#               に修正を追加。
#      12/10    solve画面を変更。
#               Fistr実行ボタンクリックで、制御ファイルへの書き込みを無くし、「設定」
#               ボタンを追加
#      12/14    moveItemToListBox:multipleSelectionに対応（複数選択が可能）
#      12/17    主応力にvectorを追加。setListDataInListBox:namesをsortして表示。
#      12/18    主ひずみ、misesひずみを追加
#               項目追加用のdialog「addOutputItemsDialog.py」を追加。
#      12/24    changeMeshScale:終了時にdialogを表示
#               CLOADに合計荷重を追加
#      12/25    行末コードlsを修正。!CLOADの行にvalue=の項目を追加（端数が生じる為）。
#      12/28    writeCloadContInCnt:node番号で設定する時にも対応できる様修正。
#               CLOADに等分布荷重が設定できるように修正。
#   16/01/04    等分布荷重の設定方法を修正
#      01/06    追加項目にtresca応力、ひずみを追加
#      01/08    BOUNDARY、CLOADについて、省略形でも読み込み可能に修正
#      01/12    abaqusinp2fistrcnt.pyをメッシュ変換に引き続き実行する様に修正。
#      01/16    「!INITIAL CONDITION」の挿入場所を修正 ver2.15
#               「!TEMPERATURE」、「!DLOAD,GRAV」に各nodeGroupの設定が可能に修正
#      01/31    applyBCGroup:TEMPERATUREでnameを全て削除した時のエラー発生を修正
#      02/04    editPlasticSsData:材料名を入力せずに「ss_data作成」場合、エラー発生
#               するので、これを修正。
#      02/13    getDataList:データの最後が空白文字の場合、エラーが発生したので修正
#      03/27    シェル要素（731、732、741）を追加 ver 2.20
#      03/28    BOUNDARYに回転を追加。材料設定にshellの板厚を追加
#      04/05    runParaView:読み込むファイルを設定してparaViewを起動。
#      04/08    シェル要素（761、781）を追加
#      04/09    readSetMaterialType:textBoxを隠す時、値をクリア
#               isRotationElementType:追加。
#      04/14    beam(611)を追加
#      05/01    meshConvert:バグ修正（file名の取得方法を修正）
#      06/20    remakeSolidShellModel（混在モデル）の場合、EQUATIONを追加 ver 2.21
#      07/01    applyContact:contactAlgoのセットを修正（バグ）
#      08/12    runFrontIstr:windowsでの並列処理（mpiexec）を追加
#      08/17    runFrontIstr:実行時のlogファイルを出力する様に修正
#      08/19    runFrontIstr:Fistrを裏で起動するように修正（バグ修正）
#      09/10    FrontISTRのインストール先、paraviewの起動コマンドをusingAppに設定
#               ver 2.22
#      11/08    getSolutitionTypeFromCnt:デフォルトのsolutionTypeを設定
#      11/19    createMaterialDefine:!SECTIONの位置を限定せずに検索する様に修正
#      11/27    solid,shell,beam混在モデルに対応 ver 2.23
#      12/14    shell、beamにモーメント入力を追加 ver 2.24
#               writeCloadContDummyInCntを追加。
#               readBoundaryNgrpName:dummyNGRPの設定を追加
#      12/24    writeCloadContDummyInCnt.createAddCont:バグ修正
#      12/25    getNodeForceAtArea.py:バグ修正
#   17/01/03    applyCloadCont,applyBoundaryCont:dummyNgrpを「meshCont」から取得
#               setCload_sub,setBoundary_sub:回転の有無を「meshCont」から取得
#      01/09    makeIniTreeData:mat.sort()を追加。
#      04/09    setContact_sub:slave, masterの名前リストのsortを追加
#               deleteContactConditions:contactのlistBoxを複数選択可に変更
#               接触アルゴリズムの初期設定を「SLAGRANGE」に変更
#               STEPのmaxIterを「1000」に変更
#      05/19    applyContact:デフォルトのINTERACTIONを「SSLID」に変更
#      06/18    applyContact:デフォルトのINTERACTIONを「FSLID」に戻す。
#               setContact_sub, applyContactCont:GUI上にINTERACTIONの日本語追加
#      07/13    outputItems:出力項目に「梁要素NQM」を追加
#      08/22    plotStepMonitor:stepの実行状況を表示させるボタンを追加 ver 2.25
#               接触解析時のNPENALTY,TPENALTYを追加。
#      08/23    setUsingApplications:削除し、pyFistr側に移動
#      08/24    接触解析時のNPENALTY,TPENALTYを削除。
#               getContactContInCnt:factorの初期値を0.0→1.0e3に修正
#      08/29    applyContact:接触ペア作成時、ペア名をsortする様に修正
#      08/30    各「設定」ボタンにdialogを表示させる様に修正
#      09/11    getNoGroups:「dummy***」のgroup名を取得しないように修正
#               「設定」ボタンのクリック時、処理が終了するまで、設定中dialogを表示
#      09/12    settingDialog, plotStepMonitorのwindows対応。
#      09/16    getDataList:高速化の為、修正。deleteSpを無くし、errorTrapを追加
#      09/18    高速化の為、無駄な書き込みをなくす。（大規模メッシュ対応）
#      09/20    changeMeshScale:高速化の為、全てのmeshContの読み込み廃止。
#      09/23    高速化の為、meshDataをmshHeaderDataとして保存、処理する様に修正
#      09/28    switchUseResult:設定値のセット方法を修正
#      09/29    deleteContactPairNameInCntMsh:バグ修正。
#      10/01    getSavedData, saveIstrData, setIstrData, subInitialize:mesh変換
#               したfile名を保存し、起動時にtextBoxに表示するように修正。
#      10/07    writeFistrModelFile:バグ修正。（ssDataがcntファイルに書き込めない）
#      10/08    getNgrpNodeNos:バグ修正（dummyGrpupが読み込めない）
#      11/10    複数step解析を可能にした。 ver 2.30
#      11/11    setContactGroupToListBox:バグ修正（メッシュ変換後、接触を選択すると
#               エラー発生）
#      11/12    バグ修正。（mesh変換時、境界条件がクリアされない事を修正。）
#      11/30    plotStepMonitor:端末への出力量を減らす。
#      12/01    plotStepMonitor:端末への出力量をさらに減らす。
#      12/03    addContactPairNameInCntMsh:バグ修正。接触ペアgroup名定義でエラー発生。
#               addContactCondition:バグ修正。pair名追加時、連番にならない。
#      12/04    meshConvert:メッシュ変換後、直ぐに読み込むとエラー発生するので修正
#               checkReformCntFile:cntファイルのチェック修正を追加
#      12/18    getSavedData:workDirを削除した時、起動しない事があるので修正。
#      12/31    readVeloNgrpName,readDloadSgrpName,readVloadEgrpName,readGravValueFromCnt,
#               readSpringValueFromCont,readAccelNgrpName:バグ修正（step毎の内容が取得できず）
#               writeFloadContInCnt:バグ修正(step0以外に設定できず）
#   18/01/01    setStep_sub:sort方法変更
#      01/04        ↑　:バグ修正
#               applyContact:factorのdefault値を1e3→1e5に修正
#      01/31    addContactCondition:使用済みのcontact名を追加。（バグ修正）
#      02/02    「NGRPの修正」ボタンを追加（reformNgrpを追加）
#      02/20    getPlasticSsData:EXCELでss_dataを読むとエラーが発生したため修正 ver 2.31
#      03/29    reformNgrp:バグ修正
#      03/31    getBoundaryNodeGroupInCnt:バグ修正
#               getSolverContFromCnt:バグ修正
#      04/04    applyTemperatureCont:初期温度の設定方法修正（バグ）
#               readTemperatureValueFromCntMesh:初期温度の読み取りに変更（バグ）
#               「INITIAL」を境界条件のlistから、Treeの上位に移動 ver 2.40
#      06/08    gnome-terminalのオプション「-x」を「--」に修正。（警告が発生する為）
#      06/17    deleteOverlapNodesDDialog.py:group内全node削除される時エラー発生
#               するので修正（バグ） ver 2.41
#      06/24    selectWorkFolder:folder移動先に必要なfileが存在しない時、初期化を追加
#      07/16    abaqus2fistr.py:小文字のkeyword読み込みに対応
#      08/28    checkNumStr:物性値の読み込み時、指数表記の小数点有無チェックを追加
#      09/01    openWorkFolder:nautilusを裏で動かす様に修正。（ubuntu18.04対応）
#      11/03    fistr2vtk.py:resファイルの要素Noの読み込み方法修正（バグ）
#      11/17    ver 2.42 としてリリース
#      12/11    大規模解析用として大幅修正 ver 2.50
#      12/30    getAnalysisTypeInCnt:詳細な結果を戻すように修正
#               plotStepMonitor:非定常熱伝導解析でplotMonitorが起動する様に修正 ver 2.51
#
#   19/01/22    python3, Glade3用に大幅修正 ver 3.00
#               CFLUXの和名を修正、CFLUXに等分布設定を追加。
#      01/30    windows用に修正
#               currDirの表示追加、temp設定保存btn追加
#               windows上での「fistr1」実行時に、「commTee.py」を使用する様に変更。
#      02/05    plotStepMonitor.py, plotStepMonitorHeatDy.py
#               windows用に修正
#      02/22    main:checkTrueCurrDirを追加。
#               currDirTrueが存在しない場合、currDirを$HOMEに設定する為。
#      03/04    yesNoDialogを追加。
#      03/06    getParameterNumber:同名のEGRPをまとめる方法を修正
#               saveDataList:face数が実数で取得されていた為、修正
#      03/07    モジュールcopyFilesFromTempToCurrDirを作成し、これに伴いmain側を修正
#      03/08    setMaterialTypeToListBox:バグ修正（matModelが2重に表示されていた）
#      03/18    convertDataForParaview,getConvertComm:fistr2vtk.py実行時に「python3 -u」
#               のオプション付きで実行する様に修正。（realTimeで出力を取得するため）
#               checkSetIstrData:istrDataの読み直しを追加
#      03/20    getBndListFromDefine:バグ修正（VLOAD,CENT,GRAVがstep設定できないを修正）
#      03/21    GRPIDの再設定時、step内のGRPIDも修正する様に変更
#               moveItemToListBoxStep:box内の選択表示が狂っていたので修正。
#      03/28    createTempCaseFiles:currDirを引数に追加。currDirが存在しない状態では、
#               エラー発生して、起動できない為、修正
#      04/06    abaqus2fistr.py, unv2fistr.py:直接pythonScriptを起動していたので
#               「python3 <pythonScript>」形式に修正。
#               （windowsでメッシュ変換できないバグ発生。）
#      04/16    vsCodeでエラーチェックし、修正
#      04/20    remakeGrpidInStep:GRPIDの設定を再修正。（3/21修正時の再修正）
#      04/22    numSettingDialog,closeSettingDialog:subprocessが正常な状態（BrokenPipe
#               では無い状態）の時flushする様に修正。ver 3.03
#               showSettingDialog:settingDialogが起動していない場合は、0.1s waitする
#      05/01    getCurrDirFromTempFolder:tempFolder内にmeshContsファイルが存在しない
#               場合、エラーが発生し、easyIstrが起動しない状態に陥るのを修正。
#
#

import gi
gi.require_version("Gtk", "3.0")
from gi.repository import Gtk

import gettext

import sys
import os
import glob
import csv
import re
import shutil
import subprocess
import time
import threading

import pyFistr
import abaqus2fistr
import deleteOverlapNodesDDialog2 as deleteOverlapNodesDDialog
import deleteOverlapNodeInNgrp as delnd
import copyFilesFromTempToCurrDir as copyTempFiles

version = "3.03-190505"

builder = ""                #Gtk.Builderの保存場所
mainWindow = ""             #GUIのwindowの保存場所

#appの設定（変数の定義）
runOfficeComm = ""          #office
runTerminalComm = ""        #ターミナル
runFileManagerComm = ""     #ファイルマネージャ
runEditorComm = ""          #エディタ
frontIstrFolder = ""        #FrontISTRのインストール先
runParaViewComm = ""        #paraview
runRevocapComm = ""         #REVOCAP
runGnuplotComm = ""         #gnuplot

settingDialog = ""          #設定中dialogのobject
currDirTemp = os.getenv("easyIstrUserPath") + os.sep + "data" + os.sep + "temp"
currDir = ""
sourceMeshFile = ""
istrDataFileName = "easyIstr_data"
istrSubDataFileName = "easyIstrSub_data"
istrData = []
materialDBName = ""
anaType = ""            #解析の種類
selPairName = ""        #選択しているcontactのPairName
materialDBCont =[]
meshGroup = []          #meshグループ名list:[EGRP, SGRP, NGRP]
matDefine = []          #材料定義:[[EGRP名, 材料, elType], ...]
bndDefine = []          #BOUNDARYグループ名（変位）
cloadDefine = []        #CLOADグループ名（荷重）
dloadDefine = []        #DLOADグループ名（面圧）
vloadDefine = []        #VLOADグループ名（体積力）
centDefine = []         #CENTグループ名（遠心力）
tempDefine = []         #TEMPERATURE
gravDefine = []         #GRAV
springDefine = []       #SPRING
contactDefine = []      #CONTACT
floadDefine = []        #FLOAD
veloDefine = []         #VELOCITY
accelDefine = []        #ACCELERATION
initialDefine = []      #INITIAL
fixtempDefine = []      #FIXTEMP
cfluxDefine = []        #CFLUX
dfluxDefine = []        #DFLUX
sfluxDefine = []        #SFLUX
sfilmDefine = []        #SFILM
sradiateDefine = []     #SRADIATE
ampDefine = []          #AMPLITUDE
stepDefine = []         #STEP
needBoundaryNo = []     #設定された解析の必要な境界条件Noのリスト
meshHeaderData = []     #meshデータの保存用（header毎に数値で保存

treeData = []
treeRoot = [] 
treeFistrModel = []
treeSolution = []
treeMaterial = []
treeInitial = []
treeBoundary = []
treeAmp = []
treeStep = []
treeSolver = []
treePost = []
treeStepBounds = []     #step解析時の境界条件用Tree

ls = "\n"               #行末コード

#binAppPath = os.getenv("easyIstrPath") + os.sep + "bin" + os.sep
#pythonAppPath = os.getenv("easyIstrPath") + os.sep + "python" + os.sep
#AppのPathを定義
binAppPath = pyFistr.binAppPath             #binFolder
pythonAppPath = pyFistr.pythonAppPath       #pythonFolder


contactAlgo = "SLAGRANGE"   #接触アルゴリズムの初期設定

#tempFolderにコピーする時、shrinkするkeywordを取得（これ以外はそのままコピーする）
shrinkKeywords = pyFistr.shrinkKeywords

def ampValTypes():
    types = [_(u"RELATIVE（相対値）"), _(u"ABSOLUTE（絶対値）")]
    return types

def analysisTypes():
    anaTypes = [_(u"線形弾性静解析"), _(u"非線形静解析"), _(u"動解析"),
                _(u"固有値解析"), _(u"周波数応答解析"), _(u"熱伝導（静解析）"),
                _(u"熱伝導（動解析）")]
    return anaTypes

def analysisTypesE():
    anaTypes = ["STATIC", "NLSTATIC", "DYNAMIC",
                "EIGEN", "DYNAMIC_F", "HEAT",
                "HEAT_D"]
    return anaTypes

def initialTreeParts():
    root = [_(u"FrontISTR analysis")] 
    fistrModel = [_(u"FistrModel.msh")]
    solution =[_(u"解析の種類")]
    material = [_(u"材料物性値")]
    initial = [_(u"初期値（初期温度）")]
    boundary = [[_(u"境界条件"), [_(u"BOUNDARY（変位）"), _(u"CLOAD（荷重）"),
                              _(u"DLOAD（圧力）"), _(u"VLOAD（体積力）"),
                              _(u"GRAV（重力）"), _(u"CENT（遠心力）"),
                              _(u"TEMPERATURE（温度）"), _(u"SPRING（バネ要素）"),
                              _(u"CONTACT（接触）"), _(u"FLOAD（周期荷重）"),
                              _(u"VELOCITY（速度）"), _(u"ACCELERATION（加速度）"),
                              _(u"FIXTEMP（温度固定）"),
                              _(u"CFLUX（集中熱量）"), _(u"SFLUX（面熱流束）"),
                              _(u"DFLUX（内部発熱）"), _(u"SFILM（熱伝達率）"),
                              _(u"SRADIATE（輻射）")]]]
    step = [_(u"ステップ解析")]
    amp = [_(u"時間変化")]
    solver = [[_(u"solver"), [_(u"線形solver"), _(u"出力")]]]
    post = [_(u"post")]
    return [root, fistrModel, solution, material, initial, boundary, amp, step, solver, post]

def boundaryNames():
    names = ["BOUNDARY", "CLOAD", "DLOAD", "VLOAD", "GRAV", "CENT",
             "TEMPERATURE", "SPRING", "CONTACT", "FLOAD", "VELOCITY", "ACCELERATION",
             "FIXTEMP", "CFLUX", "SFLUX", "DFLUX", "SFILM", "SRADIATE"]
    return names

#境界条件のorderNoを定義
nBoundary=0;  nCload=1;         nDload=2;     nVload=3;    nGrav=4
nCent=5;      nTemperature=6;   nSpring=7;    nContact=8;  nFload=9
nVelocity=10; nAcceleration=11; nFixtemp=12;  nCflux=13
nSflux=14;    nDflux=15;        nSfilm=16;    nSradiate=17

#各解析で必要な境界条件のリスト（boundary[0][1]の内容）
#線形静解析
needBndStatic = (nBoundary, nCload,nDload, nVload, nGrav, nCent, nTemperature,
                 nSpring)
#非線形
needBndNlstatic = (nBoundary, nCload,nDload, nVload, nGrav, nCent, nTemperature,
                   nSpring, nContact)
#動解析
needBndDynamic = (nBoundary, nCload, nDload, nVload, nGrav, nCent, nTemperature,
                  nSpring, nContact, nVelocity, nAcceleration)
#固有値解析
needBndEigen = (nBoundary, nCload, nDload, nVload, nGrav, nCent, nTemperature,
                nSpring)
#周波数応答解析
needBndDynamic_F = (nBoundary, nCload, nDload, nVload, nGrav, nCent, nTemperature,
                    nSpring, nFload)
#熱伝導解析（静解析）
needBndHeat = (nFixtemp, nCflux, nSflux, nDflux, nSfilm, nSradiate)
#熱伝導解析（動解析）
needBndHeat_D = (nFixtemp, nCflux, nSflux, nDflux, nSfilm, nSradiate)


materialType = [
    ["ELASTIC", [], []],
    ["PLASTIC",
        ["MISES", "MOHR-COULOMB", "DRUCKER-PRANGER"],
        ["MULTILINEAR", "BILINEAR", "SWIFT", "RAMBERG-OSGOOD", "KINEMATIC", 
          "COMBINED"]],
    ["HYPERELASTIC",
        ["NEOHOOKE", "MOONY-RIVLIN", "ARRUDA-BOYCE"], []],
    ["VISCOELASTIC", [], []],
    ["CREEP", ["NORTON"], []]
    ]

matGrpHeader = ["!ITEM", "!ELASTIC", "!DENSITY", "!EXPANSION_COEFF", "!PLASTIC",
                "!HYPERELASTIC", "!VISCOELASTIC", "!CREEP", "!SPECIFIC_HEAT",
                "!THERMAL_CONDUCTIVITY"]


solveMethod = ["CG", "BiCGSTAB", "GMRES", "GPBiCG", "DIRECT", "DIRECTmkl", "MUMPS"]

def outputItems():
    items = [_(u"変位:DISPLACEMENT"), _(u"節点反力:REACTION"),
        _(u"節点ひずみ:NSTRAIN"),  _(u"節点応力:NSTRESS"), _(u"節点Mises応力:NMISES"),
        _(u"要素ひずみ:ESTRAIN"), _(u"要素応力:ESTRESS"), _(u"要素Mises応力:EMISES"),
        _(u"積分点ひずみ:ISTRAIN"), _(u"積分点応力:ISTRESS"),
        _(u"積分点塑性ひずみ:PL_ISTRAIN"), _(u"節点熱ひずみ:TH_NSTRAIN"),
        _(u"要素熱ひずみ:TH_ESTRAIN"), _(u"速度:VEL"), _(u"加速度:ACC"),
        _(u"梁要素NQM:BEAM_NQM"), _(u"シェル表面:SHELL_SURFACE"),
        _(u"シェル積層面:SHELL_LAYER")]
    return items

#defailtの出力item
def iniOutputItems():
    items = [_(u"変位:DISPLACEMENT"), _(u"節点応力:NSTRESS"),
        _(u"節点Mises応力:NMISES"), _(u"要素応力:ESTRESS"), _(u"要素Mises応力:EMISES")]
    return items

#dynamicSolution
def defaultDynamicSolutionCont():
    #全6行、21ヶのデータ
    data = ["11", "1",
            "0.0", "1.0", "500", "1e-5",
            "0.5", "0.25",
            "1", "1", "0.0", "0.0",
            "100", "", "1",
            "1", "0", "0", "0", "0", "0"]
    return data

#freqResponseSolution
def defaultFreqResponseSolutionCont():
    #全6行、21ヶのデータ
    data = ["11", "2",
            "14000", "16000", "20", "15000",
            "0.0", "6.6e-5",
            "1", "1", "0.0", "7.2e-7",
            "10", "2", "",
            "1", "0", "0", "0", "0", "0"]
    return data

#heatSolution
def defaultHeatSolutionCont():
    data = ["0.0", "3600.0", "1.0", "20.0",      "20",             "1.0e-6"]
    return data

#dynamicHeatSolution
def defaultDynamicHeatSolutionCont():
    #       DT      ETIME     DTmin  許容変化温度  非線形最大反復数  収束判定
    data = ["10.0", "3600.0", "1.0", "20.0",      "20",            "1.0e-6"]
    return data

#eigenSolution
def defaultEigenSolutionCont():
    #      固有値数　許容差　最大反復数
    data = ["5", "1e-8", "100"]
    return data

#要素タイプが板厚を必要としているタイプかどうか
def isThicknessElementType(elType):
    ans = False
    if elType[0] == "7":
        #「7**」は、板厚要
        ans = True
    return ans

#要素タイプがbeamの設定値を必要としているかどうか
def isBeamElementType(elType):
    ans = False
    if elType[0] == "6":
        ans = True
    return ans

#回転の自由度を必要としている要素かどうか
def isRotationElementType(elType):
    ans = False
    if elType[0] == "7":
        #shell
        ans = True
    elif elType[0] == "6":
        #beam
        ans = True
    return ans


#  ---------
#  windowApp
#  ---------
#    GUIの起動
class windowApp:

    #
    #  GUIの初期化
    #
    def __init__(self):
        global builder, mainWindow
        builder = Gtk.Builder()                 #builderをglobal変数に設定
        builder.add_from_file("easyIstr_2.glade")
        mainWindow = builder.get_object("window1")
        mainWindow.connect("delete-event", self.close)
        builder.connect_signals(self)           #handlerのセット

    #
    #  GUIの表示
    #
    def main(self):
        initialize()
        checkTrueCurrDir()                      #trueCurrDir有無チェック
        checkSetIstrData()                      #currDir等をチェック
        edit = isTempCase_EditOrNoedit()        #tempFolder内の修正有無を確認
        self.setGtkObject()                     #GUI objectのnameを設定
        self.subInitialize()                    #
        setTimeStampOfMshCntFiles(edit)         #起動時のtimeStampを確認し、書き込む
        self.setTitle()                         #titleとバージョンを設定
        mainWindow.show_all()                   #GUI表示
        Gtk.main()                              #loop

    #
    #  GUIの終了
    #
    def close(self, *args):
        Gtk.main_quit(*args)


    #
    #  setGtkObject
    #    object名をセット（定義）
    def setGtkObject(self):
        #treeのmodelを定義
        self.treestore = Gtk.TreeStore(str)
        #listのmodelを定義
        self.listmodelCntFile = Gtk.ListStore(str)
        self.listmodelNoMat = Gtk.ListStore(str)
        self.listmodelDefMat = Gtk.ListStore(str)
        self.listmodelNoGroup = Gtk.ListStore(str)
        self.listmodelSetGroup = Gtk.ListStore(str)
        self.listmodelSetContact = Gtk.ListStore(str)
        self.listmodelStepNoCnd = Gtk.ListStore(str)
        self.listmodelStepSetCnd = Gtk.ListStore(str)
        self.listmodelSetAmp = Gtk.ListStore(str)
        self.listmodelAmpNoGrp = Gtk.ListStore(str)
        self.listmodelAmpSetGrp = Gtk.ListStore(str)
        #comboのmodelを定義
        self.listmodelAnaType = Gtk.ListStore(str)
        self.listmodelMatName = Gtk.ListStore(str)
        self.listmodelMatModel = Gtk.ListStore(str)
        self.listmodelMatType = Gtk.ListStore(str)
        self.listmodelMatHard = Gtk.ListStore(str)
        self.listmodelCntPair = Gtk.ListStore(str)
        self.listmodelCntSlave = Gtk.ListStore(str)
        self.listmodelCntMaster = Gtk.ListStore(str)
        self.listmodelCntIntr = Gtk.ListStore(str)
        self.listmodelStepType = Gtk.ListStore(str)
        self.listmodelSoldyType = Gtk.ListStore(str)
        self.listmodelSoldyEqn = Gtk.ListStore(str)
        self.listmodelSoldyGroup = Gtk.ListStore(str)
        self.listmodelSlinMethod = Gtk.ListStore(str)
        self.listmodelAmpValue = Gtk.ListStore(str)
        #labelのnameを定義
        self.label_title = builder.get_object("title")              #Top page
        self.versionLabel = builder.get_object("version")           #Top page
        self.label_meshCnt = builder.get_object("meshCnt")          #FrontISTR page
        self.label_setMatGrp = builder.get_object("setMatGrp")      #材料物性値_sub page
        self.boundaryFrameTitle = builder.get_object("label43")     #setGroup page
        self.boundaryFrameLabel = builder.get_object("label44")     #setGroup page
        self.boundaryFrameNoset = builder.get_object("label45")     #setGroup page
        self.boundaryFrameSet = builder.get_object("label46")       #setGroup page
        self.boundaryGrpLabel = builder.get_object("label56")       #BOUNDARY_sub page
        self.cloadGrpLabel = builder.get_object("label59")          #CLOAD_sub page
        self.dloadGrpLabel = builder.get_object("label65")          #DLOAD_sub page
        self.vloadGrpLabel = builder.get_object("label69")          #VLOAD_sub page
        self.gravGrpLabel = builder.get_object("label75")           #GRAV_sub page
        self.centGrpLabel = builder.get_object("label81")           #CENT_sub page
        self.temperatureGrpLabel = builder.get_object("label93")    #TEMPERATURE_sub page
        self.floadGrpLabel = builder.get_object("label98")          #FLOAD_sub page
        self.contactGrpLabel = builder.get_object("label106")       #CONTACT_sub page
        self.label_stepName = builder.get_object("label118")        #step_sub page
        self.label_soldyTitle = builder.get_object("label134")      #solution_dyna page
        self.label_soldySEtime = builder.get_object("label138")     #solution_dyna page
        self.label_soldyDtime = builder.get_object("label140")      #solution_dyna page
        self.label_soldyGbeta = builder.get_object("label144")      #solution_dyna page
        self.label_soldyNewmark = builder.get_object("label146")    #solution_dyna page
        self.label_soldyGroup = builder.get_object("label150")      #solution_dyna page
        self.label_soldyOutdis = builder.get_object("label151")     #solution_dyna page
        self.label_fixtempGrp = builder.get_object("label182")      #FIXTEMP_sub page
        self.label_cfluxGrp = builder.get_object("label186")        #CFLUX_sub page
        self.label_dfluxGrp = builder.get_object("label190")        #DFLUX_sub page
        self.label_sfluxGrp = builder.get_object("label194")        #SFLUX_sub page
        self.label_sfilmGrp = builder.get_object("label198")        #SFILM_sub page
        self.label_sradiateGrp = builder.get_object("label203")     #SRADIATE_sub page
        self.label_soluDt = builder.get_object("label215")          #solution_heatDyna page
        self.label_soluEtime = builder.get_object("label216")       #solution_heatDyna page
        self.label_soluDtmin = builder.get_object("label217")       #solution_heatDyna page
        self.label_soluDeltmx = builder.get_object("label218")      #solution_heatDyna page
        self.label_ampTitle = builder.get_object("label223")        #AMPLITUDE page
        self.label_ampName = builder.get_object("label224")         #AMPLITUDE page
        self.label_ampGrpName = builder.get_object("label225")      #AMPLITUDE page
        self.label_ampMsg = builder.get_object("label226")          #AMPLITUDE page
        self.label_ampGrp = builder.get_object("label229")          #AMPLITUDE_sub page
        self.label_veloGrp = builder.get_object("label238")         #VELOCITY_sub
        self.label_accelGrp = builder.get_object("label242")        #ACCELARATION_sub
        self.label_tempHres = builder.get_object("label248")        #TEMPERATURE_sub
        self.label_springGrp = builder.get_object("label252")       #SPRING_sub page
        self.label_initialGrp = builder.get_object("label256")      #IITIAL_sub page
        self.label_soluCont = builder.get_object("label259")        #solutionType page
        self.label_Mx = builder.get_object("label278")              #CLOAD_sub page
        self.label_My = builder.get_object("label279")              #CLOAD_sub page
        self.label_Mz = builder.get_object("label280")              #CLOAD_sub page
        self.label_currDir = builder.get_object("label281")         #Top page
        #textCtrlのnameを定義
        self.textCtrl_workFolder = builder.get_object("entry1")     #FrontISTR page
        self.textCtrl_useCntFile = builder.get_object("entry2")     #FrontISTR page
        self.textCtrl_sourceMesh = builder.get_object("entry3")     #FistrModel page
        self.textCtrl_meshScale = builder.get_object("entry4")      #FistrModel page
        self.textCtrl_matDB = builder.get_object("entry5")          #材料物性値
        self.textCtrl_bndX = builder.get_object("entry6")           #BOUNDARY_sub page
        self.textCtrl_bndY = builder.get_object("entry7")           #BOUNDARY_sub page
        self.textCtrl_bndZ = builder.get_object("entry8")           #BOUNDARY_sub page
        self.textCtrl_cloadX = builder.get_object("entry9")         #CLOAD_sub page
        self.textCtrl_cloadY = builder.get_object("entry10")        #CLOAD_sub page
        self.textCtrl_cloadZ = builder.get_object("entry11")        #CLOAD_sub page
        self.textCtrl_dload = builder.get_object("entry12")         #DLOAD_sub page
        self.textCtrl_vloadBx = builder.get_object("entry13")       #VLOAD_sub page
        self.textCtrl_vloadBy = builder.get_object("entry14")       #VLOAD_sub page
        self.textCtrl_vloadBz = builder.get_object("entry15")       #VLOAD_sub page
        self.textCtrl_gravX = builder.get_object("entry16")         #GRAV_sub page
        self.textCtrl_gravY = builder.get_object("entry17")         #GRAV_sub page
        self.textCtrl_gravZ = builder.get_object("entry18")         #GRAV_sub page
        self.textCtrl_centOm = builder.get_object("entry19")        #CENT_sub page
        self.textCtrl_centPx = builder.get_object("entry20")        #CENT_sub page
        self.textCtrl_centPy = builder.get_object("entry21")        #CENT_sub page
        self.textCtrl_centPz = builder.get_object("entry22")        #CENT_sub page
        self.textCtrl_centDx = builder.get_object("entry23")        #CENT_sub page
        self.textCtrl_centDy = builder.get_object("entry24")        #CENT_sub page
        self.textCtrl_centDz = builder.get_object("entry25")        #CENT_sub page
        self.textCtrl_tempIni = builder.get_object("entry26")       #TEMPERATURE_sub page
        self.textCtrl_tempSet = builder.get_object("entry27")       #TEMPERATURE_sub page
        self.textCtrl_floadCase = builder.get_object("entry28")     #FLOAD_sub page
        self.textCtrl_floadX = builder.get_object("entry29")        #FLOAD_sub page
        self.textCtrl_floadY = builder.get_object("entry30")        #FLOAD_sub page
        self.textCtrl_floadZ = builder.get_object("entry31")        #FLOAD_sub page
        self.textCtrl_cntNtol = builder.get_object("entry32")       #contact_sub page
        self.textCtrl_cntTtol = builder.get_object("entry33")       #contact_sub page
        self.textCtrl_cntCoeff = builder.get_object("entry34")      #contact_sub page
        self.textCtrl_cntFact = builder.get_object("entry35")       #contact_sub page
        self.textCtrl_stepConv = builder.get_object("entry36")      #step_sub page
        self.textCtrl_stepSubStep = builder.get_object("entry37")   #step_sub page
        self.textCtrl_stepMaxIter = builder.get_object("entry38")   #step_sub page
        self.textCtrl_stepDtime = builder.get_object("entry39")     #step_sub page
        self.textCtrl_stepEtime = builder.get_object("entry40")     #step_sub page
        self.textCtrl_eigenNum = builder.get_object("entry41")      #solution_eigen page
        self.textCtrl_eigenPerm = builder.get_object("entry42")     #solution_eigen page
        self.textCtrl_eigenMaxiter = builder.get_object("entry43")  #solution_eigen page
        self.textCtrl_soldyStime = builder.get_object("entry44")    #solution_dyna page
        self.textCtrl_soldyEtime = builder.get_object("entry45")    #solution_dyna page
        self.textCtrl_soldyAllstep = builder.get_object("entry46")  #solution_dyna page
        self.textCtrl_soldyDtime = builder.get_object("entry47")    #solution_dyna page
        self.textCtrl_soldyOutfile = builder.get_object("entry48")  #solution_dyna page
        self.textCtrl_soldyGanma = builder.get_object("entry49")    #solution_dyna page
        self.textCtrl_soldyBeta = builder.get_object("entry50")     #solution_dyna page
        self.textCtrl_soldyRm = builder.get_object("entry51")       #solution_dyna page
        self.textCtrl_soldyRk = builder.get_object("entry52")       #solution_dyna page
        self.textCtrl_soldySample = builder.get_object("entry53")   #solution_dyna page
        self.textCtrl_soldyOutterm = builder.get_object("entry55")  #solution_dyna page
        self.textCtrl_solveNcpu = builder.get_object("entry54")     #solver page
        self.textCtrl_solveFreq = builder.get_object("entry56")     #solver page
        self.textCtrl_solveFistr = builder.get_object("entry57")    #solver page
        self.textCtrl_slinPrecond = builder.get_object("entry58")   #solver_lin page
        self.textCtrl_slinNiter = builder.get_object("entry59")     #solver_lin page
        self.textCtrl_slinResid = builder.get_object("entry60")     #solver_lin page
        self.textCtrl_fixtemp = builder.get_object("entry61")       #FIXTEMP_sub
        self.textCtrl_cflux = builder.get_object("entry62")         #CFLUX_sub
        self.textCtrl_dflux = builder.get_object("entry63")         #DFLUX_sub
        self.textCtrl_sflux = builder.get_object("entry64")         #SFLUX_sub
        self.textCtrl_sfilmAmb = builder.get_object("entry65")      #SFILM_sub
        self.textCtrl_sfilmVal = builder.get_object("entry66")      #SFILM_sub
        self.textCtrl_sradiateAmb = builder.get_object("entry67")   #SRADIATE_sub
        self.textCtrl_sradiateVal = builder.get_object("entry68")   #SRADIATE_sub
        self.textCtrl_hdynaDt = builder.get_object("entry69")       #solution_heatDyna page
        self.textCtrl_hdynaEtime = builder.get_object("entry70")    #solution_heatDyna page
        self.textCtrl_hdynaDtmin = builder.get_object("entry71")    #solution_heatDyna page
        self.textCtrl_hdynaDmax = builder.get_object("entry72")     #solution_heatDyna page
        self.textCtrl_hdynaItmax = builder.get_object("entry73")    #solution_heatDyna page
        self.textCtrl_hdynaEps = builder.get_object("entry74")      #solution_heatDyna page
        self.textCtrl_veloX = builder.get_object("entry75")         #VELOCITY_sub page
        self.textCtrl_veloY = builder.get_object("entry76")         #VELOCITY_sub page
        self.textCtrl_veloZ = builder.get_object("entry77")         #VELOCITY_sub page
        self.textCtrl_accelX = builder.get_object("entry78")        #ACCELARATION_sub page
        self.textCtrl_accelY = builder.get_object("entry79")        #ACCELARATION_sub page
        self.textCtrl_accelZ = builder.get_object("entry80")        #ACCELARATION_sub page
        self.textCtrl_tempReadR = builder.get_object("entry81")     #TEMPERATURE_sub page
        self.textCtrl_tempSstep = builder.get_object("entry82")     #TEMPERATURE_sub page
        self.textCtrl_tempInterval = builder.get_object("entry83")  #TEMPERATURE_sub page
        self.textCtrl_springX = builder.get_object("entry84")       #SPRING_sub page
        self.textCtrl_springY = builder.get_object("entry85")       #SPRING_sub page
        self.textCtrl_springZ = builder.get_object("entry86")       #SPRING_sub page
        self.textCtrl_initialTemp = builder.get_object("entry87")   #INITIAL_sub page
        self.textCtrl_Rx = builder.get_object("entry88")            #BOUNDARY_sub page
        self.textCtrl_Ry = builder.get_object("entry89")            #BOUNDARY_sub page
        self.textCtrl_Rz = builder.get_object("entry90")            #BOUNDARY_sub page
        self.textCtrl_tShell = builder.get_object("entry91")        #材料物性値_sub page
        self.textCtrl_nShell = builder.get_object("entry92")        #材料物性値_sub page
        self.textCtrl_beamVx = builder.get_object("entry93")        #材料物性値_sub page
        self.textCtrl_beamVy = builder.get_object("entry94")        #材料物性値_sub page
        self.textCtrl_beamVz = builder.get_object("entry95")        #材料物性値_sub page
        self.textCtrl_beamArea = builder.get_object("entry96")      #材料物性値_sub page
        self.textCtrl_beamIyy = builder.get_object("entry97")       #材料物性値_sub page
        self.textCtrl_beamIzz = builder.get_object("entry98")       #材料物性値_sub page
        self.textCtrl_beamJx = builder.get_object("entry99")        #材料物性値_sub page
        self.textCtrl_Mx = builder.get_object("entry100")           #CLOAD_sub page
        self.textCtrl_My = builder.get_object("entry101")           #CLOAD_sub page
        self.textCtrl_Mz = builder.get_object("entry102")           #CLOAD_sub page
        #Treeのnameを定義
        self.tree_main = builder.get_object("treeview1")
        self.listBox_cntFile = builder.get_object("treeview2")      #FrontISTR page
        self.listBox_noMat = builder.get_object("treeview3")        #材料物性値 page
        self.listBox_noMat.get_selection().set_mode(Gtk.SelectionMode.MULTIPLE)
        #self.listBox_noMat.get_selection().set_mode(gtk.SELECTION_MULTIPLE)
        self.listBox_defMat = builder.get_object("treeview4")       #材料物性値 page
        self.listBox_defMat.get_selection().set_mode(Gtk.SelectionMode.MULTIPLE)
        self.listBox_noGroup = builder.get_object("treeview5")      #setGroup page
        self.listBox_noGroup.get_selection().set_mode(Gtk.SelectionMode.MULTIPLE)
        self.listBox_setGroup = builder.get_object("treeview6")     #setGroup page
        self.listBox_setGroup.get_selection().set_mode(Gtk.SelectionMode.MULTIPLE)
        self.listBox_setContact = builder.get_object("treeview7")   #contact page
        self.listBox_setContact.get_selection().set_mode(Gtk.SelectionMode.MULTIPLE)
        self.listBox_stepNoCnd = builder.get_object("treeview8")    #step_sub page
        self.listBox_stepNoCnd.get_selection().set_mode(Gtk.SelectionMode.MULTIPLE)
        self.listBox_stepSetCnd = builder.get_object("treeview9")   #step_sub page
        self.listBox_stepSetCnd.get_selection().set_mode(Gtk.SelectionMode.MULTIPLE)
        self.listBox_setAmp = builder.get_object("treeview10")      #AMPLITUDE page
        self.listBox_ampNoGrp = builder.get_object("treeview11")    #AMPLITUDE_sub page
        self.listBox_ampNoGrp.get_selection().set_mode(Gtk.SelectionMode.MULTIPLE)
        self.listBox_ampSetGrp = builder.get_object("treeview12")   #AMPLITUDE_sub page
        self.listBox_ampSetGrp.get_selection().set_mode(Gtk.SelectionMode.MULTIPLE)
        #notebookのnameを定義
        self.notebook_main = builder.get_object("notebook1")
        #comboBoxのnameを定義
        self.comboBox_anaType = builder.get_object("combobox1")     #solutionType page
        self.comboBox_matName = builder.get_object("combobox2")     #材料物性値_sub page
        self.comboBox_matModel = builder.get_object("combobox3")    #材料物性値_sub page
        self.comboBox_matType = builder.get_object("combobox4")     #材料物性値_sub page
        self.comboBox_matHard = builder.get_object("combobox5")     #材料物性値_sub page
        self.comboBox_cntAlgo = builder.get_object("combobox6")     #contact page
        self.comboBox_cntSlave = builder.get_object("combobox7")    #contact_sub page
        self.comboBox_cntMaster = builder.get_object("combobox8")   #contact_sub page
        self.comboBox_cntIntr = builder.get_object("combobox9")     #contact_sub page
        self.comboBox_stepType = builder.get_object("combobox10")   #step_sub page
        self.comboBox_soldyType = builder.get_object("combobox11")  #solution_dyna page
        self.comboBox_soldyEqn = builder.get_object("combobox12")   #solution_dyna page
        self.comboBox_soldyGroup = builder.get_object("combobox13") #solution_dyna page
        self.comboBox_slinMethod = builder.get_object("combobox14") #solver_lin page
        self.comboBox_ampValue = builder.get_object("combobox15")   #AMPLITUDE_sub page
        #buttonのnameを定義
        self.button_ssData = builder.get_object("button20")         #材料物性値_sub page
        self.button_solveFistr = builder.get_object("button43")     #solver page
        self.button_plotMonitor = builder.get_object("button72")    #solver page
        #radioButtonのnameを定義
        self.radioBtn_unv2fistr = builder.get_object("radiobutton1")    #FistrModel page
        self.radioBtn_abaqus2fistr = builder.get_object("radiobutton2") #FistrModel page
        self.radioBtn_nodeForce = builder.get_object("radiobutton3")    #CLOAD_sub page
        self.radioBtn_aveForce = builder.get_object("radiobutton4")     #CLOAD_sub page
        self.radioBtn_trueForce = builder.get_object("radiobutton5")    #CLOAD_sub page
        self.radioBtn_nodeQw = builder.get_object("radiobutton6")   #CFLUX_sub page
        self.radioBtn_aveQw = builder.get_object("radiobutton7")    #CFLUX_sub page
        self.radioBtn_trueQw = builder.get_object("radiobutton8")   #CFLUX_sub page
        #checkBoxのnameを定義
        self.checkBtn_bndX = builder.get_object("checkbutton1")     #BOUNDARY_sub page
        self.checkBtn_bndY = builder.get_object("checkbutton2")     #BOUNDARY_sub page
        self.checkBtn_bndZ = builder.get_object("checkbutton3")     #BOUNDARY_sub page
        self.checkBtn_soldyDis = builder.get_object("checkbutton4")     #solution_dyna page
        self.checkBtn_soldyVelo = builder.get_object("checkbutton5")    #solution_dyna page
        self.checkBtn_soldyAcc = builder.get_object("checkbutton6")     #solution_dyna page
        self.checkBtn_soldyForce = builder.get_object("checkbutton7")   #solution_dyna page
        self.checkBtn_soldyStrain = builder.get_object("checkbutton8")  #solution_dyna page
        self.checkBtn_soldyStress = builder.get_object("checkbutton9")  #solution_dyna page
        self.checkBtn_solvePara = builder.get_object("checkbutton10")   #solver page
        self.checkBtn_solveIlog = builder.get_object("checkbutton11")   #solver page
        self.checkBtn_solveTlog = builder.get_object("checkbutton12")   #solver page
        self.checkBtn_veloX = builder.get_object("checkbutton13")       #VELOCITY_sub
        self.checkBtn_veloY = builder.get_object("checkbutton14")       #VELOCITY_sub
        self.checkBtn_veloZ = builder.get_object("checkbutton15")       #VELOCITY_sub
        self.checkBtn_accelX = builder.get_object("checkbutton16")      #ACCELARATION_sub
        self.checkBtn_accelY = builder.get_object("checkbutton17")      #ACCELARATION_sub
        self.checkBtn_accelZ = builder.get_object("checkbutton18")      #ACCELARATION_sub
        self.checkBtn_tempUseH = builder.get_object("checkbutton19")    #TEMPERATURE_sub
        self.checkBtn_solverRestart = builder.get_object("checkbutton20")   #solver
        self.checkBtn_springX = builder.get_object("checkbutton21")     #SPRING_sub
        self.checkBtn_springY = builder.get_object("checkbutton22")     #SPRING_sub
        self.checkBtn_springZ = builder.get_object("checkbutton23")     #SPRING_sub
        self.checkBtn_soluDt = builder.get_object("checkbutton24")      #solution_heatDyna
        self.checkBtn_Rx = builder.get_object("checkbutton25")      #Boundary_sub
        self.checkBtn_Ry = builder.get_object("checkbutton26")      #Boundary_sub
        self.checkBtn_Rz = builder.get_object("checkbutton27")      #Boundary_sub

    #  setTitle
    #    title, version, currDirを設定
    def setTitle(self):
        title = "EasyISTR for FrontISTR  (ver " + version + ")"
        self.label_title.set_label(title)
        self.versionLabel.set_label("ver " + version)
        trueCurrDir = getCurrDirFromTempFolder()
        title = "EasyISTR: " + trueCurrDir.split(os.sep)[-1]
        mainWindow.set_title(title)
        self.setCurrDirInLabel(trueCurrDir)

    def setCurrDirInLabel(self, dispDir):
        if len(dispDir) > 80:
            dispDir = "..." + dispDir[-77:]
        self.label_currDir.set_label("currDir: " + dispDir)

    def subInitialize(self):
        #istrDataをセット
        self.setIstrData()
        #cnt,mshファイルの有無チェック（存在しない場合は、defaultをコピー）
        self.checkCntMshFile()
        #cntファイル内容をチェック修正
        checkReformCntFile()
        #cntファイルをlistBoxにセット
        self.setCntFilesToListBox()
        #Fistrmodel.mshデータを取得
        getMeshHeaderData()
        self.setMeshCont()
        #FistrModel.cntデータ取得
        self.setControlCont()       #cntFileの内容を取得
        matchControlCont()          #meshとcntFileの整合をとる
        #Tree作成
        makeIniTreeData()
        self.setIniTreeData()
        #材料物性値のDialog表示
        self.readMaterialDB()
        self.setMaterialNameToListBox()
        self.setMaterialModelToComboBox()
        #titleページを表示
        showPage = _(u"FrontISTR")
        self.showNoteBook(showPage)


    #
    #  handler（eventの処理）
    #  -------
    #------ TreeItem選択 -------------------
    def onSelectItem(self, event):                  #TreeView選択
        self.selectItem(event)
    #------------- 欄外button -------------------------
    def onClose(self, event):                       #閉じる btn
        self.close()
    def onClearFolder(self, event):                 #folder内クリア btn
        self.clearFolder(event)
    def onSaveTempData(self, event):                #設定保存 btn
        self.saveTempData(event)
    def onOpenWorkFolder(self, event):              #folder開く btn
        self.openWorkFolder(event)
    def onOpenTempFolder(self, event):              #tempFolder開く btn
        self.openTempFolder(event)
    def onEditCntMshFile(self, event):              #cnt,mshFile編集 btn
        self.editCntMeshFile(event)
    def onRunTerminal(self, event):                 #端末起動 btn
        self.runTerminal(event)
    #------ FrontISTR page ---------------------------
    def onSelectWorkFolder(self, event):            #参照... btn
        self.selectWorkFolder(event)
    def onSetUseCntFile(self, event):               #選択>> btn
        self.setUseCntFile(event)
    def onCopyUseCntFile(self, event):              #cntファイル置き換え btn
        self.copyUseCntFile(event)
    #----- FistrModel page ---------------------------
    def onSetMeshFile(self, event):                 #参照... btn
        self.setMeshFile(event)
    def onMeshConvert(self, event):                 #ファイル変換 btn
        self.meshConvert(event)
    def onChangeMeshScale(self, event):             #倍率変更 btn
        self.changeMeshScale(event)
    def onReadMeshData(self, event):                #mesh読込 btn
        self.readMeshData(event)
    def onReformNgrp(self, event):                  #NGRPの修正 btn
        self.reformNgrp(event)
    def onConfirmModelAtParaview(self, event):      #形状確認 btn
        self.confirmModelAtParaview(event)
    #---- solutionType page button -----------------
    def onSetSolutionCont(self, event):             #解析選択combo
        self.setSolutionCont(self)
    def onApplySolutionType(self, event):           #設定btn
        self.applySolutionType(event)
    #----- solutionType Eigen page -----------------
    def onApplyEigenSolution(self, event):          #設定btn
        self.applyEigenSolution(event)
    #----- solutionType Dynamic page -----------------
    def onSetGroupName(self, event):                #group名 comboBox
        self.setGroupName(event)
    def onApplyDynamicSolution(self, event):        #設定btn
        self.applyDynamicSolution(event)
    #----- solutionType HeatDynamic page -----------------
    def onApplyHeatDynamicSolution(self, event):    #設定btn
        self.applyHeatDynamicSolution(event)
    def onCheckDtConstant(self, event):             #時間増分固定checkBox
        self.checkDtConstant(event)
    #----- 材料物性値 page -----------------
    def onSetMaterialDB(self, event):               #参照...
        self.setMaterialDB(event)
    def onOpenDB(self, event):                      #DBを開く
        self.openMaterialDB(event)
    def onSetMaterialGroup(self, event):            #選択>>btn
        self.setMaterialGroup(event)
    def onReturnMaterialGroup(self, event):         #<<戻すbtn
        self.returnMaterialGroup(event)
    def onApplyMaterial(self, event):               #設定btn
        self.applyMaterial(event)
    #----- 材料物性値_sub page -----------------
    def onSetEachMaterialModel(self, event):        #材料モデルcomboBox
        self.setEachMaterialTypeHard()
    def onEditSsData(self, event):                  #SS_data作成btn
        self.editPlasticSsData(event)
    def onShowMaterialData(self, event):            #物性値確認btn
        self.showMaterialData(event)
    def onOpenMaterialDB(self, event):              #材料DB開くbtn
        self.openMaterialDB(event)
    def onApplyEachMaterial(self, event):           #設定btn
        self.applyEachMaterial()
    #----- setGroup page -----------------
    def onSetBCGroup(self, event):                  #選択>>btn
        self.setBCGroup(event)
    def onReturnBCGroup(self, event):               #<<戻すbtn
        self.returnBCGroup(event)
    def onApplyBCGroup(self, event):                #設定btn
        self.applyBCGroup(event)
    #----- BOUNDARY_sub page -----------------
    def onApplyBoundaryCont(self, event):           #設定btn
        self.applyBoundaryCont(event)
    #----- CLOAD_sub page -----------------
    def onApplyCloadCont(self, event):              #設定btn
        self.applyCloadCont(event)
    #----- DLOAD_sub page -----------------
    def onApplyDloadCont(self, event):              #設定btn
        self.applyDloadCont(event)
    #----- VLOAD_sub page -----------------
    def onApplyVloadCont(self, event):              #設定btn
        self.applyVloadCont(event)
    #----- GRAV_sub page -----------------
    def onApplyGravCont(self, event):               #設定btn
        self.applyGravCont(event)
    #----- CENT_sub page -----------------
    def onApplyCentCont(self, event):               #設定btn
        self.applyCentCont(event)
    #----- TEMPERATURE_sub page -----------------
    def onSwitchUseResult(self, event):             #熱伝導解析結果を使用checkBox
        self.switchUseResult(event)
    def onApplyTemperatureCont(self, event):        #設定btn
        self.applyTemperatureCont(event)
    #----- SPRING_sub page -----------------
    def onApplySpringCont(self, event):             #設定btn
        self.applySpringCont(event)
    #----- contact page -----------------
    def onAddContactCondition(self, event):         #追加>>btn
        self.addContactCondition(event)
    def onDeleteContactCondition(self, event):      #<<削除btn
        self.deleteContactConditions(event)
    def onApplyContact(self, event):                #設定btn
        self.applyContact(event)
    #----- contact_sub page -----------------
    def onApplyContactCont(self, event):            #設定btn
        self.applyContactCont(event)
    #----- FLOAD_sub page -----------------
    def onApplyFloadCont(self, event):              #設定btn
        self.applyFloadCont(event)
    #----- VELOCITY_sub page -----------------
    def onApplyVeloCont(self, event):               #設定btn
        self.applyVeloCont(event)
    #----- ACCELERATION_sub page -----------------
    def onApplyAccelCont(self, event):              #設定btn
        self.applyAccelCont(event)
    #----- INITIAL_sub page -----------------
    def onApplyInitialCont(self, event):            #設定btn
        self.applyInitialCont(event)
    #----- FIXTEMP_sub page -----------------
    def onApplyFixtempCont(self, event):            #設定btn
        self.applyFixtempCont(event)
    #----- CFLUX_sub page -----------------
    def onApplyCfluxCont(self, event):              #設定btn
        self.applyCfluxCont(event)
    #----- SFLUX_sub page -----------------
    def onApplySfluxCont(self, event):              #設定btn
        self.applySfluxCont(event)
    #----- DFLUX_sub page -----------------
    def onApplyDfluxCont(self, event):              #設定btn
        self.applyDfluxCont(event)
    #----- SFILM_sub page -----------------
    def onApplySfilmCont(self, event):              #設定btn
        self.applySfilmCont(event)
    #----- SRADIATE_sub page -----------------
    def onApplySradiateCont(self, event):           #設定btn
        self.applySradiateCont(event)
    #----- step_sub page -----------------
    def onSetBCGroupForStep(self, event):           #選択>>btn
        self.setBCGroupForStep(event)
    def onReturnBCGroupForStep(self, event):        #<<戻すbtn
        self.returnBCGroupForStep(event)
    def onApplyStepCont(self, event):               #設定btn
        self.applyStepCont(event)
    #----- AMPLITUDE page -----------------
    def onAddAmplitudeCont(self, event):            #追加>>btn
        self.addAmplitudeCont(event)
    def onDeleteAmplitudeCont(self, event):         #<<削除btn
        self.deleteAmplitudeCont(event)
    def onApplyAmplitude(self, event):              #設定btn
        self.applyAmplitude(event)
    #----- AMPLITUDE_sub page -----------------
    def onEditAmpData(self, event):                 #data作成btn
        self.editAmpData(event)
    def onSetAmpBndGrp(self, event):                #選択>>btn
        self.setAmpBndGrp(event)
    def onReturnAmpBndGrp(self, event):             #<<戻すbtn
        self.returnAmpBndGrp(event)
    def onApplyAmplitudeCont(self, event):          #設定btn
        self.applyAmplitudeCont(event)
    #----- solver page -----------------
    def onSwitchParallel(self, event):              #並列計算checkBox
        self.switchParallel(event)
    def onCreateMultiJob(self, event):              #メッシュ分割btn
        self.createMultiJob(event)
    def onSwitchRestart(self, event):               #途中stepから開始checkBox
        self.switchRestart(event)
    def onSolveSet(self, event):                    #設定btn
        self.solveSet(event)
    def onRunFrontIstr(self, event):                #FrontISTR実行btn
        self.runFrontIstr(event)
    def onPlotStepMonitor(self, event):             #step状況表示btn
        self.plotStepMonitor(event)
    #------線形solver-----------------
    def onApplySolverCont(self, event):             #設定btn
        self.applySolverCont(event)
    #----- post page -----------------
    def onResultMerge(self, event):                 #merge btn
        self.resultMerge(event)
    def onRunRevocap(self, event):                  #REVOCAP起動 btn
        self.runRevocap(event)
    def onConvertResultData(self, event):           #vtk変換 btn
        self.convertResultData(event)
    def onMergeConvertVtk(self, event):             #merge&vtk変換 btn
        self.mergeConvertVtk(event)
    def onRunParaView(self, event):                 #ParaView起動 btn
        self.runParaView(event)
    def onAddPrincipalStress(self, event):          #主応力追加 btn
        self.addPrincipalStress(event)


    #------------------------- handler の内容 --------------------
    #
    #  runTerminal
    #  -----------
    #    端末を起動する
    def runTerminal(self, event):
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #端末起動
        comm = runTerminalComm
        os.system(comm)
        #tempの環境に戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #
    #  openWorkFolder
    #  --------------
    #    currDirを開く
    def openWorkFolder(self, event):
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #端末起動
        if os.name == "nt":
            #windows
            comm = runFileManagerComm + " " + currDir
            os.system(comm)
        else:
            #linux
            comm = runFileManagerComm + " " + currDir + " &"
            os.system(comm)
        #tempの環境に戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #
    #  openTempFolder
    #  --------------
    #    tempFolderを開く
    def openTempFolder(self, event):
        #端末起動
        if os.name == "nt":
            #windows
            comm = runFileManagerComm + " " + currDir
            os.system(comm)
        else:
            #linux
            comm = runFileManagerComm + " " + currDir + " &"
            os.system(comm)

    #
    #  editCntMeshFile
    #  ---------------
    #    cnt, mesh, datファイルを開く
    def editCntMeshFile(self, event):
        fileNames = (currDir + os.sep + "FistrModel.cnt " +
                     currDir + os.sep + "FistrModel.msh " + 
                     currDir + os.sep + "hecmw_ctrl.dat")
        partFile = currDir + os.sep + "hecmw_part_ctrl.dat"
        if len(glob.glob(partFile)) != 0:
            fileNames += " " + partFile
        if os.name=="nt":
            names = fileNames.split()
            i = len(names)-1
            while i >= 0:
                fileName = names[i]
                comm = "start /b cmd /c " + runEditorComm + " " + fileName
                os.system(comm)
                i -= 1
        else:
            comm = runEditorComm + " " + fileNames + " &"
            os.system(comm)

    #
    #  saveTempData
    #  ------------
    #    tempFolderの設定内容をworkFolderに保存する
    def saveTempData(self, event):
        trueCurrDir = getCurrDirFromTempFolder()
        if len(glob.glob(trueCurrDir)) == 0:
            title = _(u"エラー")
            mess = _(u"tempFolderの保存") + "\n" + _(u"保存先のdir") + "\n" + trueCurrDir + "\n" + _(u"が存在しません") + "\n\n" + _(u"保存できません")
            self.errDialog(title, mess)
            return
        #ファイル転送
        global currDir
        showSettingDialog("save temporary data")
        currDir = trueCurrDir
        os.chdir(currDir)
        numSettingDialog(20, "saving temporary setting data...")
        copyFilesFromTempToCurrDir()
        closeSettingDialog()
        #終了message
        title = _(u"tempFolderの保存")
        mess = _(u"tempFolderの保存") + "\n" + _(u"tempFolder内のファイルを") + "\n" + currDir + "\n" + _(u"に保存しました")
        self.okDialog(title, mess)
        currDir = currDirTemp
        os.chdir(currDir)

    #
    #  clearFolder
    #  -----------
    #    workFolderをクリアする
    def clearFolder(self, event):
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #folderClear
        comm = "python3 " + pythonAppPath + "deleteFilesDialog2.py"
        pyFistr.runAppBG(comm)
        #環境を戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)


    #
    #  setGroupName
    #  ------------
    #    comboBox内の組み込みentryに選択nameをセット
    def setGroupName(self, event):
        nIter = self.comboBox_soldyGroup.get_active_iter()
        if nIter != None:
            model = self.comboBox_soldyGroup.get_model()
            name = model[nIter][0]
            entry = self.comboBox_soldyGroup.get_child()
            entry.set_text(name)

    #
    #  selectWorkFolder
    #  ----------------
    #    作業用folderを設定
    def selectWorkFolder(self, event):
        global currDir, meshHeaderData, istrData
        #cnt, mshファイルのtimeStampをチェックし、修正ならば保存する
        self.checkTempCaseDate()
        #currDirを取得
        currDirTrue = getCurrDirFromTempFolder()
        #新しいcurrDirを取得
        title = _(u"作業用folderの選択")
        result = self.dirDialog(title, currDirTrue)
        if result != "":
            #newCurrDir = result
            currDir = result
            self.textCtrl_workFolder.set_text(currDir)
            os.chdir(currDir)
            saveIstrData(["currDir "+currDir])
            stat = self.checkCntMshFile()
            if stat != "OK":
                title = _(u"workFolderの初期化")
                mess = _(u"必要なファイルが存在しなかったので、コピーしました")
                self.okDialog(title, mess)
            #currDirをlabelにセット
            self.setCurrDirInLabel(currDir)
            #tempファイルを作成
            clearTempCase()
            createTempCase(currDir)
            copyOtherFiles(currDirTemp, currDir)
            #環境をtempCaseに設定
            currDir = currDirTemp
            saveIstrData(["currDir " + currDir])
            os.chdir(currDir)

            #tempCase内容を読み取り
            self.setCntFilesToListBox()
            #Fistrmodel.mshデータを取得
            lines = readFistrModelMsh()
            meshHeaderData = pyFistr.getHeaderNumData(lines)
            self.setMeshCont()
            #FistrModel.cntデータ取得
            checkReformCntFile()        #cntFileの内容をチェック修正
            self.setControlCont()       #cntFileの内容を取得
            matchControlCont()          #meshとcntFileの整合をとる
            istrData = getSavedData()
            self.setIstrData()
            #Tree作成
            makeIniTreeData()
            self.setIniTreeData()
            #材料物性値のDialog表示
            self.readMaterialDB()
            self.setMaterialNameToListBox()
            self.setMaterialModelToComboBox()
            #titleページを表示
            showPage = _(u"FrontISTR")
            self.showNoteBook(showPage)
            #titleバーにworkDirを表示
            self.setTitle()

    #  checkTempCaseDate
    #    tempCaseDateを確認し、cnt、mshファイルが修正されていれば、保存する
    def checkTempCaseDate(self):
        global currDir
        timeStampCnt = os.path.getmtime("FistrModel.cnt")
        timeStampMsh = os.path.getmtime("FistrModel.msh")
        tempCaseDate = getMeshContsFromTempFolder()["tempCaseDate"]
        if tempCaseDate <= timeStampCnt or tempCaseDate <= timeStampMsh:
            title = _(u"tempFolderの保存")
            mess = _(u"tempFolderの保存") + "\n" + _(u"tempFolder内のデータが更新されています") + "\n" + _(u"作業用folder移動前に、保存しますか？")
            #stat = self.okCancelDialog(title, mess)
            stat = self.yesNolDialog(title, mess)
            if stat == "YES":
                #元のcurrDirを取得
                currDir = getCurrDirFromTempFolder()
                if len(glob.glob(currDir)) == 0:
                    title = _(u"エラー")
                    mess = _(u"tempFolderの保存") + "\n" + _(u"保存先のdir") + "\n" + currDir + "\n" + _(u"が存在しません") + "\n\n" + _(u"保存できませんでした")
                    self.errDialog(title, mess)
                    return
                #ファイル転送
                os.chdir(currDir)
                #ファイル転送（tempCase　→　実case）
                copyFilesFromTempToCurrDir()
                #終了メッセージ
                title = _(u"tempFolderの保存")
                mess = _(u"tempFolderの保存") + "\n" + _(u"tempFolder内のファイルを") + "\n" + currDir + "\n" + _(u"に保存しました")
                self.okDialog(title, mess)
                os.chdir(currDirTemp)

    #
    #  setUseCntFile
    #  -------------
    #    手本のcntファイルをセット
    def setUseCntFile(self, event):
        (listmodel, listIter) = self.listBox_cntFile.get_selection().get_selected()
        if listIter != None:
            useFile = self.listmodelCntFile.get_value(listIter, 0)
        else:
            title = _(u"エラー")
            mess = _(u"cntファイルを選択してください。")
            self.errDialog(title, mess)
            return
        self.textCtrl_useCntFile.set_text(useFile)

    #
    #  copyUseCntFile
    #  --------------
    #    cntファイルをコピー
    def copyUseCntFile(self, event):
        name = self.textCtrl_useCntFile.get_text()
        copyFile = os.getenv("easyIstrUserPath") + os.sep + "data" + os.sep + name
        if len(glob.glob(copyFile)) == 0:
            title = _(u"エラー")
            mess = _(u"cntファイルが正しく設定されていません")
            self.errDialog(title, mess)
            return
        pasteFile = currDir + os.sep + "FistrModel.cnt"
        shutil.copy(copyFile, pasteFile)
        #追加 easyIstrUserフォルダ内も書き換え　15/10/13
        pasteFile = os.getenv("easyIstrUserPath") + os.sep + "FistrModel.cnt"
        shutil.copy(copyFile, pasteFile)
        #hecmw_ctrl.datを書き換え
        pasteFile = currDir + os.sep + "hecmw_ctrl.dat"
        if len(glob.glob(pasteFile)) == 0:
            copyFile = os.getenv("easyIstrUserPath") + os.sep + "data" + os.sep + "hecmw_ctrl.dat"
            shutil.copy(copyFile, pasteFile)
        #cntファイルを初期化（境界条件を削除する）
        getMeshHeaderData()
        resetCntMshFile()
        self.setControlCont()       #cntFileの内容を取得
        matchControlCont()          #meshとcntFileの整合をとる
        #Tree作成
        makeIniTreeData()
        self.setIniTreeData()
        #useCntFileを保存 15/10/13
        saveIstrData(["useCntFile " + name])
        #FistrModel.cnt, hecmw_ctrl.datを元のcurrDirにも書き換える
        copyFiles = ["FistrModel.cnt", "hecmw_ctrl.dat"]
        pasteFolder = getCurrDirFromTempFolder()
        for copyFile in copyFiles:
            shutil.copy(copyFile, pasteFolder)
        #終了メッセージ
        title = _(u"cntファイルの置き換え")
        mess = _(u"cntファイルを置き換えて、制御ファイルを初期化しました")
        self.okDialog(title, mess)

    #
    #  setMeshFile
    #  -----------
    #    meshFileをセット
    def setMeshFile(self, event):
        global sourceMeshFile
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #radioBtnをチェック
        if self.radioBtn_unv2fistr.get_active() == True:
            fileType = "*.unv"
            filterSets = [[_(u"unvファイル"), fileType], [_(u"全てのファイル"), "*"]]
        else:
            fileType = "*.inp"
            filterSets = [[_(u"inpファイル"), fileType], [_(u"全てのファイル"), "*"]]
        title = _(u"meshFileの選択")
        fileName = self.fileDialog(title, currDir, filterSets)
        if fileName != "":
            sourceMeshFile = fileName.split(os.sep)[-1]
            currDir = os.sep.join(fileName.split(os.sep)[:-1])
            os.chdir(currDir)
            self.textCtrl_sourceMesh.set_text(sourceMeshFile)
        os.chdir(currDirTemp)

    #
    #  meshConvert
    #  -----------
    #    mesh変換
    def meshConvert(self, event):
        global meshHeaderData
        global currDir
        #text_ctrlからsorceMeshファイル名を取得
        sourceMeshFile = self.textCtrl_sourceMesh.get_text()
        if sourceMeshFile == "":
            title = _(u"エラー")
            mess = _(u"ファイルが選択されていません")
            self.errDialog(title, mess)
            return

        showSettingDialog("converting mesh file")
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #cntファイルチェック
        self.checkCntMshFile()
        #mesh変換
        if self.radioBtn_unv2fistr.get_active() == True:
            numSettingDialog(20, "converting unv mesh file...")
            option = "unv2fistr"
            comm = "python3 " + binAppPath + "unv2fistr.py " + currDir + os.sep + sourceMeshFile
            os.system(comm)
        else:
            numSettingDialog(20, "converting abaqus mesh file...")
            option = "abaqus2fistr"
            comm = "python3 " + binAppPath + "abaqus2fistr.py " + currDir + os.sep + sourceMeshFile
            os.system(comm)

        fileName = ".".join(sourceMeshFile.split(".")[:-1]) + ".msh"
        if len(glob.glob(fileName)) == 0:
            closeSettingDialog()
            title = _(u"エラー")
            mess = _(u"メッシュ変換に失敗しました")
            self.errDialog(title, mess)
            currDir = currDirTemp
            os.chdir(currDirTemp)
            return
            
        shutil.move(fileName, "FistrModel.msh")
        #mshファイル内のheaderチェック修正
        numSettingDialog(80, "checking mesh file...")
        #  meshFileの読み込み、10sまで待つ（直ぐに読み込むと最後まで読み込めない）
        flag = 0; count = 0
        while flag == 0:
            lines = readFistrModelMsh()
            if lines[-1][:len("!END")].upper() == "!END":
                flag = 1
            else:
                time.sleep(1)
            count += 1
            if count > 10:
                flag = 1
        meshHeaderData = pyFistr.getHeaderNumData(lines)
        meshHeaderData = checkFistrModelMeshFile(meshHeaderData)
        #cntファイルを初期化
        numSettingDialog(90, "reset and writing mesh file...")
        resetCntMshFile()               #resetと書き込み、meshHeaderData更新
        if self.radioBtn_abaqus2fistr.get_active() == True:
            comm = "python3 " + binAppPath + "abaqusinp2fistrcnt.py " + currDir + os.sep + sourceMeshFile
            os.system(comm)
            lines = readFistrModelMsh()
            meshHeaderData = pyFistr.getHeaderNumData(lines)
            getMeshParameter()          #meshの内容を取得
            self.setControlCont()       #cntFileの内容を取得
            matchControlCont()          #meshとcntFileの整合をとる
            #Tree作成
            makeIniTreeData()

        #tempCaseを作成
        lines = pyFistr.createLinesFistrModelMshHeader(meshHeaderData)
        createTempCaseFromMeshData(currDir, lines, meshHeaderData)
        self.setMeshCont()
        #環境を戻す
        os.chdir(currDirTemp)
        currDir = currDirTemp
        lines = readFistrModelMsh()
        meshHeaderData = pyFistr.getHeaderNumData(lines)
        #Treeを作成
        self.setIniTreeData()
        treeList = [_(u"FistrModel.msh")]
        self.showTreeData(treeList)
        #set内容をistrDataに書き込み
        saveIstrData(["convertOpt "+option, "sourceMesh "+sourceMeshFile])

        #終了メッセージ
        closeSettingDialog()
        title = _(u"メッシュ変換")
        mess = _(u"mesh変換しました。") + ls + _(u"FistrModel.mshを作成しました。")
        self.okDialog(title, mess)

    #
    #  changeMeshScale
    #  ---------------
    #    meshのスケールを変更
    def changeMeshScale(self, event):
        global currDir, meshHeaderData
        a = self.textCtrl_meshScale.get_text()
        try:
            scale = float(a)
        except:
            title = _(u"エラー")
            mess = _(u"倍率は、数字を入力してください")
            self.errDialog(title, mess)
            return
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #dialog表示
        showSettingDialog("change scale")
        numSettingDialog(20, "reading mesh data...")
        #msh,cntファイルを転送
        copyMshFromTempToCurrDir()
        #copyCntFromTempToCurrDir()
        #scale変更
        lines = readFistrModelMsh()
        meshHeaderData = pyFistr.getHeaderNumData(lines)
        numSettingDialog(50, "changing scale...")
        meshHeaderData = pyFistr.changeMeshScale(meshHeaderData, scale)
        numSettingDialog(90, "writing mesh file...")
        #書き込み
        lines = pyFistr.createLinesFistrModelMshHeader(meshHeaderData)
        writeFistrModelMsh(lines)
        numSettingDialog(95, "setting mesh contents...")
        #tempCase作成（tempcaseDateは更新せず）
        createTempCaseFromOnlyMeshData(currDir, lines, meshHeaderData)        
        #meshContをlabelに書き込み
        self.setMeshCont()
        closeSettingDialog()
        #環境を戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)
        lines = readFistrModelMsh()
        meshHeaderData = pyFistr.getHeaderNumData(lines)
        #終了メッセージ
        mess = _(u"meshのスケールを変更しました") + ls + _(u"  倍率: ") + a
        print (mess)
        title = _(u"スケールの変更")
        self.okDialog(title, mess)
        self.textCtrl_meshScale.set_text("1.0")

    #
    #  readMeshData
    #  ------------
    #    meshデータの読込
    def readMeshData(self, event):
        global currDir, meshHeaderData
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)

        showSettingDialog("read mesh data")
        numSettingDialog(10, "reading mesh file...")
        lines = readFistrModelMsh()
        meshHeaderData = pyFistr.getHeaderNumData(lines)
        #FistrModel.cntデータ取得
        self.setControlCont()       #cntFileの内容を取得
        matchControlCont()          #meshとcntFileの整合をとる

        #tempCaseを作成
        createTempCaseFromMeshData(currDir, lines, meshHeaderData)
        self.setMeshCont()
        #tempの環境に戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)
        lines = readFistrModelMsh()
        meshHeaderData = pyFistr.getHeaderNumData(lines)
        #Tree作成
        makeIniTreeData()
        self.setIniTreeData()
        #材料物性値のDialog表示
        self.readMaterialDB()
        self.setMaterialNameToListBox()
        self.setMaterialModelToComboBox()
        treeList = [_(u"FistrModel.msh")]
        self.showTreeData(treeList)
        closeSettingDialog()
        print (_(u"meshデータを読み込みました。"))

    #
    #  reformNgrp
    #  ----------
    #    NGRPの修正
    #    重複定義された節点を削除する。
    def reformNgrp(self, event):
        global currDir, meshHeaderData
        #overlapNGRPを取得
        meshConts = getMeshContsFromTempFolder()
        overlapNames = meshConts["overlapNGRP"]
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #修正後のmeshHderDataを取得
        [stat, data] = deleteOverlapNodesDDialog.Show(overlapNames)
        if stat == "OK":
            meshHeaderData = data
            lines = pyFistr.createLinesFistrModelMshHeader(meshHeaderData)
            createTempCaseFromOnlyMeshData(currDir, lines, meshHeaderData)
            self.setMeshCont()
        #tempの環境に戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)
        lines = readFistrModelMsh()
        meshHeaderData = pyFistr.getHeaderNumData(lines)

    #
    #  confirmModelAtParaview
    #  ----------------------
    #    メッシュ形状確認
    def confirmModelAtParaview(self, event):
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #vtkファイル取得
        fileHeader = "FistrModel"
        comm = "python3 " + binAppPath + "fistr2vtk.py -mesh " + fileHeader
        print (comm)
        os.system(comm)
        comm = runParaViewComm + " convFistrModel.msh.vtk"
        pyFistr.runAppBG(comm)
        #tempの環境に戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #
    #  setSolutionCont
    #  ---------------
    #    solutionの内容をlabelに表示
    def setSolutionCont(self, event):
        anaType = self.getAnaTypeFromComboBox()
        self.setAnaTypeContInLabel(anaType)

    #  getAnaTypeFromComboBox
    #    anaTypeをcomboBoxから取得
    def getAnaTypeFromComboBox(self):
        anaTypeJ = ""
        nIter = self.comboBox_anaType.get_active_iter()
        if nIter != None:
            model = self.comboBox_anaType.get_model()
            anaTypeJ = model[nIter][0]
        i = 0
        for name in analysisTypes():
            if name == anaTypeJ:
                break
            i += 1
        anaTypes = analysisTypesE()         #英語表記のanaTypesを取得
        if i >= len(anaTypes):
            i = 0
        anaType = anaTypes[i]
        return anaType

    #  setAnaTypeContInLabel
    #    anaTypeの出力をlabelに表示
    def setAnaTypeContInLabel(self, anaType):
        label = _(u"入出力ファイル") + ls
        if anaType == "STATIC":
            label += _(u"  入力:FistrModel.msh") + ls
            label += _(u"  入力:FistrModel.cnt") + ls
            label += _(u"  出力:FistrModel.res")
        elif anaType == "NLSTATIC":
            label += _(u"  入力:FistrModel.msh") + ls
            label += _(u"  入力:FistrModel.cnt") + ls
            label += _(u"  出力:FistrModel.res")
        elif anaType == "DYNAMIC":
            label += _(u"  入力:FistrModel.msh") + ls
            label += _(u"  入力:FistrModel.cnt") + ls
            label += _(u"  出力:FistrModel.res")
        elif anaType == "EIGEN":
            label += _(u"  入力:FistrModel.msh") + ls
            label += _(u"  入力:FistrModel.cnt") + ls
            label += _(u"  出力:FistrModel_eigen.res")
        elif anaType == "DYNAMIC_F":
            label += _(u"  入力:FistrModel.msh") + ls
            label += _(u"  入力:FistrModel.cnt") + ls
            label += _(u"  入力:FistrModel_eigen.res") + ls
            label += _(u"  出力:FistrModel.res") + ls
            label += _(u"  出力:FistrModel_dyna.res")
        elif anaType == "HEAT":
            label += _(u"  入力:FistrModel.msh") + ls
            label += _(u"  入力:FistrModel.cnt") + ls
            label += _(u"  出力:FistrModel_temp.res")
        elif anaType == "HEAT_D":
            label += _(u"  入力:FistrModel.msh") + ls
            label += _(u"  入力:FistrModel.cnt") + ls
            label += _(u"  出力:FistrModel_temp.res")
        self.label_soluCont.set_label(label)

    #
    #  applySolutionType
    #  -----------------
    #    solutionTypeを設定
    def applySolutionType(self, event):
        global anaType, settingDialog
        #設定中dialog表示
        showSettingDialog("setting Solution Type")
        #solutionTypeを設定
        orgAnaType = getSolutitionTypeFromCnt()
        anaType = self.getAnaTypeFromComboBox()
        if anaType == orgAnaType:
            #設定dialog閉じる
            closeSettingDialog()
            #設定が変わっていない場合は、何もしない
            return

        else:
            #cntの内容を修正する
            lines = readFistrModelCnt()
            lines = pyFistr.deleteHeaderName(lines, 0, "!EIGENREAD", "")
            i = pyFistr.getNextHeaderName(lines, 0, "!SOLUTION", "")
            realAnaType = anaType
            if anaType == "DYNAMIC_F":
                realAnaType = "DYNAMIC"
            elif anaType == "HEAT_D":
                realAnaType = "HEAT"
            lines[i] = abaqus2fistr.setValName(lines[i], "TYPE="+realAnaType)
            lines[i+1] = "!" + realAnaType + ls
            [lines, i] = pyFistr.deleteOnlyDataInLines(lines, i+2)
            #  初期値の設定
            if anaType == "DYNAMIC":
                values = defaultDynamicSolutionCont()
                addLines =  [", ".join(values[:2]) + ls]
                addLines += [", ".join(values[2:6]) + ls]
                addLines += [", ".join(values[6:8]) + ls]
                addLines += [", ".join(values[8:12]) + ls]
                addLines += [", ".join(values[12:15]) + ls]
                addLines += [", ".join(values[15:21]) + ls]
                lines = lines[:i] + addLines + lines[i:]
            elif anaType == "DYNAMIC_F":
                values = defaultFreqResponseSolutionCont()
                addLines =  [", ".join(values[:2]) + ls]
                addLines += [", ".join(values[2:6]) + ls]
                addLines += [", ".join(values[6:8]) + ls]
                addLines += [", ".join(values[8:12]) + ls]
                addLines += [", ".join(values[12:15]) + ls]
                addLines += [", ".join(values[15:21]) + ls]
                addLines += ["!EIGENREAD" + ls]
                addLines += ["eigen_log" + ls]
                addLines += ["1, 5" + ls]
                lines = lines[:i] + addLines + lines[i:]
            elif anaType == "EIGEN":
                values = defaultEigenSolutionCont()
                addLines = [", ".join(values) + ls]
                lines = lines[:i] + addLines + lines[i:]
            elif anaType == "HEAT":
                values = defaultHeatSolutionCont()
                addLines = [", ".join(values) + ls]
                lines = lines[:i] + addLines + lines[i:]
            elif anaType == "HEAT_D":
                values = defaultDynamicHeatSolutionCont()
                addLines = [", ".join(values) + ls]
                lines = lines[:i] + addLines + lines[i:]
            writeFistrModelCnt(lines)
            #hecmw_ctrlの内容を修正する
            lines = readHecmwCtrlDat()
            i = pyFistr.getNextHeaderName(lines, 0, "!RESULT", "NAME=fstrRES")
            i += 1
            if anaType == "EIGEN":
                #固有値解析の場合、出力file名を変える
                lines[i] = "FistrModel_eigen.res" + ls
                lines = deleteFstrDynaResultIn(lines)
            elif anaType == "DYNAMIC_F":
                lines[i] = "FistrModel.res" + ls
                lines = addFstrDynaResultIn(lines)
            elif anaType == "HEAT" or anaType == "HEAT_D":
                #熱解析の場合、出力file名を変える
                lines[i] = "FistrModel_temp.res" + ls
                lines = deleteFstrDynaResultIn(lines)
            else:
                #上記以外の場合は、そのまま
                lines[i] = "FistrModel.res" + ls
                lines = deleteFstrDynaResultIn(lines)
            writeHecmwCtrlDat(lines)
            #Treeを再設定
            global treeSolution
            if (anaType == "DYNAMIC" or anaType == "DYNAMIC_F"
                    or anaType == "EIGEN" or anaType == "HEAT_D"):
                #if type(treeSolution[0]) == str or type(treeSolution[0]) == unicode:
                if type(treeSolution[0]) == str:
                    treeSolution = [[treeSolution[0], [_(u"設定")]]]
                    makeTreeData()
                    treeList = [_(u"解析の種類")]
                    self.showTreeData(treeList)
            else:
                if type(treeSolution[0]) == list:
                    treeSolution = [treeSolution[0][0]]
                    makeTreeData()
                    treeList = [_(u"解析の種類")]
                    self.showTreeData(treeList)
        #treeの文字色を設定
        nIter = self.comboBox_anaType.get_active_iter()
        model = self.comboBox_anaType.get_model()
        anaTypeJ = model[nIter][0]
        #anaTypeJ = self.comboBox_anaType.get_active_text()
        self.setTreeFontColour(anaType)
        print (_(u"解析の種類を「") + anaTypeJ + ":" + anaType + _(u"」に変更しました。")) 
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyEigenSolution
    #  ------------------
    #    eigenSolutionの内容を設定
    def applyEigenSolution(self, event):
        #設定中dialog表示
        showSettingDialog("setting Eigen Solution contents")
        #設定
        value1 = self.textCtrl_eigenNum.get_text()
        value2 = self.textCtrl_eigenPerm.get_text()
        value3 = self.textCtrl_eigenMaxiter.get_text()
        values = [value1, value2, value3]
        lines = readFistrModelCnt()
        i = pyFistr.getInsertPointInCnt(lines, "!EIGEN", [])
        [lines, i] = pyFistr.deleteOnlyDataInLines(lines, i+1)
        addLines = [", ".join(values) + ls]
        lines = lines[:i] + addLines + lines[i:]
        writeFistrModelCnt(lines)
        print (_(u"固有値解析の設定を行いました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyDynamicSolution
    #  --------------------
    #    dynamicSolutionの内容を設定
    def applyDynamicSolution(self, event):
        #設定中dialog表示
        showSettingDialog("setting Dynamic Solution Contents")
        #設定
        values = getDynamicContFromCnt()
        if values[0] == "":
            values[0] = "LINEAR"
        if len(values[1]) != 21:
            values[1] = defaultDynamicSolutionCont()
        if values[2] == "":
            values[2] = "1"
        #線形・非線形
        n = self.comboBox_soldyType.get_active()
        if n == 0:
            values[0] = "LINEAR"
        else:
            values[0] = "NONLINEAR"
        #運動方程式
        n = self.comboBox_soldyEqn.get_active()
        if n == 0:
            values[1][0] = "11"
        else:
            values[1][0] = "1"
        #開始時刻
        values[1][2] = self.textCtrl_soldyStime.get_text()
        values[1][3] = self.textCtrl_soldyEtime.get_text()
        values[1][4] = self.textCtrl_soldyAllstep.get_text()
        values[1][5] = self.textCtrl_soldyDtime.get_text()
        values[2] = self.textCtrl_soldyOutfile.get_text()
        #パラメータ
        values[1][6] = self.textCtrl_soldyGanma.get_text()
        values[1][7] = self.textCtrl_soldyBeta.get_text()
        values[1][10] = self.textCtrl_soldyRm.get_text()
        values[1][11] = self.textCtrl_soldyRk.get_text()
        #出力
        values[1][12] = self.textCtrl_soldySample.get_text()
        values[1][13] = self.comboBox_soldyGroup.get_child().get_text().split(":")[0]
        values[1][14] = self.textCtrl_soldyOutterm.get_text()
        if self.checkBtn_soldyDis.get_active() == False:
            values[1][15] = "0"
        else:
            values[1][15] = "1"
        if self.checkBtn_soldyVelo.get_active() == False:
            values[1][16] = "0"
        else:
            values[1][16] = "1"
        if self.checkBtn_soldyAcc.get_active() == False:
            values[1][17] = "0"
        else:
            values[1][17] = "1"
        if self.checkBtn_soldyForce.get_active() == False:
            values[1][18] = "0"
        else:
            values[1][18] = "1"
        if self.checkBtn_soldyStrain.get_active() == False:
            values[1][19] = "0"
        else:
            values[1][19] = "1"
        if self.checkBtn_soldyStress.get_active() == False:
            values[1][20] = "0"
        else:
            values[1][20] = "1"
        #設定dialog閉じる
        closeSettingDialog()
        #valuesの内容をcntに書き込み
        #  errorチェック
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        if anaType == "DYNAMIC_F":
            #flag作成
            eigenFlag = len(glob.glob("eigen_log")) == 0
            if eigenFlag == True:
                title = _(u"エラー")
                mess = _(u"固有値解析の結果ファイル（eigen_log）がありません") + ls
                mess += _(u"先に固有値解析を行ってください")
                self.errDialog(title, mess)
                #環境を戻す
                currDir = currDirTemp
                os.chdir(currDirTemp)
                return
        setDynamicContInCnt(values)
        print (_(u"SOLUTION dynamic を設定しました"))
        #環境を戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #
    #  applyHeatDynamicSolution
    #  ------------------------
    #    heatDynamicの内容を設定
    def applyHeatDynamicSolution(self, event):
        #設定中dialog表示
        showSettingDialog("setting Heat Dynamic Solution contents")
        #設定
        Dt = self.textCtrl_hdynaDt.get_text()
        Etime = self.textCtrl_hdynaEtime.get_text()
        Dtmin = self.textCtrl_hdynaDtmin.get_text()
        Dmax = self.textCtrl_hdynaDmax.get_text()
        Itmax = self.textCtrl_hdynaItmax.get_text()
        Eps = self.textCtrl_hdynaEps.get_text()
        values = [Dt, Etime, Dtmin, Dmax, Itmax, Eps]
        lines = readFistrModelCnt()
        i = pyFistr.getInsertPointInCnt(lines, "!HEAT", [])
        lines[i+1] = ", ".join(values) + ls
        writeFistrModelCnt(lines)
        print (_(u"熱伝導（動解析）の設定を行いました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  checkDtConstant
    #  ---------------
    #    時間増分固定or自動の設定
    def checkDtConstant(self, event):
        if self.checkBtn_soluDt.get_active() == True:
            self.label_soluDt.set_label(_(u"時間増分"))
            self.label_soluEtime.set_label(_(u"計算時間"))
            self.textCtrl_hdynaDtmin.set_text("0")
            self.textCtrl_hdynaDtmin.set_sensitive(False)
            self.textCtrl_hdynaDmax.set_sensitive(False)
            self.label_soluDtmin.set_sensitive(False)
            self.label_soluDeltmx.set_sensitive(False)
        else:
            self.label_soluDt.set_label(_(u"初期時間増分"))
            self.label_soluEtime.set_label(_(u"計算時間"))
            self.textCtrl_hdynaDtmin.set_text("0.1")
            self.textCtrl_hdynaDtmin.set_sensitive(True)
            self.textCtrl_hdynaDmax.set_sensitive(True)
            self.label_soluDtmin.set_sensitive(True)
            self.label_soluDeltmx.set_sensitive(True)

    #
    #  setMaterialDB
    #  -------------
    #    材料DBの場所を設定
    def setMaterialDB(self, event):
        global materialDBName
        if len(glob.glob(materialDBName)) == 0:
            dbDir = os.getcwd()
        else:
            #dbDir = "/".join(materialDBName.split("/")[:-1])
            dbDir = os.sep.join(materialDBName.split(os.sep)[:-1])
        #fileType = "*.csv"

        title = _(u"材料DBの選択")
        filterSets = [[_(u"csvファイル"), "*.csv"],
                      [_(u"全てのファイル"), "*"]]
        fileName = self.fileDialog(title, dbDir, filterSets)
        if fileName != "":
            materialDBName = fileName
            self.textCtrl_matDB.set_text(materialDBName)
            saveIstrData(["materialDB "+materialDBName])
            self.readMaterialDB()
            self.setMaterialNameToListBox()
        return

    #
    #  openMaterialDB
    #  --------------
    #    材料DBを開く
    def openMaterialDB(self, event):
        fileName = materialDBName
        if len(glob.glob(fileName)) == 0:
            title = _(u"エラー")
            mess = _(u"材料DBが存在しません") + ls
            mess += _(u"DBを再設定してください")
            self.errDialog(title, mess)
            return
        comm = runOfficeComm + " " + fileName
        pyFistr.runAppBG(comm)

    #
    #  setMaterialGroup
    #  ----------------
    #    elGroupを選択
    def setMaterialGroup(self, event):
        self.moveItemToListBox(self.listBox_noMat, self.listmodelNoMat,
                               self.listBox_defMat, self.listmodelDefMat)

    #
    #  returnMaterialGroup
    #  -------------------
    #    elGroupを戻す
    def returnMaterialGroup(self, event):
        self.moveItemToListBox(self.listBox_defMat, self.listmodelDefMat,
                               self.listBox_noMat, self.listmodelNoMat)

    #  moveItemToListBox
    #    選択したitemをlistBox1からlistBox2に移動する
    def moveItemToListBox(self, listBox1, listmodel1, listBox2, listmodel2):
        names = self.moveItemToListBox_sub(listBox1, listmodel1, listBox2, listmodel2)
        if len(names) == 0:
            return

        [selNames, fromNames, toNames] = names
        #toNames.sort()
        #新しいnameListをセット
        self.setListDataInListBox(listmodel1, listBox1, fromNames)
        self.setListDataInListBox(listmodel2, listBox2, toNames)
        #selNamesを選択表示
        n = 0
        for name in toNames:
            for selName in selNames:
                if name == selName:
                    path = (n)
                    listBox2.get_selection().select_path(path)
            n += 1

    def moveItemToListBoxStep(self, listBox1, listmodel1, listBox2, listmodel2):
        names = self.moveItemToListBox_sub(listBox1, listmodel1, listBox2, listmodel2)
        if len(names) == 0:
            return

        [selNames, fromNames, toNames] = names
        #新しいnameListをセット
        self.setListDataInListBoxStep(listmodel1, listBox1, fromNames)
        self.setListDataInListBoxStep(listmodel2, listBox2, toNames)
        #selNamesを選択表示
        toNames = self.sortBndList(toNames)
        n = 0
        for name in toNames:
            for selName in selNames:
                if name == selName:
                    path = (n)
                    listBox2.get_selection().select_path(path)
            n += 1

    def moveItemToListBox_sub(self, listBox1, listmodel1, listBox2, listmodel2):
        if listBox1.get_selection().get_mode() == Gtk.SelectionMode.MULTIPLE:
            #multiple selection の場合-----------
            (listmodel, pathList) = listBox1.get_selection().get_selected_rows()
            if len(pathList) == 0:
                title = _(u"groupの選択")
                mess = _(u"group名を選択してください")
                self.errDialog(title, mess)
                return []

            #選択しているselNamesを取得
            selNames = []
            names = self.getNamesInListmodel(listmodel)
            for path in pathList:
                selName = names[path[0]]
                selNames.append(selName)
        else:
            #single selection の場合---------------
            (listmodel, listIter) = listBox1.get_selection().get_selected()
            if listIter != None:
                selName = listmodel.get_value(listIter, 0)
            else:
                title = _(u"groupの選択")
                mess = _(u"group名を選択してください")
                self.errDialog(title, mess)
                return []

            selNames = [selName]
        ##元listBoxからselNameを削除
        names = self.getNamesInListmodel(listmodel1)
        fromNames = []
        for name in names:
            flag = 0
            for selName in selNames:
                if name == selName:
                    flag = 1
                    break
            if flag == 0:
                fromNames.append(name)
        #先listBoxにselNamesを追加
        names = self.getNamesInListmodel(listmodel2)
        toNames = names + selNames
        return [selNames, fromNames, toNames]

    #
    #  applyMaterial
    #  -------------
    #    setした内容をFistrModel.cntに設定する
    def applyMaterial(self, event):
        global matDefine, meshHeaderData
        #設定中dialog表示
        showSettingDialog("setting Material")
        #elGroupを取得
        names = self.getNamesInListmodel(self.listmodelDefMat)
        matDefine = []
        for name in names:
            matDefine.append([name, "", ""])
        #treeを表示
        addMatGroupInTreeData(names)
        treeList = [_(u"材料物性値")]
        self.showTreeData(treeList)
        #材料定義を修正
        lines = readFistrModelCnt()
        lines = deleteMaterialWithoutNames(lines, names)
        matNames = getMatNamesInCnt(lines)
        writeFistrModelCnt(lines)
        meshHeaderData = deleteMaterialWithoutNamesHeader(meshHeaderData, names)
        dummy_flag = deleteMaterialInSectionWithoutNames(matNames)
        #要素タイプを追加
        for headerData in meshHeaderData:
            line = headerData[0]
            if line[:len("!ELEMENT")] == "!ELEMENT":
                elType = abaqus2fistr.getValName(line, "TYPE")
            elif line[:len("!SECTION")] == "!SECTION":
                egrp = abaqus2fistr.getValName(line, "EGRP")
                for n in range(len(matDefine)):
                    if matDefine[n][0] == egrp:
                        matDefine[n][2] = elType
                        break
        numSettingDialog(90, "writing mesh file...")
        writeFistrModelMshHeader()
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  setEachMaterialTypeHard
    #  -----------------------
    #    材料タイプ、硬化則をcomboBoxに再セット
    def setEachMaterialTypeHard(self):
        matTypes = []
        matHards = []
        #matModel（材料モデル）を取得
        nIter = self.comboBox_matModel.get_active_iter()
        if nIter != None:
            matModel = self.comboBox_matModel.get_model()[nIter][0]
        else:
            matModel = materialType[0][0]
        for matMTH in materialType:
            if matModel == matMTH[0]:
                matTypes = matMTH[1]
                matHards = matMTH[2]
                break
        if len(matTypes) == 0:
            #self.comboBox_matType.clear()
            self.comboBox_matType.set_active_id(None)
            self.comboBox_matType.set_sensitive(False)
        else:
            self.comboBox_matType.set_sensitive(True)
            self.setComboDataInComboBox(self.listmodelMatType, self.comboBox_matType, matTypes)
            self.comboBox_matType.set_active(0)
        if len(matHards) == 0:
            #self.comboBox_matHard.clear()
            self.comboBox_matHard.set_active_id(None)
            self.comboBox_matHard.set_sensitive(False)
        else:
            self.comboBox_matHard.set_sensitive(True)
            self.setComboDataInComboBox(self.listmodelMatHard, self.comboBox_matHard, matHards)
            self.comboBox_matHard.set_active(0)
        #塑性ボタンのActive
        if matModel == "PLASTIC":
            self.button_ssData.set_sensitive(True)
        else:
            self.button_ssData.set_sensitive(False)

    #
    #  editPlasticSsData
    #  -----------------
    #    塑性data作成
    def editPlasticSsData(self, event):
        #matName = self.comboBox_matName.get_active_text()
        nIter = self.comboBox_matName.get_active_iter()
        if nIter != None:
            matName = self.comboBox_matName.get_model()[nIter][0]
        else:
            #if matName == None:
            title = _(u"エラー")
            mess = _(u"材料名が入力されていません。")
            self.errDialog(title, mess)
            return

        fileName = os.path.normpath(currDir + os.sep + matName + "_PlasticSSdata.csv")
        if len(glob.glob(fileName)) == 0:
            createPlasticSsDataFile(fileName)
        comm = runOfficeComm + " " + fileName
        pyFistr.runAppBG(comm)

    #
    #  showMaterialData
    #  ----------------
    #    設定した材料の物性値を表示
    def showMaterialData(self, event):
        #matName = self.comboBox_matName.get_active_text()
        nIter = self.comboBox_matName.get_active_iter()
        if nIter == None:
            title = _("エラー")
            mess = _(u"材料名が設定されていません。")
            self.errDialog(title, mess)
            return

        matName = self.comboBox_matName.get_model()[nIter][0]
        [elastic, heatVals] = getMaterialElasticValue(matName)
        #heats = [elastic[2]] + heatVals
        matValType = getMaterialValueType(matName)
        if len(matValType) == 2:
            mess  = "youngs        \t" + elastic[0] + ls
            mess += "poisson       \t" + elastic[1] + ls
            mess += "density       \t" + elastic[2] + ls
            mess += "linearexp     \t" + elastic[3] + ls
            mess += "thermal_cond. \t" + heatVals[0] + ls
            mess += "specific_heat \t" + heatVals[1] + ls
        elif matValType[0] == "elastic":
            mess  = "youngs        \t" + elastic[0] + ls
            mess += "poisson       \t" + elastic[1] + ls
            mess += "density       \t" + elastic[2] + ls
            mess += "linearexp     \t" + elastic[3] + ls
            if (anaType == "HEAT" or anaType == "HEAT_D"):
                mess += ls + _(u"解析の種類と設定されている物性値があっていません。")
                mess += ls + _(u"「設定」ボタンで設定し直してください。")
        elif matValType[0] == "heat":
            mess  = "density       \t" + elastic[2] + ls
            mess += "thermal_cond. \t" + heatVals[0] + ls
            mess += "specific_heat \t" + heatVals[1] + ls
            if (anaType == "STATIC" or anaType == "NLSTATIC"
                or anaType == "DYNAMIC" or anaType == "EIGEN"
                or anaType == "DYNAMIC_F"):
                mess += ls + _(u"解析の種類と設定されている物性値があっていません。")
                mess += ls + _(u"「設定」ボタンで設定し直してください。")
        title = _(u"材料の物性値")
        mess = _(u"材料DB内の ") + matName + _(u" の物性値   ") + ls + mess
        self.okDialog(title, mess)

    #
    #  applyEachMaterial
    #  -----------------
    #    各groupの材料を設定
    def applyEachMaterial(self):
        line = self.label_setMatGrp.get_text()
        elGroup = line.split(":")[1]
        #matName = self.comboBox_matName.get_active_text()
        nIter = self.comboBox_matName.get_active_iter()
        if nIter == None:
            title = _(u"エラー")
            mess = _(u"設定されている材料名は、材料データベース内に存在しません")
            self.errDialog(title, mess)
            return

        matName = self.comboBox_matName.get_model()[nIter][0]
        [elastic, heatVals] = getMaterialElasticValue(matName)
        #設定中dialog表示
        showSettingDialog("setting Each Material")
        #設定
        self.writeThicknessBeamDataInCnt(elGroup)
        #matModel = self.comboBox_matModel.get_active_text()
        nIter = self.comboBox_matModel.get_active_iter()
        matModel = self.comboBox_matModel.get_model()[nIter][0]
        if matModel == "HEAT":
            numSettingDialog(90, "writing meshFile...")
            self.setHeatMaterialValueInFile(elGroup, matName, elastic, heatVals)
            #設定dialog閉じる
            closeSettingDialog()
            return

        #Heat以外の材料定義
        matType = ""; matHard = ""
        if matModel != "ELASTIC":
            #matType = self.comboBox_matType.get_active_text()
            nIter = self.comboBox_matType.get_active_iter()
            if nIter == None:
                matType = ""
            else:
                matType = self.comboBox_matType.get_model()[nIter][0]
            #matHard = self.comboBox_matHard.get_active_text()
            nIter = self.comboBox_matHard.get_active_iter()
            if nIter == None:
                matHard = ""
            else:
                matHard = self.comboBox_matHard.get_model()[nIter][0]
        if matModel == "PLASTIC":
            ssData = getPlasticSsData(matName)
            if ssData == "":
                title = _(u"エラー")
                mess = _(u"塑性data（SS_curve）が入力されていません。")
                self.errDialog(title, mess)
                #設定dialog閉じる
                closeSettingDialog()
                return
            #cnt, mshファイルへ書き込み
            numSettingDialog(90, "writing meshFile...")
            writeFistrModelFile(elGroup, matName, elastic, matModel, matType,
                matHard, ssData)
        else:
            #cnt, mshファイルへ書き込み
            numSettingDialog(90, "writing meshFile...")
            writeFistrModelFile(elGroup, matName, elastic, matModel, matType,
                matHard, "")
        print (elGroup + ": " + matName + _(u" を設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #  writeThicknessBeamDataInCnt
    #    板厚を書き込む（shellの場合）
    def writeThicknessBeamDataInCnt(self, elGrp):
        for mat in matDefine:
            if mat[0] == elGrp:
                elType = mat[2]
                break
        newLine = ""
        if isThicknessElementType(elType) == True:
            tShell = self.textCtrl_tShell.get_text()
            nShell = self.textCtrl_nShell.get_text()
            newLine = tShell + ", " + nShell + ls
        elif isBeamElementType(elType) == True:
            Vx = self.textCtrl_beamVx.get_text()
            Vy = self.textCtrl_beamVy.get_text()
            Vz = self.textCtrl_beamVz.get_text()
            Area = self.textCtrl_beamArea.get_text()
            Iyy = self.textCtrl_beamIyy.get_text()
            Izz = self.textCtrl_beamIzz.get_text()
            Jx = self.textCtrl_beamJx.get_text()
            newLine = ", ".join([Vx, Vy, Vz, Area, Iyy, Izz, Jx]) + ls
        if newLine != "":
            global meshHeaderData
            for i in range(len(meshHeaderData)):
                line = meshHeaderData[i][0]
                if line[:len("!SECTION")] == "!SECTION":
                    name = pyFistr.getValName(line, "EGRP")
                    if name == elGrp:
                        meshHeaderData[i][1] = [newLine]
                        #writeFistrModelMshHeader()

    #  setHeatMaterialValueInFile
    #    HEAT解析の場合の材料設定
    def setHeatMaterialValueInFile(self, elGroup, matName, elastic, heatVals):
        writeHeatFistrModelFile(elGroup, matName, elastic, heatVals)
        print (elGroup + ": " + matName + _(u" を設定しました"))

    #
    #  setBCGroup
    #  ----------
    #    BOUNDARYのgroupを設定
    def setBCGroup(self, event):
        self.moveItemToListBox(self.listBox_noGroup, self.listmodelNoGroup,
                               self.listBox_setGroup, self.listmodelSetGroup)

    #
    #  returnBCGroup
    #  -------------
    #    BOUNDARYのgroupを戻す
    def returnBCGroup(self, event):
        self.moveItemToListBox(self.listBox_setGroup, self.listmodelSetGroup,
                               self.listBox_noGroup, self.listmodelNoGroup)

    #
    #  applyBCGroup
    #  ------------
    #    BCGroupを決定
    def applyBCGroup(self, event):
        global tempDefine, gravDefine, stepDefine
        #設定中dialog表示
        showSettingDialog("setting Select Groups")
        #stepIdを取得
        nStep = self.getStepIdFromItem()
        #設定
        itemName = self.boundaryFrameLabel.get_text()
        names = self.getNamesInListmodel(self.listmodelSetGroup)
        if itemName == u"TEMPERATURE":          #済み（手本）
            writeDefaultTemperatureInCnt(names, nStep)
            if len(names) != 0:
                values = self.readTemperatureValueFromCntMesh(names[0], nStep)
                if values[1] == "":         #iniTempを確認
                    writeDefaultInitialInMsh(names)     #未定義の場合、書き込み
            addTempGroupInTreeData(names, nStep)
            addInitialGroupInTreeData(names)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"TEMPERATURE（温度）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"TEMPERATURE（温度）")]
            self.showTreeData(treeList)
        elif itemName == u"BOUNDARY":           #済み
            addBndGroupInTreeData(names, nStep)
            writeDefaultBoundaryInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"BOUNDARY（変位）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"BOUNDARY（変位）")]
            self.showTreeData(treeList)
        elif itemName == u"CLOAD":              #済み
            addCloadGroupInTreeData(names, nStep)
            writeDefaultCloadInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"CLOAD（荷重）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"CLOAD（荷重）")]
            self.showTreeData(treeList)
        elif itemName == u"DLOAD":              #済み
            addDloadGroupInTreeData(names, nStep)
            writeDefaultDloadInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"DLOAD（圧力）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"DLOAD（圧力）")]
            self.showTreeData(treeList)
        elif itemName == u"VLOAD":              #済み
            addVloadGroupInTreeData(names, nStep)
            writeDefaultVloadInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"VLOAD（体積力）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"VLOAD（体積力）")]
            self.showTreeData(treeList)
        elif itemName == u"CENT":               #済み（手本）
            addCentGroupInTreeData(names, nStep)
            writeDefaultCentInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"CENT（遠心力）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"CENT（遠心力）")]
            self.showTreeData(treeList)
        elif itemName == u"GRAV":               #済み
            writeDefaultGravInCnt(names, nStep)
            addGravGroupInTreeData(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"GRAV（重力）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"GRAV（重力）")]
            self.showTreeData(treeList)
        elif itemName == u"SPRING":             #済み
            addSpringGroupInTreeData(names, nStep)
            writeDefaultSpringInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"SPRING（バネ要素）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"SPRING（バネ要素）")]
            self.showTreeData(treeList)
        elif itemName == u"FLOAD":              #済み（手本）
            addFloadGroupInTreeData(names, nStep)
            writeDefaultFloadInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"FLOAD（周期荷重）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"FLOAD（周期荷重）")]
            self.showTreeData(treeList)
        elif itemName == u"VELOCITY":           #済み
            addVeloGroupInTreeData(names, nStep)
            writeDefaultVeloInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"VELOCITY（速度）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"VELOCITY（速度）")]
            self.showTreeData(treeList)
        elif itemName == u"ACCELERATION":       #済み
            addAccelGroupInTreeData(names, nStep)
            writeDefaultAccelInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"ACCELERATION（加速度）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"ACCELERATION（加速度）")]
            self.showTreeData(treeList)
        elif itemName == u"FIXTEMP":            #済み
            addFixtempGroupInTreeData(names, nStep)
            writeDefaultFixtempInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"FIXTEMP（温度固定）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"FIXTEMP（温度固定）")]
            self.showTreeData(treeList)
        elif itemName == u"CFLUX":              #済み
            addCfluxGroupInTreeData(names, nStep)
            writeDefaultCfluxInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"CFLUX（集中熱量）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"CFLUX（集中熱量）")]
            self.showTreeData(treeList)
        elif itemName == u"SFLUX":              #済み
            addSfluxGroupInTreeData(names, nStep)
            writeDefaultSfluxInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"SFLUX（面熱流束）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"SFLUX（面熱流束）")]
            self.showTreeData(treeList)
        elif itemName == u"DFLUX":              #済み
            addDfluxGroupInTreeData(names, nStep)
            writeDefaultDfluxInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"DFLUX（内部発熱）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"DFLUX（内部発熱）")]
            self.showTreeData(treeList)
        elif itemName == u"SFILM":              #済み
            addSfilmGroupInTreeData(names, nStep)
            writeDefaultSfilmInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"SFILM（熱伝達率）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"SFILM（熱伝達率）")]
            self.showTreeData(treeList)
        elif itemName == u"SRADIATE":           #済み
            addSradiateGroupInTreeData(names, nStep)
            writeDefaultSradiateInCnt(names, nStep)
            if nStep == 0:
                treeList = [_(u"境界条件"), _(u"SRADIATE（輻射）")]
            else:
                treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"SRADIATE（輻射）")]
            self.showTreeData(treeList)
        elif itemName == u"output":
            #itemNameを取得
            outputItems = []
            for name in names:
                outputItems.append(name.split(":")[1])
            #outputの書き換え
            lines = readFistrModelCnt()
            i = pyFistr.getNextHeaderName(lines, 0, "!OUTPUT_RES", "")
            if i < len(lines):
                lines = pyFistr.delete1header(lines, i)
            else:
                i = pyFistr.getInsertPointInCnt(lines, "!OUTPUT_RES", ["Output"])
            addLines = ["!OUTPUT_RES" + ls]
            for item in outputItems:
                addLines += [item + ", ON" + ls]
            lines = lines[:i] + addLines + lines[i:]
            writeFistrModelCnt(lines)
            print (_(u"出力項目を設定しました"))
        elif itemName == u"INITIAL":            #変更せず
            addInitialGroupInTreeData(names)
            numSettingDialog(90, "writing mesh file...")
            writeDefaultInitialInMsh(names)
            treeList = [_(u"初期値（初期温度）")]
            self.showTreeData(treeList)
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyBoundaryCont
    #  -----------------
    #    BOUNDARY内容を決定
    def applyBoundaryCont(self, event):

        def isDummyNgrp(ngrpName, meshCont):
            ans = False
            lines = meshCont.split("\n")
            for line in lines:
                words = line.split()
                if len(words) > 2:
                    if words[0] == "NGRP" and words[1] == "dummy_" + ngrpName:
                        ans = True
            return ans

        #設定中dialog表示
        showSettingDialog("setting BOUNDARY")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        #設定
        ngrpName = self.getElGroupFromLabel(self.boundaryGrpLabel)
        bndCont = self.getBoundaryContFromTextBox()
        #cntファイルを要素typeに応じて修正
        meshCont = self.label_meshCnt.get_label()
        dummyNgrp = isDummyNgrp(ngrpName, meshCont)
        if dummyNgrp == False:
            #cntファイルをそのまま修正
            writeBoundaryContInCnt(ngrpName, bndCont, nStep)
            print (ngrpName + _(u"にBOUNDARYを設定しました"))
        else:
            #dummyNgrpも修正
            writeBoundaryContDummyInCnt(ngrpName, bndCont, nStep)
            print (ngrpName + ", dummy_" + ngrpName + _(u"にBOUNDARYを設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #  getBoundaryContFromTextBox
    def getBoundaryContFromTextBox(self):
        ans = []
        if self.checkBtn_bndX.get_active() == True:
            val = self.textCtrl_bndX.get_text()
            if val == "":
                val = "0.0"
            ans += ["1, 1, " + val + ls]
        if self.checkBtn_bndY.get_active() == True:
            val = self.textCtrl_bndY.get_text()
            if val == "":
                val = "0.0"
            ans += ["2, 2, " + val + ls]
        if self.checkBtn_bndZ.get_active() == True:
            val = self.textCtrl_bndZ.get_text()
            if val == "":
                val = "0.0"
            ans += ["3, 3, " + val + ls]
        if self.checkBtn_Rx.get_active() == True:
            val = self.textCtrl_Rx.get_text()
            if val == "":
                val = "0.0"
            ans += ["4, 4, " + val + ls]
        if self.checkBtn_Ry.get_active() == True:
            val = self.textCtrl_Ry.get_text()
            if val == "":
                val = "0.0"
            ans += ["5, 5, " + val + ls]
        if self.checkBtn_Rz.get_active() == True:
            val = self.textCtrl_Rz.get_text()
            if val == "":
                val = "0.0"
            ans += ["6, 6, " + val + ls]
        return ans

    #
    #  applyCloadCont
    #  --------------
    #    CLOAD内容を決定
    def applyCloadCont(self, event):

        def isDummyNgrp(ngrpName, meshCont):
            #dummyのngrpがあるかチェック
            ans = False
            lines = meshCont.split("\n")
            for line in lines:
                words = line.split()
                if len(words) > 2:
                    if words[0] == "NGRP" and words[1] == "dummy_" + ngrpName:
                        ans = True
                        break
            return ans

        #設定中dialog表示
        showSettingDialog("setting CLOAD")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        #設定
        ngrpName = self.getElGroupFromLabel(self.cloadGrpLabel)
        [cloadCont, valxyz] = self.getCloadContFromTextBox(ngrpName)
        #荷重の種類を読み取り
        forceType = self.getForceTypeOfCload()
        #荷重の種類に応じて値を修正
        cloadCont = self.changeForceForCload(cloadCont, ngrpName, forceType)
        #cntファイルを要素typeに応じて修正
        meshCont = self.label_meshCnt.get_label()
        dummyNgrp = isDummyNgrp(ngrpName, meshCont)
        if dummyNgrp == False:
            #cntファイルをそのまま修正
            writeCloadContInCnt(ngrpName, cloadCont, forceType, valxyz, nStep)
            print (ngrpName + _(u"に荷重を設定しました"))
        else:
            #dummyNgrpも修正
            writeCloadContDummyInCnt(ngrpName, cloadCont, forceType, valxyz, nStep)
            print (ngrpName + ", dummy_" + ngrpName + _(u"に荷重を設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #  getCloadContFromTextBox
    def getCloadContFromTextBox(self, ngrpName):
        #textBoxの値を取得
        valx = self.textCtrl_cloadX.get_text()
        if valx == "":
            valx = "0.0"
        valy = self.textCtrl_cloadY.get_text()
        if valy == "":
            valy = "0.0"
        valz = self.textCtrl_cloadZ.get_text()
        if valz == "":
            valz = "0.0"
        ans = []
        ans += ["1, " + valx + ls]
        ans += ["2, " + valy + ls]
        ans += ["3, " + valz + ls]
        if self.textCtrl_Mx.get_sensitive() == False:
            valMx = ""; valMy = ""; valMz = ""
        else:
            valMx = self.textCtrl_Mx.get_text()
            if valMx == "":
                valMx = "0.0"
            valMy = self.textCtrl_My.get_text()
            if valMy == "":
                valMy = "0.0"
            valMz = self.textCtrl_Mz.get_text()
            if valMz == "":
                valMz = "0.0"
            ans += ["4, " + valMx + ls]
            ans += ["5, " + valMy + ls]
            ans += ["6, " + valMz + ls]
        return [ans, [valx, valy, valz, valMx, valMy, valMz]]

    #  getForceTypeOfCload
    #    集中荷重の種類を取得
    def getForceTypeOfCload(self):
        forceType = "nodeForce"
        if self.radioBtn_aveForce.get_active() == True:
            forceType = "aveForce"
        elif self.radioBtn_trueForce.get_active() == True:
            forceType = "trueForce"
        return forceType

    #  changeForceForCload
    #    集中荷重の種類に応じて値を修正
    def changeForceForCload(self, cloadCont, ngrpName, forceType):
        if forceType == "nodeForce":
            #節点当たりの荷重の場合
            val = []
            for line in cloadCont:
                dummy = pyFistr.deleteSp(line)
                v = dummy.split(",")[1]
                val.append(v)
            print (_(u"各節点に(") + ", ".join(val) + _(u")をセットします"))
            return cloadCont

        elif forceType == "aveForce":
            #group内の合計荷重の場合
            #  group内のnode数を取得
            nNodes = getNodeNumOfNodeGroupInMesh(ngrpName)
            #  値をnode数で除した値に修正
            if nNodes != 0:
                val = []
                for i in range(len(cloadCont)):
                    line = cloadCont[i]
                    line = pyFistr.deleteSp(line)
                    words = line.split(",")
                    words[1] = str(float(words[1])/nNodes)
                    cloadCont[i] = ", ".join(words) + ls
                    val.append(words[1])
                mess = _(u"節点数:") + str(int(nNodes)) + "  各節点に(" + ", ".join(val)
                mess += _(u")をセットします")
                print (mess)
            else:
                title = _(u"エラー")
                mess = _(u"group内のnode数が取得できません") + ls
                mess += _(u"meshFile内に指定したNGROUP名が存在しないか、")
                mess += _(u"node数がセットされていません。") + ls
                mess += _(u"入力値は、「節点当たりの荷重」としてセットします")
                self.errDialog(title, mess)
            return cloadCont
        elif forceType == "trueForce":
            #均一な合計荷重の場合
            numSettingDialog(10, "reading mesh file...")
            xyzForce = []
            for i in range(len(cloadCont)):
                line = cloadCont[i]
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                xyzForce.append(words[1])
                words[1] = "0.0"
                cloadCont[i] = ", ".join(words) + ls
            numSettingDialog(90, "ending...")
            return cloadCont

    #
    #  applyDloadCont
    #  --------------
    #    DLOAD内容を決定
    def applyDloadCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting DLOAD")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        #設定
        sgrpName = self.getElGroupFromLabel(self.dloadGrpLabel)
        dload = self.textCtrl_dload.get_text()
        if dload == "":
            dload = "0.0"
        addLines =  ["!DLOAD, GRPID=1" + ls]
        addLines += [sgrpName + ", S, " + dload + ls] 
        writeDloadContInCnt(sgrpName, addLines, nStep)
        print (sgrpName + _(u"に面荷重を設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyVloadCont
    #  --------------
    #    VLOAD内容を決定
    def applyVloadCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting VLOAD")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        #設定
        egrpName = self.getElGroupFromLabel(self.vloadGrpLabel)
        values = []
        values.append(self.textCtrl_vloadBx.get_text())
        values.append(self.textCtrl_vloadBy.get_text())
        values.append(self.textCtrl_vloadBz.get_text())
        i = 0
        while i < 3:
            if deleteSp(values[i]) == "":
                values[i] == "0.0"
            i += 1
        addLines =  ["!DLOAD, GRPID=1" + ls]
        addLines += [egrpName + ", BX, " + values[0] + ls]
        addLines += [egrpName + ", BY, " + values[1] + ls]
        addLines += [egrpName + ", BZ, " + values[2] + ls]
        writeVloadContInCnt(egrpName, addLines, nStep)
        print (egrpName + _(u"にVLOADを設定しました"))        
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyGravCont
    #  -------------
    #    GRAV内容を設定
    def applyGravCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting GRAV")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        #設定
        setName = self.gravGrpLabel.get_text().split(":")[1]
        #GRAVを設定する
        ax = self.textCtrl_gravX.get_text()
        ay = self.textCtrl_gravY.get_text()
        az = self.textCtrl_gravZ.get_text()
        values = [ax, ay, az]
        i = 0
        while i < 3:
            if deleteSp(values[i]) == "":
                values[i] == "0.0"
            i += 1
        x=float(values[0]); y=float(values[1]); z=float(values[2])
        g = pow((x*x + y*y + z*z), 0.5)
        ag = str(g)
        if g != 0:
            ax=str(x/g); ay=str(y/g); az=str(z/g)
        else:
            ax="0.0"; ay="0.0"; az="0.0"
        addLines =  ["!DLOAD, GRPID=1" + ls]
        addLines += [setName + ", GRAV, " + ", ".join([ag, ax, ay, az]) + ls]
        writeGravContInCnt(setName, addLines, nStep)
        print (_(u"GRAVを設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyCentCont
    #  -------------
    #    CENT内容を決定
    def applyCentCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting CENT")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        #設定
        egrpName = self.getElGroupFromLabel(self.centGrpLabel)
        values = []
        values.append(self.textCtrl_centOm.get_text())
        values.append(self.textCtrl_centPx.get_text())
        values.append(self.textCtrl_centPy.get_text())
        values.append(self.textCtrl_centPz.get_text())
        values.append(self.textCtrl_centDx.get_text())
        values.append(self.textCtrl_centDy.get_text())
        values.append(self.textCtrl_centDz.get_text())
        i = 0
        while i < 7:
            if pyFistr.deleteSp(values[i]) == "":
                values[i] == "0.0"
            i += 1
        addLines =  ["!DLOAD, GRPID=1" + ls]
        addLines += [egrpName + ", CENT, " + ", ".join(values) + ls]
        writeCentContInCnt(egrpName, addLines, nStep)
        print (egrpName + _(u"にCENTを設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  switchUseResult
    #  ---------------
    #    熱解析結果を使用するかチェック
    def switchUseResult(self, event):
        if self.checkBtn_tempUseH.get_active() == False:
            #直接温度設定
            self.textCtrl_tempSet.set_sensitive(True)
            self.textCtrl_tempReadR.set_sensitive(False)
            self.textCtrl_tempSstep.set_sensitive(False)
            self.textCtrl_tempInterval.set_sensitive(False)
        else:
            #熱解析結果を使う
            self.textCtrl_tempSet.set_sensitive(False)
            self.textCtrl_tempReadR.set_sensitive(True)
            self.textCtrl_tempSstep.set_sensitive(True)
            self.textCtrl_tempInterval.set_sensitive(True)
            #元のcurrDirを取得
            currDir = getCurrDirFromTempFolder()
            os.chdir(currDir)
            #最終のstepNoを取得
            resFiles = glob.glob("FistrModel_temp.res.0.*")
            #環境を戻す
            currDir = currDirTemp
            os.chdir(currDirTemp)
            #stepNoを取得
            stepNos = []
            for resFile in resFiles:
                stepNo = resFile.split(".")[-1]
                try:
                    stepNos.append(int(stepNo))
                except:
                    pass
            if len(stepNos) == 0:
                maxStepNo = "1"
            else:
                stepNos.sort()
                maxStepNo = str(stepNos[-1])
            #値をセット
            if self.textCtrl_tempReadR.get_text() == "":
                if len(resFiles) > 0:
                    self.textCtrl_tempReadR.set_text(maxStepNo)
            if self.textCtrl_tempSstep.get_text() == "":
                if len(resFiles) > 0:
                    self.textCtrl_tempSstep.set_text(maxStepNo)
            if self.textCtrl_tempInterval.get_text() == "":
                if len(resFiles) > 0:
                    self.textCtrl_tempInterval.set_text("1")

    #
    #  applyTemperatureCont
    #  --------------------
    #    TEMPERATURE内容を設定
    def applyTemperatureCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting TEMPERATURE")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        #TEMPERATUREを設定する
        iniTemp = self.textCtrl_tempIni.get_text()
        temp = self.textCtrl_tempSet.get_text()
        readResult = self.textCtrl_tempReadR.get_text()
        sStep = self.textCtrl_tempSstep.get_text()
        interval = self.textCtrl_tempInterval.get_text()
        grpName = self.temperatureGrpLabel.get_text().split(":")[1]
        #入力データのチェック
        if iniTemp == "":
            iniTemp = "0.0"
        if temp == "":
            temp = "0.0"
        if self.checkBtn_tempUseH.get_active() == False:
            #通常の計算
            addLines =  ["!TEMPERATURE, GRPID=1" + ls]
            #hecmw_ctrlの修正
            remakeNormalHecmwCtrl()
        else:
            #元のcurrDirを取得
            currDir = getCurrDirFromTempFolder()
            os.chdir(currDir)
            #熱解析結果を使用
            heatResFiles = glob.glob("FistrModel_temp.res.0.*")
            #環境を戻す
            currDir = currDirTemp
            os.chdir(currDirTemp)
            if len(heatResFiles) == 0:
                #設定dialog閉じる
                closeSettingDialog()
                title = _(u"エラー")
                mess = _(u"熱伝導解析結果がありません") + ls
                mess += _(u"構造解析の前に熱伝導解析を行ってください")
                self.errDialog(title, mess)
                return

            if readResult == "" or sStep == "" or interval == "":
                #設定dialog閉じる
                closeSettingDialog()
                title = _(u"エラー")
                mess = _(u"熱伝導解析結果の読み込みに関するデータが入力されていません") + ls
                mess += _(u"データを入力してください")
                self.errDialog(title, mess)
                return

            addLines = ["!TEMPERATURE, READRESULT=" + readResult + ", SSTEP=" + sStep + ", INTERVAL=" + interval + ", GRPID=1" + ls]
            #hecmw_ctrlの修正
            remakeHeatResultIn()

        numSettingDialog(20, "writing mesh file...")
        addLines += [grpName + ", " + temp + ls]
        writeTemperatureContInCnt(grpName, addLines, nStep)
        numSettingDialog(50, "writing mesh file...")
        writeInitialContInMsh(grpName, iniTemp)        
        print (_(u"TEMPERATUREをセットしました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applySpringCont
    #  ---------------
    #    SPRING内容を設定する
    def applySpringCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting SPRING")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        #設定
        ngrpName = self.getElGroupFromLabel(self.label_springGrp)
        x = ""
        if self.checkBtn_springX.get_active() == True:
            x = self.textCtrl_springX.get_text()
        y = ""
        if self.checkBtn_springY.get_active() == True:
            y = self.textCtrl_springY.get_text()
        z = ""
        if self.checkBtn_springZ.get_active() == True:
            z = self.textCtrl_springZ.get_text()
        if x=="" and y=="" and z=="":
            #設定dialog閉じる
            closeSettingDialog()
            title = _(u"エラー")
            mess = _(u"データが入力されていません")
            self.errDialog(title, mess)
            return
        #該当部を削除
        lines = readFistrModelCnt()
        if nStep <= 0:
            #最初から検索
            i = 0
            ip = -1
            while i < len(lines):
                i = pyFistr.getNextHeaderName(lines, i, "!SPRING", "")
                if i < len(lines):
                    name = deleteSp(lines[i+1]).split(",")[0]
                    if name == ngrpName:
                        ip = i
                        break
                i += 1
            if ip >= 0:
                lines = pyFistr.delete1header(lines, i)
        else:
            #途中から検索
            ip = -1
            i = skipStepId(lines, nStep)
            while i < len(lines):
                if lines[i][0] == "!" or lines[i][0] == "#":
                    ip = i
                    break
                i += 1
            if ip >= 0:
                lines = pyFistr.delete1header(lines, i)
        #追加する行を作成
        addLines = ["!SPRING, GRPID=1" + ls]
        if x != "":
            addLines += [ngrpName + ", 1, " + x + ls]
        if y != "":
            addLines += [ngrpName + ", 2, " + y + ls]
        if z != "":
            addLines += [ngrpName + ", 3, " + z + ls]
        #行を追加
        i = pyFistr.getBndInsertPointInCnt(lines, "!SPRING", ["BOUNDARY", "Boundary", "boundary"], nStep)
        lines = lines[:i] + addLines + lines[i:]
        #GRPIDを修正
        lines = pyFistr.remakeGRPID(lines, "!SPRING")
        #書き込み
        writeFistrModelCnt(lines)
        print (ngrpName + _(u"にSPRINGをセットしました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  addContactCondition
    #  -------------------
    #    contactをlistboxに追加
    def addContactCondition(self, event):
        #定義済のnameを取得
        names = self.getNamesInListmodel(self.listmodelSetContact)
        usedNames = getUsedContactNamesInCnt()
        names += usedNames
        #newNameを取得
        i = 0
        flag = ""
        while flag != "end":
            same = "no"
            for name in names:
                if name == "CP" + str(i):
                    same = "yes"
            if same == "yes":
                i += 1
            else:
                flag = "end"
        newName = "CP" + str(i)
        names = self.getNamesInListmodel(self.listmodelSetContact)
        names.append(newName)
        names.sort()
        self.setListDataInListBox(self.listmodelSetContact, self.listBox_setContact, names)
        #newNameを選択表示
        n = 0
        for name in names:
            if name == newName:
                break
            n += 1
        path = (n,)
        self.listBox_setContact.get_selection().select_path(path)

    #
    #  deleteContactConditions
    #  -----------------------
    #    contactをlistboxから削除
    def deleteContactConditions(self, event):
        names = self.getNamesInListmodel(self.listmodelSetContact)
        (listModel, pathList) = self.listBox_setContact.get_selection().get_selected_rows()
        if len(pathList) == 0:
            title = _(u"エラー")
            mess = _(u"削除するpairNameを選択してください")
            self.errDialog(title, mess)
            return
        #選択している名前を取得
        selNames = []
        for path in pathList:
            selName = names[path[0]]
            selNames.append(selName)
        #残す名前を取得
        remNames = []
        for name in names:
            flag = 0
            for selName in selNames:
                if name == selName:
                    flag = 1
                    break
            if flag == 0:
                remNames.append(name)
        #残った名前を表示
        self.setListDataInListBox(listModel, self.listBox_setContact, remNames)
        return

    #
    #  applyContact
    #  ------------
    #    contactのpairNameを決定
    def applyContact(self, event):
        global meshHeaderData
        #設定中dialog表示
        showSettingDialog("setting Contact Pair")
        nStep = self.getStepIdFromItem()         #stepIdを取得
        #設定
        names = self.getNamesInListmodel(self.listmodelSetContact)
        lines = readFistrModelCnt()
        #現在のGRPIDを取得
        grpids = getGrpidInNames(lines, "!CONTACT", names)
        #現在のpairNamesを取得
        currPairNames = getBoundaryNodeGroupInCnt(lines, "!CONTACT")
        #不要なpairNameを削除
        delNames = []
        for currName in currPairNames[nStep]:
            flag = 0
            for name in names:
                if name == currName:
                    flag = 1
                    break
            if flag != 1:
                delNames.append(currName)
        meshHeaderData = deleteContactPairNameInMsh(meshHeaderData, delNames)
        deleteContactInCnt(delNames, nStep, "all")
        numSettingDialog(90, "writing mesh file...")
        writeFistrModelMshHeader()
        #新しいpairNamesを取得（cntファイルを再読み込み）
        lines = readFistrModelCnt()
        currPairNames = getBoundaryNodeGroupInCnt(lines, "!CONTACT")
        newPairNames = []
        for name in names:
            flag = 0
            for currName in currPairNames[nStep]:
                if name == currName:
                    flag = 1
                    break
            if flag == 0:
                newPairNames.append(name)
        #contact_Algoをチェック、無ければ追加
        i = 0
        flag = 0
        while i < len(lines):
            line = lines[i]
            if line[:len("!CONTACT_ALGO")] == "!CONTACT_ALGO":
                flag = 1
                break
            i += 1
        if flag == 0:
            #contact_Algoを追加
            ip = pyFistr.getInsertPointInCnt(lines, "!CONTACT_ALGO", ["Contact"])
            addLines =  ["!CONTACT_ALGO, TYPE=SLAGRANGE" + ls]
            lines = lines[:ip] + addLines + lines[ip:]
        #contact_Algoをセット
        #contactAlgo = self.comboBox_cntAlgo.get_active_text()
        nIter = self.comboBox_cntAlgo.get_active_iter()
        contactAlgo = self.comboBox_cntAlgo.get_model()[nIter][0]
        if contactAlgo[:len("SLAGRANGE")] == "SLAGRANGE":
            cntAlgo = "SLAGRANGE"
        elif contactAlgo[:len("ALAGRANGE")] == "ALAGRANGE":
            cntAlgo = "ALAGRANGE"
        else:
            cntAlgo = "ALAGRANGE"
        ip = pyFistr.getInsertPointInCnt(lines, "!CONTACT_ALGO", [])
        lines[ip] = abaqus2fistr.setValName(lines[ip], "TYPE="+cntAlgo)
        #defaultの新しいpairNamesを追加
        ip = pyFistr.getBndInsertPointInCnt(lines, "!CONTACT", ["Contact"], nStep)
        addLines = []
        for pairName in newPairNames:
            addLines += ["!CONTACT, GRPID=1, INTERACTION=FSLID, NTOL=1.0e-5, TTOL=1.0e-3" + ls]
            #addLines += [pairName + ", 0.0, 1.0e3" + ls]
            addLines += [pairName + ", 0.0, 1.0e5" + ls]
        lines = lines[:ip] + addLines + lines[ip:]
        #GRPIDを更新
        lines = pyFistr.remakeGRPID(lines, "!CONTACT")
        #STEP内のGRPIDを修正
        lines = remakeGrpidInStep(names, lines, "!CONTACT", grpids)
        #cntを保存
        writeFistrModelCnt(lines)
        #Treeを再作成
        global contactDefine
        contactDefine = getBoundaryNodeGroupInCnt(lines, "!CONTACT")
        addContactGroupInTreeData(contactDefine[nStep], nStep)
        if nStep == 0:
            treeList = [_(u"境界条件"), _(u"CONTACT（接触）")]
        else:
            treeList = [_(u"境界条件 ")+stepDefine[nStep], _(u"CONTACT（接触）")]
        self.showTreeData(treeList)
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyContactCont
    #  ----------------
    #    CONTACT内容を決定
    def applyContactCont(self, event):
        global meshHeaderData
        #設定中dialog表示
        showSettingDialog("setting CONTACT Condition")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        #設定
        newPairName = self.getElGroupFromLabel(self.contactGrpLabel)
        #slave = self.comboBox_cntSlave.get_active_text()
        nSlave = self.comboBox_cntSlave.get_active_iter()
        #master = self.comboBox_cntMaster.get_active_text()
        nMaster = self.comboBox_cntMaster.get_active_iter()
        if nSlave == None or nMaster == None:
            #設定dialog閉じる
            closeSettingDialog()
            title = _(u"エラー")
            mess = _(u"slave名、または、master名が入力されていません。")
            self.errDialog(title, mess)
            return
        
        slave = self.comboBox_cntSlave.get_model()[nSlave][0]
        master = self.comboBox_cntMaster.get_model()[nMaster][0]
        #interaction = self.comboBox_cntIntr.get_active_text()
        nIter = self.comboBox_cntIntr.get_active_iter()
        interaction = self.comboBox_cntIntr.get_model()[nIter][0]
        interaction = interaction.split()[0]
        nTol = self.textCtrl_cntNtol.get_text()
        tTol = self.textCtrl_cntTtol.get_text()
        #nPena = self.textCtrl_cntNpena.get_text()
        #tPena = self.textCtrl_cntTpena.get_text()
        coeff = self.textCtrl_cntCoeff.get_text()
        factor = self.textCtrl_cntFact.get_text()
        meshHeaderData = deleteContactPairNameInMsh(meshHeaderData, [selPairName])
        meshHeaderData = addContactPairNameInMsh(meshHeaderData, newPairName, slave, master)
        replaceContactInCnt(newPairName, interaction, nTol, tTol, coeff, factor, nStep)
        numSettingDialog(90, "writing mesh file...")
        writeFistrModelMshHeader()
        #Tree作成
        if newPairName != selPairName:
            #Treeを再作成
            global contactDefine
            newDefine = []
            for name in contactDefine:
                if name == selPairName:
                    newDefine.append(newPairName)
                else:
                    newDefine.append(name)
            contactDefine = newDefine
            addContactGroupInTreeData(contactDefine, nStep)
            treeList = [_(u"境界条件"), _(u"CONTACT（接触）"), newPairName]
            self.showTreeData(treeList)
        print (_(u"CONTACTを設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyFloadCont
    #  --------------
    #    FLOAD内容を決定
    def applyFloadCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting FLOAD")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        ngrpName = self.getElGroupFromLabel(self.floadGrpLabel)
        floadCont = self.getFloadContFromTextBox()
        writeFloadContInCnt(ngrpName, floadCont, nStep)
        print (ngrpName + _(u"にFLOADを設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #  getFloadContFromTextBox
    def getFloadContFromTextBox(self):
        loadCase = self.textCtrl_floadCase.get_text()
        x = self.textCtrl_floadX.get_text()
        y = self.textCtrl_floadY.get_text()
        z = self.textCtrl_floadZ.get_text()
        values = [loadCase, [x, y, z]]
        return values

    #
    #  applyVeloCont
    #  -------------
    #    VELOCITY内容を決定
    def applyVeloCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting VELOCITY")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        ngrpName = self.getElGroupFromLabel(self.label_veloGrp)
        if self.checkBtn_veloX.get_active() == False:
            x = ""
        else:
            x = self.textCtrl_veloX.get_text()
        if self.checkBtn_veloY.get_active() == False:
            y = ""
        else:
            y = self.textCtrl_veloY.get_text()
        if self.checkBtn_veloZ.get_active() == False:
            z = ""
        else:
            z = self.textCtrl_veloZ.get_text()
        writeVeloContInCnt(ngrpName, [x, y, z], nStep)
        print (ngrpName + _(u"にVELOCITYを設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyAccelCont
    #  --------------
    #    ACCELERATION内容を決定
    def applyAccelCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting ACCELERATION")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        ngrpName = self.getElGroupFromLabel(self.label_accelGrp)
        if self.checkBtn_accelX.get_active() == False:
            x = ""
        else:
            x = self.textCtrl_accelX.get_text()
        if self.checkBtn_accelY.get_active() == False:
            y = ""
        else:
            y = self.textCtrl_accelY.get_text()
        if self.checkBtn_accelZ.get_active() == False:
            z = ""
        else:
            z = self.textCtrl_accelZ.get_text()
        writeAccelContInCnt(ngrpName, [x, y, z], nStep)
        print (ngrpName + _(u"にACCELERATIONを設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyInitialCont
    #  ----------------
    #    INITIAL内容を決定
    def applyInitialCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting INITIAL")
        ngrpName = self.getElGroupFromLabel(self.label_initialGrp)
        iniTemp = self.textCtrl_initialTemp.get_text()
        numSettingDialog(90, "writing mesh file...")
        writeInitialContInMsh(ngrpName, iniTemp)        
        print (ngrpName + _(u"にINITIALTEMPを設定しました"))        
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyFixtempCont
    #  ----------------
    #    FIXTEMP内容を決定
    def applyFixtempCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting FIXTEMP")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        ngrpName = self.getElGroupFromLabel(self.label_fixtempGrp)
        fixtemp = self.textCtrl_fixtemp.get_text()
        writeFixtempContInCnt(ngrpName, fixtemp, nStep)        
        print (ngrpName + _(u"にFIXTEMPを設定しました"))        
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyCfluxCont
    #  --------------
    #    CFLUX内容を設定
    def applyCfluxCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting CFLUX")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        ngrpName = self.getElGroupFromLabel(self.label_cfluxGrp)
        value = self.textCtrl_cflux.get_text()
        #集中熱量の種類を読み取り
        qwType = self.getQwTypeOfCflux()
        #集中熱量の種類に応じて値を修正
        cfluxCont = self.changeQwForCflux(value, ngrpName, qwType)
        writeCfluxContInCnt(ngrpName, cfluxCont, qwType, value, nStep)
        print (ngrpName + _(u"にCFLUXを設定しました"))        
        #設定dialog閉じる
        closeSettingDialog()

    #  getQwTypeOfCflux
    #    集中熱量の種類を取得
    def getQwTypeOfCflux(self):
        qwType = "nodeQw"
        if self.radioBtn_aveQw.get_active() == True:
            qwType = "aveQw"
        elif self.radioBtn_trueQw.get_active() == True:
            qwType = "trueQw"
        return qwType

    #  changeQwForCflux
    def changeQwForCflux(self, value, ngrpName, qwType):
        if qwType == "nodeQw":
            print (_(u"各節点に(") + value + _(u")をセットします"))
            return value
        elif qwType == "aveQw":
            nNodes = getNodeNumOfNodeGroupInMesh(ngrpName)
            if nNodes != 0:
                value = str(float(value)/nNodes)
                mess = _(u"節点数:") + str(int(nNodes)) + "  各節点に(" + value
                mess += _(u")をセットします")
                print (mess)
            else:
                title = _(u"エラー")
                mess = _(u"group内のnode数が取得できません") + ls
                mess += _(u"meshFile内に指定したNGROUP名が存在しないか、")
                mess += _(u"node数がセットされていません。") + ls
                mess += _(u"入力値は、「節点当たりの熱量」としてセットします")
                self.errDialog(title, mess)
            return value
        elif qwType == "trueQw":
            numSettingDialog(10, "reading mesh file...")
            value = "0.0"
            numSettingDialog(90, "ending...")
            return value

    #
    #  applySfluxCont
    #  --------------
    #    SFLUX内容を設定
    def applySfluxCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting SFLUX")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        sgrpName = self.getElGroupFromLabel(self.label_sfluxGrp)
        value = self.textCtrl_sflux.get_text()
        writeSfluxContInCnt(sgrpName, value, nStep)
        print (sgrpName + _(u"にSFLUXを設定しました"))        
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyDfluxCont
    #  --------------
    #    DFLUX内容を設定
    def applyDfluxCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting DFLUX")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        egrpName = self.getElGroupFromLabel(self.label_dfluxGrp)
        value = self.textCtrl_dflux.get_text()
        writeDfluxContInCnt(egrpName, value, nStep)
        print (egrpName + _(u"にDFLUXを設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applySfilmCont
    #  --------------
    #    SFILM内容を設定
    def applySfilmCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting SFILM")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        sgrpName = self.getElGroupFromLabel(self.label_sfilmGrp)
        value = self.textCtrl_sfilmVal.get_text()
        ambTemp = self.textCtrl_sfilmAmb.get_text()
        writeSfilmContInCnt(sgrpName, [value, ambTemp], nStep)
        print (sgrpName + _(u"にSFILMを設定しました"))        
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applySradiateCont
    #  -----------------
    #    SRADIATE内容を設定
    def applySradiateCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting SRADIATE")
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        sgrpName = self.getElGroupFromLabel(self.label_sradiateGrp)
        value = self.textCtrl_sradiateVal.get_text()
        ambTemp = self.textCtrl_sradiateAmb.get_text()
        writeSradiateContInCnt(sgrpName, [value, ambTemp], nStep)
        print (sgrpName + _(u"にDRADIATEを設定しました"))        
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  setBCGroupForStep
    #  -----------------
    #    stepのgroupをセット
    def setBCGroupForStep(self, event):
        self.moveItemToListBoxStep(self.listBox_stepNoCnd, self.listmodelStepNoCnd,
                                   self.listBox_stepSetCnd, self.listmodelStepSetCnd)

    #
    #  returnBCGroupForStep
    #  --------------------
    #    stepのgroupを模です
    def returnBCGroupForStep(self, event):
        self.moveItemToListBoxStep(self.listBox_stepSetCnd, self.listmodelStepSetCnd,
                                   self.listBox_stepNoCnd, self.listmodelStepNoCnd)

    #
    #  applyStepCont
    #  -------------
    #    STEP内容を決定
    def applyStepCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting STEP")
        stepName = self.label_stepName.get_text()
        bndList = getStepBndListFromDefineData(stepName)
        #stepType = self.comboBox_stepType.get_active_text()
        nIter = self.comboBox_stepType.get_active_iter()
        stepType = self.comboBox_stepType.get_model()[nIter][0]
        converg = self.textCtrl_stepConv.get_text()
        subSteps = self.textCtrl_stepSubStep.get_text()
        maxIter = self.textCtrl_stepMaxIter.get_text()
        dTime = self.textCtrl_stepDtime.get_text()
        eTime = self.textCtrl_stepEtime.get_text()
        bnds = self.getNamesInListmodel(self.listmodelStepSetCnd)
        rBnds = reconstructStepBCCont(bnds, bndList)
        values = self.readStepNameValueFromCnt(stepName)
        #入れ替えるstepData内容を作成
        newLines =  ["!STEP, TYPE=" + stepType + ", CONVERG=" + converg + ", SUBSTEPS=" + subSteps + ", MAXITER=" + maxIter + ", stepName=" + stepName + ls]
        if values[7] == "DYNAMIC":
            newLines += [dTime + ", " + eTime + ls]
        for bnd in rBnds:
            newLines += [bnd]

        #全step内容を取得
        stepDataLines = self.readStepDataLinesFromCnt()
        #stepName内の境界条件を取得
        for stepData in stepDataLines:
            if stepData[0] == stepName:
                bnLines = []
                for line in stepData[1]:
                    if line[:len("!STEP")] == "!STEP":
                        break
                    else:
                        bnLines.append(line)
        addLines = bnLines + newLines
        addData = [stepName, addLines]

        #不要なstepNameを削除
        addStepDataLines = []
        for stepData in stepDataLines:
            if stepName != stepData[0]:
                addStepDataLines.append(stepData)
            else:
                addStepDataLines.append(addData)
        #入れ替えるstepLinesを作成
        newLines = []
        for stepData in addStepDataLines:
            newLines += stepData[1]

        #step内容を書き換える
        writeStepContInCnt(newLines) 
        print (_(u"STEPを設定しました"))       
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  addAmplitudeCont
    #  ----------------
    #    amplitudeをlistBoxに追加
    def addAmplitudeCont(self, event):
        job = self.label_ampName.get_text()
        if job == "AMPLITUDE":
            self.addAmpCont_sub("AMP")
        elif job == "STEP":
            self.addAmpCont_sub("STEP")

    def addAmpCont_sub(self, baseName):
        names = self.getNamesInListmodel(self.listmodelSetAmp)
        i = 0
        flag = ""
        while flag != "end":
            same = "no"
            for name in names:
                if name == baseName + str(i):
                    same = "yes"
            if same == "yes":
                i += 1
            else:
                flag = "end"
        newName = baseName + str(i)
        names.append(newName)
        names.sort()
        self.setListDataInListBox(self.listmodelSetAmp, self.listBox_setAmp, names)
        #newNameを選択表示
        n = 0
        for name in names:
            if name == newName:
                break
            n += 1
        path = (n,)
        self.listBox_setAmp.get_selection().select_path(path)

    #
    #  deleteAmplitudeCont
    #  -------------------
    #    amplitudeをlistBoxから削除
    def deleteAmplitudeCont(self, event):
        dummy_names = self.getNamesInListmodel(self.listmodelSetAmp)
        (listmodel, listIter) = self.listBox_setAmp.get_selection().get_selected()
        if listIter != None:
            dummy_delName = listmodel.get_value(listIter, 0)
        else:
            title = _(u"エラー")
            mess = _(u"削除するpairNameを選択してください")
            self.errDialog(title, mess)
            return
        listmodel.remove(listIter)
        self.listmodelSetAmp = listmodel

    #
    #  applyAmplitude
    #  --------------
    #    amplitudeを決定
    def applyAmplitude(self, event):
        job = self.label_ampName.get_text()
        if job == "AMPLITUDE":
            self.applyAmp_sub()
        elif job == "STEP":
            self.applyStep_sub()

    def applyAmp_sub(self):
        global meshHeaderData
        #設定中dialog表示
        showSettingDialog("setting Amplitude")
        names = self.getNamesInListmodel(self.listmodelSetAmp)
        #不要なampNameを削除（names以外のampを全て削除）
        deleteAmpWithoutNamesInCntMsh(names)
        #新しいampNameを取得
        currAmpNames = getAmpGroupInMsh()
        addNames = pyFistr.getNoGroups(names, currAmpNames)
        #defaultの新しいampNameをmshファイルに追加
        addHeaderData = []
        for addName in addNames:
            header = "!AMPLITUDE, NAME=" + addName + ls
            addData  = ["1.0, 0.0" + ls]
            addData += ["1.0, 0.1" + ls]
            addHeaderData.append([header, addData])
        meshHeaderData = meshHeaderData[:-1] + addHeaderData + meshHeaderData[-1:]
        numSettingDialog(90, "writing mesh file...")
        writeFistrModelMshHeader()
        #Treeを再作成
        global ampDefine
        ampDefine = getAmpGroupInMsh()
        addAmpGroupInTreeData(ampDefine)
        treeList = [_(u"時間変化")]
        self.showTreeData(treeList)
        #設定dialog閉じる
        closeSettingDialog()

    def applyStep_sub(self):
        global stepDefine
        #設定中dialog表示
        showSettingDialog("setting Step")
        #設定
        names = self.getNamesInListmodel(self.listmodelSetAmp)
        if len(names) == 0:
            stepDefine = []
            deleteStepContInCnt()
        else:
            stepDefine = []
            #全step内容を取得
            stepDataLines = self.readStepDataLinesFromCnt()
            #不要なstepNameを削除
            addStepDataLines = []
            for stepData in stepDataLines:
                stepName = stepData[0]
                if stepName in names:
                    addStepDataLines.append(stepData)
            #新しいstep内容を作成
            newStepDataLines = []
            for name in names:
                stepDefine.append(name)
                flag = 0
                for stepData in addStepDataLines:
                    stepName = stepData[0]
                    if name == stepName:
                        flag = 1
                        break
                if flag == 0:
                    line = "!STEP, TYPE=STATIC, CONVERG=1e-6, SUBSTEPS=1, MAXITER=1000, stepName=" + name + ls
                    newStepDataLines.append([name, [line]])
            #全てのstep内容を作成
            addStepDataLines += newStepDataLines
            addStepDataLines.sort()
            addLines = []
            for stepData in addStepDataLines:
                addLines += stepData[1]
            #step内容を置き換える
            writeStepContInCnt(addLines)
        self.setControlCont()                   #define変数を再取得
        addStepGroupInTreeData(names)           #TreeData作成
        self.setTreeFontColour(anaType)
        treeList = [_(u"ステップ解析")]
        self.showTreeData(treeList)
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  applyAmplitudeCont
    #  ------------------
    #    ampを設定
    def applyAmplitudeCont(self, event):
        global meshHeaderData
        #設定中dialog表示
        showSettingDialog("setting AMP")
        ampName = self.label_ampGrp.get_label().split(":")[1]
        setBnds = self.getNamesInListmodel(self.listmodelAmpSetGrp)
        valTypeNo = self.comboBox_ampValue.get_active()
        valType = "RELATIVE"
        if valTypeNo == 1:
            valType = "ABSOLUTE"
        #errorチェック
        fileName = ampName + "_ampData.csv"
        if len(glob.glob(fileName)) == 0:
            #設定dialog閉じる
            closeSettingDialog()
            title = _(u"エラー")
            mess = _(u"ampDataが入力されていません")
            self.errDialog(title, mess)
            return

        #cntファイルから設定しているamp名を削除
        lines = readFistrModelCnt()
        lines = deleteAmpNameInCnt(lines, ampName)
        #amp名をcntファイルにセット
        for setBnd in setBnds:
            i = searchSetBndInLines(lines, setBnd)
            if i < len(lines):
                lines[i] = abaqus2fistr.setValName(lines[i], "AMP="+ampName)
        writeFistrModelCnt(lines)
        #ampDataをmshファイルにセット
        ampData = getAmpDataInFile(fileName)
        meshHeaderData = setAmpDataInMsh(meshHeaderData, ampName, valType, ampData)
        numSettingDialog(90, "writing mesh file...")
        writeFistrModelMshHeader()
        print (ampName + _(u"を設定しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  editAmpData
    #  -----------
    #    ampData作成
    def editAmpData(self, event):
        ampName = self.label_ampGrp.get_label().split(":")[1]
        fileName = os.path.normpath(currDir + os.sep + ampName + "_ampData.csv")
        if len(glob.glob(fileName)) == 0:
            createAmpDataFile(ampName, fileName)
        comm = runOfficeComm + " " + fileName
        pyFistr.runAppBG(comm)

    #
    #  setAmpBndGrp
    #  ------------
    #    ampGrpのセット
    def setAmpBndGrp(self, event):
        self.moveItemToListBox(self.listBox_ampNoGrp, self.listmodelAmpNoGrp,
                               self.listBox_ampSetGrp, self.listmodelAmpSetGrp)

    #
    #  returnAmpBndGrp
    #  ---------------
    #    ampGrpの削除
    def returnAmpBndGrp(self, event):
        self.moveItemToListBox(self.listBox_ampSetGrp, self.listmodelAmpSetGrp,
                               self.listBox_ampNoGrp, self.listmodelAmpNoGrp)

    #
    #  switchParallel
    #  --------------
    #    single, parallelのswitch
    def switchParallel(self, event):
        [para, nCpu] = getParallelInSavedData()
        parallelSwitch = self.checkBtn_solvePara.get_active()
        if parallelSwitch == True:
            #parallelの設定
            loadHcmwPartCtrlDat()
            #[para, nCpu] = getHecmwContFromDat()
            setHecmwContFromDat(para, nCpu)
            saveIstrData(["parallel True " + nCpu])
            self.textCtrl_solveNcpu.set_text(nCpu)
            setParallelHcmwCtrlDat(nCpu)
            self.button_solveFistr.set_label((_(u"FrontISTR実行") + ls + _(u"  (並列)")))
        else:
            #singleの設定
            saveIstrData(["parallel False " + nCpu])
            hideHcmwPartCtrlDat()
            setSingleHcmwCtrlDat()
            self.button_solveFistr.set_label(_(u"FrontISTR実行"))

    #
    #  createMultiJob
    #  --------------
    #    meshを分割する
    def createMultiJob(self, event):
        global currDir
        [para, nCpu] = getHecmwContFromDat()
        if para == False:
            title = _(u"エラー")
            mess = _(u"hecmw_part_ctrl.datファイルがありません") + ls
            mess += _(u"並列処理をチェックしてください")
            self.errDialog(title, mess)
            return
        #現在の設定を保存
        nCpu = self.textCtrl_solveNcpu.get_text()
        saveIstrData(["parallel True " + nCpu])
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #datファイルを転送
        datFiles = ["hecmw_ctrl.dat", "hecmw_part_ctrl.dat"]
        for datFile in datFiles:
            shutil.copy(currDirTemp + os.sep + datFile, currDir)
        #mshファイルを転送
        copyMshFromTempToCurrDir()
        #分割メッシュが残っていれば削除
        delNames =glob.glob("FistrModel_p*") 
        if len(delNames) > 0:
            for name in delNames:
                os.remove(name)
        #nCpuをセット
        nCpu = self.textCtrl_solveNcpu.get_text()
        setHecmwContFromDat(para, nCpu)
        title = "separateMesh"
        comm = "hecmw_part1"
        commSet = "python3 " + pythonAppPath + "runCommandWithDialog2.py " + title + " " + comm
        pyFistr.runAppBG(commSet)

        #datFileを戻す
        for datFile in datFiles:
            shutil.copy(currDir + os.sep + datFile, currDirTemp)
        #tempの環境に戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #
    #  switchRestart
    #  -------------
    #    restartの設定
    def switchRestart(self, event):
        restart = self.checkBtn_solverRestart.get_active()
        setRestartInCnt(restart)

    #
    #  solveSet
    #  --------
    #    設定
    def solveSet(self, event):
        #設定中dialog表示
        showSettingDialog("setting SOLVE")
        #logの出力取得
        if self.checkBtn_solveIlog.get_active() == True:
            iterLog = "YES"
        else:
            iterLog = "NO"
        if self.checkBtn_solveTlog.get_active() == True:
            timeLog = "YES"
        else:
            timeLog = "NO"
        #出力間隔取得
        freq = self.textCtrl_solveFreq.get_text()
        #設定を書き込み
        setOutputLogInCnt(iterLog, timeLog, freq)
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  runFrontIstr
    #  ------------
    #    実行
    def runFrontIstr(self, event):
        global currDir
        #設定内容を読み込み
        [para, nCpu] = getHecmwContFromDat()
        solType = getSolutitionTypeFromCnt()
        execFile = self.textCtrl_solveFistr.get_text()
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #ファイルを転送
        #copyFilesFromTempToCurrDir()
        preComm = "python3 " + pythonAppPath + "copyFilesFromTempToCurrDir.py "
        preComm += currDirTemp + " " + currDir + ls
        
        #並列の設定
        if para == True:
            #並列の場合
            if os.name == "nt":
                #runComm = "mpiexec -np " + nCpu + " " + execFile + " > FistrModel.log"
                #runComm = "mpiexec -np " + nCpu + " " + execFile + " | safetee -o FistrModel.log"
                runComm = "python3 " + pythonAppPath + "commTee.py " + "mpiexec -np " + nCpu + " " + execFile + " FistrModel.log"
            else:
                runComm = "mpirun -np " + nCpu + " " + execFile + " | tee FistrModel.log"
            #エラーチェック
            meshes = glob.glob("FistrModel_p*")
            title = _(u"エラー")
            if len(meshes) == 0:
                mess = _(u"メッシュが並列計算用に分割されていません")
                self.errDialog(title, mess)
                return
            if len(meshes) != int(nCpu):
                mess = _(u"hecmw_part_ctrl.dat内のcpu数とメッシュ分割数が合致していません") + ls
                mess += _(u"メッシュは、") + str(len(meshes)) + _(u"分割されています")
                self.errDialog(title, mess)
                return
            if len(meshes) != int(self.textCtrl_solveNcpu.get_text()):
                mess = _(u"textBox内のcpu数とメッシュ分割数が合致していません") + ls
                mess += _(u"メッシュは、") + str(len(meshes)) + _(u"分割されています")
                self.errDialog(title, mess)
                return
        else:
            #シングル処理の場合
            if os.name == "nt":
                #runComm = execFile + " > FistrModel.log"
                #runComm = execFile + " | safetee -o FistrModel.log"
                runComm = "python3 " + pythonAppPath + "commTee.py " + execFile + " FistrModel.log"
            else:
                runComm = execFile + " | tee FistrModel.log"

        #実行
        if os.name == "nt":
            #windows
            if solType == "EIGEN":
                runComm += ls + "copy 0.log eigen_log" + ls + runEditorComm + " eigen_log"
            elif solType == "DYNAMIC_F":
                runComm += ls + "python3 " + binAppPath + "createFreqResponseFile.py"
            runComm = preComm + runComm
            f=open("run.bat", "w"); f.write(runComm); f.close()
            #runComm = "start /b cmd /c run\n"
            #runComm += "python3 " + pythonAppPath + "tail-f.py FistrModel.log"
            #f=open("runrun.bat", "w"); f.write(runComm); f.close()
            #comm = "start runrun"
            comm = "start run"
            os.system(comm)
        else:
            #linux
            if solType == "EIGEN":
                runComm += ls + "cp 0.log eigen_log" + ls + runEditorComm + " eigen_log"
            elif solType == "DYNAMIC_F":
                runComm += ls + "python3 " + binAppPath + "createFreqResponseFile.py"
            runComm = preComm + runComm
            comm = "echo '" + runComm + "' > run; chmod a+x run"
            os.system(comm)
            comm = "gnome-terminal -- bash --rcfile run &"
            os.system(comm)

        #tempの環境に戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #
    #  plotStepMonitor
    #  ---------------
    #    plotStepMonitorを起動
    def plotStepMonitor(self, event):
        global currDir
        #anaTypeを取得
        lines = readFistrModelCnt()
        anaType = getAnalysisTypeInCnt(lines)
        #anaTypeに応じてplotMonitorを起動
        if anaType == "NLSTATIC" or anaType == "DYNAMIC":
            self.runPlotMonitorForNlDy()
        elif anaType == "HEAT_D":
            self.runPlotMonitorForHeatDy()
        return

    #  runPlotMonitorForHeatDy()
    #    plotMonitor起動　熱解析（非定常）
    def runPlotMonitorForHeatDy(self):
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #plotMonitor開始
        if os.name == "nt":
            #windows
            runComm = "echo 'running plotStepMonitor...'" + ls
            runComm += "python3 " + binAppPath + "plotStepMonitorHeatDy.py"
            f=open("runPlotMonitorHeatDy.bat", "w"); f.write(runComm); f.close()
            runComm = "start runplotMonitorHeatDy.bat"
            os.system(runComm)
        else:
            #linux
            runComm = "echo 'running plotStepMonitor...'" + ls
            runComm += "python3 " + binAppPath + "plotStepMonitorHeatDy.py"
            f=open("runPlotMonitorHeatDy", "w"); f.write(runComm); f.close()
            comm = "chmod a+x runPlotMonitorHeatDy"
            os.system(comm)
            comm = "gnome-terminal -- ./runPlotMonitorHeatDy"
            os.system(comm)
        #環境を戻す
        os.chdir(currDirTemp)
        currDir = currDirTemp

    #  runPlotMonitorForNlDy
    #    plotMonitor起動　非線形、動解析の場合
    def runPlotMonitorForNlDy(self):
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #plotMonitor開始
        if os.name == "nt":
            #windows
            runComm = "echo 'running plotStepMonitor...'" + ls
            runComm += "python3 " + binAppPath + "plotStepMonitor.py"
            f=open("runPlotMonitor.bat", "w"); f.write(runComm); f.close()
            runComm = "start runplotMonitor.bat"
            os.system(runComm)
        else:
            #linux
            runComm = "echo 'running plotStepMonitor...'" + ls
            runComm += "python3 " + binAppPath + "plotStepMonitor.py"
            f=open("runPlotMonitor", "w"); f.write(runComm); f.close()
            comm = "chmod a+x runPlotMonitor"
            os.system(comm)
            #comm = "gnome-terminal -x ./runPlotMonitor"
            comm = "gnome-terminal -- ./runPlotMonitor".encode()
            os.system(comm)
        #環境を戻す
        os.chdir(currDirTemp)
        currDir = currDirTemp

    #
    #  applySolverCont
    #  ---------------
    #    solver内容を決定
    def applySolverCont(self, event):
        #設定中dialog表示
        showSettingDialog("setting SOLVER")
        #method = self.comboBox_slinMethod.get_active_text()
        nIter = self.comboBox_slinMethod.get_active_iter()
        method = self.comboBox_slinMethod.get_model()[nIter][0]
        precond = self.textCtrl_slinPrecond.get_text()
        nIter = self.textCtrl_slinNiter.get_text()
        resid = self.textCtrl_slinResid.get_text()
        lines = readFistrModelCnt()
        i = pyFistr.getNextHeaderName(lines, 0, "!SOLVER", "")
        lines[i] = abaqus2fistr.setValName(lines[i], "METHOD="+method)
        lines[i] = abaqus2fistr.setValName(lines[i], "PRECOND="+precond)
        i += 1
        words = deleteSp(lines[i]).split(",")
        words[0] = nIter
        lines[i] = ", ".join(words) + ls
        i += 1
        words = deleteSp(lines[i]).split(",")
        words[0] = resid
        lines[i] = ", ".join(words) + ls
        writeFistrModelCnt(lines)
        print (_(u"線形solverの設定を変更しました"))
        #設定dialog閉じる
        closeSettingDialog()

    #
    #  resultMerge
    #  -----------
    #    分散している結果を結合する
    def resultMerge(self, event):
        global currDir
        #解析typeを確認
        solType = getSolutitionTypeFromCnt()
        if solType == "EIGEN":
            resFileHeader = "FistrModel_eigen"
        elif solType == "HEAT" or solType == "HEAT_D":
            resFileHeader = "FistrModel_temp"
        else:
            resFileHeader = "FistrModel"
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #結果をmerge
        comm = self.getResultMergeComm(resFileHeader)
        if comm == "":
            title = _(u"エラー")
            mess = _(u"並列処理した計算結果ではありません")
            self.errDialog(title, mess)
            return
        title = "mergeResult"
        commSet = "python3 " + pythonAppPath + "runCommandWithDialog2.py " + title + ' "' + comm + '"'
        pyFistr.runAppBG(commSet)
        #環境を戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #  getResultMergeComm
    #    結果をmergeするcommを取得
    def getResultMergeComm(self, resFileHeader):
        #結果データの有無確認
        if len(glob.glob(os.path.normpath(currDir + os.sep + resFileHeader + ".res.1*"))) == 0:
            return ""
        #処理開始
        names = glob.glob(os.path.normpath(currDir + os.sep + resFileHeader + ".res.0*"))
        steps = []
        for name in names:
            step = int(name.split(".")[-1])
            steps.append(step)
        steps.sort()
        startStp = str(steps[0])
        endStp = str(steps[-1])
        if len(steps) > 1:
            nextStp = str(steps[1])
            stpInt = str(int(nextStp) - int(startStp))
            comm = "rmerge -s "+ startStp + " -e " + endStp + " -i " + stpInt + " " + resFileHeader + ".res.merge"
        else:
            comm = "rmerge -s "+ startStp + " -e " + endStp + " " + resFileHeader + ".res.merge"
        #pyFistr.runAppBG(comm)
        return comm

    #
    #  runRevocap
    #  ----------
    #    REVOCAOの起動
    def runRevocap(self, event):
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #REVOCAP実行        
        comm = runRevocapComm
        pyFistr.runAppBG(comm)
        #環境を戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #
    #  convertResultData
    #  -----------------
    #    結果fileをparaView用にデータ変換
    def convertResultData(self, event):
        global currDir
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #データ変換
        error = convertDataForParaview()
        if error != "":
            print (error)
            title = _(u"エラー")
            self.errDialog(title, error)
        #環境を戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #
    #  mergeConvertVtk
    #  ---------------
    #    merge & convert vtk
    def mergeConvertVtk(self, event):
        global currDir
        #解析typeを確認
        solType = getSolutitionTypeFromCnt()
        if solType == "EIGEN":
            resFileHeader = "FistrModel_eigen"
        elif solType == "HEAT" or solType == "HEAT_D":
            resFileHeader = "FistrModel_temp"
        else:
            resFileHeader = "FistrModel"
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #結果をmerge
        mergeComm = self.getResultMergeComm(resFileHeader)
        if mergeComm == "":
            title = _(u"エラー")
            mess = _(u"並列処理した計算結果ではありません")
            self.errDialog(title, mess)
            return
        mergeComm += ls
        #vtk変換
        pyFistr.removes("conv*.vtk")
        convComm = self.getConvertComm(resFileHeader)
        #実行ファイル作成
        comm = mergeComm + "echo\n" + convComm
        if os.name == "nt":
            #widowsの場合
            f=open("run.bat", "w"); f.write(comm); f.close()
        else:
            #linux
            runComm = "echo '" + comm + "' > run; chmod a+x run"
            os.system(runComm)
        #pyFistr.runAppBG("." + os.sep + "run")
        comm = "." + os.sep + "run"
        title = "convData"
        commSet = "python3 " + pythonAppPath + "runCommandWithDialog2.py " + title + ' "' + comm + '"'
        pyFistr.runAppBG(commSet)
        #環境を戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #  getConvertComm
    #    vtk変換用のcommを取得
    def getConvertComm(self, resFileHeader):
        #オプション「-u」付きで実行
        comm = "python3 -u " + binAppPath + "fistr2vtk.py -mesh FistrModel -res " + resFileHeader + ls
        resp = getFrequencyReactFromCnt()
        if resp == True:
            #周波数応答の場合、追加変換
            resFileHeader = "FistrModel_dyna"
            pyFistr.removes("conv"+resFileHeader+".res.*.vtk")
            #オプション「-u」付きで実行
            comm += "python3 -u " + binAppPath + "fistr2vtk.py -mesh FistrModel -res " + resFileHeader + ls
        return comm

    #
    #  runParaView
    #  -----------
    #    paraViewの起動
    def runParaView(self, event):
        global currDir
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #計算結果の内容を取得
        values = getHecmwContFromDat()
        parallel = values[0]
        fileHeader = "convFistrModel"
        if anaType == "EIGEN":
            fileHeader += "_eigen"
        elif anaType == "HEAT" or anaType== "HEAT_D":
            fileHeader += "_temp"
        fileHeader += ".res"
        if parallel == True:
            fileHeader += ".merge"
            para = u"有り"
        else:
            fileHeader += ".0"
            para = u"なし"
        fileNames = glob.glob(fileHeader + "*.vtk")
        if len(fileNames) == 0:
            fileName = ""
        elif len(fileNames) == 1:
            fileName = fileNames[0]
        else:
            fileName = fileHeader + "...vtk"
        print (u"解析:" +  anaType + u" 並列:" + para + u"  の結果「" + fileName + u"」を開きます。")
        #os.chdir(currDir)
        comm = runParaViewComm + " " + fileName
        pyFistr.runAppBG(comm)
        #環境を戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    #
    #  addPrincipalStress
    #  ------------------
    #    変換した結果データに主応力を追加
    def addPrincipalStress(self, event):
        #元のcurrDirを取得
        currDir = getCurrDirFromTempFolder()
        os.chdir(currDir)
        #主応力を追加
        comm = "python3 " + pythonAppPath + "addOutputItemsDialog2.py"
        pyFistr.runAppBG(comm)
        #環境を戻す
        currDir = currDirTemp
        os.chdir(currDirTemp)

    # ---------- handler end -----------------


    #
    #  getNameInTreeData
    #    path(タプル)からtreeDataのnameを取得
    def getNameInTreeData(self, path):
        tree = [treeData]
        name = ""
        for n in path:
            nTree = tree[n]
            #if type(nTree) == str or type(nTree) == unicode:
            if type(nTree) == str:
                name = nTree
            else:
                name = nTree[0]
                tree = nTree[1]
        ans = name
        return ans

    #
    #  getParentNameInTreeData
    #    path(タプル)からtreeDataのparentを取得
    def getParentNameInTreeData(self, path):
        dPath = []
        dPath = path
        parent = self.getNameInTreeData(dPath[:-1])
        return parent

    #
    #  selectItem
    #    Treeの項目選択
    def selectItem(self, event):
        treeCtrl = self.tree_main
        #treeStore = self.treestore
        path, dummy_column = treeCtrl.get_cursor()
        if path == None:
            path = []
        name = self.getNameInTreeData(path)
        parentName = self.getParentNameInTreeData(path)
        showPage = self.getShowPageName(parentName, name)
        if showPage == _(u"FistrModel"):
            self.setFistrModelPage()
        if showPage == _(u"材料物性値"):
            self.setElGroupToListBoxInMaterial()
        elif showPage == _(u"材料物性値_sub"):
            self.setElGroupToLabel(self.label_setMatGrp, name)
            matName = self.readSetEachMaterialName(name)
            self.readSetMaterialType(matName, name)
        elif showPage == _(u"BOUNDARY"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"BOUNDARY_sub"):
            self.setBoundary_sub(name)
        elif showPage == _(u"CLOAD"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"CLOAD_sub"):
            self.setCload_sub(name)
        elif showPage == _(u"DLOAD"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"DLOAD_sub"):
            self.setDload_sub(name)
        elif showPage == _(u"VLOAD"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"VLOAD_sub"):
            self.setVload_sub(name)
        elif showPage == _(u"GRAV"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"GRAV_sub"):
            self.setGravToListBox(name)
        elif showPage == _(u"CENT"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"CENT_sub"):
            self.setCent_sub(name)
        elif showPage == _(u"TEMPERATURE"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"TEMPERATURE_sub"):
            self.setTemperatureToListBox(name)
        elif showPage == _(u"SPRING"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"SPRING_sub"):
            self.setSpring_sub(name)
        elif showPage == _(u"contact"):
            self.setContactGroupToListBox()
        elif showPage == _(u"contact_sub"):
            self.setContact_sub(name)
        elif showPage == _(u"FLOAD"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"FLOAD_sub"):
            self.setFload_sub(name)
        elif showPage == _(u"VELOCITY"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"VELOCITY_sub"):
            self.setVelocity_sub(name)
        elif showPage == _(u"ACCELERATION"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"ACCELERATION_sub"):
            self.setAcceleration_sub(name)
        elif showPage == _(u"INITIAL"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"INITIAL_sub"):
            self.setInitial_sub(name)
        elif showPage == _(u"FIXTEMP"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"FIXTEMP_sub"):
            self.setFixtemp_sub(name)
        elif showPage == _(u"CFLUX"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"CFLUX_sub"):
            self.setCflux_sub(name)
        elif showPage == _(u"SFLUX"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"SFLUX_sub"):
            self.setSflux_sub(name)
        elif showPage == _(u"DFLUX"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"DFLUX_sub"):
            self.setDflux_sub(name)
        elif showPage == _(u"SFILM"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"SFILM_sub"):
            self.setSfilm_sub(name)
        elif showPage == _(u"SRADIATE"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"SRADIATE_sub"):
            self.setSradiate_sub(name)
        elif showPage == _(u"AMPLITUDE"):
            self.setAmpGroupToListBox()
        elif showPage == _(u"AMPLITUDE_sub"):
            self.setAmplitude_sub(name)
        elif showPage == _(u"step"):
            self.setStepGroupToListBox()
        elif showPage == _(u"step_sub"):
            self.setStep_sub(name)
        elif showPage == _(u"solver"):
            self.setSolverPage(name)
        elif showPage == _(u"solver_lin"):
            self.setSolverLinPage()
        elif showPage == _(u"output"):
            self.setBCGroupToListBox(showPage)
        elif showPage == _(u"solutionType"):
            self.setSolutionTypePage(name)
        elif showPage == _(u"solution_eigen"):
            self.setSolutionEigenPage()
        elif showPage == _(u"solution_dyna"):
            self.setSolutionDynaPage()
        elif showPage == _(u"solution_heatDyna"):
            self.setSolutionHeatDynaPage()
        self.showNoteBook(showPage)

    #  getShowPageName
    def getShowPageName(self, parentName, name):
        pageName = ""
        if parentName == _(u"材料物性値"):
            pageName = _(u"材料物性値_sub")
        elif parentName == _(u"初期値（初期温度）"):
            pageName = _(u"INITIAL_sub")
        elif parentName == _(u"BOUNDARY（変位）"):
            pageName = _(u"BOUNDARY_sub")
        elif parentName == _(u"CLOAD（荷重）"):
            pageName = _(u"CLOAD_sub")
        elif parentName == _(u"DLOAD（圧力）"):
            pageName = _(u"DLOAD_sub")
        elif parentName == _(u"VLOAD（体積力）"):
            pageName = _(u"VLOAD_sub")
        elif parentName == _(u"GRAV（重力）"):
            pageName = _(u"GRAV_sub")
        elif parentName == _(u"CENT（遠心力）"):
            pageName = _(u"CENT_sub")
        elif parentName == _(u"TEMPERATURE（温度）"):
            pageName = _(u"TEMPERATURE_sub")
        elif parentName == _(u"SPRING（バネ要素）"):
            pageName = _(u"SPRING_sub")
        elif parentName == _(u"CONTACT（接触）"):
            pageName = _(u"contact_sub")
        elif parentName == _(u"FLOAD（周期荷重）"):
            pageName = _(u"FLOAD_sub")
        elif parentName == _(u"VELOCITY（速度）"):
            pageName = _(u"VELOCITY_sub")
        elif parentName == _(u"ACCELERATION（加速度）"):
            pageName = _(u"ACCELERATION_sub")
        elif parentName == _(u"INITIAL（初期温度）"):
            pageName = _(u"INITIAL_sub")
        elif parentName == _(u"FIXTEMP（温度固定）"):
            pageName = _(u"FIXTEMP_sub")
        elif parentName == _(u"CFLUX（集中熱量）"):
            pageName = _(u"CFLUX_sub")
        elif parentName == _(u"SFLUX（面熱流束）"):
            pageName = _(u"SFLUX_sub")
        elif parentName == _(u"DFLUX（内部発熱）"):
            pageName = _(u"DFLUX_sub")
        elif parentName == _(u"SFILM（熱伝達率）"):
            pageName = _(u"SFILM_sub")
        elif parentName == _(u"SRADIATE（輻射）"):
            pageName = _(u"SRADIATE_sub")
        elif parentName == _(u"時間変化"):
            pageName = _(u"AMPLITUDE_sub")
        elif parentName == _(u"ステップ解析"):
            pageName = _(u"step_sub")
        elif parentName == _(u"解析の種類"):
            pageName = self.getSolutionPage()
        else:
            if name == _(u"solver"):
                pageName = _(u"solver") 
            elif name == _(u"FrontISTR analysis"):
                pageName = _("FrontISTR")
            elif name == _(u"FistrModel.msh"):
                pageName = _(u"FistrModel")
            elif name == _(u"解析の種類"):
                pageName = _(u"solutionType")
            elif name == _(u"初期値（初期温度）"):
                pageName = _(u"INITIAL")
            elif name == _(u"境界条件"):
                pageName = _(u"境界条件")
            elif name == _(u"材料物性値"):
                pageName = _(u"材料物性値")
            elif name == _(u"BOUNDARY（変位）"):
                pageName = _(u"BOUNDARY")
            elif name == _(u"CLOAD（荷重）"):
                pageName = _(u"CLOAD")
            elif name == _(u"DLOAD（圧力）"):
                pageName = _(u"DLOAD")
            elif name == _(u"VLOAD（体積力）"):
                pageName = _(u"VLOAD")
            elif name == _(u"GRAV（重力）"):
                pageName = _(u"GRAV")
            elif name == _(u"CENT（遠心力）"):
                pageName = _(u"CENT")
            elif name == _(u"post"):
                pageName = _(u"post")
            elif name == _(u"TEMPERATURE（温度）"):
                pageName = _(u"TEMPERATURE")
            elif name == _(u"SPRING（バネ要素）"):
                pageName = _(u"SPRING")
            elif name == _(u"CONTACT（接触）"):
                pageName = _(u"contact")
            elif name == _(u"FLOAD（周期荷重）"):
                pageName = _(u"FLOAD")
            elif name == _(u"VELOCITY（速度）"):
                pageName = _(u"VELOCITY")
            elif name == _(u"ACCELERATION（加速度）"):
                pageName = _(u"ACCELERATION")
            elif name == _(u"INITIAL（初期温度）"):
                pageName = _(u"INITIAL")
            elif name == _(u"FIXTEMP（温度固定）"):
                pageName = _(u"FIXTEMP")
            elif name == _(u"CFLUX（集中熱量）"):
                pageName = _(u"CFLUX")
            elif name == _(u"SFLUX（面熱流束）"):
                pageName = _(u"SFLUX")
            elif name == _(u"DFLUX（内部発熱）"):
                pageName = _(u"DFLUX")
            elif name == _(u"SFILM（熱伝達率）"):
                pageName = _(u"SFILM")
            elif name == _(u"SRADIATE（輻射）"):
                pageName = _(u"SRADIATE")
            elif name == _(u"時間変化"):
                pageName = _(u"AMPLITUDE")
            elif name == _(u"ステップ解析"):
                pageName = _(u"step")
            elif name == _(u"出力"):
                pageName = _(u"output")
            elif name == _(u"線形solver"):
                pageName = _(u"solver_lin")
        return pageName

    #
    #  showNoteBook
    #    pageを表示
    def showNoteBook(self, name):
        if name == u"TEMPERATURE":
            name = u"setGroup"
        elif name == u"GRAV":
            name = u"setGroup"
        elif name == u"BOUNDARY":
            name = u"setGroup"
        elif name == u"CLOAD":
            name = u"setGroup"
        elif name == u"DLOAD":
            name = u"setGroup"
        elif name == u"VLOAD":
            name = u"setGroup"
        elif name == u"CENT":
            name = u"setGroup"
        elif name == u"step":
            #name = u"setGroup"
            name = u"AMPLITUDE"
        elif name == u"SPRING":
            name = u"setGroup"
        elif name == u"FLOAD":
            name = u"setGroup"
        elif name == u"VELOCITY":
            name = u"setGroup"
        elif name == u"ACCELERATION":
            name = u"setGroup"
        elif name == u"INITIAL":
            name = u"setGroup"
        elif name == u"FIXTEMP":
            name = u"setGroup"
        elif name == u"CFLUX":
            name = u"setGroup"
        elif name == u"SFLUX":
            name = u"setGroup"
        elif name == u"DFLUX":
            name = u"setGroup"
        elif name == u"SFILM":
            name = u"setGroup"
        elif name == u"SRADIATE":
            name = u"setGroup"
        elif name == u"output":
            name = u"setGroup"
        #pageText = ""
        nPage = self.notebook_main.get_n_pages()
        i = 0
        while i < nPage:
            page = self.notebook_main.get_nth_page(i)
            pageName = self.notebook_main.get_tab_label_text(page)
            if pageName == name:
                self.notebook_main.set_current_page(i)
                break
            i += 1

    #
    #  setFistrModelPage
    #    モデルの倍率を表示
    def setFistrModelPage(self):
        scale = self.textCtrl_meshScale.get_text()
        if scale == "":
            #self.textCtrl_meshScale.set_text("1.0")
            scale = "1.0"
        self.textCtrl_meshScale.set_text(scale)

    #
    #  getSolutionPage
    #    solutionのpage名を取得
    def getSolutionPage(self):
        anaType = getSolutitionTypeFromCnt()
        if anaType == "EIGEN":
            page = "solution_eigen"     #固有値
        elif anaType == "DYNAMIC":
            page = "solution_dyna"      #動解析
        elif anaType == "DYNAMIC_F":
            page = "solution_dyna"      #周波数応答
        elif anaType == "HEAT_D":
            page = "solution_heatDyna"  #熱伝導（動解析）
        return page

    #
    #  setAmpGroupToListBox
    #
    def setAmpGroupToListBox(self):
        self.label_ampName.set_text("AMPLITUDE")
        self.label_ampTitle.set_text(_(u"時間変化（AMPLITUDE）の定義"))
        self.label_ampGrpName.set_text(_(u"設定するamp名"))
        msg  = _(u"amplitude定義を") + ls
        msg += _(u"「追加>>」ボタンで追加。") + ls
        msg += _(u"「<<削除」ボタンで削除。")
        self.label_ampMsg.set_text(msg)
        self.setListDataInListBox(self.listmodelSetAmp, self.listBox_setAmp,
                ampDefine)

    #
    #  setStepGroupToListBox
    #
    def setStepGroupToListBox(self):
        self.label_ampName.set_text("STEP")
        self.label_ampTitle.set_text(_(u"ステップ解析（step）の定義"))
        self.label_ampGrpName.set_text(_(u"設定するstep名"))
        msg  = _(u"step定義を") + ls
        msg += _(u"「追加>>」ボタンで追加。") + ls
        msg += _(u"「<<削除」ボタンで削除。")
        self.label_ampMsg.set_text(msg)
        self.setListDataInListBox(self.listmodelSetAmp, self.listBox_setAmp,
                stepDefine)

    #
    #  setContactGroupToListBox
    #
    def setContactGroupToListBox(self):
        #parameterの設定
        contactAlgos = [_(u"SLAGRANGE（Lagrange乗数法）"), _(u"ALAGRANGE（拡張Lagrange法）")]
        self.setComboDataInComboBox(self.listmodelCntPair, self.comboBox_cntAlgo,
            contactAlgos)
        selAlgo = getContactAlgoInCnt()
        selNo = 1
        if selAlgo == "SLAGRANGE":
            selNo = 0
        elif selAlgo == "ALAGRANGE":
            selNo = 1
        #stepIdを取得
        nStep = self.getStepIdFromItem()
        #contactDefineを取得
        global contactDefine
        lines = readFistrModelCnt()
        contactDefine = getBoundaryNodeGroupInCnt(lines, "!CONTACT")
        #textBoxに表示
        self.comboBox_cntAlgo.set_active(selNo)
        self.setListDataInListBox(self.listmodelSetContact, self.listBox_setContact,
                contactDefine[nStep])

    #
    #  setTemperatureToListBox
    #
    def setTemperatureToListBox(self, name):
        nStep = self.getStepIdFromSubItem()     #stepIdを取得
        values = self.readTemperatureValueFromCntMesh(name, nStep)
        heatResFiles = glob.glob("FistrModel_temp.res.0.*")
        line = _(u"（現在の熱伝導解析結果: ") + str(len(heatResFiles)) + " steps）"
        self.label_tempHres.set_label(line)
        self.setElGroupToLabel(self.temperatureGrpLabel, name)
        if nStep == 0:
            self.textCtrl_tempIni.set_sensitive(True)
        else:
            self.textCtrl_tempIni.set_sensitive(False)
        if len(values) == 0:
            temp = "0.0"
            iniTemp = "0.0"
            readResult = "1"
            sStep = "1"
            interval = "1"
            self.checkBtn_tempUseH.set_active(False)
            self.textCtrl_tempSet.set_sensitive(True)
            self.textCtrl_tempReadR.set_sensitive(False)
            self.textCtrl_tempSstep.set_sensitive(False)
            self.textCtrl_tempInterval.set_sensitive(False)
        else:
            temp = values[0]
            iniTemp = values[1]
            readResult = values[2]
            sStep = values[3]
            interval = values[4]
            if readResult == "":
                #直接温度設定
                self.checkBtn_tempUseH.set_active(False)
                self.textCtrl_tempSet.set_sensitive(True)
                self.textCtrl_tempReadR.set_sensitive(False)
                self.textCtrl_tempSstep.set_sensitive(False)
                self.textCtrl_tempInterval.set_sensitive(False)
            else:
                #熱解析結果を使用する
                self.checkBtn_tempUseH.set_active(True)
                self.textCtrl_tempSet.set_sensitive(False)
                self.textCtrl_tempReadR.set_sensitive(True)
                self.textCtrl_tempSstep.set_sensitive(True)
                self.textCtrl_tempInterval.set_sensitive(True)
        #値をセット
        self.textCtrl_tempIni.set_text(iniTemp)
        self.textCtrl_tempSet.set_text(temp)
        self.textCtrl_tempReadR.set_text(readResult)
        self.textCtrl_tempSstep.set_text(sStep)
        self.textCtrl_tempInterval.set_text(interval)

    #
    #  setGravToListBox
    #
    def setGravToListBox(self, name):
        nStep = self.getStepIdFromSubItem()     #stepIdを取得
        self.setElGroupToLabel(self.gravGrpLabel, name)
        values = self.readGravValueFromCnt(name, nStep)
        if len(values) == 0:
            #val = "0.0"
            ax = "0.0"
            ay = "0.0"
            az = "0.0"
        else:
            g = float(values[0])
            x = float(values[1])
            y = float(values[2])
            z = float(values[3])
            if g != 0:
                l = pow((x*x + y*y + z*z), 0.5)
                ax = str(x/l*g)
                ay = str(y/l*g)
                az = str(z/l*g)
            else:
                ax="0.0"; ay="0.0"; az="0.0"
        self.textCtrl_gravX.set_text(ax)
        self.textCtrl_gravY.set_text(ay)
        self.textCtrl_gravZ.set_text(az)

    #
    #  setSolutionTypePage
    #    solutionTypePageをセット
    def setSolutionTypePage(self, name):
        global anaType
        anaType = getSolutitionTypeFromCnt()
        self.setAnalysisTypeToComboBox()
        return

    #
    #  setSolutionHeatDynaPage
    #    熱伝導動解析のpageをセット
    def setSolutionHeatDynaPage(self):
        #dataを取得
        values = getHeatDinaContFromCnt()
        self.textCtrl_hdynaDt.set_text(values[0])
        self.textCtrl_hdynaEtime.set_text(values[1])
        self.textCtrl_hdynaDtmin.set_text(values[2])
        self.textCtrl_hdynaDmax.set_text(values[3])
        self.textCtrl_hdynaItmax.set_text(values[4])
        self.textCtrl_hdynaEps.set_text(values[5])
        if float(values[2]) <= 0.0:
            self.checkBtn_soluDt.set_active(True)
        else:
            self.checkBtn_soluDt.set_active(False)

    #
    #  setSolutionDynaPage
    #    動解析のpageをセット
    def setSolutionDynaPage(self):
        anaType = getSolutitionTypeFromCnt()
        if anaType == "DYNAMIC":
            self.setDynamicContToListBox()
        elif anaType == "DYNAMIC_F":
            self.setFreqResponseContToListBox()

    #
    #  setSolutionEigenPage
    #    固有値のpageをセット
    def setSolutionEigenPage(self):
        self.setEigenContToListBox()

    #
    #  setEigenContToListBox
    #    固有値解析の内容をセット
    def setEigenContToListBox(self):
        #dataを取得
        values = getEigenContFromCnt()
        if len(values) == 0:
            #defaultの値を設定
            values = defaultEigenSolutionCont()
        self.textCtrl_eigenNum.set_text(values[0])
        self.textCtrl_eigenPerm.set_text(values[1])
        self.textCtrl_eigenMaxiter.set_text(values[2])

    #
    #  setFreqResponseContToListBox
    #    周波数応答解析の内容をセット
    def setFreqResponseContToListBox(self):
        self.label_soldyTitle.set_text(_(u"周波数応答解析の設定"))
        defaultData = defaultFreqResponseSolutionCont()
        values = self.setDynamicContToListBox_sub(defaultData)
        visType = [_(u"1:モード空間"), _(u"2:物理空間")]
        self.setComboDataInComboBox(self.listmodelSoldyGroup, self.comboBox_soldyGroup, visType)
        if values[1][13] == "1":
            #self.comboBox_soldyGroup.child.set_text(visType[0])
            self.comboBox_soldyGroup.get_child().set_text(visType[0])
        else:
            #self.comboBox_soldyGroup.child.set_text(visType[1])
            self.comboBox_soldyGroup.get_child().set_text(visType[1])
        #file出力間隔を隠す
        self.textCtrl_soldyOutfile.set_sensitive(False)
        #開始・終了時間を表示する
        self.textCtrl_soldyStime.set_sensitive(True)
        self.textCtrl_soldyEtime.set_sensitive(True)
        self.textCtrl_soldySample.set_sensitive(True)
        #labelを修正
        self.label_soldySEtime.set_text(_(u"開始・終了 Hz"))
        self.label_soldyDtime.set_text(_(u"変位計算 Hz"))
        self.label_soldyGbeta.set_text(_(u"開始・終了時間"))
        self.label_soldyNewmark.set_text(_(u"実時間における"))
        self.label_soldyGroup.set_text(_(u"出力指定"))
        self.label_soldyOutdis.set_text(_(u" nodeID"))

    #
    #  setDynamicCont
    #    動解析の内容をセット
    def setDynamicContToListBox(self):
        self.label_soldyTitle.set_text(_(u"動解析の設定"))
        defaultData = defaultDynamicSolutionCont()
        values = self.setDynamicContToListBox_sub(defaultData)
        nodeGrp = meshGroup[2]
        self.setComboDataInComboBox(self.listmodelSoldyGroup, self.comboBox_soldyGroup, nodeGrp)
        entry = self.comboBox_soldyGroup.get_child()
        entry.set_text(values[1][13])
        #file出力間隔を隠す
        self.textCtrl_soldyOutfile.set_sensitive(False)
        #開始・終了時間を隠す
        self.textCtrl_soldyStime.set_sensitive(False)
        self.textCtrl_soldyEtime.set_sensitive(False)
        self.textCtrl_soldySample.set_sensitive(False)
        #labelを修正
        self.label_soldySEtime.set_text(_(u"開始・終了時間"))
        self.label_soldyDtime.set_text(_(u"時間増分"))
        self.label_soldyGbeta.set_text(_(u"ganma, beta"))
        self.label_soldyNewmark.set_text(_(u"Newmark-β法"))
        self.label_soldyGroup.set_text(_(u"group名"))
        self.label_soldyOutdis.set_text(_(u"出力間隔"))

    #  setDynamicContToListBox_sub
    #    textBoxにデータをセット
    def setDynamicContToListBox_sub(self, defaultData):
        #comboBoxをセット
        self.setComboDataInComboBox(self.listmodelSoldyType, self.comboBox_soldyType, [_(u"線形解析"), _(u"非線形解析")])
        self.setComboDataInComboBox(self.listmodelSoldyEqn, self.comboBox_soldyEqn, [_(u"陽解法（中央差分法）"), _(u"陰解法（Newmark-β法）")])
        #dataを取得
        values = getDynamicContFromCnt()
        if values[0] == "LINEAR" or values[0] == "NONLINEAR":
            pass
        else:
            values[0] == "LINEAR"
        if len(values[1]) == 21:
            pass
        else:
            values[1] = defaultData
        #線形・非線形
        self.comboBox_soldyType.set_active(0)
        if values[0] == "NONLINEAR":
            self.comboBox_soldyType.set_active(1)
        data = values[1]
        #運動方程式
        self.comboBox_soldyEqn.set_active(0)
        if data[0] != "11":
            self.comboBox_soldyEqn.set_active(1)
        #開始時間等
        self.textCtrl_soldyStime.set_text(data[2])
        self.textCtrl_soldyEtime.set_text(data[3])
        self.textCtrl_soldyAllstep.set_text(data[4])
        self.textCtrl_soldyDtime.set_text(data[5])
        self.textCtrl_soldyOutfile.set_text(values[2])
        #パラメータ
        self.textCtrl_soldyGanma.set_text(data[6])
        self.textCtrl_soldyBeta.set_text(data[7])
        self.textCtrl_soldyRm.set_text(data[10])
        self.textCtrl_soldyRk.set_text(data[11])
        #モニタ
        self.textCtrl_soldySample.set_text(data[12])
        self.textCtrl_soldyOutterm.set_text(data[14])
        self.checkBtn_soldyDis.set_active(False)
        self.checkBtn_soldyVelo.set_active(False)
        self.checkBtn_soldyAcc.set_active(False)
        self.checkBtn_soldyForce.set_active(False)
        self.checkBtn_soldyStrain.set_active(False)
        self.checkBtn_soldyStress.set_active(False)
        if data[15] == "1":
            self.checkBtn_soldyDis.set_active(True)
        if data[16] == "1":
            self.checkBtn_soldyVelo.set_active(True)
        if data[17] == "1":
            self.checkBtn_soldyAcc.set_active(True)
        if data[18] == "1":
            self.checkBtn_soldyForce.set_active(True)
        if data[19] == "1":
            self.checkBtn_soldyStrain.set_active(True)
        if data[20] == "1":
            self.checkBtn_soldyStress.set_active(True)
        return values

    #
    #  setSolverPage
    #
    def setSolverPage(self, name):
        values = getSolverContFromCnt()
        iterLog = values[4]
        timeLog = values[5]
        freq = values[6]
        restartFreq = values[7]
        if iterLog == "YES":
            self.checkBtn_solveIlog.set_active(True)
        else:
            self.checkBtn_solveIlog.set_active(False)
        if timeLog == "YES":
            self.checkBtn_solveTlog.set_active(True)
        else:
            self.checkBtn_solveTlog.set_active(False)
        #parallelの設定の読み込み
        [para, nCpu] = getParallelInSavedData()
        if para == "True":
            parallel = True
        else:
            parallel = False
        self.checkBtn_solvePara.set_active(parallel)
        self.textCtrl_solveNcpu.set_text(nCpu)
        self.textCtrl_solveFreq.set_text(freq)
        if self.checkBtn_solvePara.get_active() == True:
            self.button_solveFistr.set_label((_(u"FrontISTR実行") + ls + _(u"  (並列)")))
        else:
            self.button_solveFistr.set_label(_(u"FrontISTR実行"))
        #RESTARTの設定
        if int(restartFreq) < 0:
            #Restartの設定
            self.checkBtn_solverRestart.set_active(True)
        else:
            #Restartせず
            self.checkBtn_solverRestart.set_active(False)

    #
    #  setSolverLinPage
    #    線形solverのpage作成
    def setSolverLinPage(self):
        values = getSolverContFromCnt()
        method = values[0]
        precond = values[1]
        nIter = values[2]
        resid = values[3]
        solvers = solveMethod
        self.setComboDataInComboBox(self.listmodelSlinMethod, self.comboBox_slinMethod, solvers)
        self.setComboActiveText(self.comboBox_slinMethod, method, solvers)
        self.textCtrl_slinPrecond.set_text(precond)
        self.textCtrl_slinNiter.set_text(nIter)
        self.textCtrl_slinResid.set_text(resid)

    #
    #  setStep_sub
    #
    def setStep_sub(self, stepName):

        def getNoBnds(allBnds, cLines):
            noLines = []
            for allBnd in allBnds:
                newList = allBnd[:2] + [allBnd[-1]]
                allLine = ",".join(newList)
                flag = 0
                for cLine in cLines:
                    if allLine == cLine:
                        flag = 1
                        break
                if flag == 0:
                    noLines.append(allLine)
            return noLines

        self.label_stepName.set_text(stepName)
        #bndList = getBndListFromDefineData()
        bndList = getStepBndListFromDefineData(stepName)
        stepTypes = [u"STATIC", u"VISCO"]
        self.setComboDataInComboBox(self.listmodelStepType, self.comboBox_stepType, stepTypes)
        #values = self.readStepValueFromCnt()
        values = self.readStepNameValueFromCnt(stepName)
        stepType = values[0]
        converg = values[1]
        subSteps = values[2]
        maxIter = values[3]
        dTime = values[4]
        eTime = values[5]
        bnds = values[6]
        solutionType = values[7]
        cBnds = reformStepBCCont(bnds, bndList)
        cBnds = pyFistr.deleteSameData(cBnds)
        noBnds = getNoBnds(bndList, cBnds)
        noBnds = pyFistr.deleteSameData(noBnds)
        self.setComboActiveText(self.comboBox_stepType, stepType, stepTypes)
        self.textCtrl_stepConv.set_text(converg)
        self.textCtrl_stepSubStep.set_text(subSteps)
        self.textCtrl_stepMaxIter.set_text(maxIter)
        if solutionType == "DYNAMIC":
            self.textCtrl_stepDtime.set_sensitive(True)
            self.textCtrl_stepEtime.set_sensitive(True)
            self.textCtrl_stepDtime.set_text(dTime)
            self.textCtrl_stepEtime.set_text(eTime)
        else:
            self.textCtrl_stepDtime.set_sensitive(False)
            self.textCtrl_stepEtime.set_sensitive(False)
        self.setListDataInListBoxStep(self.listmodelStepNoCnd, self.listBox_stepNoCnd, noBnds)
        self.setListDataInListBoxStep(self.listmodelStepSetCnd, self.listBox_stepSetCnd, cBnds)

    #
    #  setContact_sub
    #
    def setContact_sub(self, name):
        global selPairName
        nStep = self.getStepIdFromSubItem()     #stepIdを取得
        #pairNameを取得
        self.setElGroupToLabel(self.contactGrpLabel, name)
        selPairName = name
        #conts（接触の設定を取得）
        conts = getContactContInCntMsh(name, nStep)
        slave = conts[0]
        master = conts[1]
        interaction = conts[2]
        nTol = conts[3]
        tTol = conts[4]
        coeff = conts[5]
        factor = conts[6]
        interactions = [u"SSLID （微小すべり）", u"FSLID （有限すべり）"]
        self.setComboDataInComboBox(self.listmodelCntIntr, self.comboBox_cntIntr, interactions)
        n = 0
        for name in interactions:
            if name.split()[0] == interaction:
                break
            n += 1
        self.comboBox_cntIntr.set_active(n)
        self.textCtrl_cntNtol.set_text(nTol)
        self.textCtrl_cntTtol.set_text(tTol)
        self.textCtrl_cntCoeff.set_text(coeff)
        self.textCtrl_cntFact.set_text(factor) 
        #slave側を設定
        slaveNames = meshGroup[2]
        slaveNames.sort()
        self.setComboDataInComboBox(self.listmodelCntSlave, self.comboBox_cntSlave, slaveNames)
        n = 0
        for name in slaveNames:
            if name == slave:
                break
            n += 1
        self.comboBox_cntSlave.set_active(n)
        #master側を設定
        masterNames = meshGroup[1]
        masterNames.sort()
        self.setComboDataInComboBox(self.listmodelCntMaster, self.comboBox_cntMaster, masterNames)
        n = 0
        for name in masterNames:
            if name == master:
                break
            n += 1
        self.comboBox_cntMaster.set_active(n)

    #
    #  setCent_sub
    #
    def setCent_sub(self, name):
        nStep = self.getStepIdFromSubItem()     #stepIdを取得
        self.setElGroupToLabel(self.centGrpLabel, name)
        values = self.readCentEgrpName(name, nStep)
        self.textCtrl_centOm.set_text(values[0])
        self.textCtrl_centPx.set_text(values[1])
        self.textCtrl_centPy.set_text(values[2])
        self.textCtrl_centPz.set_text(values[3])
        self.textCtrl_centDx.set_text(values[4])
        self.textCtrl_centDy.set_text(values[5])
        self.textCtrl_centDz.set_text(values[6])

    #
    #  setSpring_sub
    #
    def setSpring_sub(self, name):
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        self.setElGroupToLabel(self.label_springGrp, name)
        [x, y, z] = self.readSpringValueFromCont(name, nStep)
        if x == "":
            self.checkBtn_springX.set_active(False)
            self.textCtrl_springX.set_text("0.0")
        else:
            self.checkBtn_springX.set_active(True)
            self.textCtrl_springX.set_text(x)
        if y == "":
            self.checkBtn_springY.set_active(False)
            self.textCtrl_springY.set_text("0.0")
        else:
            self.checkBtn_springY.set_active(True)
            self.textCtrl_springY.set_text(y)
        if z == "":
            self.checkBtn_springZ.set_active(False)
            self.textCtrl_springZ.set_text("0.0")
        else:
            self.checkBtn_springZ.set_active(True)
            self.textCtrl_springZ.set_text(z)

    #
    #  setVload_sub
    #
    def setVload_sub(self, name):
        nStep = self.getStepIdFromSubItem()     #stepIdを取得
        self.setElGroupToLabel(self.vloadGrpLabel, name)
        values = self.readVloadEgrpName(name, nStep)
        self.textCtrl_vloadBx.set_text(values[0])
        self.textCtrl_vloadBy.set_text(values[1])
        self.textCtrl_vloadBz.set_text(values[2])

    #
    #  setDload_sub
    #    pageの初期化
    def setDload_sub(self, name):
        nStep = self.getStepIdFromSubItem()
        self.setElGroupToLabel(self.dloadGrpLabel, name)
        values = self.readDloadSgrpName(name, nStep)
        self.textCtrl_dload.set_text(values[0])

    #
    #  setAcceleration_sub
    #    pageの初期化
    def setAcceleration_sub(self, name):
        nStep = self.getStepIdFromSubItem()     #stepIdを取得
        self.setElGroupToLabel(self.label_accelGrp, name)
        [x, y, z] = self.readAccelNgrpName(name, nStep)
        if x == "":
            self.checkBtn_accelX.set_active(False)
        else:
            self.checkBtn_accelX.set_active(True)
        if y == "":
            self.checkBtn_accelY.set_active(False)
        else:
            self.checkBtn_accelY.set_active(True)
        if z == "":
            self.checkBtn_accelZ.set_active(False)
        else:
            self.checkBtn_accelZ.set_active(True)
        self.textCtrl_accelX.set_text(x)
        self.textCtrl_accelY.set_text(y)
        self.textCtrl_accelZ.set_text(z)

    #
    #  setVelocity_sub
    #    pageの初期化
    def setVelocity_sub(self, name):
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        self.setElGroupToLabel(self.label_veloGrp, name)
        [x, y, z] = self.readVeloNgrpName(name, nStep)
        if x == "":
            self.checkBtn_veloX.set_active(False)
        else:
            self.checkBtn_veloX.set_active(True)
        if y == "":
            self.checkBtn_veloY.set_active(False)
        else:
            self.checkBtn_veloY.set_active(True)
        if z == "":
            self.checkBtn_veloZ.set_active(False)
        else:
            self.checkBtn_veloZ.set_active(True)
        self.textCtrl_veloX.set_text(x)
        self.textCtrl_veloY.set_text(y)
        self.textCtrl_veloZ.set_text(z)

    #
    #  setFload_sub
    #    pageの初期化
    def setFload_sub(self, name):
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        self.setElGroupToLabel(self.floadGrpLabel, name)
        values = self.readFloadNgrpName(name, nStep)
        loadCase = values[0]
        [x, y, z] = values[1]
        self.textCtrl_floadCase.set_text(loadCase)
        self.textCtrl_floadX.set_text(x)
        self.textCtrl_floadY.set_text(y)
        self.textCtrl_floadZ.set_text(z)

    #
    #  setAmplitude_sub
    #    pageの初期化
    def setAmplitude_sub(self, name):

        def getNoBnds(allBnds, setBnds):
            noBnds = []
            for allBnd in allBnds:
                newList = allBnd[:2] + [allBnd[-1]]
                allLine = ",".join(newList)
                flag = 0
                for sLine in setBnds:
                    #sLine = ",".join(setBnd)
                    if allLine == sLine:
                        flag = 1
                        break
                if flag == 0:
                    noBnds.append(allLine)
            return noBnds

        self.setElGroupToLabel(self.label_ampGrp, name)
        setValues = ampValTypes()
        self.setComboDataInComboBox(self.listmodelAmpValue, self.comboBox_ampValue, setValues)
        value = self.readAmpGrpNameInMsh(name)
        setBndList = self.readAmpGrpNameInCnt(name)
        setBndList.sort()
        i = 0
        if value == "ABSOLUTE":
            i = 1
        self.comboBox_ampValue.set_active(i)
        #allBndList = getBndListFromDefineData()
        allBndList = getAllStepBndListFromDefineData()
        #STEPがあれば追加
        allBndList += getStepListFromCnt()
        noBndList = getNoBnds(allBndList, setBndList)
        noBndList.sort()
        self.setListDataInListBox(self.listmodelAmpNoGrp, self.listBox_ampNoGrp, noBndList)
        self.setListDataInListBox(self.listmodelAmpSetGrp, self.listBox_ampSetGrp, setBndList)

    #
    #  setSradiate_sub
    #    pageの初期化
    def setSradiate_sub(self, name):
        nStep = self.getStepIdFromSubItem()     #stepIdを取得
        self.setElGroupToLabel(self.label_sradiateGrp, name)
        values = self.readSradiateEgrpName(name, nStep)
        self.textCtrl_sradiateVal.set_text(values[0])
        self.textCtrl_sradiateAmb.set_text(values[1])


    #
    #  setSfilm_sub
    #    pageの初期化
    def setSfilm_sub(self, name):
        nStep = self.getStepIdFromSubItem()     #stepIdを取得
        self.setElGroupToLabel(self.label_sfilmGrp, name)
        values = self.readSfilmEgrpName(name, nStep)
        self.textCtrl_sfilmVal.set_text(values[0])
        self.textCtrl_sfilmAmb.set_text(values[1])

    #
    #  setDflux_sub
    #    pageの初期化
    def setDflux_sub(self, name):
        nStep = self.getStepIdFromSubItem()        #stepIdを取得
        self.setElGroupToLabel(self.label_dfluxGrp, name)
        value = self.readDfluxEgrpName(name, nStep)
        self.textCtrl_dflux.set_text(value)

    #
    #  setSflux_sub
    #    pageの初期化
    def setSflux_sub(self, name):
        nStep = self.getStepIdFromSubItem()     #stepId取得
        self.setElGroupToLabel(self.label_sfluxGrp, name)
        value = self.readSfluxNgrpName(name, nStep)
        self.textCtrl_sflux.set_text(value)

    #
    #  setCflux_sub
    #    pageの初期化
    def setCflux_sub(self, name):
        nStep = self.getStepIdFromSubItem()     #stepIdを取得
        self.setElGroupToLabel(self.label_cfluxGrp, name)
        [value, qwType] = self.readCfluxNgrpName(name, nStep)
        if qwType == "aveQw":
            self.radioBtn_aveQw.set_active(True)
        elif qwType == "trueQw":
            self.radioBtn_trueQw.set_active(True)
        else:
            self.radioBtn_nodeQw.set_active(True)
        self.textCtrl_cflux.set_text(value)

    #
    #  setInitial_sub
    #    pageの初期化
    def setInitial_sub(self, name):
        self.setElGroupToLabel(self.label_initialGrp, name)
        value = self.readInitialNgrpName(name)
        self.textCtrl_initialTemp.set_text(value)

    #
    #  setFixtemp_sub
    #    pageの初期化
    def setFixtemp_sub(self, name):
        nStep = self.getStepIdFromSubItem()         #stepIdを取得
        self.setElGroupToLabel(self.label_fixtempGrp, name)
        value = self.readFixtempNgrpName(name, nStep)
        self.textCtrl_fixtemp.set_text(value)

    #
    #  setCload_sub
    #    pageの初期化
    def setCload_sub(self, name):
        #stepIdを取得
        nStep = self.getStepIdFromSubItem()
        #labelをセット
        self.setElGroupToLabel(self.cloadGrpLabel, name)
        #値を取得
        [[x, y, z, Mx, My, Mz], forceType] = self.readCloadNgrpName(name, nStep)
        meshCont = self.label_meshCnt.get_label()
        rotation = getRotationNodeGroup(name, meshCont)
        if rotation == True:
            self.showRotationCloadValue()
        else:
            self.hideRotationCloadValue()
            Mx = []; My = []; Mz = []
        self.setCloadContToTextBox([x, y, z, Mx, My, Mz], forceType, name)

    #  showRotationCloadValue
    #    Cloadの回転のtextBoxを表示する
    def showRotationCloadValue(self):
        self.textCtrl_Mx.set_sensitive(True)
        self.textCtrl_My.set_sensitive(True)
        self.textCtrl_Mz.set_sensitive(True)
        self.label_Mx.set_sensitive(True)
        self.label_My.set_sensitive(True)
        self.label_Mz.set_sensitive(True)


    #  hideRotationCloadValue
    #    Cloadの回転のtextBoxを隠す
    def hideRotationCloadValue(self):
        self.textCtrl_Mx.set_sensitive(False)
        self.textCtrl_My.set_sensitive(False)
        self.textCtrl_Mz.set_sensitive(False)
        self.label_Mx.set_sensitive(False)
        self.label_My.set_sensitive(False)
        self.label_Mz.set_sensitive(False)

    #
    #  setBoundary_sub
    #    pageの初期化
    def setBoundary_sub(self, name):
        #stepIdを取得
        nStep = self.getStepIdFromSubItem()
        #labelをセット
        self.setElGroupToLabel(self.boundaryGrpLabel, name)
        #値を取得
        [x, y, z, Rx, Ry, Rz] = self.readBoundaryNgrpName(name, nStep)
        meshCont = self.label_meshCnt.get_label()
        rotation = getRotationNodeGroup(name, meshCont)
        if rotation == True:
            self.showRotationValue()
        else:
            self.hideRotationValue()
            Rx = []; Ry = []; Rz = []
        self.setBoundaryContToTextBox([x, y, z, Rx, Ry, Rz])

    #  showRotationValue
    #    回転のcheckBtnを表示する
    def showRotationValue(self):
        self.checkBtn_Rx.set_sensitive(True)
        self.checkBtn_Ry.set_sensitive(True)
        self.checkBtn_Rz.set_sensitive(True)
        self.textCtrl_Rx.set_sensitive(True)
        self.textCtrl_Ry.set_sensitive(True)
        self.textCtrl_Rz.set_sensitive(True)

    #  hideRotationValue
    #    回転のcheckBtnを隠す
    def hideRotationValue(self):
        self.checkBtn_Rx.set_sensitive(False)
        self.checkBtn_Ry.set_sensitive(False)
        self.checkBtn_Rz.set_sensitive(False)
        self.textCtrl_Rx.set_sensitive(False)
        self.textCtrl_Ry.set_sensitive(False)
        self.textCtrl_Rz.set_sensitive(False)

    #  setCloadContToTextBox
    def setCloadContToTextBox(self, bndCont, forceType, name):
        if forceType == "nodeForce":
            self.radioBtn_nodeForce.set_active(True)
        elif forceType == "aveForce":
            self.radioBtn_aveForce.set_active(True)
        elif forceType == "trueForce":
            self.radioBtn_trueForce.set_active(True)

        x = bndCont[0]
        y = bndCont[1]
        z = bndCont[2]
        Mx = bndCont[3]
        My = bndCont[4]
        Mz = bndCont[5]
        if len(x) > 0:
            v = bndCont[0][1]
            self.textCtrl_cloadX.set_text(v)
        else:
            self.textCtrl_cloadY.set_text("0.0")
        if len(y) > 0:
            v = bndCont[1][1]
            self.textCtrl_cloadY.set_text(v)
        else:
            self.textCtrl_cloadY.set_text("0.0")
        if len(z) > 0:
            v = bndCont[2][1]
            self.textCtrl_cloadZ.set_text(v)
        else:
            self.textCtrl_cloadZ.set_text("0.0")

        if len(Mx) > 0:
            v = Mx[1]
        else:
            v = ""
        self.textCtrl_Mx.set_text(v)
        if len(My) > 0:
            v = My[1]
        else:
            v = ""
        self.textCtrl_My.set_text(v)
        if len(Mz) > 0:
            v = Mz[1]
        else:
            v = ""
        self.textCtrl_Mz.set_text(v)

    #  setBoundaryContToTextBox
    def setBoundaryContToTextBox(self, bndCont):
        x = bndCont[0]
        y = bndCont[1]
        z = bndCont[2]
        Rx = bndCont[3]
        Ry = bndCont[4]
        Rz = bndCont[5]
        if len(x) > 0:
            v = bndCont[0][1]
            self.checkBtn_bndX.set_active(True)
            self.textCtrl_bndX.set_text(v)
        else:
            self.checkBtn_bndX.set_active(False)
            self.textCtrl_bndX.set_text("")
        if len(y) > 0:
            v = bndCont[1][1]
            self.checkBtn_bndY.set_active(True)
            self.textCtrl_bndY.set_text(v)
        else:
            self.checkBtn_bndY.set_active(False)
            self.textCtrl_bndY.set_text("")
        if len(z) > 0:
            v = bndCont[2][1]
            self.checkBtn_bndZ.set_active(True)
            self.textCtrl_bndZ.set_text(v)
        else:
            self.checkBtn_bndZ.set_active(False)
            self.textCtrl_bndZ.set_text("")

        if len(Rx) > 0:
            v = bndCont[3][1]
            self.checkBtn_Rx.set_active(True)
            self.textCtrl_Rx.set_text(v)
        else:
            self.checkBtn_Rx.set_active(False)
            self.textCtrl_Rx.set_text("")
        if len(Ry) > 0:
            v = bndCont[4][1]
            self.checkBtn_Ry.set_active(True)
            self.textCtrl_Ry.set_text(v)
        else:
            self.checkBtn_Ry.set_active(False)
            self.textCtrl_Ry.set_text("")
        if len(Rz) > 0:
            v = bndCont[5][1]
            self.checkBtn_Rz.set_active(True)
            self.textCtrl_Rz.set_text(v)
        else:
            self.checkBtn_Rz.set_active(False)
            self.textCtrl_Rz.set_text("")

    #
    #  readStepValueFromCnt
    #    STEPの値を取得
    def readStepValueFromCnt(self):
        values = []
        lines = readFistrModelCnt()
        i = 0
        while i < len(lines):
            line = lines[i]
            if line[:len("!STEP")] == "!STEP":
                stepType = abaqus2fistr.getValName(line, "TYPE")
                if stepType == "":
                    stepType = "STATIC"
                converg = abaqus2fistr.getValName(line, "CONVERG")
                if converg == "":
                    converg = "1.0e-6"
                subSteps = abaqus2fistr.getValName(line, "SUBSTEPS")
                if subSteps == "":
                    subSteps = "1"
                maxIter = abaqus2fistr.getValName(line, "MAXITER")
                if maxIter == "":
                    maxIter = "50"
                i += 1
                words = deleteSp(lines[i]).split(",")
                flag = 0
                try:
                    dTime = str(float(words[0]))
                    eTime = str(float(words[1]))
                    flag = 1
                except:
                    dTime = "1.0"
                    eTime = "1.0"
                if flag == 1:
                    i += 1
                bnds = []
                while i < len(lines):
                    line = lines[i]
                    if line[0] != "!":
                        if line[0] != "#":
                            bnds.append(line)
                    else:
                        break
                    i += 1
                values = [stepType, converg, subSteps, maxIter, dTime, eTime, bnds]
                break
            i += 1
        if len(values) > 0:
            #SOLUTIONのTYPEを追加
            solutionType = "STATIC"
            for line in lines:
                if line[:len("!SOLUTION")] == "!SOLUTION":
                    solutionType = abaqus2fistr.getValName(line, "TYPE")
                    break
            values += [solutionType]
        return values

    #  getStepParameter
    #    stepの内容を取得
    def getStepParameter(self, line):
        stepName = abaqus2fistr.getValName(line, "stepName")
        stepType = abaqus2fistr.getValName(line, "TYPE")
        if stepType == "":
            stepType = "STATIC"
        converg = abaqus2fistr.getValName(line, "CONVERG")
        if converg == "":
            converg = "1.0e-6"
        subSteps = abaqus2fistr.getValName(line, "SUBSTEPS")
        if subSteps == "":
            subSteps = "1"
        maxIter = abaqus2fistr.getValName(line, "MAXITER")
        if maxIter == "":
            maxIter = "50"
        return [stepName, stepType, converg, subSteps, maxIter]

    #
    #  readStepNameValueFromCnt
    #    stepNameの内容を取得
    def readStepNameValueFromCnt(self, stepName):
        values = []
        lines = readFistrModelCnt()
        i = 0
        while i < len(lines):
            line = lines[i]
            if line[:len("!STEP")] == "!STEP":
                data = self.getStepParameter(line)
                if data[0] == stepName:
                    i += 1
                    words = deleteSp(lines[i]).split(",")
                    flag = 0
                    try:
                        dTime = str(float(words[0]))
                        eTime = str(float(words[1]))
                        flag = 1
                    except:
                        dTime = "1.0"
                        eTime = "1.0"
                    if flag == 1:
                        i += 1
                    bnds = []
                    while i < len(lines):
                        line = lines[i]
                        if line[0] != "!":
                            if line[0] != "#":
                                bnds.append(line)
                        else:
                            break
                        i += 1
                    values = data[1:] + [dTime, eTime, bnds]
                    break
            i += 1
        if len(values) > 0:
            solutionType = "STATIC"
            for line in lines:
                if line[:len("!SOLUTION")] == "!SOLUTION":
                    solutionType = abaqus2fistr.getValName(line, "TYPE")
                    break
            values += [solutionType]
        return values    

    #
    #  readStepDataLinesFromCnt
    #    全てのstepの内容を取得
    def readStepDataLinesFromCnt(self):

        def get1stepLinesFromCurrLine(lines, i):
            stepLines = []
            flag = 0
            stepName = ""
            while i < len(lines):
                line = lines[i]
                if flag == 1:
                    if line[0] != "!" and line[:2] != "!!" and line[0] != "#":
                        stepLines.append(line)
                    else:
                        break
                else:
                    if line[:len("!STEP")] == "!STEP":
                        stepLines.append(line)
                        stepName = abaqus2fistr.getValName(line, "stepName")
                        flag = 1
                    elif line[:2] != "!!" and line[0] != "#":
                        stepLines.append(line)
                    else:
                        break
                i += 1
            return [stepName, stepLines, i]

        data = []
        lines = readFistrModelCnt()
        #最初のstepを探す
        flag = 0
        i = 0
        while i < len(lines):
            line = lines[i]
            if line[:len("!STEP")] == "!STEP":
                flag = 1
                break
            i += 1
        if flag == 1:
            #最初のstepからstep内容を取得
            while i < len(lines):
                [stepName, stepLines, i] = get1stepLinesFromCurrLine(lines, i)
                if len(stepLines) != 0:
                    data.append([stepName, stepLines])
                else:
                    break
        return data

    #
    #  readSpringValueFromCont
    #    SPRINGの値を取得
    def readSpringValueFromCont(self, name, nStep):
        values = ["", "", ""]
        lines = readFistrModelCnt()
        i = skipStepId(lines, nStep)
        getFlag = 0
        while i < len(lines):
            i = pyFistr.getNextHeaderName(lines, i, "!SPRING", "")
            if i < len(lines):
                sName = deleteSp(lines[i+1]).split(",")[0]
                if sName == name:
                    i += 1
                    while i < len(lines):
                        words = deleteSp(lines[i]).split(",")
                        if words[0] == name:
                            n = int(words[1]) - 1
                            values[n] = words[2]
                            getFlag = 1
                        else:
                            break
                        i += 1
                    if getFlag == 1:
                        break
            i += 1        
        return values

    #
    #  readTemperatureValueFromCntMesh
    #    TEMPERATUREの値を取得
    def readTemperatureValueFromCntMesh(self, name, nStep):
        values = []
        temp = ""
        iniTemp = ""
        lines = readFistrModelCnt()
        #temperatureを検索
        i = skipStepId(lines, nStep)        #stepId分をskip
        while i < len(lines):
            line = lines[i]
            if line[:len("!TEMPERATURE")] == "!TEMPERATURE":
                if deleteSp(lines[i+1]).split(",")[0] == name:
                    readResult = abaqus2fistr.getValName(line, "READRESULT")
                    sStep = abaqus2fistr.getValName(line, "SSTEP")
                    interval = abaqus2fistr.getValName(line, "INTERVAL")
                    temp = deleteSp(lines[i+1]).split(",")[1]
                    break
            i += 1
        #iniTempを検索
        iniTemp = self.readInitialNgrpName(name)
        #検索結果を設定
        if temp != "":
            values = [temp, iniTemp, readResult, sStep, interval]
        return values

    #
    #  readGravValueFromCnt
    #    GRAVの値を取得
    def readGravValueFromCnt(self, name, nStep):
        lines = readFistrModelCnt()
        ansLine = ""
        values = []
        i = skipStepId(lines, nStep)
        while i < len(lines):
            grpTypes = pyFistr.getNextDloadGrpType(lines, i)
            if len(grpTypes) > 0:
                for [grp, bndType, line, i] in grpTypes:
                    if grp == name and bndType == "GRAV":
                        ansLine = line
                i += 1
            else:
                break
            if ansLine != "":
                break
        if ansLine != "":
            values = deleteSp(ansLine).split(",")[2:]
        return values

    #
    #  readCentEgrpName
    #    EGRP名のCENT値を取得
    def readCentEgrpName(self, name, nStep):
        lines = readFistrModelCnt()
        getLine = ""
        values = []
        i = skipStepId(lines, nStep)        #stepId分をskip
        while i < len(lines):
            grpTypes = pyFistr.getNextDloadGrpType(lines, i)
            if len(grpTypes) > 0:
                if len(grpTypes) == 1:
                    [grp, bndType, line, i] = grpTypes[0]
                    if grp == name and bndType == "CENT":
                        getLine = line
                        break
            else:
                break
            i += 1        
        if getLine != "":
            words = getLine.split(",")
            values = words[2:]
        return values

    #
    #  readVloadEgrpName
    #    EGRP名のVLOAD値を取得
    def readVloadEgrpName(self, name, nStep):
        lines = readFistrModelCnt()
        bxLine = ""
        byLine = ""
        bzLine = ""
        values = []
        i = skipStepId(lines, nStep)    #stepId分をskip
        while i < len(lines):
            grpTypes = pyFistr.getNextDloadGrpType(lines, i)
            if len(grpTypes) > 0:
                for [grp, bndType, line, i] in grpTypes:
                    if grp == name and bndType == "BX":
                        bxLine = line
                    elif grp == name and bndType == "BY":
                        byLine = line
                    elif grp == name and bndType == "BZ":
                        bzLine = line
                i += 1
            else:
                break
            if bxLine != "" or byLine != "" or bzLine != "":
                break
        bx = "0.0"; by = "0.0"; bz = "0.0"
        if bxLine != "":
            bx = deleteSp(bxLine).split(",")[2]
        if byLine != "":
            by = deleteSp(byLine).split(",")[2]
        if bzLine != "":
            bz = deleteSp(bzLine).split(",")[2]
        values = [bx, by, bz]
        return values

    #
    #  readDloadSgrpName
    #    SGRP名のDLOADを取得
    def readDloadSgrpName(self, name, nStep):
        lines = readFistrModelCnt()
        ansLine = ""
        values = []
        #stepId分skipする
        i = skipStepId(lines, nStep)
        while i < len(lines):
            grpTypes = pyFistr.getNextDloadGrpType(lines, i)
            if len(grpTypes) > 0:
                for [grp, bndType, line, i] in grpTypes:
                    if grp == name and bndType == "S":
                        ansLine = line
                i += 1
            else:
                break
            if ansLine != "":
                break
        if ansLine != "":
            values = deleteSp(ansLine).split(",")[2:]
        return values

    #
    #  readAmpGrpNameInCnt
    #    ampが設定されている境界条件を取得
    def readAmpGrpNameInCnt(self, ampName):

        def setStepNameToBnds(bndsSet, stepName):
            for n in range(len(bndsSet)):
                if bndsSet[n][2] == "":
                    bndsSet[n][2] = stepName
            return bndsSet

        bndsSet = []
        lines = readFistrModelCnt()
        i = 0
        while i < len(lines):
            if lines[i][0] == "!":
                n = lines[i].find("AMP=")
                if n >= 0:
                    name = abaqus2fistr.getValName(lines[i], "AMP")
                    if name == ampName:
                        words = deleteSp(lines[i]).split(",")
                        words2 = deleteSp(lines[i+1]).split(",")
                        if words[0] == "!DLOAD":
                            if words2[1] == "S":
                                bnds = ["DLOAD", words2[0], ""]
                            elif words2[1] == "BX" or words2[1] == "BY" or words2[1] == "BZ":
                                bnds = ["VLOAD", words2[0], ""]
                            else:
                                bnds = [words2[1], words2[0], ""]
                        elif words[0] == "!STEP":
                            stepName = abaqus2fistr.getValName(lines[i], "stepName")
                            bndsSet = setStepNameToBnds(bndsSet, stepName)
                            bnds = [words[0][1:], "SUBSTEPS", stepName]
                        else:
                            bnds = [words[0][1:], words2[0], ""]
                        #bndsSet.append(",".join(bnds))
                        bndsSet.append(bnds)
                else:
                    words = deleteSp(lines[i]).split(",")
                    if words[0] == "!STEP":
                        stepName = abaqus2fistr.getValName(lines[i], "stepName")
                        bndsSet = setStepNameToBnds(bndsSet, stepName)
            i += 1
        bndsSet = setStepNameToBnds(bndsSet, "STEP0")
        bndLines = []
        for i in range(len(bndsSet)):
            bndLines.append(",".join(bndsSet[i]))
        return bndLines

    #
    #  readAmpGrpNameInMsh
    #    amp名のvalue（rel or abs）を取得
    def readAmpGrpNameInMsh(self, ampName):
        value = "RELATIVE"
        for headerData in meshHeaderData:
            line = headerData[0]
            if line[:len("!AMPLITUDE")] == "!AMPLITUDE":
                name = pyFistr.getValName(line, "NAME")
                if name == ampName:
                    value = pyFistr.getValName(line, "VALUE")
                    break
        return value

    #
    #  readSradiateEgrpName
    #    SGRP名のSRADITEを取得
    def readSradiateEgrpName(self, name, nStep):
        ans = ""
        lines = readFistrModelCnt()
        i = skipStepId(lines, nStep)            #stepId分をskip
        while i < len(lines):
            i = pyFistr.getNextHeaderName(lines, i, "!SRADIATE", "")
            if i < len(lines):
                i += 1
                words = deleteSp(lines[i]).split(",")
                if words[0] == name:
                    ans = [words[1], words[2]]
                    break
        return ans

    #
    #  readSfilmEgrpName
    #    SGRP名のSFILMを取得
    def readSfilmEgrpName(self, name, nStep):
        ans = ""
        lines = readFistrModelCnt()
        i = skipStepId(lines, nStep)        #stepId分をskip
        while i < len(lines):
            i = pyFistr.getNextHeaderName(lines, i, "!SFILM", "")
            if i < len(lines):
                i += 1
                words = deleteSp(lines[i]).split(",")
                if words[0] == name:
                    ans = [words[1], words[2]]
                    break
        return ans

    #
    #  readDfluxEgrpName
    #    EGRP名のDFLUXを取得
    def readDfluxEgrpName(self, name, nStep):
        ans = ""
        lines = readFistrModelCnt()
        i = skipStepId(lines, nStep)        #stepId分をskip
        while i < len(lines):
            i = pyFistr.getNextHeaderName(lines, i, "!DFLUX", "")
            if i < len(lines):
                i += 1
                words = deleteSp(lines[i]).split(",")
                if words[0] == name and words[1] == "BF":
                    ans = words[2]
                    break
        return ans

    #
    #  readSfluxNgrpName
    #    SGRP名のSFLUXを取得
    def readSfluxNgrpName(self, name, nStep):
        ans = ""
        lines = readFistrModelCnt()
        i = skipStepId(lines, nStep)            #stepId分skip
        while i < len(lines):
            i = pyFistr.getNextHeaderName(lines, i, "!SFLUX", "")
            if i < len(lines):
                i += 1
                words = deleteSp(lines[i]).split(",")
                if words[0] == name:
                    ans = words[1]
                    break
        return ans

    #
    #  readCfluxNgrpName
    #    NGRP名のCFLUXを取得
    def readCfluxNgrpName(self, name, nStep):
        ans = ["", ""]
        lines = readFistrModelCnt()
        i = skipStepId(lines, nStep)            #stepId分skip
        while i < len(lines):
            i = pyFistr.getNextHeaderName(lines, i, "!CFLUX", "")
            if i < len(lines):
                words = deleteSp(lines[i+1]).split(",")
                if words[0] == name:
                    qwType = pyFistr.getValName(lines[i], "qwType")
                    qwValue = pyFistr.getValName(lines[i], "value")
                    if qwValue == "":
                        words = deleteSp(lines[i+1]).split(",")
                        qwValue = words[1]
                    ans = [qwValue, qwType]
                    break
            i += 1                
        return ans

    #
    #  readInitialNgrpName
    #    NGRP名のINITIALを取得
    def readInitialNgrpName(self, name):
        ans = ""
        for headerData in meshHeaderData:
            line = headerData[0]
            if line[:len("!INITIAL CONDITION")] == "!INITIAL CONDITION":
                dataLines = headerData[1]
                for dataLine in dataLines:
                    words = deleteSp(dataLine).split(",")
                    if words[0] == name:
                        ans = words[1]
                        break
                if ans != "":
                    break
        return ans

    #
    #  readFixtempNgrpName
    #    NGRP名のFIXTEMPを取得
    def readFixtempNgrpName(self, name, nStep):
        ans = ""
        lines = readFistrModelCnt()
        i = skipStepId(lines, nStep)        #stepId分をskip
        while i < len(lines):
            i = pyFistr.getNextHeaderName(lines, i, "!FIXTEMP", "")
            if i < len(lines):
                i += 1
                words = deleteSp(lines[i]).split(",")
                if words[0] == name:
                    ans = words[1]
                    break
        return ans

    #
    #  readAccelNgrpName
    #    NGRP名のACCELERATIONを取得
    def readAccelNgrpName(self, name, nStep):
        ans = ["", "", ""]
        lines = readFistrModelCnt()
        i = skipStepId(lines, nStep)        #stepId分をskip
        getFlag = 0
        while i < len(lines):
            i = pyFistr.getNextHeaderName(lines, i, "!ACCELERATION", "")
            if i < len(lines):
                i += 1
                while i < len(lines):
                    words = deleteSp(lines[i]).split(",")
                    if words[0] != name:
                        break
                    else:
                        loc = int(words[1]) - 1
                        ans[loc] = words[3] 
                        getFlag = 1
                    i += 1
                if getFlag == 1:
                    break
            i += 1
        return ans

    #
    #  readVeloNgrpName
    #    NGRP名のVELOCITYを取得
    def readVeloNgrpName(self, name, nStep):
        ans = ["", "", ""]
        lines = readFistrModelCnt()
        i = skipStepId(lines, nStep)        #stepId分skip
        getFlag = 0
        while i < len(lines):
            i = pyFistr.getNextHeaderName(lines, i, "!VELOCITY", "")
            if i < len(lines):
                i += 1
                while i < len(lines):
                    words = deleteSp(lines[i]).split(",")
                    if words[0] != name:
                        break
                    else:
                        getFlag = 1
                        loc = int(words[1]) - 1
                        ans[loc] = words[3]
                    i += 1
                if getFlag == 1:
                    break
            i += 1
        return ans

    #
    #  readFloadNgrpName
    #    NGRP名のFLOADを取得
    def readFloadNgrpName(self, name, nStep):
        ans = ["", ["", "", ""]]
        lines = readFistrModelCnt()
        i = skipStepId(lines, nStep)        #stepId分をskip
        getFlag = 0
        while i < len(lines):
            i = pyFistr.getNextHeaderName(lines, i, "!FLOAD", "")
            if i < len(lines):
                loadCase = abaqus2fistr.getValName(lines[i], "CASE")
                i += 1
                while i < len(lines):
                    line = deleteSp(lines[i])
                    words = line.split(",")
                    if words[0] == name:
                        ans[0] = loadCase
                        if words[1] == "1":
                            ans[1][0] = words[2]
                        elif words[1] == "2":
                            ans[1][1] = words[2]
                        elif words[1] == "3":
                            ans[1][2] = words[2]
                        getFlag = 1
                    else:
                        break
                    i += 1
                if getFlag == 1:
                    break
        return ans

    #
    #  readCloadNgrpName
    #    NGRP名のCLOADを取得
    def readCloadNgrpName(self, name, nStep):

        def getForceType(line):
            n = line.find("forceType=")
            if n >= 0:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                for word in words:
                    if word[:len("forceType=")] == "forceType=":
                        forceType = word.split("=")[1]
                        break
            else:
                forceType = "nodeForce"
            return forceType

        def getOrgxyz(line):
            n = line.find("value=")
            if n>=0:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                for i in range(len(words)):
                    word = words[i]
                    if word[:len("value=")] == "value=":
                        x = ["1", word.split("=")[1]]
                        y = ["2", words[i+1]]
                        z = ["3", words[i+2]]
                        Mx = ""; My = ""; Mz = ""
                        if i+3 < len(words):
                            Mx = ["4", words[i+3]]
                        else:
                            Mx = ["4", "0.0"]
                        if i+4 < len(words):
                            My = ["5", words[i+4]]
                        else:
                            My = ["5", "0.0"]
                        if i+5 < len(words):
                            Mz = ["6", words[i+5]]
                        else:
                            Mz = ["6", "0.0"]
                        break
            else:
                x = ""
                y = ""
                z = ""
                Mx = ""
                My = ""
                Mz = ""
            return [x, y, z, Mx, My, Mz]

        def getBndLines(lines, i, name):
            newLine = []
            while i < len(lines):
                line = deleteSp(lines[i])
                ngrp = line.split(",")[0]
                if ngrp == name:
                    newLine.append(line)
                else:
                    break
                i += 1 
            return newLine

        def remakeBndCont(lines):
            x = ["1", "0.0"]
            y = ["2", "0.0"]
            z = ["3", "0.0"]
            Mx = ["4", "0.0"]
            My = ["5", "0.0"]
            Mz = ["6", "0.0"]
            for line in lines:
                words = line.split(",")
                if words[1] == "1":
                    x[1] = words[2]
                elif words[1] == "2":
                    y[1] = words[2]
                elif words[1] == "3":
                    z[1] = words[2]
                elif words[1] == "4":
                    Mx[1] = words[2]
                elif words[1] == "5":
                    My[1] = words[2]
                elif words[1] == "6":
                    Mz[1] = words[2]
            return [x, y, z, Mx, My, Mz]

        lines = readFistrModelCnt()
        #stepId分をskip
        i = skipStepId(lines, nStep)
        #値を取得
        bndLines = [[], [], []]
        while i < len(lines):
            line = lines[i]
            if line[:len("!CLOAD")] == "!CLOAD":
                forceType = getForceType(line)
                orgxyz = getOrgxyz(line)
                i += 1
                line = deleteSp(lines[i])
                ngrp = line.split(",")[0]
                if ngrp == name:
                    bndLines = getBndLines(lines, i, name)
                    break
            i += 1
        xyz = remakeBndCont(bndLines)
        if len(orgxyz[0]) != 0:
            xyz = orgxyz
        ans = [xyz, forceType]
        return ans

    #
    #  readBoundaryNgrpName
    #    NGRP名のBOUNDARYを取得
    def readBoundaryNgrpName(self, name, nStep):

        def getBndLines(lines, i, name):
            newLine = []
            while i < len(lines):
                line = deleteSp(lines[i])
                ngrp = line.split(",")[0]
                if ngrp == name or ngrp == "dummy_"+name:
                    newLine.append(line)
                else:
                    break
                i += 1 
            return newLine

        def remakeBndCont(lines, name):
            x = []; y = []; z = []
            Rx = []; Ry = []; Rz = []
            for line in lines:
                words = line.split(",")
                if words[0] == name:
                    #記述が省略されているか確認
                    if len(words) == 2:
                        #拘束方向のみ記述の場合
                        words += [words[1]] + ["0.0"]
                    elif len(words) == 3:
                        #値を省略している場合
                        words += ["0.0"]
                    #複数の拘束を記述しているか
                    if words[1] != words[2]:
                        #複数の拘束記述
                        if words[1] == "1" and words[2] == "2":
                            x += ["1"] + [words[3]]
                            y += ["2"] + [words[3]]
                        if words[1] == "1" and words[2] == "3":
                            x += ["1"] + [words[3]]
                            y += ["2"] + [words[3]]
                            z += ["3"] + [words[3]]
                        if words[1] == "2" and words[2] == "3":
                            y += ["2"] + [words[3]]
                            z += ["3"] + [words[3]]
                    else:
                        #通常の記述
                        if words[1] == "1":
                            if len(x) == 0:
                                x += [words[1]] + [words[3]]
                            else:
                                x[0] = "1"
                                x[1] = words[3]
                        elif words[1] == "2":
                            if len(y) == 0:
                                y += [words[1]] + [words[3]]
                            else:
                                y[0] = "2"
                                y[1] = words[3]
                        elif words[1] == "3":
                            if len(z) == 0:
                                z += [words[1]] + [words[3]]
                            else:
                                y[0] = "3"
                                y[1] = words[3]
                        elif words[1] == "4":
                            if len(Rx) == 0:
                                Rx += [words[1]] + [words[3]]
                            else:
                                Rx[0] = "4"
                                Rx[1] = words[3]
                        elif words[1] == "5":
                            if len(Ry) == 0:
                                Ry += [words[1]] + [words[3]]
                            else:
                                Ry[0] = "5"
                                Ry[1] = words[3]
                        elif words[1] == "6":
                            if len(Rz) == 0:
                                Rz += [words[1]] + [words[3]]
                            else:
                                Rz[0] = "6"
                                Rz[1] = words[3]
                else:
                    #dummyを取得
                    if words[1] == "1":
                        Rx = [words[1], words[3]]
                    elif words[1] == "2":
                        Ry = [words[1], words[3]]
                    elif words[1] == "3":
                        Rz = [words[1], words[3]]    
            return [x, y, z, Rx, Ry, Rz]

        lines = readFistrModelCnt()
        #stepId分をskipする
        i = skipStepId(lines, nStep)
        #boundaryNameを検索
        bndLines = [[], [], []]
        while i < len(lines):
            line = lines[i]
            if line[:len("!BOUNDARY")] == "!BOUNDARY":
                i += 1
                line = deleteSp(lines[i])
                ngrp = line.split(",")[0]
                if ngrp == name:
                    bndLines = getBndLines(lines, i, name)
                    break
            i += 1
        ans = remakeBndCont(bndLines, name)
        return ans

    #
    #  setBCGroupToListBox
    #    BCGroup選択時のpageの初期化
    def setBCGroupToListBox(self, showPage):
        #stepIdを取得
        nStep = self.getStepIdFromItem()
        #自身の処理        
        self.boundaryFrameLabel.set_label(showPage)
        self.boundaryFrameTitle.set_label(_(u"境界条件の設定"))
        self.boundaryFrameNoset.set_label(_(u"group名:"))
        if showPage == _(u"TEMPERATURE"):
            self.boundaryFrameNoset.set_label(_(u"nodeGroup名:"))
            global tempDefine
            lines = readFistrModelCnt()
            tempDefine = getBoundaryNodeGroupInCnt(lines, "!TEMPERATURE")
            #tempDefine = getTemperatuteGroupInCnt(lines)
            ngrps = meshGroup[2] + ["ALL"]        #nodeGroup
            noBnd = self.getNoGroups(ngrps, tempDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup,
                        self.listBox_noGroup, noBnd)
            self.setListDataInListBox(self.listmodelSetGroup,
                        self.listBox_setGroup, tempDefine[nStep])
        elif showPage == _(u"GRAV"):
            self.boundaryFrameNoset.set_label(_(u"elGroup名:"))
            global gravDefine
            lines = readFistrModelCnt()
            gravDefine = getGravGroupInCnt(lines)
            ngrps = meshGroup[0] + ["ALL"]        #elementGroup
            noBnd = self.getNoGroups(ngrps, gravDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup,
                        self.listBox_noGroup, noBnd)
            self.setListDataInListBox(self.listmodelSetGroup,
                        self.listBox_setGroup, gravDefine[nStep])
        elif showPage == _(u"BOUNDARY"):
            self.boundaryFrameNoset.set_label(_(u"nodeGroup名:"))
            global bndDefine
            lines = readFistrModelCnt()
            bndDefine = getBoundaryNodeGroupInCnt(lines, "!BOUNDARY")
            #bndDefine = getBoundaryGroupInCnt(lines)
            ngrps = meshGroup[2]            #nodeGroup
            noBnd = self.getNoGroups(ngrps, bndDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noBnd)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    bndDefine[nStep])
        elif showPage == _(u"CLOAD"):
            self.boundaryFrameNoset.set_label(_(u"nodeGroup名:"))
            global cloadDefine
            lines = readFistrModelCnt()
            #cloadDefine = getCloadGroupInCnt(lines)
            cloadDefine = getBoundaryNodeGroupInCnt(lines, "!CLOAD")
            ngrps = meshGroup[2]
            #cloads = cloadDefine
            noCload = self.getNoGroups(ngrps, cloadDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noCload)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    cloadDefine[nStep])
        elif showPage == _(u"DLOAD"):
            self.boundaryFrameNoset.set_label(_(u"surfaceGroup名:"))
            global dloadDefine
            lines = readFistrModelCnt()
            dloadDefine = getDloadGroupInCnt(lines)
            sgrps = meshGroup[1]
            noGrps = self.getNoGroups(sgrps, dloadDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noGrps)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    dloadDefine[nStep])
        elif showPage == _(u"VLOAD"):
            self.boundaryFrameNoset.set_label(_(u"elGroup名:"))
            global vloadDefine
            lines = readFistrModelCnt()
            vloadDefine = getVloadGroupInCnt(lines)
            egrps = meshGroup[0]
            noGrps = self.getNoGroups(egrps, vloadDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noGrps)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    vloadDefine[nStep])
        elif showPage == _(u"CENT"):
            self.boundaryFrameNoset.set_label(_(u"elGroup名:"))
            global centDefine
            lines = readFistrModelCnt()
            centDefine = getCentGroupInCnt(lines)
            egrps = meshGroup[0]
            noGrps = self.getNoGroups(egrps, centDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noGrps)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    centDefine[nStep])
        elif showPage == _(u"SPRING"):
            self.boundaryFrameNoset.set_label(_(u"nodeGroup名:"))
            global springDefine
            lines = readFistrModelCnt()
            #springDefine = getSpringGroupInCnt(lines)
            springDefine = getBoundaryNodeGroupInCnt(lines, "!SPRING")
            ngrps = meshGroup[2]
            noGrps = self.getNoGroups(ngrps, springDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noGrps)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    springDefine[nStep])
        elif showPage == _(u"FLOAD"):
            self.boundaryFrameNoset.set_label(_(u"nodeGroup名:"))
            global floadDefine
            lines = readFistrModelCnt()
            #floadDefine = getFloadGroupInCnt(lines)
            floadDefine = getBoundaryNodeGroupInCnt(lines, "!FLOAD")
            ngrps = meshGroup[2]
            #floads = cloadDefine
            noFload = self.getNoGroups(ngrps, floadDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noFload)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    floadDefine[nStep])
        elif showPage == _(u"VELOCITY"):
            self.boundaryFrameNoset.set_label(_(u"nodeGroup名:"))
            global veloDefine
            lines = readFistrModelCnt()
            #veloDefine = getVeloGroupInCnt(lines)
            veloDefine = getBoundaryNodeGroupInCnt(lines, "!VELOCITY")
            ngrps = meshGroup[2]
            noVelo = self.getNoGroups(ngrps, veloDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noVelo)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    veloDefine[nStep])
        elif showPage == _(u"ACCELERATION"):
            self.boundaryFrameNoset.set_label(_(u"nodeGroup名:"))
            global accelDefine
            lines = readFistrModelCnt()
            #accelDefine = getAccelGroupInCnt(lines)
            accelDefine = getBoundaryNodeGroupInCnt(lines, "!ACCELERATION")
            ngrps = meshGroup[2]
            noAccel = self.getNoGroups(ngrps, accelDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noAccel)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    accelDefine[nStep])
        elif showPage == _(u"INITIAL"):
            self.boundaryFrameNoset.set_label(_(u"nodeGroup名:"))
            global initialDefine
            initialDefine = getInitialGroupInMsh()
            ngrps = meshGroup[2] + ["ALL"]
            noInitial = self.getNoGroups(ngrps, initialDefine)
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noInitial)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    initialDefine)
        elif showPage == _(u"FIXTEMP"):
            self.boundaryFrameNoset.set_label(_(u"nodeGroup名:"))
            global fixtempDefine
            lines = readFistrModelCnt()
            #fixtempDefine = getFixtempGroupInCnt(lines)
            fixtempDefine = getBoundaryNodeGroupInCnt(lines, "!FIXTEMP")
            ngrps = meshGroup[2]
            noFixtemp = self.getNoGroups(ngrps, fixtempDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noFixtemp)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    fixtempDefine[nStep])
        elif showPage == _(u"CFLUX"):
            self.boundaryFrameNoset.set_label(_(u"nodeGroup名:"))
            global cfluxDefine
            lines = readFistrModelCnt()
            #cfluxDefine = getCfluxGroupInCnt(lines)
            cfluxDefine = getBoundaryNodeGroupInCnt(lines, "!CFLUX")
            ngrps = meshGroup[2]
            noCflux = self.getNoGroups(ngrps, cfluxDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noCflux)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    cfluxDefine[nStep])
        elif showPage == _(u"SFLUX"):
            self.boundaryFrameNoset.set_label(_(u"surfaceGroup名:"))
            global sfluxDefine
            lines = readFistrModelCnt()
            #sfluxDefine = getSfluxGroupInCnt(lines)
            sfluxDefine = getBoundaryNodeGroupInCnt(lines, "!SFLUX")
            sgrps = meshGroup[1]
            noSflux = self.getNoGroups(sgrps, sfluxDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noSflux)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    sfluxDefine[nStep])
        elif showPage == _(u"DFLUX"):
            self.boundaryFrameNoset.set_label(_(u"elGroup名:"))
            global dfluxDefine
            lines = readFistrModelCnt()
            #dfluxDefine = getDfluxGroupInCnt(lines)
            dfluxDefine = getBoundaryNodeGroupInCnt(lines, "!DFLUX")
            egrps = meshGroup[0]
            noDflux = self.getNoGroups(egrps, dfluxDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noDflux)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    dfluxDefine[nStep])
        elif showPage == _(u"SFILM"):
            self.boundaryFrameNoset.set_label(_(u"surfaceGroup名:"))
            global sfilmDefine
            lines = readFistrModelCnt()
            #sfilmDefine = getSfilmGroupInCnt(lines)
            sfilmDefine = getBoundaryNodeGroupInCnt(lines, "!SFILM")
            sgrps = meshGroup[1]
            noSfilm = self.getNoGroups(sgrps, sfilmDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noSfilm)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    sfilmDefine[nStep])
        elif showPage == _(u"SRADIATE"):
            self.boundaryFrameNoset.set_label(_(u"surfaceGroup名:"))
            global sradiateDefine
            lines = readFistrModelCnt()
            #sradiateDefine = getSradiateGroupInCnt(lines)
            sradiateDefine = getBoundaryNodeGroupInCnt(lines, "!SRADIATE")
            sgrps = meshGroup[1]
            noSradiate = self.getNoGroups(sgrps, sradiateDefine[nStep])
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noSradiate)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    sradiateDefine[nStep])

        elif showPage == _(u"step"):
            values = self.readStepValueFromCnt()
            if len(values) == 0:
                self.setListDataInListBox(self.listmodelNoGroup,
                        self.listBox_noGroup, ["STEP"])
                self.setListDataInListBox(self.listmodelSetGroup,
                        self.listBox_setGroup, [])
            else:
                self.setListDataInListBox(self.listmodelNoGroup,
                        self.listBox_noGroup, [])
                self.setListDataInListBox(self.listmodelSetGroup,
                        self.listBox_setGroup, ["STEP"])
        elif showPage == _(u"output"):
            values = getOutputContFromCnt()
            noSelItems = values[0]
            selItems = values[1]
            self.setListDataInListBox(self.listmodelNoGroup, self.listBox_noGroup,
                    noSelItems)
            self.setListDataInListBox(self.listmodelSetGroup, self.listBox_setGroup,
                    selItems)
            self.boundaryFrameTitle.set_label(_(u"出力項目の設定"))
            self.boundaryFrameNoset.set_label(_(u"出力項目:"))
            self.boundaryFrameSet.set_label(_(u"設定する出力項目"))

    #
    #  setElGroupToListBoxInMaterial
    #    elGrpと材料定義をlistboxに追加
    def setElGroupToListBoxInMaterial(self):
        egrps = meshGroup[0]    #EGRP名
        mats = []               #材料定義済のEGRP名
        for names in matDefine:
            mats.append(names[0])
        noMat = []              #未定義のEGRP名
        for egrp in egrps:
            flag = 0
            for mat in mats:
                if egrp == mat:
                    flag = 1
                    break
            if flag == 0:
                noMat.append(egrp)

        self.listmodelNoMat.clear()
        if len(noMat) > 0:
            self.setListDataInListBox(self.listmodelNoMat, self.listBox_noMat, noMat)
        self.listmodelDefMat.clear()
        if len(matDefine) > 0:
            self.setListDataInListBox(self.listmodelDefMat, self.listBox_defMat, mats)

    #
    #  setElGroupToLabel
    #    group名をlabelにセット
    def setElGroupToLabel(self, label, name):
        string = label.get_text()
        newString = string.split(":")[0] + ":" + name
        label.set_text(newString)

    #
    #  getElGroupFromLabel
    #    group名をlabelから取得
    def getElGroupFromLabel(self, label):
        line = label.get_text()
        name = line.split(":")[1]
        return name

    #
    #  readSetEachMaterialName
    #    各groupの材料名をセット
    def readSetEachMaterialName(self, elGroupName):
        matName = ""
        elGrpsMatNames = readMeshGetEachMaterialName()
        for grpName in elGrpsMatNames:
            if elGroupName == grpName[0]:
                matName = grpName[1]
                break
        if matName != "":
            n = 0
            iter = self.listmodelMatName.get_iter_first()
            while iter != None:
                name = self.listmodelMatName.get_value(iter, 0)
                if name == matName:
                    break
                iter = self.listmodelMatName.iter_next(iter)
                n += 1
            self.comboBox_matName.set_active(n)
        return matName

    #
    #  readSetMaterialType
    #    材料名、タイプを設定
    def readSetMaterialType(self, matName, egrpName):
        #板厚を取得
        elType = ""
        for mat in matDefine:
            if mat[0] == egrpName:
                elType = mat[2]
                break
        if isThicknessElementType(elType) == True:
            params = getShellThickness(egrpName)
            self.setMaterialThicknessToTextBox(params)
            self.hideMaterialBeamParamsTextBox()
        elif isBeamElementType(elType) == True:
            params = getShellThickness(egrpName)
            self.setMaterialBeamParamsToTextBox(params)            
            self.hideMaterialThicknessTextBox()
        else:
            self.setMaterialThicknessToTextBox(["", ""])
            self.hideMaterialThicknessTextBox()
            self.hideMaterialBeamParamsTextBox()
        #材料名、タイプを取得
        if anaType[:len("HEAT")] != "HEAT":
            [matModel, matType, matHard] = readGetMaterialModel(matName)
            self.setMaterialTypeToListBox([matModel, matType, matHard])
        else:
            self.setHeatMaterialTypeToListBox()

    #
    #  setMaterialThicknessToTextBox(params)
    #    材料の板厚をtextBoxにセット
    def setMaterialThicknessToTextBox(self, params):
        self.textCtrl_tShell.set_sensitive(True)
        self.textCtrl_nShell.set_sensitive(True)
        self.textCtrl_tShell.set_text(params[0])
        self.textCtrl_nShell.set_text(params[1])

    #
    #  setMaterialBeamParamsToTextBox
    #    beamのデータをtextBoxにセット
    def setMaterialBeamParamsToTextBox(self, params):
        self.textCtrl_beamVx.set_sensitive(True)
        self.textCtrl_beamVy.set_sensitive(True)
        self.textCtrl_beamVz.set_sensitive(True)
        self.textCtrl_beamArea.set_sensitive(True)
        self.textCtrl_beamIyy.set_sensitive(True)
        self.textCtrl_beamIzz.set_sensitive(True)
        self.textCtrl_beamJx.set_sensitive(True)
        if len(params) != 7:
            #paramsが取得できていない場合、空白を設定する
            i = len(params)
            while i < 7:
                params.append("")
                i += 1
        self.textCtrl_beamVx.set_text(params[0])
        self.textCtrl_beamVy.set_text(params[1])
        self.textCtrl_beamVz.set_text(params[2])
        self.textCtrl_beamArea.set_text(params[3])
        self.textCtrl_beamIyy.set_text(params[4])
        self.textCtrl_beamIzz.set_text(params[5])
        self.textCtrl_beamJx.set_text(params[6])

    #
    #  hideMaterialThicknessTextBox
    #    textBoxを隠す
    def hideMaterialThicknessTextBox(self):
        self.textCtrl_tShell.set_sensitive(False)
        self.textCtrl_nShell.set_sensitive(False)
        self.textCtrl_tShell.set_text("")
        self.textCtrl_nShell.set_text("")

    #
    #  hideMaterialBeamParamsTextBox
    #
    def hideMaterialBeamParamsTextBox(self):
        self.textCtrl_beamVx.set_sensitive(False)
        self.textCtrl_beamVy.set_sensitive(False)
        self.textCtrl_beamVz.set_sensitive(False)
        self.textCtrl_beamArea.set_sensitive(False)
        self.textCtrl_beamIyy.set_sensitive(False)
        self.textCtrl_beamIzz.set_sensitive(False)
        self.textCtrl_beamJx.set_sensitive(False)
        self.textCtrl_beamVx.set_text("")
        self.textCtrl_beamVy.set_text("")
        self.textCtrl_beamVz.set_text("")
        self.textCtrl_beamArea.set_text("")
        self.textCtrl_beamIyy.set_text("")
        self.textCtrl_beamIzz.set_text("")
        self.textCtrl_beamJx.set_text("")

    #
    #  setMaterialTypeToListBox
    #    材料モデルなどをlistboxにセット
    def setMaterialTypeToListBox(self, modelType):
        [matModel, matType, matHard] = modelType
        #matModelをセット
        matModels = []
        for mat in materialType:
            matModels.append(mat[0])
        self.listmodelMatModel = Gtk.ListStore(str)
        self.setComboDataInComboBox(self.listmodelMatModel, self.comboBox_matModel, matModels)
        i = 0
        for mat in matModels:
            if mat == matModel:
                break
            i += 1
        self.comboBox_matModel.set_active(i)
        #matTypeをセット
        matTypes = []
        matHards = []
        for nameGroup in materialType:
            if matModel == nameGroup[0]:
                matTypes = nameGroup[1]
                matHards = nameGroup[2]
                break
        self.comboBox_matType.set_sensitive(True)
        self.comboBox_matHard.set_sensitive(True)
        self.comboBox_matType.clear()
        self.listmodelMatType.clear()
        if len(matTypes) == 0:
            self.comboBox_matType.set_sensitive(False)
        else:
            i = 0
            nMatType = 0
            for name in matTypes:
                self.listmodelMatType.append([name])
                if name == matType:
                    nMatType = i
                i += 1
            cell = Gtk.CellRendererText()
            self.comboBox_matType.pack_start(cell, True)
            self.comboBox_matType.add_attribute(cell, "text", 0)
            self.comboBox_matType.set_model(self.listmodelMatType)
            self.comboBox_matType.set_active(nMatType)
        #matHardをセット
        self.comboBox_matHard.clear()
        self.listmodelMatHard.clear()
        if len(matHards) == 0:
            self.comboBox_matHard.set_sensitive(False)
        else:
            i = 0
            nMatHard = 0
            for name in matHards:
                self.listmodelMatHard.append([name])
                if name == matHard:
                    nMatHard = i
                i += 1
            cell = Gtk.CellRendererText()
            self.comboBox_matHard.pack_start(cell, True)
            self.comboBox_matHard.add_attribute(cell, "text", 0)
            self.comboBox_matHard.set_model(self.listmodelMatHard)
            self.comboBox_matHard.set_active(nMatHard)
        #ssDataボタン表示設定
        if matModel == "PLASTIC":
            self.button_ssData.set_sensitive(True)
        else:
            self.button_ssData.set_sensitive(False)

    #
    #  setHeatMaterialTypeToListBox
    #    HEATの設定
    def setHeatMaterialTypeToListBox(self):
        matModels = ["HEAT"]
        self.listmodelMatModel = Gtk.ListStore(str)
        self.setComboDataInComboBox(self.listmodelMatModel, self.comboBox_matModel, matModels)
        self.comboBox_matModel.set_active(0)
        self.comboBox_matType.set_sensitive(False)
        self.comboBox_matHard.set_sensitive(False)

    #
    #  checkCntMshFile
    #    cnt, mshファイルをチェックし、存在しない場合defaultのファイルをcopyする
    def checkCntMshFile(self):
        flag = "OK"
        cntFile = currDir + os.sep + "FistrModel.cnt"
        if len(glob.glob(cntFile)) == 0:
            name = self.textCtrl_useCntFile.get_text()
            copyFile = os.getenv("easyIstrUserPath") + os.sep + "data" + os.sep + name
            pasteFile = cntFile
            #shutil.copy(copyFile, pasteFile)
            osCopyFile(copyFile, pasteFile)
            flag = "copied"
        hecmwFile = currDir + os.sep + "hecmw_ctrl.dat"
        if len(glob.glob(hecmwFile)) == 0:
            copyFile = os.getenv("easyIstrUserPath") + os.sep + "data" + os.sep + "hecmw_ctrl.dat"
            pasteFile = hecmwFile
            #shutil.copy(copyFile, pasteFile)
            osCopyFile(copyFile, pasteFile)
            flag = "copied"
        mshFile = currDir + os.sep + "FistrModel.msh"
        if len(glob.glob(mshFile)) == 0:
            copyFile = os.getenv("easyIstrUserPath") + os.sep + "data" + os.sep + "FistrModel_noMesh.msh"
            pasteFile = mshFile
            #shutil.copy(copyFile, pasteFile)
            osCopyFile(copyFile, pasteFile)
            flag = "copied"
        return flag

    #
    #  setCntFilesToListBox
    #    cntファイルをlistboxに表示
    def setCntFilesToListBox(self):
        cntDir = os.getenv("easyIstrUserPath") + os.sep + "data"
        files = glob.glob(cntDir + os.sep + "*.cnt")
        names = []
        for fileName in files:
            name = fileName.split(os.sep)[-1]
            names.append(name)
        self.setListDataInListBox(self.listmodelCntFile, self.listBox_cntFile, names)

    #
    #  setControlCont
    #    境界条件を取得
    def setControlCont(self):
        global bndDefine, cloadDefine, dloadDefine, vloadDefine, centDefine
        global tempDefine
        global gravDefine, anaType, contactDefine, stepDefine, floadDefine
        global fixtempDefine, cfluxDefine, dfluxDefine, sfluxDefine, sfilmDefine
        global sradiateDefine, veloDefine, accelDefine, springDefine
        anaType = getSolutitionTypeFromCnt()
        lines = readFistrModelCnt()
        bndDefine = getBoundaryNodeGroupInCnt(lines, "!BOUNDARY")
        #bndDefine = getBoundaryGroupInCnt(lines)
        cloadDefine = getBoundaryNodeGroupInCnt(lines, "!CLOAD")
        #cloadDefine = getCloadGroupInCnt(lines)
        dloadDefine = getDloadGroupInCnt(lines)
        vloadDefine = getVloadGroupInCnt(lines)
        centDefine = getCentGroupInCnt(lines)
        gravDefine = getGravGroupInCnt(lines)
        springDefine = getBoundaryNodeGroupInCnt(lines, "!SPRING")
        #springDefine = getSpringGroupInCnt(lines)
        contactDefine = getBoundaryNodeGroupInCnt(lines, "!CONTACT")
        #contactDefine = getContactGroupInCnt(lines)
        floadDefine = getBoundaryNodeGroupInCnt(lines, "!FLOAD")
        #floadDefine = getFloadGroupInCnt(lines)
        veloDefine = getBoundaryNodeGroupInCnt(lines, "!VELOCITY")
        #veloDefine = getVeloGroupInCnt(lines)
        accelDefine = getBoundaryNodeGroupInCnt(lines, "!ACCELERATION")
        #accelDefine = getAccelGroupInCnt(lines)
        fixtempDefine = getBoundaryNodeGroupInCnt(lines, "!FIXTEMP")
        #fixtempDefine = getFixtempGroupInCnt(lines)
        cfluxDefine = getBoundaryNodeGroupInCnt(lines, "!CFLUX")
        #cfluxDefine = getCfluxGroupInCnt(lines)
        dfluxDefine = getBoundaryNodeGroupInCnt(lines, "!DFLUX")
        #dfluxDefine = getDfluxGroupInCnt(lines)
        sfluxDefine = getBoundaryNodeGroupInCnt(lines, "!SFLUX")
        #sfluxDefine = getSfluxGroupInCnt(lines)
        sfilmDefine = getBoundaryNodeGroupInCnt(lines, "!SFILM")
        #sfilmDefine = getSfilmGroupInCnt(lines)
        sradiateDefine = getBoundaryNodeGroupInCnt(lines, "!SRADIATE")
        #sradiateDefine = getSradiateGroupInCnt(lines)
        tempDefine = getBoundaryNodeGroupInCnt(lines, "!TEMPERATURE")
        #tempDefine = getTemperatureGroupInCnt(lines)
        stepDefine = getStepGroupInCnt(lines)

    #  setAnalysisTypeToComboBox
    #
    def setAnalysisTypeToComboBox(self):
        anaTypes = analysisTypes()
        self.listmodelAnaType.clear()
        self.comboBox_anaType.clear()
        #modelにデータセット
        for data in anaTypes:
            self.listmodelAnaType.append([data])
        #modelをセット
        cell = Gtk.CellRendererText()
        self.comboBox_anaType.pack_start(cell, True)
        self.comboBox_anaType.add_attribute(cell, 'text', 0)
        self.comboBox_anaType.set_model(self.listmodelAnaType)
        #active名をセット   
        if anaType == "STATIC":
            self.comboBox_anaType.set_active(0)
        elif anaType == "NLSTATIC":
            self.comboBox_anaType.set_active(1)
        elif anaType == "DYNAMIC":
            self.comboBox_anaType.set_active(2)
        elif anaType == "EIGEN":
            self.comboBox_anaType.set_active(3)
        elif anaType == "DYNAMIC_F":
            self.comboBox_anaType.set_active(4)
        elif anaType == "HEAT":
            self.comboBox_anaType.set_active(5)
        elif anaType == "HEAT_D":
            self.comboBox_anaType.set_active(6)
        else:
            self.comboBox_anaType.set_active(0)

    #  getNoGroups
    #    allとselectのgroupからunselectのgroupを返す
    def getNoGroups(self, allGroups, selGroups):
        noSels = []
        for allGroup in allGroups:
            flag = 0
            for selGroup in selGroups:
                if allGroup == selGroup:
                    flag = 1
                    break
            if flag == 0:
                #「dummy***」のgroup名は除く
                if allGroup[:len("dummy")] != "dummy":
                    noSels.append(allGroup)
        noSels.sort()
        return noSels

    #
    #  setMaterialModelToComboBox
    #    材料モデルをcomboBoxにセットする（デフォルト値）
    def setMaterialModelToComboBox(self):
        #材料モデルをセット
        self.listmodelMatModel.clear()
        self.comboBox_matModel.clear()
        for nameType in materialType:
            self.listmodelMatModel.append([nameType[0]])
        cell = Gtk.CellRendererText()
        self.comboBox_matModel.pack_start(cell, True)
        self.comboBox_matModel.add_attribute(cell, "text", 0)
        self.comboBox_matModel.set_model(self.listmodelMatModel)
        #降伏条件/タイプをセット
        self.listmodelMatType.clear()
        self.comboBox_matType.clear()
        self.listmodelMatType.append([" "])
        self.comboBox_matType.pack_start(cell, True)
        self.comboBox_matType.add_attribute(cell, "text", 0)
        self.comboBox_matType.set_model(self.listmodelMatType)
        #硬化則
        self.listmodelMatHard.clear()
        self.comboBox_matHard.clear()
        self.listmodelMatHard.append([" "])
        self.comboBox_matHard.pack_start(cell, True)
        self.comboBox_matHard.add_attribute(cell, "text", 0)
        self.comboBox_matHard.set_model(self.listmodelMatHard)

    #
    #  setMaterialNameToListBox
    #    材料名をlistBoxにセット
    def setMaterialNameToListBox(self):
        global materialDBCont
        self.listmodelMatName.clear()
        self.comboBox_matName.clear()
        for name in materialDBCont:
            self.listmodelMatName.append([name])
        cell = Gtk.CellRendererText()
        self.comboBox_matName.pack_start(cell, True)
        self.comboBox_matName.add_attribute(cell, "text", 0)
        self.comboBox_matName.set_model(self.listmodelMatName)

    #
    #  readMaterialDB
    #    材料DBを読み込み表示
    def readMaterialDB(self):
        global materialDBCont
        fileName = materialDBName
        if len(glob.glob(fileName)) == 0:
            return

        data = pyFistr.readCsvData(fileName)
        materialDBCont = []
        i = 2
        while i < len(data):
            mat = data[i]
            materialDBCont.append(mat[0])
            i += 1
        materialDBCont.sort()

    #
    #  setIstrData
    #    istr_dataの内容をGUIに設定する
    def setIstrData(self):
        global currDir, sourceMeshFile, istrData, materialDBName
        currDirTrue = getCurrDirFromTempFolder()
        self.textCtrl_workFolder.set_text(currDirTrue)
        for line in istrData:
            items = line.split()
            if items[0] == "convertOpt":
                if items[1] == "unv2fistr":
                    self.radioBtn_unv2fistr.set_active(True)
                else:
                    self.radioBtn_abaqus2fistr.set_active(True)
            elif items[0] == "currDir":
                currDir = items[1]
                #self.textCtrl_workFolder.set_text(currDir)
            elif items[0] == "sourceMesh":
                if len(items) > 1:
                    sourceMeshFile = items[1]
                    self.textCtrl_sourceMesh.set_text(sourceMeshFile)
                else:
                    self.textCtrl_sourceMesh.set_text("")
            elif items[0] == "materialDB":
                materialDBName = items[1]
                self.textCtrl_matDB.set_text(materialDBName)
            elif items[0] == "useCntFile":
                self.textCtrl_useCntFile.set_text(items[1])
            elif items[0] == "execFile":
                self.textCtrl_solveFistr.set_text(items[1])
        if len(glob.glob(currDir)) == 0:
            currDir = os.getenv("HOME")
        os.chdir(currDir)

    #
    #  showTreeData
    #    treeList構造を開いて表示
    def showTreeData(self, treeList):
        self.setNewTreeData()
        self.showTreeParentExpand(treeList)

    #
    #  showTreeParentExpand
    #    親itemを表示し、親をexpandする
    def showTreeParentExpand(self, treeList):
        #rootName = treeData[0]
        #表示させるpathを取得
        tree = treeData[1]
        path = (0,)
        for name in treeList:
            n = 0
            while n < len(tree):
                nTree = tree[n]
                #if type(nTree) == str or type(nTree) == unicode:
                if type(nTree) == str:
                    treeName = nTree
                    aTree = []
                else:
                    treeName = nTree[0]
                    aTree = nTree[1]
                if treeName == name:
                    path += (n,)
                    tree = aTree
                    break
                n += 1
        #pathまでをexpandする。
        Gpath = Gtk.TreePath(path)
        self.tree_main.expand_to_path(Gpath)
        self.tree_main.set_cursor(Gpath)

    #
    #  setIniTreeData
    #    初期のTreeを作成
    def setIniTreeData(self):
        rootName = treeData[0]
        items = treeData[1]
        #treeMainをクリアする
        self.treeMainClear()
        #rootを追加
        root = self.treestore.append(None, [rootName])
        #root以下をmodelに追加
        self.addTreeNodes(self.treestore, root, items)
        #treeViewにmodelを追加
        self.tree_main.set_model(model=self.treestore)
        #treeのlabelを1行目に追加
        self.tvcolumn = Gtk.TreeViewColumn("Tree")
        self.tree_main.append_column(self.tvcolumn)
        #treeを作成
        self.cell = Gtk.CellRendererText()
        self.tvcolumn.pack_start(self.cell, True)
        self.tvcolumn.add_attribute(self.cell, "text", 0)
        #treeの文字色を設定
        self.setTreeFontColour(anaType)
        #rootを展開
        #self.tree_main.expand_row(0, False)
        path = Gtk.TreePath(0)
        self.tree_main.expand_row(path, False)

    #
    #  setTreeFontColour
    #    treeの文字色を設定
    def setTreeFontColour(self, anaType_1):

        #def _setTVAttr(col, cell, model, itr):
        def _setTVAttr(col, cell, model, itr, dummy):
            cell.props.foreground = "black"
            path = model.get_path(itr)
            if len(path) == 3:
                for upath in unneedPath:
                    if path[1] == upath[1] and path[2] == upath[2]:
                        cell.props.foreground = "gray"
                        break

        #font色を変えるpathを取得
        [dummy_needBnds, unneedBnds] = getNeedUnneedBoundaryNo(anaType)
        unneedPath = []
        for n in unneedBnds:
            #unneedPath.append((0,3,n))
            unneedPath.append((0,4,n))
        if len(stepDefine) >= 2:
            for m in range(len(stepDefine)-1):
                for n in unneedBnds:
                    #unneedPath.append((0,3+m+1, n))
                    unneedPath.append((0,4+m+1, n))
        #font色変更
        self.tvcolumn.set_cell_data_func(self.cell, _setTVAttr) 

    #treeMainClear
    #  treeMainをクリア
    def treeMainClear(self):
        self.treestore.clear()
        col = self.tree_main.get_column(0)
        if col != None:
            self.tree_main.remove_column(col)

    #
    #  setNewTreeData
    #    treeDataを入れ替え
    def setNewTreeData(self):
        rootName = treeData[0]
        items = treeData[1]
        #treeMainをクリアする
        self.treestore.clear()
        col = self.tree_main.get_column(0)
        if col != None:
            self.tree_main.remove_column(col)
        #treeのlabelを1行目に追加
        self.tvcolumn = Gtk.TreeViewColumn("Tree")
        self.tree_main.append_column(self.tvcolumn)
        #treeを作成
        self.cell = Gtk.CellRendererText()
        self.tvcolumn.pack_start(self.cell, True)
        self.tvcolumn.add_attribute(self.cell, "text", 0)

        #rootを追加
        root = self.treestore.append(None, [rootName])
        #root以下をmodelに追加
        self.addTreeNodes(self.treestore, root, items)
        #treeの文字色を設定
        self.setTreeFontColour(anaType)

    #  addTreeNodes
    def addTreeNodes(self, treeStore, parentItem, items):
        for item in items:
            #if type(item) == str or type(item) == unicode:
            if type(item) == str:
                newItem = treeStore.append(parentItem, [item])
            else:
                newItem = treeStore.append(parentItem, [item[0]])
                self.addTreeNodes(treeStore, newItem, item[1])

    #
    #  setMeshCont
    #    mesh内容を読み込み、表示
    def setMeshCont(self):
        global ampDefine, initialDefine
        #meshデータ読み込み
        [meshCont, ampNames, initialNames] = getFistrModelMeshData(currDir)
        meshConts = getMeshContsFromTempFolder()
        meshCont = meshConts["meshCont"]
        #ampNames = meshConts["ampNames"]
        #initialNames = meshConts["initialNames"]
        #labelに表示
        self.label_meshCnt.set_label(meshCont)
        #amplitudeを取得
        ampDefine = ampNames
        #initialを取得
        initialDefine = initialNames

    #
    #  getStepIdFromItem
    #    親itemからstepIdを取得
    def getStepIdFromItem(self):
        #親itemを取得
        treeCtrl = self.tree_main
        #treeStore = self.treestore
        path, dummy_column = treeCtrl.get_cursor()
        #name = self.getNameInTreeData(path)
        parentName = self.getParentNameInTreeData(path)
        #stepIdを取得
        nStep = 0
        words = parentName.split()
        if len(words) >= 2:
            i = 0
            for step in stepDefine:
                if step == words[1]:
                    nStep = i
                    break
                i += 1
        return nStep

    #
    #  getStepIdFromSubItem
    #    親の親itemからstepIdを取得
    def getStepIdFromSubItem(self):
        #親親itemを取得
        treeCtrl = self.tree_main
        #treeStore = self.treestore
        path, dummy_column = treeCtrl.get_cursor()
        gndParentName = self.getNameInTreeData(path[:-2])
        #stepIdを取得
        nStep = 0
        words = gndParentName.split()
        if len(words) >= 2:
            i = 0
            for step in stepDefine:
                if step == words[1]:
                    nStep = i
                    break
                i += 1
        return nStep


    #----------comboBox, listBoxの設定----------------------
    #
    #  getNamesInListmodel
    #    listmodelから全namesを取得
    def getNamesInListmodel(self, listmodel):
        names = []
        iter = listmodel.get_iter_first()
        while iter != None:
            name = listmodel.get_value(iter, 0)
            names.append(name)
            iter = listmodel.iter_next(iter)
        return names

    #
    #  setListDataInListBox
    #    listBox(TreeView)をクリアしてデータをセットする
    def setListDataInListBox(self, listModel, listBox, setNames):
        listModel.clear()
        setNames.sort()
        for name in setNames:
            listModel.append([name])
        listBox.set_model(model=listModel)
        cols = [""]
        for i in range(len(cols)):
            coll = listBox.get_column(i)
            if coll != None:
                listBox.remove_column(coll)
            cell = Gtk.CellRendererText()
            col = Gtk.TreeViewColumn(cols[i], cell, text=i)
            listBox.append_column(col)
        listBox.set_headers_visible(False)

    #
    #  sortBndList
    #    stepのlistをsortする
    def sortBndList(self, setNames):
        bnds = []
        for bnd in setNames:
            words = bnd.split(",")
            bnds.append([words[-1], bnd])
        bnds.sort()
        ans = []
        for bnd in bnds:
            ans.append(bnd[1])
        setNames = ",".join(ans)
        return ans

    #
    #  setListDataInListBoxStep
    #    stepのlistBox(TreeView)をクリアしてデータをセットする
    def setListDataInListBoxStep(self, listModel, listBox, setNames):
        listModel.clear()
        setNames = self.sortBndList(setNames)
        for name in setNames:
            listModel.append([name])
        listBox.set_model(model=listModel)
        cols = [""]
        for i in range(len(cols)):
            coll = listBox.get_column(i)
            if coll != None:
                listBox.remove_column(coll)
            cell = Gtk.CellRendererText()
            col = Gtk.TreeViewColumn(cols[i], cell, text=i)
            listBox.append_column(col)
        listBox.set_headers_visible(False)

    #
    #  setComboDataInComboBox
    #    comboBoxをクリアしてデータをセットする
    def setComboDataInComboBox(self, listModel, comboBox, setNames):
        comboBox.clear()
        listModel.clear()
        for name in setNames:
            listModel.append([name])
        cell = Gtk.CellRendererText()
        comboBox.pack_start(cell, True)
        comboBox.add_attribute(cell, "text", 0)
        comboBox.set_model(listModel)

    #
    #  setComboActiveText
    #    comboBoxの指定したtextをactiveに設定
    def setComboActiveText(self, comboBox, selName, names):
        n = 0
        for name in names:
            if name == selName:
                break
            n += 1
        comboBox.set_active(n)


    #---universal dialog--------------
    def fileDialog(self, title, fileDir, filterSets):
        dlg = Gtk.FileChooserDialog(
                    title = title,
                    parent = mainWindow,
                    action = Gtk.FileChooserAction.OPEN,
                    buttons = (Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL,
                               Gtk.STOCK_OPEN, Gtk.ResponseType.OK))
        for [name, pattern] in filterSets:
            filter = Gtk.FileFilter()
            filter.set_name(name)
            filter.add_pattern(pattern)
            dlg.add_filter(filter)
        dlg.set_current_folder(fileDir)
        stat = dlg.run()
        if stat == Gtk.ResponseType.OK:
            fileName = dlg.get_filename()
        else:
            fileName = ""
        dlg.destroy()
        return fileName

    def dirDialog(self, title, path):
        dlg = Gtk.FileChooserDialog(
                    title = title,
                    parent = mainWindow,
                    action = Gtk.FileChooserAction.SELECT_FOLDER,
                    buttons = (Gtk.STOCK_CANCEL, Gtk.ResponseType.CANCEL,
                              Gtk.STOCK_OPEN, Gtk.ResponseType.OK))
        dlg.set_current_folder(path)
        result = dlg.run()
        if result == Gtk.ResponseType.OK:
            folderDir = dlg.get_filename()
        else:
            folderDir = ""
        dlg.destroy()
        return folderDir

    def okDialog(self, title, message):
        dlg = Gtk.MessageDialog(
                parent=mainWindow,
                message_type=Gtk.MessageType.INFO,
                buttons=Gtk.ButtonsType.OK)
        dlg.set_title(title)
        #messageを分ける
        mess1 = message.split(ls)[0]
        mess2 = ls.join(message.split(ls)[1:])
        dlg.set_markup(mess1)
        dlg.format_secondary_text(mess2)
        #dummy_ans = dlg.run()
        dlg.run()
        dlg.destroy()

    def okCancelDialog(self, title, message):
        dlg = Gtk.MessageDialog(
                parent=mainWindow,
                message_type=Gtk.MessageType.INFO,
                buttons=Gtk.ButtonsType.OK_CANCEL)
        dlg.set_title(title)
        #messageを分ける
        mess1 = message.split(ls)[0]
        mess2 = ls.join(message.split(ls)[1:])
        dlg.set_markup(mess1)
        dlg.format_secondary_text(mess2)
        ans = dlg.run() 
        dlg.destroy()
        if ans == Gtk.ResponseType.OK:
            stat = "OK"
        else:
            stat = "CANCEL"
        return stat

    def yesNolDialog(self, title, message):
        dlg = Gtk.MessageDialog(
                parent=mainWindow,
                message_type=Gtk.MessageType.INFO,
                buttons=Gtk.ButtonsType.YES_NO)
        dlg.set_title(title)
        #messageを分ける
        mess1 = message.split(ls)[0]
        mess2 = ls.join(message.split(ls)[1:])
        dlg.set_markup(mess1)
        dlg.format_secondary_text(mess2)
        ans = dlg.run() 
        dlg.destroy()
        if ans == Gtk.ResponseType.YES:
            stat = "YES"
        else:
            stat = "CANCEL"
        return stat

    def errDialog(self, title, message):
        dlg = Gtk.MessageDialog(
                parent=mainWindow,
                message_type=Gtk.MessageType.ERROR,
                buttons=Gtk.ButtonsType.OK)
        dlg.set_title(title)
        mess1 = message.split(ls)[0]
        mess2 = ls.join(message.split(ls)[1:])
        dlg.set_markup(mess1)
        dlg.format_secondary_text(mess2)
        #dummy_ans = dlg.run()
        dlg.run() 
        dlg.destroy()


#
#  checkNumStr
#    指数表記の文字列に小数点が無い場合は追加する
def checkNumStr(word):
    if word.find(".") >= 0:
        return word
    n = word.lower().find("e")
    if n >= 0:
        word = word[:n] + ".0" + word[n:]
    return word

#
#  checkNumStrs
#    list内の指数表記の文字列で小数点をチェック
def checkNumStrs(numStrs):
    nums = []
    for numStr in numStrs:
        num = checkNumStr(numStr)
        nums.append(num)
    return nums            

#
#  getUsedContactNamesInCnt
#    cnt内から使用済みのcontactNameを取得する。
def getUsedContactNamesInCnt():
    lines = readFistrModelCnt()
    usedNames = []
    flag = 0
    for line in lines:
        if line[0] == "!":
            words = pyFistr.deleteSp(line).split(",")
            if words[0] == "!CONTACT":
                flag = 1
            else:
                flag = 0
        else:
            if flag == 1:
                name = pyFistr.deleteSp(line).split(",")[0]
                usedNames.append(name)
    return usedNames    

#
#  skipStepId
#    nStep分skipする
def skipStepId(lines, nStep):
    i = 0
    if nStep <= 0:
        return i
 
    while i < len(lines):
        line = lines[i]
        if line[:len("!STEP")] == "!STEP":
            nStep -= 1
            if nStep <= 0:
                i += 1
                break
        i += 1
    return i

#
#  getMeshHeaderData
#    meshDataを取得
def getMeshHeaderData():
    global meshHeaderData
    lines = readFistrModelMsh()
    meshHeaderData = pyFistr.getHeaderNumData(lines) 

#
#  showSettingDialog
#    設定中dialogを表示
def showSettingDialog(title):
    global settingDialog
    comm = "python3 " + pythonAppPath + "settingDialog2.py '" + title + "'"
    settingDialog = subprocess.Popen(
        comm,
        shell=True,
        stdin=subprocess.PIPE,
        stdout=subprocess.PIPE)
    numSettingDialog(0, "preparing...")

#
#  numSettingDialog
#    設定中dialogに進行状況を表示
#    （num>100.0の場合は、閉じる）
def numSettingDialog(num, cont):
    settingDialog.stdin.write((str(num) + "," + cont + "\n").encode())
    if settingDialog.poll() == None:
        #BrokenPipeでは無い時にflushする
        settingDialog.stdin.flush()

#
#  closeSettingDialog
#    設定中dialogを閉じる
def closeSettingDialog():
    numSettingDialog(100, "close")
    settingDialog.stdin.write(("close\n").encode())
    if settingDialog.poll() == None:
        #BrokenPipeでは無い時にflushする
        settingDialog.stdin.flush()

#
#  getRotationNodeGroup
#    回転の自由度を持っている要素のNGRPかどうかチェック
def getRotationNodeGroup(ngrpName, meshCont):
    #dummyのnodeGroupをチェック
    rotation = ""
    lines = meshCont.split("\n")
    for line in lines:
        words = line.split()
        if len(words) > 2:
            if words[0] == "NGRP" and words[1] == "dummy_" + ngrpName:
                rotation = True
                break
    if rotation != "":
        #dummyがあれば、Trueを返す
        return rotation

    #solid要素をチェック
    rotation = True
    for line in lines:
        words = line.split()
        if len(words) > 2:
            if words[0] == "elements":
                elType = words[1].split(":")[-1]
                if elType[0] == "3":
                    #dummyが無くて、solid要素があればFalseをチェック
                    rotation = False
                    break
    return rotation

#
#  getMaterialValueType
#    材料type（elastic or heat）をcntファイルから取得
def getMaterialValueType(matName):

    def isMatGrpHeader(headerName):
        ans = False
        for matHeader in matGrpHeader:
            if matHeader == headerName:
                ans = True
                break
        return ans

    lines = readFistrModelCnt()
    i = pyFistr.getNextHeaderName(lines, 0, "!MATERIAL", "NAME="+matName)
    if i >= len(lines):
        return ["elastic"]

    matValType = []
    #st = i
    i += 1
    i = pyFistr.skipNextHeader(lines, i)
    while i < len(lines):
        headerName = deleteSp(lines[i].split(",")[0])
        if isMatGrpHeader(headerName) == True:
            if headerName == "!ELASTIC":
                matValType.append("elastic")
            elif headerName == "!SPECIFIC_HEAT":
                matValType.append("heat")
        else:
            break
        i += 1
        i = pyFistr.skipNextHeader(lines, i)

    if len(matValType) == 0:
        matValType.append("elastic")
    return matValType

#
#  osCopyFile
#    osに基づいたfileCopy
#    pythonで各行を読み込み、そのまま各行を書き込む事で、変換できる
def osCopyFile(copyFile, pasteFile):
    f=open(copyFile, encoding="utf-8"); lines=f.readlines(); f.close()
    w=open(pasteFile, "w", encoding="utf-8")
    for line in lines:
        w.write(line)
    w.close()

#  needBndItemNoDict
#    解析内容に必要な境界条件
needBndItemNoDict = {
        #解析名        境界条件No
        "STATIC":       needBndStatic,      #線形弾性静解析 
        "NLSTATIC":     needBndNlstatic,    #非線形解析
        "DYNAMIC":      needBndDynamic,     #動解析
        "EIGEN":        needBndEigen,       #固有値解析
        "DYNAMIC_F":    needBndDynamic_F,   #周波数応答解析
        "HEAT":         needBndHeat,        #定常伝熱解析
        "HEAT_D":       needBndHeat_D       #非定常伝熱解析
        }

#
#  getNeedUnneedBoundaryNo
#    現在の解析で必要な境界条件の要不要な境界条件Noを返す
def getNeedUnneedBoundaryNo(anaType):
    #解析内容に応じた境界条件Noを取得
    needBndNo = needBndItemNoDict[anaType]
    #treeを作成
    tree = initialTreeParts()
    #boundary = tree[4]
    boundary = tree[5]
    allBnds = boundary[0][1]
    unneedBndNo = []
    for an in range(len(allBnds)):
        flag = 0
        for n in needBndNo:
            if an == n:
                flag = 1
                break
        if flag == 0:
            unneedBndNo.append(an)
    return [needBndNo, unneedBndNo]

#
#  remakeNormalHecmwCtrl
#    hecmw_ctrl.datファイルを通常の状態に戻す
def remakeNormalHecmwCtrl():
    lines = readHecmwCtrlDat()
    i = pyFistr.getNextHeaderName(lines, 0, "!RESULT", "NAME=fstrRES")
    i += 1
    lines[i] = "FistrModel.res" + ls
    lines = deleteFstrDynaResultIn(lines)
    writeHecmwCtrlDat(lines)

#
#  remakeHeatResultIn
#    hecmw_ctrl.datファイルに熱解析結果入力を追加する
def remakeHeatResultIn():
    lines = readHecmwCtrlDat()
    lines = deleteFstrDynaResultIn(lines)
    addLines =  ["!RESULT, NAME=fstrTEMP, IO=IN" + ls]
    addLines += ["FistrModel_temp.res" + ls]
    i = pyFistr.getInsertPointInCnt(lines, "!RESULT", ["NAME=fstrRES"])
    lines = lines[:i] + addLines + lines[i:]
    writeHecmwCtrlDat(lines)

#
#  addFstrDynaResultIn
#    hecmw_ctrl.datの!RESULT NAMEにfistrDynaとresult-inを追加
def addFstrDynaResultIn(lines):
    #fstrDYNAを追加
    i = pyFistr.getNextHeaderName(lines, 0, "!RESULT", "NAME=fstrDYNA")
    if i < len(lines):
        i += 1
        lines[i] = "FistrModel_dyna.res" + ls
    else:
        addLines = ["!RESULT, NAME=fstrDYNA, IO=OUT" + ls]
        addLines += ["FistrModel_dyna.res" + ls]
        i = pyFistr.getInsertPointInCnt(lines, "!RESULT", ["NAME=fstrRES"])
        lines = lines[:i] + addLines + lines[i:]
    #result-inを追加
    i = pyFistr.getNextHeaderName(lines, 0, "!RESULT", "NAME=result-in")
    if i < len(lines):
        i += 1
        lines[i] = "FistrModel_eigen.res" + ls
    else:
        addLines = ["!RESULT, NAME=result-in, IO=IN" + ls]
        addLines += ["FistrModel_eigen.res" + ls]
        i = pyFistr.getInsertPointInCnt(lines, "!RESULT", ["NAME=fstrRES"])
        lines = lines[:i] + addLines + lines[i:]
    return lines

#
#  deleteFstrDynaResultIn
#    hecmw_ctrl.datの!RESULT NAMEからfistrDynaとresult-inを削除
def deleteFstrDynaResultIn(lines):
    lines = pyFistr.deleteHeaderName(lines, 0, "!RESULT", "NAME=fstrDYNA")
    lines = pyFistr.deleteHeaderName(lines, 0, "!RESULT", "NAME=result-in")
    lines = pyFistr.deleteHeaderName(lines, 0, "!RESULT", "NAME=fstrTEMP")
    return lines

#
#  setSingleHcmwCtrlDat
#    hecmw_ctrl.datをsingle設定にする
def setSingleHcmwCtrlDat():
    lines = readHecmwCtrlDat()
    #for partitionを削除
    i = pyFistr.getNextHeaderName(lines, 0, "!MESH", "NAME=part_in")
    if i < len(lines):
        lines = pyFistr.delete1header(lines, i)
    i = pyFistr.getNextHeaderName(lines, 0, "!MESH", "NAME=part_out")
    if i < len(lines):
        lines = pyFistr.delete1header(lines, i)
    #for solver
    i = pyFistr.getNextHeaderName(lines, 0, "!MESH", "NAME=fstrMSH")
    lines[i] = abaqus2fistr.setValName(lines[i], "TYPE=HECMW-ENTIRE")
    lines[i+1] = "FistrModel.msh" + ls
    #for visualizer
    i = pyFistr.getNextHeaderName(lines, 0, "!MESH", "NAME=mesh")
    lines[i] = abaqus2fistr.setValName(lines[i], "TYPE=HECMW-ENTIRE")
    lines[i+1] = "FistrModel.msh" + ls
    writeHecmwCtrlDat(lines)

#
#  setParallelHcmwCtrlDat
#    hcmw_ctrl.datをparallel設定にする
def setParallelHcmwCtrlDat(nCpu):
    lines = readHecmwCtrlDat()
    #for partitionerを削除（無ければ何もしない）
    i = pyFistr.getNextHeaderName(lines, 0, "!MESH", "NAME=part_in")
    if i < len(lines):
        lines = pyFistr.delete1header(lines, i)
    i = pyFistr.getNextHeaderName(lines, 0, "!MESH", "NAME=part_out")
    if i < len(lines):
        lines = pyFistr.delete1header(lines, i)
    #for partitionerを追加
    addLines =  ["!MESH, NAME=part_in, TYPE=HECMW-ENTIRE" + ls]
    addLines += ["FistrModel.msh" + ls]
    addLines += ["!MESH, NAME=part_out, TYPE=HECMW-DIST" + ls]
    addLines += ["FistrModel_p" + nCpu + ls]
    i = pyFistr.getInsertPointInCnt(lines, "!MESH", ["partition"])
    lines = lines[:i] + addLines + lines[i:]
    #for solver
    i = pyFistr.getNextHeaderName(lines, 0, "!MESH", "NAME=fstrMSH")
    lines[i] = abaqus2fistr.setValName(lines[i], "TYPE=HECMW-DIST")
    lines[i+1] = "FistrModel_p" + nCpu + ls
    #for visualizer
    i = pyFistr.getNextHeaderName(lines, 0, "!MESH", "NAME=mesh")
    lines[i] = abaqus2fistr.setValName(lines[i], "TYPE=HECMW-DIST")
    lines[i+1] = "FistrModel_p" + nCpu + ls
    writeHecmwCtrlDat(lines)

#
#  hideHcmwPartCtrlDat
#    hcmw_part_ctrl.datを隠す
def hideHcmwPartCtrlDat():
    fileName = currDir + os.sep + "hecmw_part_ctrl.dat"
    if len(glob.glob(fileName)) != 0:
        #os.rename(fileName, fileName+".bak")
        shutil.copy(fileName, fileName+".bak")
        os.remove(fileName)

#
#  loadHcmwPartCtrlDat
#    hcmw_part_ctrl.datをloadする
def loadHcmwPartCtrlDat():
    fileName = currDir + os.sep + "hecmw_part_ctrl.dat"
    if len(glob.glob(fileName+".bak")) != 0:
        #bakファイルをrenameする
        shutil.copy(fileName+".bak", fileName)
        os.remove(fileName+".bak")
    else:
        #defaultのhcmw_part_ctrl.datをコピーする
        copyFile = os.getenv("easyIstrUserPath") + os.path.normpath("/data/hecmw_part_ctrl.dat")
        #shutil.copy(copyFile, currDir)
        f=open(copyFile, encoding="utf-8"); lines= f.readlines(); f.close()
        w=open(fileName, "w", encoding="utf-8")
        for line in lines:
            w.write(line)
        w.close()

#
#  setHecmwContFromDat
#    hecmwの内容をセット
def setHecmwContFromDat(para, nCpu):
    fileName = currDir + os.sep + "hecmw_part_ctrl.dat"
    if len(glob.glob(fileName)) == 0:
        shutil.copy(currDir + os.sep + "hecmw_part_ctrl.dat", currDir)
    #hecmw_part_ctrl.datを書き換え
    f=open(fileName, encoding="utf-8"); lines=f.readlines(); f.close()
    i = pyFistr.getNextHeaderName(lines, 0, "!PARTITION", "")
    lines[i] = abaqus2fistr.setValName(lines[i], "DOMAIN="+nCpu)
    f=open(fileName, "w", encoding="utf-8")
    for line in lines:
        f.write(line)

#
#  getHecmwContFromDat
#    hecmwの内容を取得
def getHecmwContFromDat():
    fileName = currDir + os.sep + "hecmw_part_ctrl.dat"
    if len(glob.glob(fileName)) == 0:
        #シングルコア
        parallel = False
        nCpu = "1"
    else:
        parallel = True
        f=open(fileName, encoding="utf-8"); lines=f.readlines(); f.close()
        i = pyFistr.getNextHeaderName(lines, 0, "!PARTITION", "")
        nCpu = abaqus2fistr.getValName(lines[i], "DOMAIN")
    return [parallel, nCpu]

#
#  setDynamicContInCnt
#    dynamicSolutionの内容を設定
def setDynamicContInCnt(values):

    #eigenLogの個数を読み込み
    def getEigenNumber(fileName):
        f=open(fileName, encoding="utf-8"); lines=f.readlines(); f.close()
        st = "1"
        ed = "4"
        flag = 0
        i = 0
        while i < len(lines):
            words = lines[i].split()
            if len(words) > 2:
                if words[0] == "---":
                    i += 1
                    st = lines[i].split()[0]
                    flag = 1
                if flag == 1:
                    ed = lines[i].split()[0]
            i += 1
        return [st, ed]                    

    lines = readFistrModelCnt()
    i = pyFistr.getNextHeaderName(lines, 0, "!DYNAMIC", "")
    lines[i] = abaqus2fistr.setValName(lines[i], "TYPE="+values[0])
    #data部を削除
    i += 1
    ip = i
    while i < len(lines):
        if lines[i][0] == "!" or lines[i][0] == "#":
            break
        i += 1
    lines = lines[:ip] + lines[i:]
    #data部を追加
    data = values[1]
    addLines =  [", ".join(data[:2]) + ls]
    addLines += [", ".join(data[2:6]) + ls]
    addLines += [", ".join(data[6:8]) + ls]
    addLines += [", ".join(data[8:12]) + ls]
    addLines += [", ".join(data[12:15]) + ls]
    addLines += [", ".join(data[15:21]) + ls]
    lines = lines[:ip] + addLines + lines[ip:]
    #restartを修正
    i = pyFistr.getNextHeaderName(lines, 0, "!RESTART", "")
    if i >= len(lines):
        i = pyFistr.getInsertPointInCnt(lines, "!RESTART", ["SOLVER", "Solver"])
        lines = lines[:i] + ["!RESTART" + ls] + lines[i:]
    lines[i] = abaqus2fistr.setValName(lines[i], "FREQUENCY="+values[2])
    #!EIGENREADのチェック修正
    if anaType == "DYNAMIC_F":
        i = pyFistr.getInsertPointInCnt(lines, "!EIGENREAD", [])
        [st, ed] = getEigenNumber("eigen_log")
        lines[i+2] = st + ", " + ed + ls
    writeFistrModelCnt(lines)

#
#  setRestartInCnt
#    restartの設定
def setRestartInCnt(restart):
    #hecmw_cnt.datファイルをチェック
    addLines = []
    lines = readHecmwCtrlDat()
    i = pyFistr.getNextHeaderName(lines, 0, "!RESTART", "IO=OUT")
    if i >= len(lines):
        i = pyFistr.getInsertPointInCnt(lines, "!RESTART", ["NAME=fstrRES", "CONTROL"])
        addLines =  ["!RESTART, NAME=restart-out, IO=OUT" + ls]
        addLines += ["FistrModel.restart" + ls]
        lines = lines[:i] + addLines + lines[i:]
    i = pyFistr.getNextHeaderName(lines, 0, "!RESTART", "IO=IN")
    if i >= len(lines):
        i = pyFistr.getInsertPointInCnt(lines, "!RESTART", ["NAME=fstrRES", "CONTROL"])
        addLines =  ["!RESTART, NAME=restart-in, IO=IN" + ls]
        addLines += ["FistrModel.restart" + ls]
        lines = lines[:i] + addLines + lines[i:]
    if len(addLines) > 0:
        writeHecmwCtrlDat(lines)
    #cntファイルを修正
    lines = readFistrModelCnt()
    i = pyFistr.getNextHeaderName(lines, 0, "!RESTART", "")
    freq = "1"
    if i < len(lines):
        freq = abaqus2fistr.getValName(lines[i], "FREQUENCY")
        if freq == "":
            freq = "1"
        if restart == True:
            newFreq = deleteSp(str(abs(int(freq)) * (-1)))
        else:
            newFreq = deleteSp(str(abs(int(freq))))
        lines[i] = abaqus2fistr.setValName(lines[i], "FREQUENCY="+newFreq)
    else:
        if restart == True:
            i = pyFistr.getInsertPointInCnt(lines, "!RESTART", ["!SOLVER", "SOLVER"])
            addLines = ["!RESTART, FREQUENCY=-1" + ls]
            lines = lines[:i] + addLines + lines[i:]
        else:
            i = pyFistr.getInsertPointInCnt(lines, "!RESTART", ["!SOLVER", "SOLVER"])
            addLines = ["!RESTART, FREQUENCY=1" + ls]
            lines = lines[:i] + addLines + lines[i:]
    writeFistrModelCnt(lines)

#
#  setOutputLogInCnt
#    logの出力設定
def setOutputLogInCnt(iterLog, timeLog, freq):
    lines = readFistrModelCnt()
    i = pyFistr.getNextHeaderName(lines, 0, "!SOLVER", "")
    if iterLog == "YES":
        lines[i] = abaqus2fistr.setValName(lines[i], "ITERLOG=YES")
    else:
        lines[i] = abaqus2fistr.setValName(lines[i], "ITERLOG=NO")
    if timeLog == "YES":
        lines[i] = abaqus2fistr.setValName(lines[i], "TIMELOG=YES")
    else:
        lines[i] = abaqus2fistr.setValName(lines[i], "TIMELOG=NO")
    i = pyFistr.getNextHeaderName(lines, 0, "!WRITE", "")
    lines[i] = abaqus2fistr.setValName(lines[i], "FREQUENCY="+freq)
    i = pyFistr.getNextHeaderName(lines, i+1, "!WRITE", "")
    lines[i] = abaqus2fistr.setValName(lines[i], "FREQUENCY="+freq)
    writeFistrModelCnt(lines)

#
#  setAmpDataInMsh
#    ampDataを追加
def setAmpDataInMsh(meshHeaderData, ampName, valType, ampData):
    flag = 0
    for i in range(len(meshHeaderData)):
        line = meshHeaderData[i][0]
        if line[:len("!AMPLITUDE")] == "!AMPLITUDE":
            name = pyFistr.getValName(line, "NAME")
            if name == ampName:
                header = abaqus2fistr.setValName(line, "VALUE="+valType)
                headerData = [header, ampData]
                meshHeaderData[i] = headerData
                flag = 1
                break
    if flag == 0:
        header = "!AMPLITUDE, VALUE="+valType + ", NAME=" + ampName + ls
        headerData = [header, ampData]
        meshHeaderData = meshHeaderData[:-1] + [headerData] + meshHeaderData[-1:]
    return meshHeaderData

#
#  getAmpDataInFile
#    ampDataをcsvファイルから取得
def getAmpDataInFile(fileName):
    ampData = []
    contList = pyFistr.readCsvData(fileName)
    for row in contList[2:]:
        data = row[1] + row[2]
        if data != "":
            #timeとvalueを入れ替える
            ampData += [", ".join([row[2], row[1]]) + ls]
    return ampData

#
#  getPlasticSsData
#    csvデータを取得する
def getPlasticSsData(matName):
    fileName = currDir + os.sep + matName + "_PlasticSSdata.csv"
    ssData = ""
    if len(glob.glob(fileName)) == 0:
        return ssData
    contList = pyFistr.readCsvData(fileName)
    if contList[0][0] != "":
        st = 0
    else:
        st = 1
    for row in contList[2:]:
        data = row[st] + row[st+1]
        #data = row[1] + row[2]
        if data != "":
            #strain, stressを入れ替える
            ssData += ", ".join([row[st+1], row[st]]) + ls
    return ssData

#
#  createAmpDataFile
#    ampDataのcsvファイルを作成
def createAmpDataFile(ampName, fileName):
    #mshファイルからampDataを取得
    dataLines = []
    for headerData in meshHeaderData:
        line = headerData[0]
        if line[:len("!AMPLITUDE")] == "!AMPLITUDE":
            name = pyFistr.getValName(line, "NAME")
            if name == ampName:
                dataLines = headerData[1]
    #ampDataからcsvファイル作成
    rows = []
    rows += [["", "ampData", ""]]
    rows += [["", "time", "value"]]
    f = open(fileName, "w", encoding="utf-8")
    for row in rows:
        line = ",".join(row) + ls
        f.write(line)
    for dataLine in dataLines:
        words = deleteSp(dataLine).split(",")
        line = "," + words[1] + "," + words[0] + ls
        f.write(line)
    f.close()

#
#  createPlasticSsDataFile
#    csvファイルを作成
def createPlasticSsDataFile(fileName):
    rows = []
    rows += [["", "SS_curve", ""]]
    #rows += [["", "strain", "stress"]]
    rows += [["", "value", "stress"]]
    f=open(fileName, "w", encoding="utf-8")
    for row in rows:
        line = ",".join(row) + ls
        f.write(line)
    f.close()

#
#  getSolutionTypeFromCnt
#    solutionTypeを取得
def getSolutitionTypeFromCnt():
    #values = []
    lines = readFistrModelCnt()
    i = pyFistr.getNextHeaderName(lines, 0, "!SOLUTION", "")
    if i >= len(lines):
        #デフォルト値を設定
        solType = "STATIC"
    else:
        solType = abaqus2fistr.getValName(lines[i], "TYPE")
    if solType == "DYNAMIC":
        i = pyFistr.getNextHeaderName(lines, 0, "!DYNAMIC", "")
        i += 1
        if i < len(lines):
            words = deleteSp(lines[i]).split(",")
            if len(words) >= 2:
                if words[1] == "2":
                    solType = "DYNAMIC_F"
    elif solType == "HEAT":
        i = pyFistr.getNextHeaderName(lines, 0, "!HEAT", "")
        i += 1
        if i < len(lines):
            words = deleteSp(lines[i]).split(",")
            try:
                dt = float(words[0])
            except:
                dt = 0.0
            if dt > 0.0:
                solType = "HEAT_D"
    return solType

#
#  getFrequencyReactFromCnt
#    周波数応答解析かどうかをチェック
def getFrequencyReactFromCnt():
    ans = False
    lines = readFistrModelCnt()
    i = pyFistr.getNextHeaderName(lines, 0, "!SOLUTION", "TYPE=DYNAMIC")
    if i < len(lines):
        i = pyFistr.getNextHeaderName(lines, 0, "!DYNAMIC", "")
        i += 1
        if i < len(lines):
            words = deleteSp(lines[i]).split(",")
            if len(words) >= 2:
                if words[1] == "2":
                    ans = True
    return ans

#
#  getHeatDinaContFromCnt
#    熱伝導動解析に関するdataをcntファイルから取得
def getHeatDinaContFromCnt():
    lines = readFistrModelCnt()
    i = pyFistr.getNextHeaderName(lines, 0, "!HEAT", "")
    i += 1
    values = deleteSp(lines[i]).split(",")
    n = len(values)
    while n < 6:
        values.append("")
        n += 1
    return values

#
#  getEigenContFromCnt
#    固有値解析に関するdataをcntファイルから取得
def getEigenContFromCnt():
    lines = readFistrModelCnt()
    i = pyFistr.getNextHeaderName(lines, 0, "!EIGEN", "")
    i += 1
    [values, i] = pyFistr.getOnlyDataInLines(lines, i)
    return values

#
#  getDynamicContFromCnt
#    動解析に関するdataをcntファイルから取得
def getDynamicContFromCnt():
    values = []
    lines = readFistrModelCnt()
    i = pyFistr.getNextHeaderName(lines, 0, "!DYNAMIC", "")
    dynType = abaqus2fistr.getValName(lines[i], "TYPE")
    values.append(dynType)
    i += 1
    data = []
    while i < len(lines):
        if lines[i][0] == "!":
            break
        else:
            if lines[i][0] != "#":
                line = deleteSp(lines[i])
                words = line.split(",")
                data += words
        i += 1
    values += [data]
    i = pyFistr.getNextHeaderName(lines, 0, "!RESTART", "")
    if i >= len(lines):
        resFreq = "1"
    else:
        resFreq = abaqus2fistr.getValName(lines[i], "FREQUENCY")
        if resFreq == "":
            resFreq = "1"
    values += [resFreq]
    return values

#
#  getSolverContFromCnt
#    solverに関するdataをcntファイルから取得
def getSolverContFromCnt():
    #values = []
    lines = readFistrModelCnt()
    i = pyFistr.getNextHeaderName(lines, 0, "!SOLVER", "")
    method = abaqus2fistr.getValName(lines[i], "METHOD")
    precond = abaqus2fistr.getValName(lines[i], "PRECOND")
    iterLog = abaqus2fistr.getValName(lines[i], "ITERLOG")
    timeLog = abaqus2fistr.getValName(lines[i], "TIMELOG")
    i += 1
    if lines[i][0] == "!":
        nIter = ""
        resid = ""
    else:
        nIter = deleteSp(lines[i]).split(",")[0]
        i += 1
        if lines[i] == "!":
            resid = ""
        else:
            resid = deleteSp(lines[i]).split(",")[0]
    #出力間隔を取得
    freq = "1"
    i = pyFistr.getNextHeaderName(lines, 0, "!WRITE", "")
    val = abaqus2fistr.getValName(lines[i], "FREQUENCY")
    if val != "":
        freq = val
    #restartを取得
    i = pyFistr.getNextHeaderName(lines, 0, "!RESTART", "")
    if i < len(lines):
        restartFreq = abaqus2fistr.getValName(lines[i], "FREQUENCY")
    else:
        restartFreq = "1"
    if restartFreq == "":
        restartFreq = "1"
    return [method, precond, nIter, resid, iterLog, timeLog, freq, restartFreq]

#
#  getOutputContFromCnt
#    outputに関するdataをcntファイルから取得
def getOutputContFromCnt():
    #values = []
    lines = readFistrModelCnt()
    #outputItemsを取得
    allItems = outputItems()
    selItems = []
    
    i = pyFistr.getNextHeaderName(lines, 0, "!OUTPUT_RES", "")
    i += 1
    while i < len(lines):
        line = lines[i]
        if line[0] == "!" or line[0] == "#":
            break
        words = deleteSp(line).split(",")
        if len(words) == 2:
            if words[1] == "ON":
                selItems.append(words[0])
        i += 1
    if len(selItems) == 0:
        selItems = iniOutputItems()
        selItems.sort()
    else:
        selItems = makeLongOutputName(selItems)
    noItems = pyFistr.getNoGroups(allItems, selItems)
    noItems.sort()
    return [noItems, selItems]

#
#  makeLongOutputName
#    outputNameに説明追加
def makeLongOutputName(names):
    newNames = []
    allNames = outputItems()
    for name in names:
        for longName in allNames:
            if name == longName.split(":")[1]:
                newNames.append(longName)
                break
    return newNames

#
#  searchSetBndInLines
#    bndSetをcntファイルから探す
def searchSetBndInLines(lines, setBnd):
    [bnd, setName, stepName] = setBnd.split(",")
    #nStepを求める
    nStep = 0
    for n in range(len(stepDefine)):
        if stepDefine[n] == stepName:
            nStep = n
            break

    #検索してセットする
    ip = -1
    if bnd == "GRAV" or bnd == "CENT":
        #i = 0
        i = skipStepId(lines, nStep)
        while i < len(lines):
            if lines[i][:len("!DLOAD")] == "!DLOAD":
                words = deleteSp(lines[i+1]).split(",")
                if words[1] == bnd and words[0] == setName:
                    ip = i
                    break
            i += 1
    elif bnd == "VLOAD":
        #i = 0
        i = skipStepId(lines, nStep)
        while i < len(lines):
            if lines[i][:len("!DLOAD")] == "!DLOAD":
                words = deleteSp(lines[i+1]).split(",")
                if words[1][0] == "B" and words[0] == setName:
                    ip = i
                    break
            i += 1
    elif bnd == "DLOAD":
        #i = 0
        i = skipStepId(lines, nStep)
        while i < len(lines):
            if lines[i][:len("!DLOAD")] == "!DLOAD":
                words = deleteSp(lines[i+1]).split(",")
                if words[1] == "S" and words[0] == setName:
                    ip = i
                    break
            i += 1
    elif bnd == "STEP":
        #ip = pyFistr.getNextHeaderName(lines, 0, "!"+bnd, "")
        i = skipStepId(lines, nStep)
        ip = pyFistr.getNextHeaderName(lines, i, "!STEP", "")
    else:
        #i = 0
        i = skipStepId(lines, nStep)
        while i < len(lines):
            if lines[i][:len("!"+bnd)] == "!"+bnd:
                words = deleteSp(lines[i+1]).split(",")
                if words[0] == setName:
                    ip = i
                    break
            i += 1
    return ip

#
#  getStepListFromCnt
#    AMPLITUDEのために、!STEPがあれば、そのlistを返す
def getStepListFromCnt():
    lines = readFistrModelCnt()
    bndLines = []
    i = pyFistr.getNextHeaderName(lines, 0, "!STEP", "")
    while i < len(lines):
        if i < len(lines):
            stepName = abaqus2fistr.getValName(lines[i], "stepName")
            if stepName == "":
                stepName = "STEP0"
            ans = ["STEP", "SUBSTEPS", "STEP", stepName]
            bndLines.append(ans)
        i += 1
        i = pyFistr.getNextHeaderName(lines, i, "!STEP", "")
    return bndLines

#
#  getStepBndListFromDefineData
#    stepName部分のbndListを作成する
def getStepBndListFromDefineData(stepName):
    #step名からstepNoを取得
    n = 0; nStep = 0
    for name in stepDefine:
        if name == stepName:
            nStep = n
            break
        n += 1
    #境界条件を取得
    bndList = []
    lines = readFistrModelCnt()
    #stepNameまでの境界条件Listを取得
    n = 0
    while n <= nStep:
        bnList = getBndListFromDefine(lines, n)
        bndList += bnList
        n += 1
    return bndList

#
#  getAllStepBndListFromDefineData
#    全てのBndListを作成する
def getAllStepBndListFromDefineData():
    if len(stepDefine) > 0:
        stepName = stepDefine[-1]
        bndList = getStepBndListFromDefineData(stepName)
    else:
        lines = readFistrModelCnt()
        bndList = getBndListFromDefine(lines, 0)
    return bndList        

#
#  getBndListFromDefine
#    nStep目の境界条件Listを取得
def getBndListFromDefine(lines, nStep):
    bndList = []
    if len(stepDefine) == 0:
        stepName = ""
    else:
        stepName = stepDefine[nStep]
    #BOUNDARY
    for name in bndDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!BOUNDARY", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["BOUNDARY", name, "BOUNDARY", grpId, stp])
    #CLOAD
    for name in cloadDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!CLOAD", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["CLOAD", name, "LOAD", grpId, stp])
    #DLOAD(S)
    for name in dloadDefine[nStep]:
        bList = getDloadBoundaryIdStpName("DLOAD", lines, "S", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["DLOAD", name, "LOAD", grpId, stp])
    #DLOAD(BX)
    for name in vloadDefine[nStep]:
        bList = getDloadBoundaryIdStpName("DLOAD", lines, "BX", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["VLOAD", name, "LOAD", grpId, stp])
    #DLOAD(GRAV)
    for name in gravDefine[nStep]:
        bList = getDloadBoundaryIdStpName("DLOAD", lines, "GRAV", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["GRAV", name, "LOAD", grpId, stp])
    #DLOAD(CENT)
    for name in centDefine[nStep]:
        bList = getDloadBoundaryIdStpName("DLOAD", lines, "CENT", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["CENT", name, "LOAD", grpId, stp])
    #TEMPERATURE
    for name in tempDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!TEMPERATURE", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["TEMPERATURE", name, "LOAD", grpId, stp])
    #SPRING
    for name in springDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!SPRING", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["SPRING", name, "SPRING", grpId, stp])
    #CONTACT
    for name in contactDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!CONTACT", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["CONTACT", name, "CONTACT", grpId, stp])
    #FLOAD
    for name in floadDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!FLOAD", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["FLOAD", name, "FLOAD", grpId, stp])
    #VELOCITY
    for name in veloDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!VELOCITY", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["VELOCITY", name, "VELOCITY", grpId, stp])
    #ACCELERATION
    for name in accelDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!ACCELERATION", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["ACCELERATION", name, "ACCELERATION", grpId, stp])
    #FIXTEMP
    for name in fixtempDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!FIXTEMP", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["FIXTEMP", name, "FIXTEMP", grpId, stp])
    #CFLUX
    for name in cfluxDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!CFLUX", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["CFLUX", name, "CFLUX", grpId, stp])
    #SFLUX
    for name in sfluxDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!SFLUX", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["SFLUX", name, "SFLUX", grpId, stp])
    #DFLUX
    for name in dfluxDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!DFLUX", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["DFLUX", name, "DFLUX", grpId, stp])
    #SFILM
    for name in sfilmDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!SFILM", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["SFILM", name, "SFILM", grpId, stp])
    #SRADIATE
    for name in sradiateDefine[nStep]:
        bList = getBoundaryIdStpName(lines, "!SRADIATE", name, stepName)
        for [grpId, stp] in bList:
            bndList.append(["SRADIATE", name, "SRADIATE", grpId, stp])
    return bndList

#  getBoundaryIdStpName
def getBoundaryIdStpName(lines, bndName, name, stepName):
    grpId = ""
    i = 0
    nStep = 0
    bList = []
    while i < len(lines):
        line = lines[i]
        if line[:len(bndName)] == bndName:
            if deleteSp(lines[i+1]).split(",")[0] == name:
                grpId = abaqus2fistr.getValName(line, "GRPID")
                if len(stepDefine) == 0:
                    step = "STEP0"
                else:
                    step = stepDefine[nStep]
                bList.append([grpId, step])
        elif line[:len("!STEP")] == "!STEP":
            nStep += 1
            if abaqus2fistr.getValName(line, "stepName") == stepName:
                break
        i += 1
    return bList

#  getDloadBoundaryIdStpName
def getDloadBoundaryIdStpName(bnd, lines, bndName, name, stepName):
    grpId = ""
    i = 0
    nStep = 0
    bList = []
    while i < len(lines):
        line = lines[i]
        if line[:len(bnd)+1] == "!"+bnd:
            words = deleteSp(lines[i+1]).split(",")
            if words[1] == bndName:
                grpId = abaqus2fistr.getValName(line, "GRPID")
                step = stepDefine[nStep]
                bList.append([grpId, step])
        elif line[:len("!STEP")] == "!STEP":
            nStep += 1
            if abaqus2fistr.getValName(line, "stepName") == stepName:
                break
        i += 1
    return bList

#  getBoundaryId
def getBoundaryId(lines, bndName, name):
    grpId = ""
    i = 0
    while i < len(lines):
        if lines[i][:len(bndName)] == bndName:
            if deleteSp(lines[i+1]).split(",")[0] == name:
                grpId = abaqus2fistr.getValName(lines[i], "GRPID")
                break
        i += 1
    return grpId

#  getDloadBoundaryId
def getDloadBoundaryId(lines, bndName, name):
    grpId = ""
    i = 0
    while i < len(lines):
        if lines[i][:len("!DLOAD")] == "!DLOAD":
            i += 1
            words = deleteSp(lines[i]).split(",")
            if words[1] == bndName:
                grpId = abaqus2fistr.getValName(lines[i-1], "GRPID")
                break
        i += 1
    return grpId

#
#  reformStepBCCont
#    STEP解析に使用する境界条件を成形する
def reformStepBCCont(bnds, bndList):
    ans = []
    for bnd in bnds:
        bnd = deleteSp(bnd)
        for blist in bndList:
            if bnd == ",".join(blist[2:4]):
                newList = blist[:2] + [blist[-1]]
                #ans.append(",".join(blist[:2]))
                ans.append(",".join(newList))
                break
    return ans

#
#  reconstructStepBCCont
#    STEP解析に使用する境界条件を元に戻す
def reconstructStepBCCont(bnds, bndList):
    ans = []
    for bnd in bnds:
        bnd = deleteSp(bnd)
        for blist in bndList:
            newList = blist[:2] + [blist[-1]]
            #bLine = ",".join(blist[:2])
            bLine = ",".join(newList)
            if bnd == bLine:
                rLine = ", ".join(blist[2:4]) + ls
                ans.append(rLine)
                break
    return ans

#
#  convertDataForParaview
#    データ変換
def convertDataForParaview():
    #fileHeaderの確認
    meshFileHeader = "FistrModel"
    solType = getSolutitionTypeFromCnt()
    if solType == "EIGEN":
        resFileHeader = "FistrModel_eigen"
    elif solType == "HEAT" or solType == "HEAT_D":
        resFileHeader = "FistrModel_temp"
    else:
        resFileHeader = "FistrModel"
    #結果データの有無確認
    values = getHecmwContFromDat()
    parallel = values[0]
    if parallel == False:
        #シングル計算の場合 
        files = glob.glob(currDir + os.sep + resFileHeader + ".res.0*")
        if len(files) == 0:
            mess = _(u"計算結果が存在しません。")
            return mess
    else:
        #並列計算の場合
        files = glob.glob(currDir + os.sep + resFileHeader + ".res.merge*")
        if len(files) == 0:
            mess = _(u"計算結果が分散したままです。") + ls
            mess += _(u"rmergeで計算結果を結合して、FistrModel.res.merge.*ファイルを作成してください。")
            return mess

    #メッシュ変換
    addPara = " -para no"
    if parallel == True:
        addPara = " -para yes"
    os.chdir(currDir)
    pyFistr.removes("conv"+resFileHeader+".res.*.vtk")
    #「-u」オプション付きで「fistr2vtk.py」を起動する
    #realTimeでfistr2vtkの出力を取得するため
    comm = "python3 -u " + binAppPath + "fistr2vtk.py -mesh " + meshFileHeader + " -res " + resFileHeader + addPara + ls
    resp = getFrequencyReactFromCnt()
    if resp == True:
        #周波数応答の場合、追加変換
        resFileHeader = "FistrModel_dyna"
        pyFistr.removes("conv"+resFileHeader+".res.*.vtk")
        #「-u」オプション付きで「fistr2vtk.py」を起動する
        comm += "python3 - u " + binAppPath + "fistr2vtk.py -mesh " + meshFileHeader + " -res " + resFileHeader + addPara + ls
    title = "convData"
    if os.name=="nt":
        f=open("run.bat", "w"); f.write(comm); f.close()
        #runComm = 'echo "' + comm + '" > run.bat'
        #os.system(runComm)
        commSet = "python3 " + pythonAppPath + "runCommandWithDialog2.py " + title + " run.bat"
    else:
        comm = "#!/bin/bash" + ls + comm
        runComm = "echo '" + comm + "' > run; chmod a+x run"
        os.system(runComm)
        commSet = "python3 " + pythonAppPath + "runCommandWithDialog2.py " + title + " ./run"
    pyFistr.runAppBG(commSet)
    return u""

#
#  deleteStepContInCnt
#    STEPを削除
def deleteStepContInCnt():
    lines = readFistrModelCnt()
    lines = deleteStepCont(lines)
    writeFistrModelCnt(lines)

#
#  deleteGravContInCnt
#    GRAVを削除
def deleteGravContInCnt():
    lines = readFistrModelCnt()
    lines = deleteGravCont(lines)
    writeFistrModelCnt(lines)

#
#  deleteGravCont
#
def deleteGravCont(lines):
    newLines = []
    i = 0
    while i < len(lines):
        grpTypes = pyFistr.getNextDloadGrpType(lines, i)
        if len(grpTypes) > 0:
            if len(grpTypes) == 1:
                [grp, bndType, dummy_line, i] = grpTypes[0]
                if grp == "ALL" and bndType == "GRAV":
                    newLines = lines[:i-1] + lines[i+1:]
                    break
                else:
                    i += 1
            else:
                i += 1
        else:
            break
    if len(newLines) > 0:
        #GRPIDを修正
        newLines = pyFistr.remakeGRPID(newLines, "!DLOAD")
    else:
        newLines = lines
    return newLines

#
#  matchControlCont
#    cntFileの内容をmeshに合わせる
def matchControlCont():
    lines = readFistrModelCnt()
    lines = deleteDloadWithoutNames(lines, meshGroup[1], -1)
    lines = deleteCloadWithoutNames(lines, meshGroup[2], -1)
    lines = deleteBoundaryWithoutNames(lines, meshGroup[2], -1)
    lines = deleteVloadWithoutNames(lines, meshGroup[0], -1)
    lines = deleteCentWithoutNames(lines, meshGroup[0], -1)
    writeFistrModelCnt(lines)
    matNames = getMatNamesInCnt(lines)
    flag = deleteMaterialInSectionWithoutNames(matNames)
    if flag == 1:
        writeFistrModelMshHeader()

#
#  deleteMaterialInSectionWithoutNames
#    mshファイルのSECTION行から指定されていないmatNamesを削除する
def deleteMaterialInSectionWithoutNames(matNames):
    global meshHeaderData
    flag = 0
    for i in range(len(meshHeaderData)):
        line = meshHeaderData[i][0]
        if line[:len("!SECTION")] == "!SECTION":
            name = abaqus2fistr.getValName(line, "MATERIAL")
            delName = "yes"
            for matName in matNames:
                if name == matName:
                    delName = "no"
                    break
            if delName == "yes":
                flag = 1
                #matNameを削除
                words = deleteSp(line).split(",")
                newWords = []
                for word in words:
                    if word[:len("MATERIAL=")] != "MATERIAL=":
                        newWords.append(word)
                meshHeaderData[i][0] = ", ".join(newWords) + ls
    return flag

#
#  getMatNamesInCnt
#    cntファイルに定義されているmatNamesを取得
def getMatNamesInCnt(lines):
    matNames = []
    for line in lines:
        if line[:len("!MATERIAL")] == "!MATERIAL":
            matName = abaqus2fistr.getValName(line, "NAME")
            matNames.append(matName)
    return matNames

#
#  resetCntMshFile
#    cntファイルの材料と境界条件を削除する
def resetCntMshFile():
    global matDefine, bndDefine, cloadDefine, dloadDefine, vloadDefine, centDefine
    global tempDefine, gravDefine, contactDefine, stepDefine, meshHeaderData
    lines = readFistrModelCnt()
    lines = deleteMaterialWithoutNames(lines, [])
    lines = deleteDloadWithoutNames(lines, [], -1)
    lines = deleteCloadWithoutNames(lines, [], -1)
    lines = deleteBoundaryWithoutNames(lines, [], -1)
    lines = deleteVloadWithoutNames(lines, [], -1)
    lines = deleteTemperatureCont(lines)
    lines = deleteGravCont(lines)
    writeFistrModelCnt(lines)
    #lines = readFistrModelMsh()
    #meshHeaderData = pyFistr.getHeaderNumData(lines)
    meshHeaderData = deleteMaterialWithoutNamesHeader(meshHeaderData, [])
    writeFistrModelMshHeader()
    matDefine = []
    bndDefine = [[]]
    cloadDefine = [[]]
    dloadDefine = [[]]
    vloadDefine = [[]]
    centDefine = [[]]
    tempDefine = [[]]
    gravDefine = [[]]
    contactDefine = [[]]
    stepDefine = []
    makeIniTreeData()

#
#  deleteMaterialWithoutNamesHeader
#    不要なMATERIALの定義を削除（meshHeaderData内から削除）
def deleteMaterialWithoutNamesHeader(meshHeaderData, matNames):

    def isOtherName(matNames, name):
        ans = False
        flag = 0
        for matName in matNames:
            if name == matName:
                flag = 1
                break
        if flag == 0:
            ans = True
        return ans

    def isInMatHeader(line, matGrp):
        ans = False
        for mat in matGrp:
            if line[:len(mat)] == mat:
                ans = True
                break
        return ans    

    def skipNextHeader(i, matGrp):
        ans = i
        while i < len(meshHeaderData):
            line = meshHeaderData[i][0]
            if isInMatHeader(line, matGrp) == False:
                ans = i - 1
                break
            i += 1
        return ans

    matGrp = matGrpHeader
    newHeaderData = []
    i = 0
    while i < len(meshHeaderData):
        line = meshHeaderData[i][0]
        data = meshHeaderData[i][1]
        if line[:len("!MATERIAL")] == "!MATERIAL":
            name = abaqus2fistr.getValName(line, "NAME")
            if isOtherName(matNames, name) == True:
                i = skipNextHeader(i+1, matGrp)
            else:
                newHeaderData.append([line, data])
        else:
            newHeaderData.append([line, data])
        i += 1        
    return newHeaderData

#
#  deleteMaterialWithoutNames
#    不要なMATERIALの定義を削除
def deleteMaterialWithoutNames(lines, matNames):

    def isOtherName(matNames, name):
        ans = False
        flag = 0
        for matName in matNames:
            if name == matName:
                flag = 1
                break
        if flag == 0:
            ans = True
        return ans

    def isInMaterial(line, matGrp):
        ans = False
        for mat in matGrp:
            if line[:len(mat)] == mat:
                ans = True
                break
        return ans    

    def skipNextLine(lines, i, matGrp):
        ans = i
        while i < len(lines):
            if lines[i][0] == "!" or lines[i][0] == "#":
                if isInMaterial(lines[i], matGrp) == False:
                    ans = i - 1
                    break
            i += 1
        return ans

    matGrp = matGrpHeader
    newLines = []
    i = 0
    while i < len(lines):
        line = lines[i]
        if line[:len("!MATERIAL")] == "!MATERIAL":
            name = abaqus2fistr.getValName(line, "NAME")
            if isOtherName(matNames, name) == True:
                i = skipNextLine(lines, i+1, matGrp)
            else:
                newLines.append(lines[i])
        else:
            newLines.append(lines[i])
        i += 1
    return newLines

#
#  addContactPairNameInMsh
#    contact定義を追加
def addContactPairNameInMsh(meshHeaderData, pairName, slave, master):
    #mshにpairName追加
    header = "!CONTACT PAIR, NAME=" + pairName + ls
    data = [slave + ", " + master + ls]
    addHeaderData = [header, data]
    ni = -1
    for i in range(len(meshHeaderData)):
        line = meshHeaderData[i][0]
        if line[:len("!END")] == "!END":
            ni = i
            break
    if ni > 0:
        meshHeaderData = meshHeaderData[:ni] + [addHeaderData] + meshHeaderData[ni:]
    else:
        meshHeaderData += [addHeaderData]
    return meshHeaderData

#
#  replaceContactInCnt
#    contactを置き換える
def replaceContactInCnt(pairName, interaction, nTol, tTol, coeff, factor, nStep):
    lines = readFistrModelCnt()
    i = skipStepId(lines, nStep)
    while i < len(lines):
        line = lines[i]
        if line[0] == "!":
            words = deleteSp(line).split(",")
            if words[0] == "!CONTACT":
                if deleteSp(lines[i+1]).split(",")[0] == pairName:
                    #置き換える場所start
                    ps = i
                    break
        i += 1
    i = ps + 1
    while i < len(lines):
        line = lines[i]
        if line[0] == "!":
            #置き換える場所end
            pe = i
            break
        i += 1
    #置き換え
    grpid = abaqus2fistr.getValName(lines[ps], "GRPID")
    addLines =  ["!CONTACT, GRPID=" + grpid + ", INTERACTION=" + interaction + ", NTOL=" + nTol
                    + ", TTOL=" + tTol + ls]
    addLines += [pairName + ", " + coeff + ", " + factor + ls]
    newLines = lines[:ps] + addLines + lines[pe:]
    writeFistrModelCnt(newLines)

#
#  deleteAmpNameInCnt
#    該当するsetNameをcntファイルから削除
def deleteAmpNameInCnt(lines, ampName):
    i = 0
    while i < len(lines):
        if lines[i][0] == "!":
            name = abaqus2fistr.getValName(lines[i], "AMP")
            if name == ampName:
                words = deleteSp(lines[i]).split(",")
                newWords = []
                for word in words:
                    if word[:len("AMP=")] != "AMP=":
                        newWords.append(word)
                lines[i] = ", ".join(newWords) + ls
        i += 1
    return lines

#
#  deleteAmpWithoutNamesInCntMsh
#    amplitude定義を削除（names以外を削除）
def deleteAmpWithoutNamesInCntMsh(names):
    global meshHeaderData
    #msh側のampNameを削除
    newHeaderData = []
    for headerData in meshHeaderData:
        line = headerData[0]
        if line[:len("!AMPLITUDE")] == "!AMPLITUDE":
            name = abaqus2fistr.getValName(line, "NAME")
            isDelete = "yes"
            for ampName in names:
                if ampName == name:
                    isDelete = "no"
                    break
            if isDelete == "no":
                newHeaderData.append(headerData)
        else:
            newHeaderData.append(headerData)
    meshHeaderData = newHeaderData
    #cnt側を削除
    lines = readFistrModelCnt()
    flag = 0
    i = 0
    while i < len(lines):
        if lines[i][0] == "!":
            name = abaqus2fistr.getValName(lines[i], "AMP")
            if name != "":
                isDelete = "yes"
                for ampName in names:
                    if ampName == name:
                        isDelete = "no"
                        break
                if isDelete == "yes":
                    lines[i] = pyFistr.deleteValName(lines[i], "AMP")
                    flag = 1
        i += 1
    if flag == 1:
        writeFistrModelCnt(lines)

#
#  deleteContactPairNameInMsh
#    contactPairNameをmshファイルから削除
def deleteContactPairNameInMsh(meshHeaderData, pairNames):
    delMeshPairNames = pairNames
    #msh側のcontactPairを削除
    newHeaderData = []
    for headerData in meshHeaderData:
        line = headerData[0]
        if line[:len("!CONTACT PAIR")] == "!CONTACT PAIR":
            name = abaqus2fistr.getValName(line, "NAME")
            if name in delMeshPairNames:
                pass
            else:
                newHeaderData.append(headerData)
        else:
            newHeaderData.append(headerData)
    meshHeaderData = newHeaderData
    return meshHeaderData

#
#  deleteContactInCnt
#    対象のcontactを全てor内容を削除する
#    delFlag = "all":全て削除, "cont":内容を削除（!CONTACT行を残す）
def deleteContactInCnt(pairNames, nStep, delFlag):
    lines = readFistrModelCnt()
    #contact削除
    cntLines = []
    n = 0
    i = 0
    while i < len(lines):
        line = lines[i]
        if line[:len("!CONTACT")] == "!CONTACT":
            if deleteSp(line).split(",")[0] == "!CONTACT":
                if n == nStep:
                    name = deleteSp(lines[i+1]).split(",")[0]
                    flag = 0
                    for pairName in pairNames:
                        if name == pairName:
                            if delFlag != "all":
                                cntLines.append(lines[i])
                            flag = 1
                            break
                    if flag == 0:
                        cntLines.append(lines[i])
                    else:
                        i += 1
                else:
                    cntLines.append(lines[i])
            else:
                cntLines.append(lines[i])
        elif line[:len("!STEP")] == "!STEP":
            n += 1
            cntLines.append(lines[i])
        else:
            cntLines.append(lines[i])
        i += 1
    writeFistrModelCnt(cntLines)

#
#  getInitialGroupInMsh
#    INITIALのgroup名を取得
def getInitialGroupInMsh():
    names = []
    for headerData in meshHeaderData:
        line = headerData[0]
        if line[:len("!INITIAL CONDITION")] == "!INITIAL CONDITION":
            dataLines = headerData[1]
            for dataLine in dataLines:
                name = deleteSp(dataLine).split(",")[0]
                names.append(name)
    names.sort()
    return names

#
#  getAmpGroupInMsh
#    AMP名を取得
def getAmpGroupInMsh():
    names = []
    for headerData in meshHeaderData:
        line = headerData[0]
        if line[:len("!AMPLITUDE")] == "!AMPLITUDE":
            name = abaqus2fistr.getValName(line, "NAME")
            names.append(name)
    names.sort()
    return names

#
#  getNodeNumOfNodeGroupInMesh
#    nodeGroup内のnode数を取得
def getNodeNumOfNodeGroupInMesh(ngrpName):
    nNodes = 0.0
    parameterList = getMeshParameterList()
    flag = 0
    for lines in parameterList:
        if len(lines) != 0:
            if lines[0][:len("!NGROUP")] == "!NGROUP":
                for line in lines:
                    sName = "NGRP=" + ngrpName
                    n = line.find(sName)
                    if n >= 0:
                        line = pyFistr.deleteSp(line)
                        words = line.split(",")
                        flag = 1
                        break
            if flag == 1:
                sName = "NUM="
                for word in words:
                    if word[:len(sName)] == sName:
                        nNodes = float(word.split("=")[1])
                        break
    return nNodes

#
#  getContactContInCntMsh
#    [slave, master, interaction, nTol, tTol, coeff, factor]を取得
def getContactContInCntMsh(name, nStep):
    pairNames = getContactPairNameInMsh(name)
    conts = getContactContInCnt(name, nStep)
    ans = pairNames + conts
    return ans

#
#  getContactContInCnt
#    contactの内容を取得
def getContactContInCnt(name, nStep):
    #coeffs = ["0.0", "1.0e3"]
    coeffs = ["0.0", "1.0e5"]
    interaction = "FSLID"
    nTol = "1.0e-5"
    tTol = "1.0e-3"
    #nPena = "1.0e3"
    #tPena = "1.0e3"
    lines = readFistrModelCnt()
    i = skipStepId(lines, nStep)            #stepId分skip
    while i < len(lines):
        line = lines[i]
        if line[:len("!CONTACT")] == "!CONTACT":
            if deleteSp(line).split(",")[0] == "!CONTACT":
                words = deleteSp(lines[i+1]).split(",")
                if words[0] == name:
                    coeffs = words[1:]
                    interW = abaqus2fistr.getValName(line, "INTERACTION")
                    nTolW = abaqus2fistr.getValName(line, "NTOL")
                    tTolW = abaqus2fistr.getValName(line, "TTOL")
                    if interW != "":
                        interaction = interW
                    if nTolW != "":
                        nTol = nTolW
                    if tTolW != "":
                        tTol = tTolW
                    break
        i += 1
    conts = [interaction] + [nTol] + [tTol] + coeffs
    return conts

#
#  getContactPairNameInMsh
#    contactPairの[slave, master]名を取得
def getContactPairNameInMsh(name):
    pairNames = ["", ""]
    for headerData in meshHeaderData:
        line = headerData[0]
        if line[:len("!CONTACT PAIR")] == "!CONTACT PAIR":
            if abaqus2fistr.getValName(line, "NAME") == name:
                pairLine = headerData[1][0]
                pairNames = deleteSp(pairLine).split(",")
                break
    return pairNames

#
#  getContactAlgoInCnt
#    contactの内容を取得
def getContactAlgoInCnt():
    lines = readFistrModelCnt()
    #algo = "SLAGRANGE"
    algo = contactAlgo
    i = 0
    while i < len(lines):
        line = lines[i]
        if line[:len("!CONTACT_ALGO")] == "!CONTACT_ALGO":
            algo = abaqus2fistr.getValName(line, "TYPE")
            break
        i += 1
    return algo

#
#  getTemperatuteGroupInCnt
#    TEMPERATUREのgroup名を取得
def getTemperatuteGroupInCnt(lines):
    names = []
    i = 0
    while i < len(lines):
        i = pyFistr.getNextHeaderName(lines, i, "!TEMPERATURE", "")
        if i < len(lines):
            name = deleteSp(lines[i+1]).split(",")[0]
            names.append(name)
        i += 1
    return names

#
#  getCentGroupInCnt
#    CENT（遠心力）のgroupを取得
def getCentGroupInCnt(lines):
    cents = getDloadTypeGroupInCnt(lines, "CENT")
    return cents

#  getGravGroupInCnt
#    GRAV（重力）のgroupを取得
def getGravGroupInCnt(lines):
    grp = getDloadTypeGroupInCnt(lines, "GRAV")
    return grp

#
#  getVloadGroupInCnt
#    VLOAD（体積力）のgroupを取得
def getVloadGroupInCnt(lines):
    vload = getDloadTypeGroupInCnt(lines, "BX")
    if len(vload) == 0:
        vload = getDloadTypeGroupInCnt(lines, "BY")
        if len(vload) == 0:
            vload = getDloadTypeGroupInCnt(lines, "BZ")
    return vload

#
#  getDloadGroupInCnt
#    DLOAD（面荷重）のgroupを取得
def getDloadGroupInCnt(lines):
    dload = getDloadTypeGroupInCnt(lines, "S")
    return dload

#  getDloadTypeGroupInCnt
def getDloadTypeGroupInCnt(lines, bndType):
    dload = []
    bnd = []
    i = 1
    while i < len(lines):
        line = lines[i]
        if line[:len("!DLOAD")] == "!DLOAD":
            i += 1
            line = deleteSp(lines[i])
            words = line.split(",")
            if words[1] == bndType:
                sgrp = words[0]
                #dload.append(sgrp)
                bnd.append(sgrp)
        elif line[:len("!STEP")] == "!STEP":
            dload.append(bnd)
            bnd = []
        i += 1
    if len(dload) == 0:
        dload.append(bnd)
    return dload

#
#  getStepGroupInCnt
#    STEPのgroup名を取得
def getStepGroupInCnt(lines):
    steps = []
    i = 0
    while i < len(lines):
        line = lines[i]
        if line[:len("!STEP")] == "!STEP":
            stepName = abaqus2fistr.getValName(line, "stepName")
            if stepName != "":
                steps.append(stepName)
        i += 1
    return steps

#
#  getTemperatureGroupInCnt
#    TEMPERATUREのgroupを取得
def getTemperatureGroupInCnt(lines):
    temp = []
    i = pyFistr.getNextHeaderName(lines, 0, "!TEMPERATURE", "")
    while i < len(lines):
        ngrp = deleteSp(lines[i+1]).split(",")[0]
        temp.append(ngrp)
        i = pyFistr.getNextHeaderName(lines, i+1, "!TEMPERATURE", "")
    return temp

#
#  getAnalysisTypeInCnt
#    解析の種類を取得
def getAnalysisTypeInCnt(lines):
    anaType = "STATIC"
    i = 0
    while i < len(lines):
        line = lines[i]
        if line[:len("!SOLUTION")] == "!SOLUTION":
            anaType = abaqus2fistr.getValName(line, "TYPE")
            break
        i += 1
    if anaType == "DYNAMIC":
        if lines[i+1][:len("!EIGENREAD")] == "!EIGENREAD":
            anaType = "DYNAMIC_F"
    elif anaType == "HEAT":
        if lines[i+1][:len("!HEAT")] == "!HEAT":
            words = deleteSp(lines[i+2]).split(",")
            if len(words) > 3:
                try:
                    if float(words[0]) > 0.0:
                        anaType = "HEAT_D"
                except:
                    pass
    return anaType

#
#  getBoundaryNodeGroupInCnt
#    nodeGroupに設定する境界条件のgroupを取得
def getBoundaryNodeGroupInCnt(lines, boundName):
    boundary = []
    bnd = []
    i = 0
    while i < len(lines):
        line = lines[i]
        if line[:len(boundName)] == boundName:
            words = deleteSp(line).split(",")
            if words[0] == boundName:
                i += 1
                line = deleteSp(lines[i])
                ngrp = line.split(",")[0]
                bnd.append(ngrp)
        elif line[:len("!STEP")] == "!STEP":
            boundary.append(bnd)
            bnd = []
        i += 1
    if len(boundary) == 0:
        boundary.append(bnd)
    return boundary


#
#  writeInitialContInMsh
#    INITIALを書き換え
def writeInitialContInMsh(ngrpName, iniTemp):
    global meshHeaderData
    i = 0
    while i < len(meshHeaderData):
        line = meshHeaderData[i][0]
        if line[:len("!INITIAL CONDITION")] == "!INITIAL CONDITION":
            dataLines = meshHeaderData[i][1]
            flag = 0
            for n in range(len(dataLines)):
                dataLine = dataLines[n]
                name = deleteSp(dataLine).split(",")[0]
                if name == ngrpName:
                    dataLines[n] = name + ", " + iniTemp + ls
                    flag = 1
                    break
            if flag == 1:
                meshHeaderData[i][1] = dataLines
                break
        i += 1
    if flag == 0:
        header = "!INITIAL CONDITION, TYPE=TEMPERATURE" + ls
        dataLines = [ngrpName + ", " + iniTemp + ls]
        headerData = [header, dataLines]
        meshHeaderData = meshHeaderData[:-1] + headerData + meshHeaderData[-1:]
    writeFistrModelMshHeader()

#
#  writeSradiateContInCnt
#    SRADIATEを書き換え
def writeSradiateContInCnt(sgrpName, vals, nStep):
    ip = -1
    lines = readFistrModelCnt()
    i = skipStepId(lines, nStep)
    while i < len(lines):
        i = pyFistr.getNextHeaderName(lines, i, "!SRADIATE", "")
        if i < len(lines):
            #i += 1
            words = deleteSp(lines[i+1]).split(",")
            if words[0] == sgrpName:
                ip = i
                #words[1] = vals[0]
                #words[2] = vals[1]
                #lines[i] = ", ".join(words) + "\n"
                break
        i += 1
    if ip >= 0:
        lines = pyFistr.delete1header(lines, ip)
    #追加する行を作成
    addLines =  ["!SRADIATE, GRPID=1" + ls]
    addLines += [sgrpName + ", " + vals[0] + ", " + vals[1] + ls]
    #行を追加
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!SRADIATE")
    writeFistrModelCnt(lines)

#
#  writeSfilmContInCnt
#    SFILMを書き換え
def writeSfilmContInCnt(sgrpName, vals, nStep):
    lines = readFistrModelCnt()
    #ip = -1
    i = skipStepId(lines, nStep)
    while i < len(lines):
        i = pyFistr.getNextHeaderName(lines, i, "!SFILM", "")
        if i < len(lines):
            i += 1
            words = deleteSp(lines[i]).split(",")
            if words[0] == sgrpName:
                #ip = i
                words[1] = vals[0]
                words[2] = vals[1]
                lines[i] = ", ".join(words) + ls
                break
    if i >= len(lines):
        addLines =  ["!SFILM" + ls]
        addLines += [sgrpName + ", " + vals[0] + ", " + vals[1] + ls]
        lines = addLines + lines
    writeFistrModelCnt(lines)

#
#  writeDfluxContInCnt
#    DFLUXを書き換え
def writeDfluxContInCnt(egrpName, value, nStep):
    ip = -1
    lines = readFistrModelCnt()
    i = skipStepId(lines, nStep)
    while i < len(lines):
        i = pyFistr.getNextHeaderName(lines, i, "!DFLUX", "")
        if i < len(lines):
            #i += 1
            words = deleteSp(lines[i+1]).split(",")
            if words[0] == egrpName and words[1] == "BF":
                ip = i
                words[2] = value
                lines[i] = ", ".join(words) + ls
                break
        i += 1
    if ip >= 0:
        lines = pyFistr.delete1header(lines, ip)
    #追加する行を作成
    addLines =  ["!DFLUX, GRPID=1" + ls]
    addLines += [egrpName + ", BF, " + value + ls]
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!DFLUX")
    writeFistrModelCnt(lines)

#
#  writeSfluxContInCnt
#    SFLUXを書き換え
def writeSfluxContInCnt(sgrpName, value, nStep):
    lines = readFistrModelCnt()
    #該当部を削除
    ip = -1
    i = skipStepId(lines, nStep)
    while i < len(lines):
        i = pyFistr.getNextHeaderName(lines, i, "!SFLUX", "")
        if i < len(lines):
            #i += 1
            words = deleteSp(lines[i+1]).split(",")
            if words[0] == sgrpName:
                ip = i
                words[1] = value
                lines[i] = ", ".join(words) + ls
                break
        i += 1
    if ip >= 0:
        lines = pyFistr.delete1header(lines, ip)
    #追加する行を作成
    addLines =  ["!SFLUX, GRPID=1" + ls]
    addLines += [sgrpName + ", " + value + ls]
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!SFLUX")
    writeFistrModelCnt(lines)

#
#  writeCfluxContInCnt
#    CFLUXを書き換え
def writeCfluxContInCnt(ngrpName, cfluxCont, qwType, value, nStep):
    lines = readFistrModelCnt()
    #該当部分を削除
    ip = -1
    i = skipStepId(lines, nStep)
    while i < len(lines):
        i = pyFistr.getNextHeaderName(lines, i, "!CFLUX", "")
        if i < len(lines):
            words = deleteSp(lines[i+1]).split(",")
            if words[0] == ngrpName:
                ip = i
                words[1] = value
                lines[i] = ", ".join(words) + ls
                break
        i += 1
    if ip >= 0:
        lines = pyFistr.delete1header(lines, ip)
    #追加する行を作成
    addLines =  ["!CFLUX, qwType=" + qwType + ", value=" + value + ", GRPID=1" + ls]
    addLines += [ngrpName + ", " + cfluxCont + ls]
    #行を追加
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!CFLUX")
    writeFistrModelCnt(lines)

#
#  writeFixtempContInCnt
#    FIXTEMPを書き換え
def writeFixtempContInCnt(ngrpName, value, nStep):
    lines = readFistrModelCnt()
    #該当部を削除
    ip = -1
    i = skipStepId(lines, nStep)
    while i < len(lines):
        i = pyFistr.getNextHeaderName(lines, i, "!FIXTEMP", "")
        if i < len(lines):
            words = deleteSp(lines[i+1]).split(",")
            if words[0] == ngrpName:
                ip = i
                words[1] = value
                lines[i] = ", ".join(words) + ls
                break
        i += 1
    if ip >= 0:
        lines = pyFistr.delete1header(lines, ip)
    #追加する行を作成
    addLines =  ["!FIXTEMP, GRPID=1" + ls]
    addLines += [ngrpName + ", " + value + ls]
    #行を追加
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!FIXTEMP")
    writeFistrModelCnt(lines)

#
#  writeAccelContInCnt
#    ACCELERATIONを書き換え
def writeAccelContInCnt(ngrpName, values, nStep):
    [x, y, z] = values
    lines = readFistrModelCnt()
    #該当部を削除
    ip = -1
    i = skipStepId(lines, nStep)        #stepId分skipする
    while i < len(lines):
        i = pyFistr.getNextHeaderName(lines, i, "!ACCELERATION", "")
        if i < len(lines):
            words = deleteSp(lines[i+1]).split(",")
            if words[0] == ngrpName:
                ip = i
                break                
        i += 1
    if ip >= 0:
        lines = pyFistr.delete1header(lines, ip)
    #追加する行を作成
    if x=="" and y=="" and z=="":
        addLines = []
    else:
        addLines = ["!ACCELERATION, GRPID=1" + ls]
        if x != "":
            addLines += [ngrpName + ", 1, 1, " + x + ls]
        if y != "":
            addLines += [ngrpName + ", 2, 2, " + y + ls]
        if z != "":
            addLines += [ngrpName + ", 3, 3, " + z + ls]
    #行を追加
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!ACCELERATION")
    #書き込み
    writeFistrModelCnt(lines)

#
#  writeVeloContInCnt
#    VELOCITYを書き換え
def writeVeloContInCnt(ngrpName, values, nStep):
    [x, y, z] = values
    lines = readFistrModelCnt()
    #該当部を削除
    ip = -1
    if nStep <= 0:
        #最初から検索
        i = 0
    else:
        #途中から検索
        i = skipStepId(lines, nStep)
    #  削除部分を検索
    i = pyFistr.getNextHeaderName(lines, i, "!VELOCITY", "")
    while i < len(lines):
        if lines[i][:len("!STEP")] == "!STEP":
            break
        i += 1
        name = deleteSp(lines[i]).split(",")[0]
        if name == ngrpName:
            ip = i - 1
            break
        i = pyFistr.getNextHeaderName(lines, i, "!VELOCITY", "")
    #  削除
    if ip > 0:
        lines = pyFistr.delete1header(lines, ip)
    #追加する行を作成
    if x=="" and y=="" and z=="":
        addLines = []
    else:
        addLines = ["!VELOCITY, GRPID=1" + ls]
        if x != "":
            addLines += [ngrpName + ", 1, 1, " + x + ls]
        if y != "":
            addLines += [ngrpName + ", 2, 2, " + y + ls]
        if z != "":
            addLines += [ngrpName + ", 3, 3, " + z + ls]
    #行を追加
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!VELOCITY")
    #書き込み
    writeFistrModelCnt(lines)
        
#
#  writeFloadContInCnt
#    FLOADを書き換え
def writeFloadContInCnt(ngrpName, values, nStep):
    loadCase = values[0]
    [x, y, z] = values[1]
    lines = readFistrModelCnt()
    #該当部を削除
    ip = -1
    if nStep <= 0:
        i = 0
    else:
        i = skipStepId(lines, nStep)
    #  削除部分を検索
    i = pyFistr.getNextHeaderName(lines, i, "!FLOAD", "")
    while i < len(lines):
        if lines[i][:len("!STEP")] == "!STEP":
            break
        i += 1
        name = deleteSp(lines[i]).split(",")[0]
        if name == ngrpName:
            ip = i - 1
            break
        i = pyFistr.getNextHeaderName(lines, i, "!FLOAD", "")
    if ip > 0:
        lines = pyFistr.delete1header(lines, ip)
    #追加する行を作成
    addLines  = ["!FLOAD, CASE=" + loadCase + ls]
    addLines += [ngrpName + ", 1, " + x + ls]
    addLines += [ngrpName + ", 2, " + y + ls]
    addLines += [ngrpName + ", 3, " + z + ls]
    #行を追加
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDをセット
    lines = pyFistr.remakeGRPID(lines, "!FLOAD")
    #書き込み
    writeFistrModelCnt(lines)

#
#  writeCentContInCnt
#    CENTを書き換え
def writeCentContInCnt(grp, addLines, nStep):
    lines = readFistrModelCnt()
    lines = deleteDloadNames(lines, "CENT", [grp], nStep)
    lines = addDloadContNames(lines, [grp], addLines, nStep)
    writeFistrModelCnt(lines)

#
#  writeTemperatureContInCnt
#    TEMPERATURE, REFTEMPを書き換え
def writeTemperatureContInCnt(grp, addLines, nStep):
    lines = readFistrModelCnt()
    lines = deleteTemperatureGrpCont(lines, [grp], nStep)
    lines = addTemperatureCont(lines, addLines, nStep)
    lines = pyFistr.remakeGRPID(lines, "!TEMPERATURE")
    #lines = pyFistr.remakeGRPID(lines, "!REFTEMP")
    writeFistrModelCnt(lines)

#
#  writeRefTempContInCnt
#
def writeRefTempContInCnt(addLines):
    lines = readFistrModelCnt()
    #lines = deleteRefTempCont(lines)
    lines = pyFistr.deleteHeaderName(lines, 0, "!REFTEMP", "")
    lines = addRefTempCont(lines, addLines)
    lines = pyFistr.remakeGRPID(lines, "!REFTEMP")
    writeFistrModelCnt(lines)

#
#  writeStepContInCnt
#    STEPを書き換え
def writeStepContInCnt(addLines):
    lines = readFistrModelCnt()
    lines = deleteStepCont(lines)
    lines = addStepCont(lines, addLines)
    writeFistrModelCnt(lines)

#
#  writeGravContInCnt
#    GRAVを書き換え
def writeGravContInCnt(grp, addLines, nStep):
    lines = readFistrModelCnt()
    lines = deleteGravContNames(lines, [grp], nStep)
    lines = addDloadContNames(lines, [grp], addLines, nStep)
    writeFistrModelCnt(lines)

#
#  writeVloadContInCnt
#    VLOADを書き換え
def writeVloadContInCnt(grp, addLines, nStep):
    lines = readFistrModelCnt()
    lines = deleteVloadContNames(lines, [grp], nStep)
    lines = addDloadContNames(lines, [grp], addLines, nStep)
    writeFistrModelCnt(lines)

#
#  writeDloadContInCnt
#    DLOADを書き換え
def writeDloadContInCnt(grp, addLines, nStep):
    lines = readFistrModelCnt()
    lines = deleteDloadContNames(lines, [grp], nStep)
    lines = addDloadContNames(lines, [grp], addLines, nStep)
    writeFistrModelCnt(lines)

#  addStepCont
def addStepCont(lines, addLines):
    ip = pyFistr.getInsertPointInCnt(lines, "!STEP", ["STEP", "Step", "step"])
    lines = lines[:ip] + addLines + lines[ip:]
    return lines

#  addRefTempCont
def addRefTempCont(lines, addLines):
    #insertPointを取得
    ip = pyFistr.getInsertPointInCnt(lines, "!TEMPERATURE", ["TEMPERATURE", "Temperature", "temperature"])
    newLines = lines[:ip] + addLines + lines[ip:]
    return newLines

# addTemperatureCont
def addTemperatureCont(lines, addLines, nStep):
    #insertPointを取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!TEMPERATURE", ["TEMPERATURE", "Temperature", "temperature"], nStep)
    newLines = lines[:ip] + addLines + lines[ip:]
    return newLines

#  addDloadContNames
def addDloadContNames(lines, names, addLines, nStep):

    def getInsertPointer(lines):
        if nStep <= 0:
            #最初から検索
            iP = 0
            i = 0
            while i < len(lines):
                line = lines[i]
                isDload = (line[:len("!DLOAD")] == "!DLOAD")
                isType = False
                if isDload == True:
                    nextLine = deleteSp(lines[i+1])
                    bndType = nextLine.split(",")[1]
                    if bndType == "S":
                        isType = True
                if isDload and isType:
                    iP = i
                    break
                else:
                    if line[0] == "#":
                        n1 = line.find("BOUNDARY")
                        n2 = line.find("Boundary")
                        n3 = line.find("boundary")
                        if n1>=0 or n2>=0 or n3>=0:
                            if lines[i+1][:3] == "###":
                                iP = i + 2
                            else:
                                iP = i + 1
                            break
                i += 1
        else:
            #途中から検索
            iP = 0
            i = skipStepId(lines, nStep)
            while i < len(lines):
                line = lines[i]
                if line[0] == "!" or line[0] == "#":
                    iP = i
                    break
                i += 1
        return iP

    #addNames = getAddNames(names)
    iP = getInsertPointer(lines)
    lines = lines[:iP] + addLines + lines[iP:]
    lines = pyFistr.remakeGRPID(lines, "!DLOAD")
    return lines

#
#  writeCloadContInCnt
#    CLOADを書き換え
def writeCloadContInCnt(ngrp, cloadCont, forceType, valxyz, nStep):

    def skipThisBoundary(lines, ngrp, i):
        p = i
        i += 1
        while i < len(lines):
            cname = deleteSp(lines[i]).split(",")[0]
            #if cname != ngrp:
            if cname != ngrp and (cname[0] == "!" or cname[0] == "#"):
                p = i - 1
                break
            i += 1
        return p

    def deleteBoundary(lines, ngrp, nStep):
        ip = 0
        newLines = []
        i = 0
        n = 0
        while i < len(lines):
            line = lines[i]
            if line[:len("!CLOAD")] == "!CLOAD":
                newLines.append(line)
                cname = deleteSp(lines[i+1]).split(",")[0]
                if n == nStep:
                    if cname == ngrp:
                        ip = i+1
                        i = skipThisBoundary(lines, ngrp, i+1)
            elif line[:len("!STEP")] == "!STEP":
                n += 1
                newLines.append(line)
            else:
                newLines.append(line)
            i += 1
        return [newLines, ip]

    def createAddCont(name, bndCont):
        newConts = []
        #for bnd in bndCont:
        for i in range(len(bndCont)):
            bnd = bndCont[i]
            words = bnd.split(",")
            #if i < 3:
            if len(words) == 2:
                line = name + ", " + bnd
            else:
                line = bnd
            newConts.append(line)
        return newConts

    def changeCloadHeaderLine(line, forceType):
        if forceType == "nodeForce":
            n = line.find("forceType=")
            if n>= 0:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                for i in range(len(words)):
                    word = words[i]
                    if word[:len("forceType=")] == "forceType=":
                        words[i] = "forceType=nodeForce"
                        break
                newLine = ", ".join(words) + ls
            else:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                words.append("forceType=nodeForce")
                newLine = ", ".join(words) + ls
        elif forceType == "aveForce":
            n = line.find("forceType=")
            if n>= 0:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                for i in range(len(words)):
                    word = words[i]
                    if word[:len("forceType=")] == "forceType=":
                        words[i] = "forceType=aveForce"
                        break
                newLine = ", ".join(words) + ls
            else:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                words.append("forceType=aveForce")
                newLine = ", ".join(words) + ls
        elif forceType == "trueForce":
            n = line.find("forceType=")
            if n>= 0:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                for i in range(len(words)):
                    word = words[i]
                    if word[:len("forceType=")] == "forceType=":
                        words[i] = "forceType=trueForce"
                        break
                newLine = ", ".join(words) + ls
            else:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                words.append("forceType=trueForce")
                newLine = ", ".join(words) + ls
        return newLine

    def changeValueInHeaderLine(line, valxyz):
        n = line.find("value=")
        line = pyFistr.deleteSp(line)
        words = line.split(",")
        if n>=0:
            for i in range(len(words)):
                word = words[i]
                if word[:len("value=")] == "value=":
                    words[i] = "value=" + valxyz[0]
                    words[i+1] = valxyz[1]
                    words[i+2] = valxyz[2]
                    if valxyz[3] != "":
                        if i+3 < len(words):
                            words[i+3] = valxyz[3]
                        else:
                            words += [valxyz[3]]
                        if i+4 < len(words):
                            words[i+4] = valxyz[4]
                        else:
                            words += [valxyz[4]]
                        if i+5 < len(words):
                            words[i+5] = valxyz[5]
                        else:
                            words += [valxyz[5]]
                    break
            newLine = ", ".join(words) + ls
        else:
            words.append("value=" + valxyz[0])
            words.append(valxyz[1])
            words.append(valxyz[2])
            if valxyz[3] != "":
                words.append(valxyz[3])
                words.append(valxyz[4])
                words.append(valxyz[5])
            newLine = ", ".join(words) + ls
        return newLine

    lines = readFistrModelCnt()
    [lines, ip] = deleteBoundary(lines, ngrp, nStep)
    addConts = createAddCont(ngrp, cloadCont)
    lines[ip-1] = changeCloadHeaderLine(lines[ip-1], forceType)
    lines[ip-1] = changeValueInHeaderLine(lines[ip-1], valxyz)
    newLines = lines[:ip] + addConts + lines[ip:]
    newLines = pyFistr.remakeGRPID(newLines, "!CLOAD")
    writeFistrModelCnt(newLines)

#
#  writeCloadContDummyInCnt
#    CLOADを書き換え（dummyを含む）
def writeCloadContDummyInCnt(ngrp, cloadCont, forceType, valxyz, nStep):

    def skipThisBoundary(lines, ngrp, i):
        p = i
        i += 1
        while i < len(lines):
            cname = deleteSp(lines[i]).split(",")[0]
            #if cname != ngrp:
            if cname != ngrp and (cname[0] == "!" or cname[0] == "#"):
                p = i - 1
                break
            i += 1
        return p

    def deleteBoundary(lines, ngrp, nStep):
        ip = 0
        newLines = []
        i = 0
        n = 0
        while i < len(lines):
            line = lines[i]
            if line[:len("!CLOAD")] == "!CLOAD":
                newLines.append(line)
                cname = deleteSp(lines[i+1]).split(",")[0]
                if n == nStep:
                    if cname == ngrp:
                        ip = i+1
                        i = skipThisBoundary(lines, ngrp, i+1)
            elif line[:len("!STEP")] == "!STEP":
                n += 1
                newLines.append(line)
            else:
                newLines.append(line)
            i += 1
        return [newLines, ip]

    def getNgrpNodeNos(name):
        for headerData in meshHeaderData:
            line = headerData[0]
            if line[:len("!NGROUP")] == "!NGROUP":
                hdName = pyFistr.getValName(line, "NGRP")
                if hdName == name:
                    nodes = headerData[1]
                elif hdName == "dummy_" + name:
                    dummyNodes = headerData[1]
        return [nodes, dummyNodes]

    def createAddCont(name, cloadCont):
        newConts = []
        nodes = []; dummyNodes = []
        flag = 0
        for i in range(len(cloadCont)):
            line = cloadCont[i]
            words = deleteSp(line).split(",")
            if len(words) == 2:
                if int(words[0]) <= 3:
                    newLine = name + ", " + line
                else:
                    words[0] = str(int(words[0]) - 3)
                    newLine = ", ".join(["dummy_" + name] + words) + "\n"
                newConts.append(newLine)
            else:
                if flag == 0:
                    [nodes, dummyNodes] = getNgrpNodeNos(name)
                    flag = 1
                nodeNo = words[0]
                if int(words[1]) >= 4:
                    j = 0
                    for node in nodes:
                        if int(nodeNo) == node and len(dummyNodes) > 0:
                            words[0] = str(dummyNodes[j])
                            if words[1] == "4":
                                words[1] = "1"
                            elif words[1] == "5":
                                words[1] = "2"
                            elif words[1] == "6":
                                words[1] = "3"
                            break
                        j += 1
                newLine = ", ".join(words) + "\n"
                newConts.append(newLine)
        return newConts

    def changeCloadHeaderLine(line, forceType):
        if forceType == "nodeForce":
            n = line.find("forceType=")
            if n>= 0:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                for i in range(len(words)):
                    word = words[i]
                    if word[:len("forceType=")] == "forceType=":
                        words[i] = "forceType=nodeForce"
                        break
                newLine = ", ".join(words) + ls
            else:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                words.append("forceType=nodeForce")
                newLine = ", ".join(words) + ls
        elif forceType == "aveForce":
            n = line.find("forceType=")
            if n>= 0:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                for i in range(len(words)):
                    word = words[i]
                    if word[:len("forceType=")] == "forceType=":
                        words[i] = "forceType=aveForce"
                        break
                newLine = ", ".join(words) + ls
            else:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                words.append("forceType=aveForce")
                newLine = ", ".join(words) + ls
        elif forceType == "trueForce":
            n = line.find("forceType=")
            if n>= 0:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                for i in range(len(words)):
                    word = words[i]
                    if word[:len("forceType=")] == "forceType=":
                        words[i] = "forceType=trueForce"
                        break
                newLine = ", ".join(words) + ls
            else:
                line = pyFistr.deleteSp(line)
                words = line.split(",")
                words.append("forceType=trueForce")
                newLine = ", ".join(words) + ls
        return newLine

    def changeValueInHeaderLine(line, valxyz):
        n = line.find("value=")
        line = pyFistr.deleteSp(line)
        words = line.split(",")
        if n>=0:
            for i in range(len(words)):
                word = words[i]
                if word[:len("value=")] == "value=":
                    words[i] = "value=" + valxyz[0]
                    words[i+1] = valxyz[1]
                    words[i+2] = valxyz[2]
                    if valxyz[3] != "":
                        if i+3 < len(words):
                            words[i+3] = valxyz[3]
                        else:
                            words += [valxyz[3]]
                        if i+4 < len(words):
                            words[i+4] = valxyz[4]
                        else:
                            words += [valxyz[4]]
                        if i+5 < len(words):
                            words[i+5] = valxyz[5]
                        else:
                            words += [valxyz[5]]
                    break
            newLine = ", ".join(words) + ls
        else:
            words.append("value=" + valxyz[0])
            words.append(valxyz[1])
            words.append(valxyz[2])
            if valxyz[3] != "":
                words.append(valxyz[3])
                words.append(valxyz[4])
                words.append(valxyz[5])
            newLine = ", ".join(words) + ls
        return newLine


    lines = readFistrModelCnt()
    [lines, ip] = deleteBoundary(lines, "dummy_"+ngrp, nStep)
    [lines, ip] = deleteBoundary(lines, ngrp, nStep)
    addConts = createAddCont(ngrp, cloadCont)
    lines[ip-1] = changeCloadHeaderLine(lines[ip-1], forceType)
    lines[ip-1] = changeValueInHeaderLine(lines[ip-1], valxyz)
    newLines = lines[:ip] + addConts + lines[ip:]
    newLines = pyFistr.remakeGRPID(newLines, "!CLOAD")
    writeFistrModelCnt(newLines)

#
#  writeBoundaryContInCnt
#    BOUNDARYを書き換え
def writeBoundaryContInCnt(ngrp, bndCont, nStep):

    def skipThisBoundary(lines, ngrp, i):
        p = i
        i += 1
        while i < len(lines):
            cname = deleteSp(lines[i]).split(",")[0]
            if cname != ngrp:
                p = i - 1
                break
            i += 1
        return p

    def deleteBoundary(lines, ngrp, nStep):
        ip = 0
        newLines = []
        i = 0
        n = 0
        while i < len(lines):
            line = lines[i]
            if line[:len("!BOUNDARY")] == "!BOUNDARY":
                newLines.append(line)
                cname = deleteSp(lines[i+1]).split(",")[0]
                if n == nStep:
                    if cname == ngrp:
                        ip = i+1
                        i = skipThisBoundary(lines, ngrp, i+1)
            elif line[:len("!STEP")] == "!STEP":
                n += 1
                newLines.append(line)
            else:
                newLines.append(line)
            i += 1
        return [newLines, ip]

    def createAddCont(name, bndCont):
        newConts = []
        for bnd in bndCont:
            line = name + ", " + bnd
            newConts.append(line)
        return newConts

    lines = readFistrModelCnt()
    [lines, ip] = deleteBoundary(lines, ngrp, nStep)
    addConts = createAddCont(ngrp, bndCont)
    newLines = lines[:ip] + addConts + lines[ip:]
    writeFistrModelCnt(newLines)

#
#  writeBoundaryContDummyInCnt
#    BOUNDARYを書き換え（dummyを含む）
def writeBoundaryContDummyInCnt(ngrp, bndCont, nStep):

    def skipThisBoundary(lines, ngrp, i):
        p = i
        i += 1
        while i < len(lines):
            cname = deleteSp(lines[i]).split(",")[0]
            if cname != ngrp and cname != "dummy_"+ngrp:
                p = i - 1
                break
            i += 1
        return p

    def deleteBoundary(lines, ngrp, nStep):
        ip = 0
        newLines = []
        i = 0
        n = 0
        while i < len(lines):
            line = lines[i]
            if line[:len("!BOUNDARY")] == "!BOUNDARY":
                newLines.append(line)
                cname = deleteSp(lines[i+1]).split(",")[0]
                if n == nStep:
                    if cname == ngrp:
                        ip = i+1
                        i = skipThisBoundary(lines, ngrp, i+1)
            elif line[:len("!STEP")] == "!STEP":
                n += 1
                newLines.append(line)
            else:
                newLines.append(line)
            i += 1
        return [newLines, ip]

    def createAddCont(name, bndCont):
        newConts = []
        for bnd in bndCont:
            words = deleteSp(bnd).split(",")
            if int(words[0]) <= 3:
                line = name + ", " + bnd
                newConts.append(line)
            else:
                words[0] = str(int(words[0]) - 3)
                words[1] = str(int(words[1]) - 3)
                line = ", ".join(["dummy_"+name] + words) + "\n"
                newConts.append(line)
        return newConts

    lines = readFistrModelCnt()
    [lines, ip] = deleteBoundary(lines, "dummy_"+ngrp, nStep)
    [lines, ip] = deleteBoundary(lines, ngrp, nStep)
    addConts = createAddCont(ngrp, bndCont)
    newLines = lines[:ip] + addConts + lines[ip:]
    writeFistrModelCnt(newLines)

#
#  writeDefaultSradiateInCnt
#    defaultのSRADIATEをファイルに書き込み
def writeDefaultSradiateInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!SRADIATE", names)             #GRPIDを取得
    lines = deleteSradiateWithoutNames(lines, names, nStep)
    lines = addDefaultSradiateNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!SRADIATE", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)    

#
#  writeDefaultSfilmInCnt
#    defaultのSFILMをファイルに書き込み
def writeDefaultSfilmInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!SFILM", names)             #GRPIDを取得
    lines = deleteSfilmWithoutNames(lines, names, nStep)
    lines = addDefaultSfilmNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!SFILM", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)    

#
#  writeDefaultDfluxInCnt
#    defaultのDFLUXをファイルに書き込み
def writeDefaultDfluxInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!DFLUX", names)             #GRPIDを取得
    lines = deleteDfluxWithoutNames(lines, names, nStep)
    lines = addDefaultDfluxNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!DFLUX", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)    

#
#  writeDefaultSfluxInCnt
#    defaultのSFLUXをファイルに書き込み
def writeDefaultSfluxInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!SFLUX", names)             #GRPIDを取得
    lines = deleteSfluxWithoutNames(lines, names, nStep)
    lines = addDefaultSfluxNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!SFLUX", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)    

#
#  writeDefaultAccelInCnt
#    defaultのACCELERATIONをファイルに書き込み
def writeDefaultAccelInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!ACCELERATION", names)             #GRPIDを取得
    lines = deleteAccelWithoutNames(lines, names, nStep)
    lines = addDefaultAccelNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!ACCELERATION", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)    

#
#  writeDefaultVeloInCnt
#    defaultのVELOCITYをファイルに書き込み
def writeDefaultVeloInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!VELOCITY", names)             #GRPIDを取得
    lines = deleteVeloWithoutNames(lines, names, nStep)
    lines = addDefaultVeloNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!VELOCITY", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)

#
#  writeDefaultCfluxInCnt
#    defaultのCFLUXをファイルに書き込み
def writeDefaultCfluxInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!CFLUX", names)             #GRPIDを取得
    lines = deleteCfluxWithoutNames(lines, names, nStep)
    lines = addDefaultCfluxNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!CFLUX", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)    

#
#  writeDefaultInitialInMsh
#    defaultのINITIALをmshファイルに書き込み
def writeDefaultInitialInMsh(names):
    global meshHeaderData
    meshHeaderData = deleteInitialWithoutNames(meshHeaderData, names)
    meshHeaderData = addDefaultInitialNames(meshHeaderData, names)
    writeFistrModelMshHeader()

#
#  writeDefaultFixtempInCnt
#    defaultのFIXTEMPをファイルに書き込み
def writeDefaultFixtempInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!FIXTEMP", names)             #GRPIDを取得
    lines = deleteFixtempWithoutNames(lines, names, nStep)
    lines = addDefaultFixtempNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!FIXTEMP", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)    

#
#  writeDefaultFloadInCnt
#    defaultのFLOADをファイルに書き込み
def writeDefaultFloadInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!FLOAD", names)             #GRPIDを取得
    lines = deleteFloadWithoutNames(lines, names, nStep)
    lines = addDefaultFloadNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!FLOAD", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)    

#
#  writeDefaultSpringInCnt
#    defaultのSPRINGをファイルに書き込み
def writeDefaultSpringInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!SPRING", names)             #GRPIDを取得
    lines = deleteSpringWithoutNames(lines, names, nStep)
    lines = addDefaultSpringNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!SPRING", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)

#
#  writeDefaultCentInCnt
#    defaultのCENTをファイルに書き込み
def writeDefaultCentInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!DLOAD", names)             #GRPIDを取得
    lines = deleteCentWithoutNames(lines, names, nStep)
    lines = addDefaultCentNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!DLOAD", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)

#
#  writeDefaultGravInCnt
#    defaultのGravをファイルに書き込み
def writeDefaultGravInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!DLOAD", names)             #GRPIDを取得
    lines = deleteGravWithoutNames(lines, names, nStep)
    lines = addDefaultGravNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!DLOAD", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)

#
#  writeDefaultVloadInCnt
#    defaultのVLOADをファイルに書き込み
#    VLOADのkeywordは「DLOAD」になる。
def writeDefaultVloadInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!DLOAD", names)             #GRPIDを取得
    lines = deleteVloadWithoutNames(lines, names, nStep)
    lines = addDefaultVloadNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!DLOAD", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)

#
#  writeDefaultDloadInCnt
#    defaultのDLOADをファイルに書き込み
def writeDefaultDloadInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!DLOAD", names)             #GRPIDを取得
    lines = deleteDloadWithoutNames(lines, names, nStep)
    lines = addDefaultDloadNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!DLOAD", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)

#
#  writeDefaultTemperatureInCnt
#    defaultのTEMPERATUREをファイルに書き込み
def writeDefaultTemperatureInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!TEMPERATURE", names)             #GRPIDを取得
    lines = deleteTemperatureWithoutNames(lines, names, nStep)
    lines = addDefaultTemperatureNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!TEMPERATURE", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)

#
#  writeDefaultCloadInCnt
#    defaultのCLOADをファイルに書き込み
def writeDefaultCloadInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!CLOAD", names)             #GRPIDを取得
    lines = deleteCloadWithoutNames(lines, names, nStep)
    lines = addDefaultCloadNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!CLOAD", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)

#
#  addDefaultSradiateNames
#    defaultのSRADIATEを設定
def addDefaultSradiateNames(lines, names, nStep):
    #追加するnamesを取得
    addNames = pyFistr.getNoGroups(names, sradiateDefine[nStep])
    #追加するlinesを作成
    addLines = []
    for name in addNames:
        addLines += ["!SRADIATE, GRPID=1" + ls]
        addLines += [name + ", 0.0, 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!SRADIATE", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!SRADIATE")
    return lines

#
#  addDefaultSfilmNames
#    defaultのSFILMを設定
def addDefaultSfilmNames(lines, names, nStep):
    #追加するnamesを取得
    addNames = pyFistr.getNoGroups(names, sfilmDefine[nStep])
    #追加するlinesを作成
    addLines = []
    for name in addNames:
        addLines += ["!SFILM, GRPID=1" + ls]
        addLines += [name + ", 0.0, 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!SFILM", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!SFILM")
    return lines

#
#  addDefaultDfluxNames
#    defaultのDFLUXを設定
def addDefaultDfluxNames(lines, names, nStep):
    #追加するnamesを取得
    addNames = pyFistr.getNoGroups(names, dfluxDefine[nStep])
    #追加するlinesを作成
    addLines = []
    for name in addNames:
        addLines += ["!DFLUX, GRPID=1" + ls]
        addLines += [name + ", BF, 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!DFLUX", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!DFLUX")
    return lines

#
#  addDefaultSfluxNames
#    defaultのSFLUXを設定
def addDefaultSfluxNames(lines, names, nStep):
    #追加するnamesを取得
    addNames = pyFistr.getNoGroups(names, sfluxDefine[nStep])
    #追加するlinesを作成
    addLines = []
    for name in addNames:
        addLines += ["!SFLUX, GRPID=1" + ls]
        addLines += [name + ", 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!SFLUX", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!SFLUX")
    return lines

#
#  addDefaultAccelNames
#    defaultのACCELERATIONを設定
def addDefaultAccelNames(lines, names, nStep):
    #追加するnamesを取得
    addNames = pyFistr.getNoGroups(names, accelDefine[nStep])
    #追加するlinesを作成
    addLines = []
    for name in addNames:
        addLines += ["!ACCELERATION, GRPID=1" + ls]
        addLines += [name + ", 1, 1, 0.0" + ls]
        addLines += [name + ", 2, 2, 0.0" + ls]
        addLines += [name + ", 3, 3, 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!ACCELERATION", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!ACCELERATION")
    return lines

#
#  addDefaultVeloNames
#    defaultのVELOCITYを設定
def addDefaultVeloNames(lines, names, nStep):
    #追加するnamesを取得
    addNames = pyFistr.getNoGroups(names, veloDefine[nStep])
    #追加するlinesを作成
    addLines = []
    for name in addNames:
        addLines += ["!VELOCITY, GRPID=1" + ls]
        addLines += [name + ", 1, 1, 0.0" + ls]
        addLines += [name + ", 2, 2, 0.0" + ls]
        addLines += [name + ", 3, 3, 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!VELOCITY", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!VELOCITY")
    return lines

#
#  addDefaultCfluxNames
#    defaultのCFLUXを設定
def addDefaultCfluxNames(lines, names, nStep):
    #追加するnamesを取得
    addNames = pyFistr.getNoGroups(names, cfluxDefine[nStep])
    #追加するlinesを作成
    addLines = []
    for name in addNames:
        addLines += ["!CFLUX, GRPID=1" + ls]
        addLines += [name + ", 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!CFLUX", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!CFLUX")
    return lines

#
#  addDefaultInitialNames
#    defaultのINITIALを取得
def addDefaultInitialNames(meshHeaderData, names):
    if len(names) == 0:
        return meshHeaderData

    #追加する内容を作成
    addHeader = "!INITIAL CONDITION, TYPE=TEMPERATURE" + ls
    addData = []
    for name in names:
        addData += [name + ", 0.0" + ls]
    addHeaderData = [addHeader, addData]
    #最後（!ENDの前）に挿入
    meshHeaderData = meshHeaderData[:-1] + [addHeaderData] + meshHeaderData[-1:]
    return meshHeaderData

#
#  addDefaultFixtempNames
#    defaultのFIATEMPを設定
def addDefaultFixtempNames(lines, names, nStep):
    #追加するnamesを取得
    addNames = pyFistr.getNoGroups(names, fixtempDefine[nStep])
    #追加するlinesを作成
    addLines = []
    for name in addNames:
        addLines += ["!FIXTEMP, GRPID=1" + ls]
        addLines += [name + ", 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!FIXTEMP", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!FIXTEMP")
    return lines

#
#  addDefaultFloadNames
#    defaultのFloadを設定
def addDefaultFloadNames(lines, names, nStep):
    #追加するnamesを取得
    addNames = pyFistr.getNoGroups(names, floadDefine[nStep])
    #追加するlinesを作成
    addLines = []
    for name in addNames:
        #addLines += ["!FLOAD, LOAD CASE=2, GRPID=1" + ls]
        addLines += ["!FLOAD, LOAD CASE=1, GRPID=1" + ls]
        addLines += [name + ", 1, 0.0" + ls]
        addLines += [name + ", 2, 0.0" + ls]
        addLines += [name + ", 3, 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!FLOAD", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!FLOAD")
    return lines

#
#  addReftempLines
#    defaultのREFTEMPを作成
def addReftempLines():
    lines = readFistrModelCnt()
    addLines = ["!REFTEMP" + ls]
    addLines += ["0.0" + ls]
    ip = pyFistr.getInsertPointInCnt(lines, "!TEMPERATURE", ["TEMPERATURE", "Temperature", "temperature"])
    lines = lines[:ip] + addLines + lines[ip:]
    lines = pyFistr.remakeGRPID(lines, "!REFTEMP")
    writeFistrModelCnt(lines)

#
#  addDefaultTemperatureNames
#    defaultのTEMPERATUREを設定
def addDefaultTemperatureNames(lines, names, nStep):
    #追加するnameを取得
    addNames = pyFistr.getNoGroups(names, tempDefine[nStep])
    #追加するlineを作成
    addLines = []
    for name in addNames:
        addLines += ["!TEMPERATURE, GRPID=1" + ls]
        addLines += [name + ", 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!TEMPERATURE", ["TEMPERATURE", "Temperature", "temperature"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!TEMPERATURE")
    return lines

#
#  addDefaultSpringNames
#    defaultのSPRINGを設定
def addDefaultSpringNames(lines, names, nStep):
    #追加するnameを取得
    addNames = pyFistr.getNoGroups(names, springDefine[nStep])
    #追加するlineを作成
    addLines = []
    for name in addNames:
        addLines += ["!SPRING, GRPID=1" + ls]
        addLines += [name + ", 1, 0.0" + ls]
        addLines += [name + ", 2, 0.0" + ls]
        addLines += [name + ", 3, 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!SPRING", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!SPRING")
    return lines

#
#  addDefaultCentNames
#    defaultのCENTを設定
#    新しく追加されたgroupのみdefaultの内容を追加する
def addDefaultCentNames(lines, names, nStep):
    #追加するnameを取得
    addNames = pyFistr.getNoGroups(names, centDefine[nStep])
    #追加するlineを作成
    addLines = []
    for name in addNames:
        addLines += ["!DLOAD, GRPID=1" + ls]
        addLines += [name + ", CENT, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!DLOAD", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!DLOAD")
    return lines

#
#  addDefaultGravNames
#    defailtのGRAVを設定
#    新しく追加されたgroupのみdefaultの内容を追加する
def addDefaultGravNames(lines, names, nStep):
    #追加するnameを取得
    addNames = pyFistr.getNoGroups(names, gravDefine[nStep])
    #追加するlineを作成
    addLines = []
    for name in addNames:
        addLines += ["!DLOAD, GRPID=1" + ls]
        addLines += [name+", GRAV, 0.0, 1.0, 0.0, 0.0" + ls]
    #挿入する場所を取得
    ip = pyFistr.getBndInsertPointInCnt(lines, "!DLOAD", ["BOUNDARY", "Boundary", "boundary"], nStep)
    lines = lines[:ip] + addLines + lines[ip:]
    #GRPIDを修正
    lines = pyFistr.remakeGRPID(lines, "!DLOAD")    
    return lines

#
#  addDefaultVloadNames
#    defaultのVLOADを設定
#    新しく追加されたgroupのみdefaultの内容を追加する
def addDefaultVloadNames(lines, names, nStep):

    def getInsertPointer(lines):
        if nStep <= 0:
            #最初から検索
            iP = 0
            i = 0
            while i < len(lines):
                line = lines[i]
                isDload = (line[:len("!DLOAD")] == "!DLOAD")
                isType = False
                if isDload == True:
                    nextLine = deleteSp(lines[i+1])
                    bndType = nextLine.split(",")[1]
                    if bndType == "BX" or bndType == "BY" or bndType == "BZ":
                        isType = True
                if isDload and isType:
                    iP = i
                    break
                else:
                    if line[0] == "#":
                        n1 = line.find("BOUNDARY")
                        n2 = line.find("Boundary")
                        n3 = line.find("boundary")
                        if n1>=0 or n2>=0 or n3>=0:
                            if lines[i+1][:3] == "###":
                                iP = i + 2
                            else:
                                iP = i + 1
                            break
                i += 1
        else:
            #途中から検索
            iP = 0
            i = skipStepId(lines, nStep)
            while i < len(lines):
                line = lines[i]
                if line[0] == "!" or line[0] == "#":
                    iP = i
                    break
                i += 1
        return iP

    def createAddBoundary(addNames):
        addLines = []
        for name in addNames:
            addLines += ["!DLOAD, GRPID=1" + ls]
            addLines += [name + ", BX, 0.0" + ls]
            addLines += [name + ", BY, 0.0" + ls]
            addLines += [name + ", BZ, 0.0" + ls]
        return addLines

    #addNames = getAddNames(names)
    addNames = pyFistr.getNoGroups(names, vloadDefine[nStep])
    iP = getInsertPointer(lines)
    addLines = createAddBoundary(addNames)
    lines = lines[:iP] + addLines + lines[iP:]
    lines = pyFistr.remakeGRPID(lines, "!DLOAD")
    return lines


#
#  addDefaultDloadNames
#    defaultのDLOADを設定
#    新しく追加したgroupのみdefaultの内容を追加する。
def addDefaultDloadNames(lines, names, nStep):

    def getInsertPointer(lines):
        if nStep <= 0:
            #最初から検索
            iP = 0
            i = 0
            while i < len(lines):
                line = lines[i]
                isDload = (line[:len("!DLOAD")] == "!DLOAD")
                isType = False
                if isDload == True:
                    nextLine = deleteSp(lines[i+1])
                    bndType = nextLine.split(",")[1]
                    if bndType == "S":
                        isType = True
                if isDload and isType:
                    iP = i
                    break
                else:
                    if line[0] == "#":
                        n1 = line.find("BOUNDARY")
                        n2 = line.find("Boundary")
                        n3 = line.find("boundary")
                        if n1>=0 or n2>=0 or n3>=0:
                            if lines[i+1][:3] == "###":
                                iP = i + 2
                            else:
                                iP = i + 1
                            break
                i += 1
        else:
            #途中から検索
            iP = 0
            i = skipStepId(lines, nStep)
            while i < len(lines):
                line = lines[i]
                if line[0] == "!" or line[0] == "#":
                    iP = i
                    break
                i += 1
        return iP

    def createAddBoundary(addNames):
        addLines = []
        for name in addNames:
            addLines += ["!DLOAD, GRPID=1" + ls]
            addLines += [name + ", S, 0.0" + ls]
        return addLines

    #addNames = getAddNames(names)
    addNames = pyFistr.getNoGroups(names, dloadDefine[nStep])
    iP = getInsertPointer(lines)
    addLines = createAddBoundary(addNames)
    lines = lines[:iP] + addLines + lines[iP:]
    lines = pyFistr.remakeGRPID(lines, "!DLOAD")
    return lines

#
#  addDefaultCloadNames
#    defaultのCLOADを設定
def addDefaultCloadNames(lines, names, nStep):

    def getInsertPointer(lines):
        if nStep <= 0:
            #最初から検索
            iP = 0
            i = 0
            while i < len(lines):
                line = lines[i]
                if line[:len("!CLOAD")] == "!CLOAD":
                    iP = i
                    break
                else:
                    if line[0] == "#":
                        n1 = line.find("BOUNDARY")
                        n2 = line.find("Boundary")
                        n3 = line.find("boundary")
                        if n1>=0 or n2>=0 or n3>=0:
                            if lines[i+1][:3] == "###":
                                iP = i + 2
                            else:
                                iP = i + 1
                            break
                i += 1
        else:
            #途中から検索
            iP = 0
            i = skipStepId(lines, nStep)
            while i < len(lines):
                line = lines[i]
                if line[0] == "!" or line[0] == "#":
                    iP = i
                    break
                i += 1
        return iP

    def createAddBoundary(addNames):
        addLines = []
        for name in addNames:
            addLines += ["!CLOAD, GRPID=1" + ls]
            addLines += [name + ", 1, 0.0" + ls]
            addLines += [name + ", 2, 0.0" + ls]
            addLines += [name + ", 3, 0.0" + ls]
        return addLines

    #addNames = getAddNames(names)
    addNames = pyFistr.getNoGroups(names, cloadDefine[nStep])
    iP = getInsertPointer(lines)
    addLines = createAddBoundary(addNames)
    lines = lines[:iP] + addLines + lines[iP:]
    lines = pyFistr.remakeGRPID(lines, "!CLOAD")
    return lines

#
#  getGrpidInNmes
#    各grpNamesに対応するGRPIDを取得する
#    [[<grpName1>, <GRPID1>], [<grpName2>, <GRPID2>, ...], ...]
#    [ ["fix", "1"], ["load", "2"] ], [ ["load", "3"]] ]
#       ---- STEP0 ---------------     ---- STEP1 -----
def getGrpidInNames(lines, bndType, grpNames):
    grpids = []
    stepGrpids = []
    for i in range(len(lines)):
        line = lines[i]
        if line[0] == "!":
            keyword = deleteSp(line).split(",")[0]
            if keyword == "!STEP":
                grpids.append(stepGrpids)
                stepGrpids = []
            elif keyword == bndType:
                grpid = pyFistr.getValName(line, "GRPID")
                grpName = deleteSp(lines[i+1]).split(",")[0]
                stepGrpids.append([grpName, grpid])
    grpids.append(stepGrpids)
    return grpids

#
#  remakeGrpidInStep
#    !STEP内のgrpidを修正する
def remakeGrpidInStep(names, lines, bndType, grpids):

    def getOldToNewIdDict(oldIDs, newIDs):
        idDict = {}
        for nStep in range(len(oldIDs)):
            for oldID in oldIDs[nStep]:
                name = oldID[0]
                grpid = oldID[1]
                for newID in newIDs[nStep]:
                    if name == newID[0]:
                        idDict[grpid] = [newID[1], name]
                        break

        return idDict

    #bndTypeを修正（step内で使用されるbndTypeに設定）
    if bndType == "!CLOAD" or bndType == "!DLOAD" or bndType == "!TEMPERATURE":
        stepBndType = "LOAD"
    else:
        stepBndType = bndType[1:]
    #新しいgrpidを取得
    newGrpids = getGrpidInNames(lines, bndType, names)
    #各step内のgrpidを修正
    newLines = []
    nStep = 0
    stepFlag = 0
    stepGrpids = []
    newStepGrpids = []
    for i in range(len(lines)):
        line = lines[i]
        if line[0] == "!":
            #keyword行の処理
            newLines.append(line)
            stepFlag = 0
            keyword = deleteSp(line).split(",")[0]
            if keyword == "!STEP":
                #!STEP行の場合
                stepFlag = 1
                #oldIdをkeyとして辞書を作成
                stepGrpids += [grpids[nStep]]
                newStepGrpids += [newGrpids[nStep]]
                idDict = getOldToNewIdDict(stepGrpids, newStepGrpids)
                nStep += 1
        elif stepFlag == 1:
            #!STEP内のgrpidを修正（対象のbndTypeのみ）
            words = deleteSp(line).split(",")
            #対象のbndTypeかどうかチェック
            if words[0] == stepBndType:
                #対象のbndTypeの場合
                grpid = words[1]
                if grpid in idDict.keys():
                    #辞書からnewGrpidを取得
                    words[1] = idDict[grpid][0]
                    newLine = ", ".join(words) + ls
                    newLines.append(newLine)
            else:
                newLines.append(line)
        else:
            newLines.append(line)
    return newLines

#
#  writeDefaultBoundaryInCnt
#    defaultのBOUNDARYをファイルに書き込み
def writeDefaultBoundaryInCnt(names, nStep):
    lines = readFistrModelCnt()
    grpids = getGrpidInNames(lines, "!BOUNDARY", names)             #GRPIDを取得
    lines = deleteBoundaryWithoutNames(lines, names, nStep)
    lines = addDefaultBoundaryNames(lines, names, nStep)
    lines = remakeGrpidInStep(names, lines, "!BOUNDARY", grpids)    #STEP内のGRPIDを修正
    writeFistrModelCnt(lines)

#
#  addDefaultBoundaryNames
#    defaultのBOUNDARYを設定
def addDefaultBoundaryNames(lines, names, nStep):

    def getInsertPointer(lines):
        if nStep <= 0:
            #最初から検索
            iP = 0
            i = 0
            while i < len(lines):
                line = lines[i]
                if line[:len("!BOUNDARY")] == "!BOUNDARY":
                    iP = i
                    break
                else:
                    if line[0] == "#":
                        n1 = line.find("BOUNDARY")
                        n2 = line.find("Boundary")
                        n3 = line.find("boundary")
                        if n1>=0 or n2>=0 or n3>=0:
                            if lines[i+1][:3] == "###":
                                iP = i + 2
                            else:
                                iP = i + 1
                            break
                i += 1
        else:
            #途中から検索
            iP = 0
            i = skipStepId(lines, nStep)
            while i < len(lines):
                line = lines[i]
                if line[0] == "!" or line[0] == "#":
                    iP = i
                    break
                i += 1
        return iP

    def createAddBoundary(addNames):
        addLines = []
        for name in addNames:
            addLines += ["!BOUNDARY, GRPID=1" + ls]
            addLines += [name + ", 1, 1, 0.0" + ls]
            addLines += [name + ", 2, 2, 0.0" + ls]
            addLines += [name + ", 3, 3, 0.0" + ls]
            addLines += [name + ", 4, 4, 0.0" + ls]
            addLines += [name + ", 5, 5, 0.0" + ls]
            addLines += [name + ", 6, 6, 0.0" + ls]
        return addLines

    #addNames = getAddNames(names)
    addNames = pyFistr.getNoGroups(names, bndDefine[nStep])
    iP = getInsertPointer(lines)
    addLines = createAddBoundary(addNames)
    lines = lines[:iP] + addLines + lines[iP:]
    lines = pyFistr.remakeGRPID(lines, "!BOUNDARY")
    return lines

#
#  deleteStepCont
#    STEPを削除
def deleteStepCont(lines):

    def isBoundaryLine(line):
        ans = False
        bounNames = boundaryNames()
        for bounName in bounNames:
            if line[:len(bounName)+1] == "!"+bounName:
                ans = True
                break
        return ans

    newLines = []
    i = 0
    while i < len(lines):
        line = lines[i]
        #最初の!STEPを探す
        if line[:len("!STEP")] == "!STEP":
            #「#」または「!」までskipする（boundaryはskipする）
            i += 1
            while i < len(lines):
                if lines[i][0] == "!":
                    if (isBoundaryLine(lines[i]) == True or
                        lines[i][:len("!STEP")] == "!STEP"):
                        pass
                    else:
                        break
                elif lines[i][0] == "#":
                    break
                i += 1
            newLines.append(lines[i])
        else:
            newLines.append(line)
        i += 1
    return newLines

#
#  deleteTemperatureCont
#    TEMPERATUREを削除
def deleteTemperatureCont(lines):
    newLines = []
    i = 0
    while i < len(lines):
        line = lines[i]
        if line[:len("!TEMPERATURE")] == "!TEMPERATURE":
            i += 2
        elif line[:len("!REFTEMP")] == "!REFTEMP":
            i += 2
        else:
            newLines.append(line)
            i += 1
    return newLines

#
#  deleteTemperatureGrpCont
#    TEMPERATUREのnamesを削除
def deleteTemperatureGrpCont(lines, names, nStep):
    #temperatureを削除
    if nStep <= 0:
        i = 0
    else:
        i = skipStepId(lines, nStep)
    lines = pyFistr.deleteHeaderName(lines, i, "!TEMPERATURE", "")
    return lines    

#
#  deleteGravContNames
#    指定したGRAVのgroupを削除
def deleteGravContNames(lines, names, nStep):
    lines = deleteDloadNames(lines, "GRAV", names, nStep)
    return lines
    
#
#  deleteVloadContNames
#    指定したVLOADのgroupを削除
def deleteVloadContNames(lines, names, nStep):
    lines = deleteDloadNames(lines, "BX", names, nStep)
    return lines

#
#  deleteDloadContNames
#    指定したDLOADのgroupを削除
def deleteDloadContNames(lines, names, nStep):
    lines = deleteDloadNames(lines, "S", names, nStep)
    return lines

#
#  deleteDloadNames
#    指定したgroupを削除
def deleteDloadNames(lines, bndType, names, nStep):

    def isDeleteName(bndName, names):
        flag = 0
        for name in names:
            if bndName == name:
                flag = 1
                break
        if flag == 1:
            return True
        else:
            return False

    def skipNextHeader(lines, i):
        ans = 0
        while i < len(lines):
            if lines[i][0] == "!" or lines[i][0] == "#":
                ans = i - 1
                break
            i += 1
        return ans

    bndNames = []
    bnds = []
    newLines = []
    i = 0
    n = 0
    while i < len(lines):
        if lines[i][:len("!DLOAD")] == "!DLOAD":
            line = deleteSp(lines[i+1])
            if line.split(",")[1] == bndType:
                bndName = line.split(",")[0]
                #bndNames.append(bndName)
                #bnds.append(bndName)
                if n == nStep or nStep < 0:
                    if isDeleteName(bndName, names) == True:
                        i += 1
                        i = skipNextHeader(lines, i)
                    else:
                        bnds.append(bndName)
                        newLines.append(lines[i])
                else:
                    bnds.append(bndName)
                    newLines.append(lines[i])
            else:
                newLines.append(lines[i])
        elif lines[i][:len("!STEP")] == "!STEP":
            newLines.append(lines[i])
            bndNames.append(bnds)
            bnds = []
            n += 1
        else:
            newLines.append(lines[i])
        i += 1
    if len(bndNames) == 0:
        bndNames.append(bnds)
    return newLines

#
#  deleteSpringWithoutNames
#    設定以外のSPRINGを削除
def deleteSpringWithoutNames(lines, names, nStep):
    global springDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!SPRING", names, nStep)
    springDefine = bndNames
    return lines

#
#  deleteCentWithoutNames
#    設定以外のCENTを削除
def deleteCentWithoutNames(lines, names, nStep):
    global centDefine
    [lines, bndNames] = deleteAllDloadWithoutNames(lines, "CENT", names, nStep)
    centDefine = bndNames
    return lines

#
#  deleteGravWithoutNames
#    設定以外のGRAVを削除
def deleteGravWithoutNames(lines, names, nStep):
    global gravDefine
    [lines, bndNames] = deleteAllDloadWithoutNames(lines, "GRAV", names, nStep)
    gravDefine = bndNames
    return lines

#
#  deleteVloadWithoutNames
#    設定以外のVLOADを削除
def deleteVloadWithoutNames(lines, names, nStep):
    global vloadDefine
    [lines, bndNames] = deleteAllDloadWithoutNames(lines, "BX", names, nStep)
    if len(bndNames) == 0:
        [lines, bndNames] = deleteAllDloadWithoutNames(lines, "BY", names, nStep)
        if len(bndNames) == 0:
            [lines, bndNames] = deleteAllDloadWithoutNames(lines, "BZ", names, nStep)
    vloadDefine = bndNames
    return lines

#
#  deleteDloadWithoutNames
#    設定以外のDLOADを削除
def deleteDloadWithoutNames(lines, names, nStep):
    global dloadDefine
    [lines, bndNames] = deleteAllDloadWithoutNames(lines, "S", names, nStep)
    dloadDefine = bndNames
    return lines

#  deleteAllDloadWithoutNames
def deleteAllDloadWithoutNames(lines, bndType, names, nStep):
    allSetNames = getDloadTypeGroupInCnt(lines, bndType)
    delNames = []
    setNames = allSetNames[nStep]
    for setName in setNames:
        flag = 0
        for name in names:
            if setName == name:
                flag = 1
                break
        if flag == 0:
            delNames.append(setName)
    lines = deleteDloadNames(lines, bndType, delNames, nStep)
    return [lines, allSetNames]

#
#  deleteSradiateWithoutNames
#    設定以外のSRADIATEを削除
def deleteSradiateWithoutNames(lines, names, nStep):
    global sradiateDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!SRADIATE", names, nStep)
    sradiateDefine = bndNames
    return lines

#
#  deleteSfilmWithoutNames
#    設定以外のSFILMを削除
def deleteSfilmWithoutNames(lines, names, nStep):
    global sfilmDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!SFILM", names, nStep)
    sfilmDefine = bndNames
    return lines

#
#  deleteDfluxWithoutNames
#    設定以外のDFLUXを削除
def deleteDfluxWithoutNames(lines, names, nStep):
    global dfluxDefine
    [lines, bndNames] = deleteBndWithoutTypeNames(lines, "!DFLUX", "BF", names, nStep)
    dfluxDefine = bndNames
    return lines

#
#  deleteSfluxWithoutNames
#    設定以外のSFLUXを削除
def deleteSfluxWithoutNames(lines, names, nStep):
    global sfluxDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!SFLUX", names, nStep)
    sfluxDefine = bndNames
    return lines

#
#  deleteAccelWithoutNames
#    設定以外のACCELERATIONを削除
def deleteAccelWithoutNames(lines, names, nStep):
    global accelDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!ACCELERATION", names, nStep)
    accelDefine = bndNames
    return lines

#
#  deleteVeloWithoutNames
#    設定以外のVELOCITYを削除
def deleteVeloWithoutNames(lines, names, nStep):
    global veloDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!VELOCITY", names, nStep)
    veloDefine = bndNames
    return lines

#
#  deleteCfluxWithoutNames
#    設定以外のCFLUXを削除
def deleteCfluxWithoutNames(lines, names, nStep):
    global cfluxDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!CFLUX", names, nStep)
    cfluxDefine = bndNames
    return lines

#
#  deleteInitialWithoutNames
#    設定以外のINITIALを削除
def deleteInitialWithoutNames(meshHeaderData, names):
    global initialDefine
    [meshHeaderData, dummy_bndNames] = deleteInitialWithoutNamesHeader(meshHeaderData, names)
    #initialDefine = bndNames
    initialDefine = names
    return meshHeaderData

#
#  deleteFixtempWithoutNames
#    設定以外のFIXTEMPを削除
def deleteFixtempWithoutNames(lines, names, nStep):
    global fixtempDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!FIXTEMP", names, nStep)
    fixtempDefine = bndNames
    return lines

#
#  deleteFloadWithoutNames
#    設定以外のFLOADを削除
def deleteFloadWithoutNames(lines, names, nStep):
    global floadDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!FLOAD", names, nStep)
    floadDefine = bndNames
    return lines

#
#  deleteTemperatureWithoutNames
#    設定以外のTEMPERATUREを削除
def deleteTemperatureWithoutNames(lines, names, nStep):
    global tempDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!TEMPERATURE", names, nStep)
    tempDefine = bndNames
    return lines

#
#  deleteCloadWithoutNames
#    設定以外のCLOADを削除
def deleteCloadWithoutNames(lines, names, nStep):
    global cloadDefine
    [lines, bndNames] = deleteBndWithoutNames(lines, "!CLOAD", names, nStep)
    cloadDefine = bndNames
    return lines


def deleteInitialWithoutNamesHeader(meshHeaderData, names):
    bndNames = []
    newHeaderData = []
    for i in range(len(meshHeaderData)):
        line = meshHeaderData[i][0]
        #"!INITIAL CONDITION"を削除する。
        if line[:len("!INITIAL CONDITION")] == "!INITIAL CONDITION":
            pass
        else:
            newHeaderData.append(meshHeaderData[i])
    return [newHeaderData, bndNames]


def deleteBndWithoutTypeNames(lines, bnd, typeName, names, nStep):

    def isDeleteName(bName, names):
        ans = True
        for name in names:
            if bName == name:
                ans = False
                break
        return ans

    bndNames = []
    bnds = []
    newLines = []
    n = 0
    i = 0
    while i < len(lines):
        if lines[i][:len(bnd)] == bnd:
            words = deleteSp(lines[i+1]).split(",")
            if words[1] == typeName:
                #bndNames.append(words[0])
                bnds.append(words[0])
                if n == nStep:
                    if isDeleteName(words[0], names) == True:
                        i = pyFistr.skipNextHeader(lines, i+1) - 1
                    else:
                        newLines.append(lines[i])
                else:
                    newLines.append(lines[i])
            else:
                newLines.append(lines[i])
        elif lines[i][:len("!STEP")] == "!STEP":
            newLines.append(lines[i])
            bndNames.append(bnds)
            bnds = []
            n += 1
        else:
            newLines.append(lines[i])    
        i += 1
    return [newLines, bndNames]


def deleteBndWithoutNames(lines, bnd, names, nStep):

    def isDeleteName(bndName, names):
        flag = 0
        for name in names:
            if bndName == name:
                flag = 1
                break
        if flag == 0:
            return True
        else:
            return False

    def skipNextHeader(lines, i):
        ans = 0
        while i < len(lines):
            if lines[i][0] == "!" or lines[i][0] == "#":
                ans = i - 1
                break
            i += 1
        return ans

    bndNames = []
    bnds = []
    newLines = []
    n = 0
    i = 0
    while i < len(lines):
        if lines[i][:len(bnd)] == bnd:
            line = deleteSp(lines[i+1])
            bndName = line.split(",")[0]
            #bndNames.append(bndName)
            #bnds.append(bndName)
            if n == nStep or nStep < 0:
                if isDeleteName(bndName, names) == True:
                    i += 1
                    i = skipNextHeader(lines, i)
                else:
                    bnds.append(bndName)
                    newLines.append(lines[i])
            else:
                bnds.append(bndName)
                newLines.append(lines[i])
        elif lines[i][:len("!STEP")] == "!STEP":
            newLines.append(lines[i])
            bndNames.append(bnds)
            bnds = []
            n += 1
        else:
            newLines.append(lines[i])
        i += 1
    if len(bndNames) == 0:
        bndNames.append(bnds)
    return [newLines, bndNames]


#
#  deleteBoundaryWithoutNames
#    設定(names)以外のBOUNDARYを削除
#    nStep = -1 の場合は、全てを検索して削除する。
def deleteBoundaryWithoutNames(lines, names, nStep):
    global bndDefine

    def isDeleteName(bndName, names):
        flag = 0
        for name in names:
            if bndName == name:
                flag = 1            #残す
                break
        if flag == 0:
            #削除
            return True
        else:
            #残す
            return False

    def skipNextHeader(lines, i):
        ans = 0
        while i < len(lines):
            if lines[i][0] == "!" or lines[i][0] == "#":
                ans = i - 1
                break
            i += 1
        return ans

    bndNames = []
    bnd = []
    newLines = []
    n = 0
    i = 0
    while i < len(lines):
        if lines[i][:len("!BOUNDARY")] == "!BOUNDARY":
            line = deleteSp(lines[i+1])
            bndName = line.split(",")[0]
            #bndNames.append(bndName)
            #bnd.append(bndName)
            if n == nStep or nStep < 0:
                if isDeleteName(bndName, names) == True:
                    i += 1
                    i = skipNextHeader(lines, i)
                else:
                    bnd.append(bndName)
                    newLines.append(lines[i])
            else:
                bnd.append(bndName)
                newLines.append(lines[i])
        elif lines[i][:len("!STEP")] == "!STEP":
            newLines.append(lines[i])
            bndNames.append(bnd)
            bnd = []
            n += 1
        else:
            newLines.append(lines[i])
        i += 1
    if len(bndNames) == 0:
        bndNames.append(bnd)
    bndDefine = bndNames
    return newLines

#
#  remakeDefineMaterial
#    材料設定を再修正
#    余分な材料設定を削除、cntの材料定義順をmshファイルに合わせる
def remakeDefineMaterial(cntLines):
    global meshHeaderData, matDefine

    #  1ヶ分の材料定義内容を取得
    def get1MaterialDataInCnt(lines, i):
        newLines = []
        matGrp = matGrpHeader   #material定義内のheader名のlist
        while i < len(lines):
            if lines[i][0] == "!":
                flag = 0
                for header in matGrp:
                    if lines[i][:len(header)] == header:
                        newLines += [lines[i]]
                        flag = 1
                        break
                if flag == 0:
                    break
            else:
                if lines[i][0] != "#":
                    newLines += [lines[i]]
            i += 1
        return [newLines, i]

    #  全ての材料定義内容を取得
    def getAllMaterialDataInCnt(lines):
        matLines = []
        i = pyFistr.getNextHeaderName(lines, 0, "!MATERIAL", "")
        while i < len(lines):
            name = abaqus2fistr.getValName(lines[i], "NAME")
            conts = [lines[i]]
            i += 1
            [matLine, i] = get1MaterialDataInCnt(lines, i)
            matLines += [[name, conts+matLine]]
            i = pyFistr.getNextHeaderName(lines, i, "!MATERIAL", "")
        return matLines

    #  mshファイル内の材料定義順で、cntファイル内に材料定義を追加する
    def addSettingMaterial(lines, matNames, matLines):
        addLines = []
        for matName in matNames:
            for matLine in matLines:
                if matName == matLine[0]:
                    addLines += matLine[1]
                    break
        i = pyFistr.getInsertPointInCnt(lines, "!MATERIAL", ["Material"])
        lines = lines[:i] + addLines + lines[i:]
        return lines

    #mshファイルから定義してあるmaretialNameを定義順に取得する。
    def getMaterialNamesInMsh():
        addMatNames = []
        for headerData in meshHeaderData:
            line = headerData[0]
            if line[:len("!MATERIAL")] == "!MATERIAL":
                matName = abaqus2fistr.getValName(line, "NAME")
                addMatNames.append(matName)
        return addMatNames

    #matDefineを取得
    matDefine = createMaterialDefine()
    matNames = []
    for name in matDefine:
        matNames.append(name[1])
    #FistrModel.mshの修正
    meshHeaderData = deleteMaterialWithoutNamesHeader(meshHeaderData, matNames)
    writeFistrModelMshHeader()
    addMatNames = getMaterialNamesInMsh()
    #FistrModel.cntの修正
    matLines = getAllMaterialDataInCnt(cntLines)
    cntLines = deleteMaterialWithoutNames(cntLines, [])
    cntLines = addSettingMaterial(cntLines, addMatNames, matLines)
    writeFistrModelCnt(cntLines)

#
#  writeHeatFistrModelFile
#    HEAT用の材料物性値をファイルに書き込み
def writeHeatFistrModelFile(elGroup, matName, elastic, heatVals):
    global meshHeaderData

    def isElGroup(line, elGroup):
        ans = False
        if line[:len("!SECTION")] == "!SECTION":
            egrp = abaqus2fistr.getValName(line, "EGRP")
            if egrp == elGroup:
                ans = True
        return ans

    #meshデータ修正
    #!SECTION部の材料名変更
    for i in range(len(meshHeaderData)):
        line = meshHeaderData[i][0]
        if isElGroup(line, elGroup) == True:
            newLine = abaqus2fistr.setValName(line, "MATERIAL="+matName)
            meshHeaderData[i][0] = newLine
            #ni = i
            break
    #!MATERIAL部の追加部作成、追加
    headerData = []
    header = "!MATERIAL, NAME="+matName+", ITEM=3" + ls
    data = []
    headerData.append([header, data])
    header = "!ITEM=1, SUBITEM=1" + ls
    data =  [elastic[2] + ", 300" + ls]
    data += [elastic[2] + ", 500" + ls]
    headerData.append([header, data])
    header = "!ITEM=2, SUBITEM=1" + ls
    data =  [heatVals[1] + ", 300" + ls]
    data += [heatVals[1] + ", 500" + ls]
    headerData.append([header, data])
    header = "!ITEM=3, SUBITEM=1" + ls
    data =  [heatVals[0] + ", 300" + ls]
    data += [heatVals[0] + ", 500" + ls]
    headerData.append([header, data])
    meshHeaderData = addOrExchangeMaterialInMeshHeader(meshHeaderData, matName, headerData)
    #meshHeaderData = meshHeaderData[:ni] + headerData + meshHeaderData[ni:]
    #制御ファイル修正
    lines = readFistrModelCnt()
    #headerの作成
    newMat =  ["!MATERIAL, NAME=" + matName + ls]
    #ITEM1:密度の作成
    newMat += ["!DENSITY" + ls]
    newMat += [elastic[2] + ", 300" + ls]
    newMat += [elastic[2] + ", 500" + ls]
    #ITEM2:比熱の作成
    newMat += ["!SPECIFIC_HEAT" + ls]
    newMat += [heatVals[1] + ", 300" + ls]
    newMat += [heatVals[1] + ", 500" + ls]
    #ITEM3:熱伝導率の作成
    newMat += ["!THERMAL_CONDUCTIVITY" + ls]
    newMat += [heatVals[0] + ", 300" + ls]
    newMat += [heatVals[0] + ", 500" + ls]
    #!MATERIAL部（定義部）を修正
    lines = addOrExchangeMaterialInCnt(lines, matName, newMat)
    #材料の定義順をcntファイルに合わせてcnt,mshを保存
    remakeDefineMaterial(lines)

#
#  writeFistrModelFile
#    材料物性値をファイルに書き込み(cnt, mshファイル)
def writeFistrModelFile(elGroup, matName, elastic, matModel, matType, matHard, ssData):
    global meshHeaderData

    def isElGroup(line, elGroup):
        ans = False
        if line[:len("!SECTION")] == "!SECTION":
            egrp = abaqus2fistr.getValName(line, "EGRP")
            if egrp == elGroup:
                ans = True
        return ans

    #meshファイル修正
    #!SECTION部の材料名変更
    for i in range(len(meshHeaderData)):
        line = meshHeaderData[i][0]
        if isElGroup(line, elGroup) == True:
            newLine = abaqus2fistr.setValName(line, "MATERIAL="+matName)
            meshHeaderData[i][0] = newLine
            #ni = i
            break
    #!MATERIAL部の追加部作成
    headerData = []
    header = "!MATERIAL, NAME="+matName+", ITEM=3" + ls
    data = []
    headerData.append([header, data])
    header = "!ITEM=1, SUBITEM=2" + ls
    data = [elastic[0] + ", " + elastic[1] + ls]
    headerData.append([header, data])
    header = "!ITEM=2, SUBITEM=1" + ls
    data = [elastic[2] + ls]
    headerData.append([header, data])
    header = "!ITEM=3, SUBITEM=1" + ls
    data = [elastic[3] + ls]
    headerData.append([header, data])
    meshHeaderData = addOrExchangeMaterialInMeshHeader(meshHeaderData, matName, headerData)
    #制御ファイル修正
    lines = readFistrModelCnt()
    newMat =  ["!MATERIAL, NAME=" + matName + ls]
    newMat += ["!ELASTIC, TYPE=ISOTROPIC" + ls]
    newMat += [elastic[0] + ", " + elastic[1] + ls]
    newMat += ["!DENSITY" + ls]
    newMat += [elastic[2] + ls]
    newMat += ["!EXPANSION_COEFF, DEPENDENCIES=0" + ls]
    newMat += [elastic[3] + ls] 
    if matModel != "ELASTIC":
        newLine = "!" + matModel
        if matType != "":
            newLine += ", YIELD=" + matType
            if matHard != "":
                newLine += ", HARDEN=" + matHard
        newLine += ls
        newMat += [newLine]
        #PLASTICの場合塑性データ追加
        if matModel == "PLASTIC":
            newMat += ssData
    #!MATERIAL部（定義部）を修正
    lines = addOrExchangeMaterialInCnt(lines, matName, newMat)
    #材料定義順をmshファイルに合わせて、cnt, mshを保存
    remakeDefineMaterial(lines)

#
#  addOrExchangeMaterialInCnt
#    材料定義部を追加or入れ替える
def addOrExchangeMaterialInCnt(lines, matName, newMat):
    lines = deleteDefineMaterialInCnt(lines, matName)
    lines = addDefineMaterialInCnt(lines, matName, newMat)
    return lines

#  addDefineMaterialInCnt
#    cntファイルに材料定義を追加
def addDefineMaterialInCnt(lines, matName, newMat):

    def skipMaterialHeader(lines):
        ans = 0
        i = 0
        while i < len(lines):
            line = lines[i]
            if line[:len("!MATERIAL")] == "!MATERIAL":
                ans = i
                break
            else:
                if line[0] == "#":
                    n1 = line.find("MATERIAL")
                    n2 = line.find("Material")
                    n3 = line.find("material")
                    if n1>= 0 or n2>=0 or n3>=0:
                        i += 1
                        if lines[i][:3] == "###":
                            ans = i + 1
                        else:
                            ans = i
                        break
            if ans != 0:
                break
            i += 1
        return ans

    i = skipMaterialHeader(lines)
    newLines = lines[:i] + newMat + lines[i:]
    return newLines

#  deleteDefineMaterialInCnt
#    cntファイルから材料定義部を削除
def deleteDefineMaterialInCnt(lines, matName):

    def isEndOfMaterial(line):
        header = deleteSp(line).split(",")[0]
        if header == "!MATERIAL" or header[0] == "#":
            ans = True
        else:
            ans = True
            for matGrp in matGrpHeader:
                if matGrp == header:
                    ans = False
        return ans

    i = 0
    ip = -1
    while i < len(lines):
        i = pyFistr.getNextHeaderName(lines, i, "!MATERIAL", "NAME="+matName)
        if i < len(lines):
            ip = i
            ie = -1
            i += 1
            while i < len(lines):
                i = pyFistr.skipNextHeader(lines, i)
                if isEndOfMaterial(lines[i]) == True:
                    ie = i
                    break
                i += 1
            if ie > 0:
                break
    if ip > 0 and ie > 0:
        lines = lines[:ip] + lines[ie:]
    return lines

#
#  addOrExchangeMaterialInMesh
#    材料定義部を追加or入れ替える
def addOrExchangeMaterialInMesh(lines, matName, newMat):
    lines = deleteDefineMaterialInMesh(lines, matName)
    lines = addDefineMaterialInMesh(lines, matName, newMat)
    return lines

#
#  addOrExchangeMaterialInMeshHeader
#    材料定義部を追加or入れ替える
def addOrExchangeMaterialInMeshHeader(meshHeaderData, matName, newMatHeader):
    meshHeaderData = deleteDefineMaterialInMeshHeader(meshHeaderData, matName)
    meshHeaderData = addDefineMaterialInMeshHeader(meshHeaderData, matName, newMatHeader)
    return meshHeaderData

#  addDefineMaterialInMesh
#    meshファイルに材料定義を追加
def addDefineMaterialInMesh(lines, matName, newMat):
    newLines = []
    i = 0
    while i < len(lines):
        line = lines[i]
        if line[:len("!SECTION")] == "!SECTION":
            name = abaqus2fistr.getValName(line, "MATERIAL")
            if name == matName:
                newLines = lines[:i]
                newLines += newMat
                newLines += lines[i:]
                break
        i += 1
    if i < len(lines):
        return newLines
    else:
        return lines

#  addDefineMaterialInMeshHeader
#    meshファイルに材料定義を追加
def addDefineMaterialInMeshHeader(meshHeaderData, matName, newMatHeader):
    newHeaderData = []
    ni = -1
    for i in range(len(meshHeaderData)):
        line = meshHeaderData[i][0]
        if line[:len("!SECTION")] == "!SECTION":
            name = abaqus2fistr.getValName(line, "MATERIAL")
            if name == matName:
                ni = i
                break
    newHeaderData = meshHeaderData[:ni] + newMatHeader + meshHeaderData[ni:]
    return newHeaderData
        
#  deleteDefineMaterialInMesh
#    meshファイルから材料定義部を削除
def deleteDefineMaterialInMesh(lines, matName):
    nItem = ""
    newLines = []
    i = 0
    while i < len(lines):
        line = lines[i]
        if line[:len("!MATERIAL")] == "!MATERIAL":
            name = abaqus2fistr.getValName(line, "NAME")
            if name == matName:
                newLines = lines[:i]

                i += 1
                while i < len(lines):
                    if lines[i][0] == "!":
                        if lines[i][:len("!ITEM=")] != "!ITEM=":
                            break
                    i += 1
                if i < len(lines):
                    newLines += lines[i:]
                    nItem = "OK"
                    break
        i += 1
    if nItem != "":
        return newLines
    else:
        return lines

#  deleteDefineMaterialInMeshHeader
#    meshファイルから材料定義部を削除
def deleteDefineMaterialInMeshHeader(meshHeaderData, matName):
    newHeaderData = []
    i = 0
    while i < len(meshHeaderData):
        headerData = meshHeaderData[i]
        line = headerData[0]
        if line[:len("!MATERIAL")] == "!MATERIAL":
            name = abaqus2fistr.getValName(line, "NAME")
            if name == matName:
                #skip
                i += 1
                while i < len(meshHeaderData):
                    line = meshHeaderData[i][0]
                    if line[:len("!ITEM=")] != "!ITEM=":
                        i -= 1
                        break
                    i += 1
            else:
                newHeaderData.append(headerData)
        else:
            newHeaderData.append(headerData)
        i += 1
    return newHeaderData

#
#  getMaterialElasticValue
#    物性値（弾性）をDBから取得
def getMaterialElasticValue(matName):
    fileName = materialDBName
    data = pyFistr.readCsvData(fileName)
    matData = data[2:]
    vals = []; heatVals = []
    for words in matData:
        if matName == words[0]:
            vals = words[1:5]       #[young, poisson, density, linearexp]
            heatVals = words[5:7]   #[熱伝導率, 比熱]
    #指数表記の場合、小数点をチェックする。
    vals = checkNumStrs(vals)
    heatVals = checkNumStrs(heatVals)
    return [vals, heatVals]

#
#  readMeshGetEachMaterialName
#    group名と材料名を取得
def readMeshGetEachMaterialName():
    ans = []
    for headerData in meshHeaderData:
        line = headerData[0]
        if line[:len("!SECTION")] == "!SECTION":
            elGroup = abaqus2fistr.getValName(line, "EGRP")
            matName = abaqus2fistr.getValName(line, "MATERIAL")
            ans.append([elGroup, matName])
    return ans

#
#  readGetMaterialModel
#    材料モデル、タイプを取得
def readGetMaterialModel(matName):

    def checkMaterialType(line):
        ans = False
        for matGroup in materialType[1:]:
            matType = matGroup[0]
            if line[1:len(matType)+1] == matType:
                ans = True
                break
        return ans

    #matName = ""
    matModel="ELASTIC"; matType=""; matHard=""
    lines = readFistrModelCnt()
    i = 0
    #flag = 0
    while i < len(lines):
        i = pyFistr.getNextHeaderName(lines, i, "!MATERIAL", "NAME="+matName)
        i += 1
        while i < len(lines):
            i = pyFistr.skipNextHeader(lines, i)
            if lines[i][:len("!MATERIAL")] != "!MATERIAL" and lines[i][0] != "#":
                if checkMaterialType(lines[i]) == True:
                    matModel = (deleteSp(lines[i])).split(",")[0][1:]
                    matType = abaqus2fistr.getValName(lines[i], "YIELD")
                    matHard = abaqus2fistr.getValName(lines[i], "HARDEN")
            else:
                break
            i += 1
    return [matModel, matType, matHard]

#
#  getShellThickness
#    板厚を取得
def getShellThickness(egrpName):
    data = []
    for headerData in meshHeaderData:
        line = headerData[0]
        if line[:len("!SECTION")] == "!SECTION":
            name = pyFistr.getValName(line, "EGRP")
            if name == egrpName:
                data = headerData[1]
                break
    words = []
    for line in data:
        words += deleteSp(line).split(",")
    return words

# addSradiateGroupInTreeData
def addSradiateGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nSradiate, nStep)

#  addSfilmGroupInTreeData
def addSfilmGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nSfilm, nStep)

#  addDfluxGroupInTreeData
def addDfluxGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nDflux, nStep)

#  addSfluxGroupInTreeData
def addSfluxGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nSflux, nStep)

#  addCfluxGroupInTreeData
def addCfluxGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nCflux, nStep)

#  addFixtempGroupInTreeData
def addFixtempGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nFixtemp, nStep)

#  addAccelGroupInTreeData
def addAccelGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nAcceleration, nStep)

#  addVeloGroupInTreeData
def addVeloGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nVelocity, nStep)

#  addFloadGroupInTreeData
def addFloadGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nFload, nStep)

#  addContactGroupInTreeData
def addContactGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nContact, nStep)

#  addSpringGroupInTreeData
def addSpringGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nSpring, nStep)

#  addTempGroupInTreeData
def addTempGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nTemperature, nStep)

#  addCentGroupInTreeData
def addCentGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nCent, nStep)

#  addGravGroupInTreeData
def addGravGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nGrav, nStep)

#  addVloadGroupInTreeData
def addVloadGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nVload, nStep)

#  addDloadGroupInTreeData
#    TreeDataにDLOADを追加
def addDloadGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nDload, nStep)

#  addCloadGroupInTreeData
#    TreeDataにCloadを追加
def addCloadGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nCload, nStep)

#  addBndGroupInTreeData
#    TreeDataにbndを追加
def addBndGroupInTreeData(names, nStep):
    addBoundaryGroupInTreeData(names, 0, 1, nBoundary, nStep)

#  addBoundaryGroupInTreeData
def addBoundaryGroupInTreeData(names, t1, t2, t3, nStep):
    global treeBoundary, treeStepBounds
    if nStep == 0:
        treeBnd = treeBoundary[t1][t2][t3]
        #if type(treeBnd) == str or type(treeBnd) == unicode:
        if type(treeBnd) == str:
            treeBoundary[t1][t2][t3] = [treeBnd, names]
        else:
            treeBoundary[t1][t2][t3][1] = names
            treeBoundary[t1][t2][t3][1].sort()
    else:
        treeBnd = treeStepBounds[nStep-1][t1][t2][t3]
        #if type(treeBnd) == str or type(treeBnd) == unicode:
        if type(treeBnd) == str:
            treeStepBounds[nStep-1][t1][t2][t3] = [treeBnd, names]
        else:
            treeStepBounds[nStep-1][t1][t2][t3][1] = names
            treeStepBounds[nStep-1][t1][t2][t3][1].sort()
    makeTreeData()

#
#  addInitialGroupInTreeData
def addInitialGroupInTreeData(names):
    global treeInitial
    #if type(treeInitial[0]) == str or type(treeInitial[0]) == unicode:
    if type(treeInitial[0]) == str:
        treeInitial = [[treeInitial[0], names]]
    else:
        treeInitial[0][1] = names
        treeInitial[0][1].sort()
    makeTreeData()
    #addBoundaryGroupInTreeData(names, 0, 1, nInitial, 0)

#
#  addAmpGroupInTreeData
#
def addAmpGroupInTreeData(names):
    global treeAmp
    #if type(treeAmp[0]) == str or type(treeAmp[0]) == unicode:
    if type(treeAmp[0]) == str:
        treeAmp = [[treeAmp[0], names]]
    else:
        treeAmp[0][1] = names
        treeAmp[0][1].sort()
    makeTreeData()

#
#  addStepGroupInTreeData
#
def addStepGroupInTreeData(names):
    global treeStep, treeStepBounds
    #step部のTreeを作成
    #if type(treeStep[0]) == str or type(treeStep[0]) == unicode:
    if type(treeStep[0]) == str:
        treeStep = [[treeStep[0], names]]
    else:
        treeStep[0][1] = names
        treeStep[0][1].sort()
    #stepのboundaryを作成
    if len(stepDefine) <= 1:
        treeStepBounds = []
    else:
        #複数stepの場合
        treeStepBounds = []
        nAdd = len(names) - 1
        for i in range(nAdd):
            #stepの境界条件を再作成
            treeParts = initialTreeParts()
            #treeStepBound = setTreeBoundary(treeParts[4], i+1)
            treeStepBound = setTreeBoundary(treeParts[5], i+1)
            treeStepBound[0][0] = _(u"境界条件 ") + stepDefine[i+1]
            treeStepBounds.append(treeStepBound)
    makeTreeData()

#
#  addMatGroupInTreeData
#    TreeDataをroot以下に追加
def addMatGroupInTreeData(names):
    global treeMaterial
    #if type(treeMaterial[0]) == str or type(treeMaterial[0]) == unicode:
    if type(treeMaterial[0]) == str:
        treeMaterial = [[treeMaterial[0], names]]
    else:
        treeMaterial[0][1] = names
        treeMaterial[0][1].sort()
    makeTreeData()

#
#  makeIniTreeData
#    初期のTreeDataを作成
def makeIniTreeData():
    global treeData, treeRoot, treeFistrModel, treeMaterial, treeInitial, treeBoundary, treeStep
    global treeSolution, treeAmp, treeStepBounds
    global treeSolver, treePost, matDefine, bndDefine
    #初期のTreeDataを取得
    [treeRoot, treeFistrModel, treeSolution, treeMaterial, treeInitial, treeBoundary, treeAmp,
        treeStep, treeSolver, treePost] = initialTreeParts()
    #解析種類を追加
    if (anaType == "DYNAMIC" or anaType== "DYNAMIC_F"
            or anaType == "EIGEN" or anaType == "HEAT_D"):
        treeSolution = [[treeSolution[0], [_(u"設定")]]]
    #材料定義を追加
    if len(matDefine) > 0:
        mat = []
        for names in matDefine:
            mat.append(names[0])
        mat.sort()
        treeMaterial = [[treeMaterial[0], mat]]
    #初期値に定義namesを追加
    if len(initialDefine) > 0:
        iniNames = initialDefine
        iniNames.sort()
        treeInitial = [[treeInitial[0], iniNames]]
    #境界条件を追加
    treeBoundary = setTreeBoundary(treeBoundary, 0)
    treeStepBounds = []
    if len(stepDefine) >= 2:
        #stepの境界条件を作成
        for i in range(len(stepDefine)-1):
            treeParts = initialTreeParts()
            #treeStepBound = setTreeBoundary(treeParts[4], i+1)
            treeStepBound = setTreeBoundary(treeParts[5], i+1)
            treeStepBound[0][0] = _(u"境界条件 ") + stepDefine[i+1]
            treeStepBounds.append(treeStepBound)
    #AMPLITUDE
    if len(ampDefine) > 0:
        treeAmp = [[treeAmp[0], ampDefine]]
    #STEP
    if len(stepDefine) > 0:
        treeStep = [[treeStep[0], stepDefine]]
    #treeを作成
    makeTreeData()
    return


#  setTreeBoundary
#    境界条件をtreeにセット
def setTreeBoundary(treeBoundary, n):
    #BOUNDARYを追加
    if len(bndDefine) > 0:
        treeBnd = treeBoundary[0][1][nBoundary]
        bnd = bndDefine[n]
        bnd.sort()
        treeBoundary[0][1][nBoundary] = [treeBnd, bnd]
    #CLOAD
    if len(cloadDefine) > 0:
        treeBnd = treeBoundary[0][1][nCload]
        bnd = cloadDefine[n]
        bnd.sort()
        treeBoundary[0][1][nCload] = [treeBnd, bnd]
    #DLOAD
    if len(dloadDefine) > 0:
        treeBnd = treeBoundary[0][1][nDload]
        bnd = dloadDefine[n]
        bnd.sort()
        treeBoundary[0][1][nDload] = [treeBnd, bnd]
    #VLOAD
    if len(vloadDefine) > 0:
        treeBnd = treeBoundary[0][1][nVload]
        bnd = vloadDefine[n]
        bnd.sort()
        treeBoundary[0][1][nVload] = [treeBnd, bnd]
    #GRAV
    if len(gravDefine) > 0:
        treeBnd = treeBoundary[0][1][nGrav]
        bnd = gravDefine[n]
        bnd.sort()
        treeBoundary[0][1][nGrav] = [treeBnd, bnd]
    #CENT
    if len(centDefine) > 0:
        treeBnd = treeBoundary[0][1][nCent]
        bnd = centDefine[n]
        bnd.sort()
        treeBoundary[0][1][nCent] = [treeBnd, bnd]
    #TEMPERATURE
    if len(tempDefine) > 0:
        treeBnd = treeBoundary[0][1][nTemperature]
        bnd = tempDefine[n]
        bnd.sort()
        treeBoundary[0][1][nTemperature] = [treeBnd, bnd]
    #SPRING
    if len(springDefine) > 0:
        treeBnd = treeBoundary[0][1][nSpring]
        bnd = springDefine[n]
        bnd.sort()
        treeBoundary[0][1][nSpring] = [treeBnd, bnd]
    #CONTACT
    if len(contactDefine) > 0:
        treeBnd = treeBoundary[0][1][nContact]
        bnd = contactDefine[n]
        bnd.sort()
        treeBoundary[0][1][nContact] = [treeBnd, bnd]
    #FLOAD
    if len(floadDefine) > 0:
        treeBnd = treeBoundary[0][1][nFload]
        bnd = floadDefine[n]
        bnd.sort()
        treeBoundary[0][1][nFload] = [treeBnd, bnd]
    #VELOCITY
    if len(veloDefine) > 0:
        treeBnd = treeBoundary[0][1][nVelocity]
        bnd = veloDefine[n]
        bnd.sort()
        treeBoundary[0][1][nVelocity] = [treeBnd, bnd]
    #ACCELERATION
    if len(accelDefine) > 0:
        treeBnd = treeBoundary[0][1][nAcceleration]
        bnd = accelDefine[n]
        bnd.sort()
        treeBoundary[0][1][nAcceleration] = [treeBnd, bnd]
    #FIXTEMP
    if len(fixtempDefine) > 0:
        treeBnd = treeBoundary[0][1][nFixtemp]
        bnd = fixtempDefine[n]
        bnd.sort()
        treeBoundary[0][1][nFixtemp] = [treeBnd, bnd]
    #CFLUX
    if len(cfluxDefine) > 0:
        treeBnd = treeBoundary[0][1][nCflux]
        bnd = cfluxDefine[n]
        bnd.sort()
        treeBoundary[0][1][nCflux] = [treeBnd, bnd]
    #SFLUX
    if len(sfluxDefine) > 0:
        treeBnd = treeBoundary[0][1][nSflux]
        bnd = sfluxDefine[n]
        bnd.sort()
        treeBoundary[0][1][nSflux] = [treeBnd, bnd]
    #DFLUX
    if len(dfluxDefine) > 0:
        treeBnd = treeBoundary[0][1][nDflux]
        bnd = dfluxDefine[n]
        bnd.sort()
        treeBoundary[0][1][nDflux] = [treeBnd, bnd]
    #SFILM
    if len(sfilmDefine) > 0:
        treeBnd = treeBoundary[0][1][nSfilm]
        bnd = sfilmDefine[n]
        bnd.sort()
        treeBoundary[0][1][nSfilm] = [treeBnd, bnd]
    #SRADIATE
    if len(sradiateDefine) > 0:
        treeBnd = treeBoundary[0][1][nSradiate]
        bnd = sradiateDefine[n]
        bnd.sort()
        treeBoundary[0][1][nSradiate] = [treeBnd, bnd]
    return treeBoundary


#
#  makeTreeData
#    TreeDataを作成する
def makeTreeData():
    global treeData
    treeData = []
    treeData += treeRoot
    items = []
    items += treeFistrModel
    items += treeSolution
    items += treeMaterial
    items += treeInitial
    items += treeBoundary
    for treeBound in treeStepBounds:
        items += treeBound
    items += treeStep
    items += treeAmp
    items += treeSolver
    items += treePost
    treeData += [items]

#
#  getFistrModelMeshData
#    FistrModeのメッシュデータ読み込み
def getFistrModelMeshData(currDir):
    fileName = currDir + os.sep + "FistrModel.msh"
    if len(glob.glob(fileName)) != 0:
        print (_(u"メッシュパラメータを取得中..."))
        cont = getMeshParameter()
        ampNames = getAmpGroupInMsh()
        initialNames = getInitialGroupInMsh()
        print (_(u"取得しました"))
    else:
        cont = ""
        ampNames = []
        initialNames = []
    return [cont, ampNames, initialNames]

#  getMeshParameter
#    mesh内容を取得
def getMeshParameter():
    global meshGroup, matDefine
    #modelSizeを取得
    xyz = getModelSize()
    #FistrModel.mshからparameterListを取得
    parameterList = getMeshParameterList()
    #parameterListから数量を取得
    paraNum = getParameterNumber(parameterList)
    #meshGroup作成
    meshGroup = createMeshGroup(paraNum)
    #材料定義を取得
    matDefine = createMaterialDefine()
    #出力内容を作成
    cont = xyz + createParameterCont(paraNum)
    return cont

#  getModelSize
#    meshHeaderDataからモデルのサイズを取得
def getModelSize():
    lineData = []
    for headerData in meshHeaderData:
        header = headerData[0]
        if header[:len("!NODE")] == "!NODE":
            lineData = headerData[1]
            break
    px = []
    py = []
    pz = []
    for nodeData in lineData:
        px.append(nodeData[1])
        py.append(nodeData[2])
        pz.append(nodeData[3])
    dx = max(px) - min(px)
    dy = max(py) - min(py)
    dz = max(pz) - min(pz)
    ans = "modelSize(xyz): " + str(dx) + " " + str(dy) + " " + str(dz) + ls + ls
    return ans

#  createMaterialDefine
#    材料定義を取得
def createMaterialDefine():
    matTemps = []
    matDefine = []
    for headerData in meshHeaderData:
        line = headerData[0]
        dummy_data = headerData[1]
        if line[:len("!ELEMENT")] == "!ELEMENT":
            elType = abaqus2fistr.getValName(line, "TYPE")
            egrp = abaqus2fistr.getValName(line, "EGRP")
            matTemps.append([elType, egrp])
        elif line[:len("!SECTION")] == "!SECTION":
            egrp = abaqus2fistr.getValName(line, "EGRP")
            for matTemp in matTemps:
                if matTemp[1] == egrp:
                    elType = matTemp[0]
                    break
            matName = abaqus2fistr.getValName(line, "MATERIAL")
            matDefine.append([egrp, matName, elType])
    return matDefine

#  createMeshGroup
def createMeshGroup(paraNum):
    #EGRP
    elGroup = []
    for para in paraNum[2]:
        name = para[0].split()[1]
        elGroup.append(name)
    #SGRP
    surGroup = []
    for para in paraNum[3]:
        surGroup.append(para[0].split()[1])
    #NGRP
    ndGroup = []
    for para in paraNum[4]:
        ndGroup.append(para[0].split()[1])
    ans = [elGroup, surGroup, ndGroup]
    return ans

#  createParameterCont
def createParameterCont(paraNum):
    cont = ""
    #nodeを作成
    cont += paraNum[0][0] + " " + str(paraNum[0][1]) + ls
    #elementを作成
    for line in paraNum[1]:
        cont += line[0] + " " + str(line[1]) + ls
    cont += ls
    #elementGroupを作成
    for line in paraNum[2]:
        cont += line[0] + " " + str(line[1]) + ls
    #surfaceGroupを作成
    for line in paraNum[3]:
        cont += line[0] + " " + str(line[1]) + ls
    #nodeGroupを作成
    for line in paraNum[4]:
        cont += line[0] + " " + str(line[1]) + ls
    return cont

#  getParameterNumber
def getParameterNumber(parameter):

    def reformGroupName(paraNum):
        #同名のEGRPをまとめる
        #  egrpName:egrpNo の辞書作成
        egrpDict = {}
        egrpNo = 0
        for i in range(len(paraNum)):
            if not paraNum[i][0] in egrpDict.keys():
                egrpDict[paraNum[i][0]] = egrpNo
                egrpNo += 1
        #  同名のegrpNameをまとめる
        nNames = len(egrpDict.keys())
        newParaNum = [ ["","0"] for i in range(nNames) ]
        for i in range(len(paraNum)):
            egrpName = paraNum[i][0]
            egrpNo = egrpDict[egrpName]
            newParaNum[egrpNo][1] = str(int(newParaNum[egrpNo][1]) + int(paraNum[i][1]))
            newParaNum[egrpNo][0] = egrpName
        return newParaNum

    paraNum = [[], [], [], [], []]
    #node数を取得
    num = 0
    for line in parameter[0]:
        n = int(abaqus2fistr.getValName(line, "NUM"))
        num += n
    paraNum[0] = ["nodes", str(num)]
    #element数を取得
    for line in parameter[1]:
        num = getItemNum(line)
        typeName = abaqus2fistr.getValName(line, "TYPE")
        paraNum[1] += [["elements type:"+typeName, num]]
    #elementGroup数を取得
    for line in parameter[1]:
        #「!ELEMENT」から取得
        grpName = abaqus2fistr.getValName(line, "EGRP")
        if grpName != "":
            num = getItemNum(line)
            paraNum[2] += [["EGRP "+grpName, num]]
    for line in parameter[2]:
        #「!EGROUP」から取得
        grpName = abaqus2fistr.getValName(line, "EGRP")
        num = getItemNum(line)
        paraNum[2] += [["EGRP "+grpName, num]]
    #  同名elementGroupをまとめる
    paraNum[2] = reformGroupName(paraNum[2])
    #surfaceGroupの取得
    for line in parameter[3]:
        grpName = abaqus2fistr.getValName(line, "SGRP")
        num = getItemNum(line)
        paraNum[3] += [["SGRP "+grpName, num]]
    #nodeGroupの取得
    for line in parameter[0]:
        grpName = abaqus2fistr.getValName(line, "NGRP")
        if grpName != "":
            num = getItemNum(line)
            paraNum[4] += [["NGRP "+grpName, num]]
    for line in parameter[4]:
        grpName = abaqus2fistr.getValName(line, "NGRP")
        num = getItemNum(line)
        paraNum[4] += [["NGRP "+grpName, num]]
    return paraNum

# getItemNum
#    行内のNUM=を取得
def getItemNum(line):
    if line.find("GENERATE") >= 0:
        num = "GENERATE"
    else:
        num = abaqus2fistr.getValName(line, "NUM")
    return num        

#  keyword取得用のDict
keywordItemContDict = {
        #keyword     item     length   typeName
        "!NODE":    ["NODE",    4,      "NGRP"],         #節点定義
        "!ELEMENT": ["ELEMENT", 0,      "TYPE"],         #要素定義
        "!EGROUP":  ["EGROUP",  1,      "EGRP"],         #要素group定義
        "!SGROUP":  ["SGROUP",  2,      "SGRP"],         #面group定義
        "!NGROUP":  ["NGROUP",  1,      "NGRP"]          #節点group定義
        }

#  要素内容を定義
elementContsDict = {
        #name  type    次数　種別　　節点数  
        "341":["solid",  1, "tet",   4],
        "342":["solid",  2, "tet",   10],
        "361":["solid",  1, "hex",   8],
        "362":["solid",  2, "hex",   20],
        "351":["solid",  1, "prism", 6],
        "352":["solid",  2, "prism", 15],
        "731":["shell",  1, "tri",   3],
        "732":["shell",  2, "tri",   6],
        "741":["shell",  1, "quad",  4],
        "761":["shell3", 1, "tri",   6],        #3自由度shell
        "781":["shell3", 1, "quad",  8],        #3自由度shell
        "611":["beam",   1, "beam",  2],
        "641":["beam3",  1, "beam",  4]         #3自由度beam
        }

#  getMeshParameterList
#    各項目名と個数を取得
def getMeshParameterList():
    meshList = [[], [], [], [], []]
    item = ""
    header = ""
    data = []
    for headerData in meshHeaderData:
        line = headerData[0]
        #keywordを取得
        keyword = deleteSp(line).split(",")[0]
        #keywordを元に処理開始
        if keyword in keywordItemContDict.keys():
            [item, dummy_length, dummy_typeName] = keywordItemContDict[keyword]
        else:
            #定義されていない要素
            item = ""
            data = []
        #登録されているkeyword？
        if item != "":
            header = line
            #elName = abaqus2fistr.getValName(line, typeName)
            data = headerData[1]
            #要素定義？
            # if item == "ELEMENT":
            #     elCont = elementContsDict[elName]
            #     nNodes = elCont[3]
            #     #length = nNodes + 1
        #meshList作成
        if len(data) > 0:
            meshList = saveDataList(item, header, data, meshList)
    return meshList

#
#  saveDataList
#    取得したdataListを保存
def saveDataList(item, header, data, meshList):
    if item == "NODE":
        num = str(len(data))
        header = abaqus2fistr.setValName(header, "NUM="+num)
        meshList[0].append(header)
    elif item == "ELEMENT":
        num = str(len(data))
        header = abaqus2fistr.setValName(header, "NUM="+num)
        meshList[1].append(header)
    elif item == "EGROUP":
        num = str(len(data))
        header = abaqus2fistr.setValName(header, "NUM="+num)
        meshList[2].append(header)
    elif item == "SGROUP":
        num = str(int(len(data)/2))
        header = abaqus2fistr.setValName(header, "NUM="+num)
        meshList[3].append(header)
    elif item == "NGROUP":
        num = str(len(data))
        header = abaqus2fistr.setValName(header, "NUM="+num)
        meshList[4].append(header)
    return meshList

#
#  checkFistrModelMeshFile
#    headerからPARTNAMEとNUMを削除
def checkFistrModelMeshFile(meshHeaderData):

    def deletePartNum(line):
        newLine = line
        if line.find("PARTNAME=") >= 0 or line.find("NUM=") >= 0:
            words = deleteSp(line).split(",")
            newWords = []
            for word in words:
                if word[:len("PARTNAME=")] != "PARTNAME=":
                    if word[:len("NUM=")] != "NUM=":
                        newWords.append(word)
            newLine = ", ".join(newWords) + ls
        return newLine

    for n in range(len(meshHeaderData)):
        meshHeaderData[n][0] = deletePartNum(meshHeaderData[n][0])
    #writeFistrModelMshHeader()
    return meshHeaderData


#
#  getAbsDir
#
def getAbsDir(workDir):
    if workDir[0] == "~":
        getDir = os.getenv("HOME") + workDir[1:]
        getDir = os.path.abspath(getDir)
    else:
        getDir = os.path.abspath(workDir)
    return getDir

#
#  initialize
#  ----------
#    初期化
def initialize():
    global currDir, istrData
    global runOfficeComm, runTerminalComm, runFileManagerComm, runEditorComm
    global frontIstrFolder, runParaViewComm, runRevocapComm, runGnuplotComm
    # $easyIstrUserPath内のfile有無確認、セット
    checkSetUserPathFiles()
    istrData = getSavedData()
    #materialDBのチェック
    for i in range(len(istrData)):
        item = istrData[i].split()[0]
        if item == "materialDB":
            matDir = istrData[i].split()[1]
            iMat = i
            break
    if matDir == os.getenv("easyIstrPath") + os.sep + "data" + os.sep + "mat.csv":
        #インストール直後の確認
        #maDirを設定
        matDir = os.getenv("easyIstrUserPath") + os.sep + "data" + os.sep + "mat.csv"
        istrData[iMat] = istrData[iMat].split()[0] + " " + matDir
        #currDirを設定
        for i in range(len(istrData)):
            item = istrData[i].split()[0]
            if item == "currDir":
                currDir = os.getenv("easyIstrUserPath")
                istrData[i] = istrData[i].split()[0] + " " + currDir
                break
        saveIstrData(istrData)
    #applicationの設定
    [runOfficeComm, runTerminalComm,
        runFileManagerComm, runEditorComm,
        frontIstrFolder, runParaViewComm,
        runRevocapComm, runGnuplotComm] = pyFistr.readUsingApplications()
    #Pathの設定
    if frontIstrFolder != "":
        if os.name != "nt":
            setDir = getAbsDir(frontIstrFolder)
            os.environ["PATH"] = setDir + ":" + os.getenv("PATH")
        else:
            os.environ["PATH"] = frontIstrFolder + ";" + os.getenv("PATH")
    else:
        if os.name != "nt":
            frontIstrFolder = "/opt/FrontISTR/bin"
            setDir = getAbsDir(frontIstrFolder)
            os.environ["PATH"] = setDir + ":" + os.getenv("PATH")
    #未定義の場合、デフォルト値を設定
    if runParaViewComm == "":
        runParaViewComm = "paraview"
    if runRevocapComm == "":
        runRevocapComm = "revocap"
    if runGnuplotComm == "":
        runGnuplotComm = "gnuplot"
    #設定内容を表示
    setFile = "easyIstrUser" + os.sep + "data" + os.sep + "usingApp"
    mess = _(u"EasyISTRで使用するapplicationを ") + setFile
    mess += _(u" ファイルに基づき設定します。") 
    print (mess)
    print (_(u"    office:         "), runOfficeComm)
    print (_(u"    terminal:       "), runTerminalComm)
    print (_(u"    fileManager:    "), runFileManagerComm)
    print (_(u"    editor:         "), runEditorComm)
    print (_(u"    frontIstrFolder:"), frontIstrFolder)
    print (_(u"    paraView:       "), runParaViewComm)
    print (_(u"    REVOCAP:        "), runRevocapComm)
    print (_(u"    gnuplot:        "), runGnuplotComm)
    print (ls + _(u"EasyISTR ") + version + _(u" を起動します"))

#  checkSetUserPathFiles
#    $easyIstrUserPath内のfile有無確認、セット
def checkSetUserPathFiles():
    easyIstrDir = os.getenv("easyIstrPath") + os.sep + "data"
    files = glob.glob(easyIstrDir + os.sep + "*")
    fileNames = []
    for name in files:
        fileNames.append(name.split(os.sep)[-1])
    userDir = os.getenv("easyIstrUserPath") + os.sep + "data"
    for fileName in fileNames:
        if len(glob.glob(userDir + os.sep + fileName)) == 0:
            copyName = easyIstrDir + os.sep + fileName
            shutil.copy(copyName, userDir)
    #easyIstr_dataの内容チェック（存在しないDirを修正）
    data = getSavedData()
    flag = 0
    for i in range(len(data)):
        line = data[i]
        words = line.split()
        if len(words) >= 2:
            if words[0] == "currDir":
                currDir = words[1]
                if len(glob.glob(currDir)) == 0:
                    data[i] = "currDir " + os.getenv("HOME")
                    flag = 1
            elif words[0] == "materialDB":
                matDir = words[1]
                if len(glob.glob(matDir)) == 0:
                    matDir = os.getenv("easyIstrUserPath") + os.sep + "data" + os.sep + "mat.csv"
                    data[i] = "materialDB " + matDir
                    flag = 1
    if flag == 1:
        saveIstrData(data)

#
#  getParallelInSavedData
#    parallelの設定を読み込み
def getParallelInSavedData():
    savedData = getSavedData()
    para = "False"
    nCpu = "4"
    for line in savedData:
        words = line.split()
        if len(words) > 0:
            if words[0] == "parallel":
                para = words[1]
                nCpu = words[2]
                break
    return [para, nCpu]

#
#  getSavedData
#    保存したデータの読み込み
def getSavedData():
    #全体データの読み込み
    dataDir = os.getenv("easyIstrUserPath")
    fileName = dataDir + os.sep + "data" + os.sep + istrDataFileName
    if len(glob.glob(fileName)) == 0:
        sourceFile = os.getenv("easyIstrPath") + os.sep + "data" + os.sep + istrDataFileName
        shutil.copy(sourceFile, dataDir)
    f = open(fileName, encoding="utf-8"); lines = f.readlines(); f.close()
    #個別データの読み込み
    subDataDir = os.getenv("HOME")
    for line in lines:
        words = line.split()
        if len(words) > 1:
            if words[0] == "currDir":
                subDataDir = words[1]
                break
    #subDataDirの有無チェック
    if len(glob.glob(subDataDir)) == 0:
        subDataDir = os.getenv("HOME")
    #subDataFileの読み込み
    fileName = subDataDir + os.sep + istrSubDataFileName
    if len(glob.glob(fileName)) == 0:
        sourceFile = os.getenv("easyIstrPath") + os.sep + "data" + os.sep + istrSubDataFileName
        shutil.copy(sourceFile, subDataDir)
    f = open(fileName, encoding="utf-8"); lines += f.readlines(); f.close()
    #取得データを整理
    ans = []
    for line in lines:
        words = line.split()
        if len(words) >= 1:
            if words[0][0] != "#":
                ans.append(line)
    return ans

#
#  saveIstrData
#    Istrのセットデータを保存
def saveIstrData(setData):

    def changeLine(newLine, conts):
        #currDir = os.getenv("HOME")
        flag = 0
        item = newLine.split()[0]
        if item == "useCntFile" or item == "currDir" or item == "materialDB" or item == "execFile":
            i = 0
            while i < len(conts):
                line = conts[i]
                lineItems = line.split()
                if len(lineItems) >= 1:
                    if item == lineItems[0]:
                        #行末コードを確認してセット
                        if newLine[-1] == ls:
                            conts[i] == newLine
                        else:
                            conts[i] = newLine + ls
                        #修正flagをセット
                        flag = 1
                        break
                i += 1 
            if flag == 0:
                conts += [newLine]
        return conts

    def getCurrDir(conts):
        #currDir = os.getenv("HOME")
        for line in conts:
            words = line.split()
            if len(words) > 1:
                if words[0] == "currDir":
                    currDir = words[1]
                    break
        return currDir

    def changeSubLine(newLine, conts):
        flag = 0
        item = newLine.split()[0]
        if (item == "convertOpt" or item == "sourceMesh" or item == "addFlag"
            or item == "stressTensor" or item == "strainTensor"
            or item == "parallel"):
            i = 0
            while i < len(conts):
                line = conts[i]
                lineItems = line.split()
                if len(lineItems) >= 1:
                    if item == lineItems[0]:
                        #行末コードを確認し、セット
                        if newLine[-1] == ls:
                            conts[i] = newLine
                        else:
                            conts[i] = newLine + ls
                        #修正flagをセット
                        flag = 1
                        break
                i += 1 
            if flag == 0:
                conts += [newLine]
        return conts


    #全体設定に保存
    fileName = os.getenv("easyIstrUserPath") + os.sep + "data" + os.sep + istrDataFileName
    f=open(fileName, encoding="utf-8"); conts=f.readlines(); f.close()
    for newLine in setData:
        conts = changeLine(newLine, conts)
    f=open(fileName, "w", encoding="utf-8")
    for line in conts:
        f.write(line)
    f.close()
    #個別設定に保存
    currDir = getCurrDir(conts)
    fileName = currDir + os.sep + istrSubDataFileName
    if len(glob.glob(fileName)) == 0:
        sourceFile = os.getenv("easyIstrUserPath") + os.sep + "data" + os.sep + istrSubDataFileName
        shutil.copy(sourceFile, currDir)
    f=open(fileName, encoding="utf-8"); subConts=f.readlines(); f.close()
    for newLine in setData:
        subConts = changeSubLine(newLine, subConts)
    f=open(fileName, "w", encoding="utf-8")
    for line in subConts:
        f.write(line)
    f.close()


#
#  checkReformCntFile
#  ------------------
#    cntファイルをチェック修正する
def checkReformCntFile():
    lines = readFistrModelCnt()
    #step行のstepNameをチェック
    num = 0
    flag = 0; i = 0
    for line in lines:
        if line[0] == "!":
            if line[:len("!STEP")] == "!STEP":
                stepName = abaqus2fistr.getValName(line, "stepName")
                if stepName == "":
                    #stepNameが定義されていない場合、stepNameを追記
                    lines[i] = abaqus2fistr.setValName(line, "stepName=STEP"+str(num))
                    num += 1
                    flag = 1
        i += 1
    if flag == 1:
        writeFistrModelCnt(lines)

#
#  checkTrueCurrDir
#  ----------------
#    trueCurrDirの有無チェック
#    存在しない場合、$HOMEをセット
def checkTrueCurrDir():
    global currDirTemp, currDir
    istrData = getSavedData()
    for i in range(len(istrData)):
        line = istrData[i]
        words = line.split()
        if words[0] == "currDir":
            if words[1] == currDirTemp:
                trueCurrDir = getCurrDirFromTempFolder()
                if len(glob.glob(trueCurrDir)) == 0:
                    trueCurrDir = os.getenv("HOME")
                    saveIstrData(["currDir " + trueCurrDir])

#
#  checkSetIstrData
#  ----------------
#    istrDataをチェック（currDirが正しくセットされていない場合、再セットする）
def checkSetIstrData():
    global currDirTemp, currDir, istrData
    istrData = getSavedData()
    for i in range(len(istrData)):
        line = istrData[i]
        words = line.split()
        if words[0] == "currDir":
            if words[1] != currDirTemp:
                #tempFolderをクリアする
                clearTempCase()
                #簡易caseのfileをコピーする
                createTempCase(words[1])
                copyOtherFiles(currDirTemp, words[1])
                saveIstrData(["currDir " + currDirTemp])
                #currDirを再セット
                currDir = currDirTemp
                istrData = getSavedData()
            break

#
#  isTempCase_EditOrNoedit
#  -----------------------
#    tempCase内が修正されているかどうかをチェック
def isTempCase_EditOrNoedit():
    meshConts = getMeshContsFromTempFolder()
    tempCaseDate = meshConts["tempCaseDate"]
    timeStampCnt = os.path.getmtime(currDirTemp + os.sep + "FistrModel.cnt")
    timeStampMsh = os.path.getmtime(currDirTemp + os.sep + "FistrModel.msh")
    editDate = max([timeStampCnt, timeStampMsh])
    if tempCaseDate < editDate:
        ans = "edit"
    else:
        ans = "noedit"
    return ans

#
#  setTimeStampOfMshCntFiles
#    msh, cntファイルのtimeStampを確認し、meshContsファイルに書き込む
def setTimeStampOfMshCntFiles(edit):
    if edit == "noedit":
        #編集されていない場合
        timeStampCnt = os.path.getmtime("FistrModel.cnt")
        timeStampMsh = os.path.getmtime("FistrModel.msh")
        tempCaseDate = max([timeStampCnt, timeStampMsh]) + 1.0
        setValues = [["tempCaseDate", tempCaseDate]]
        setMeshContsToTempFolder(setValues)

#
#  clearTempCase
#    tempCase内をクリアする
def clearTempCase():
    if len(glob.glob(currDirTemp)) == 0:
        os.mkdir(currDirTemp)
    else:
        files = glob.glob(currDirTemp + os.sep + "*")
        for fileName in files:
            os.remove(fileName)
        #shutil.rmtree(currDirTemp)
        #os.mkdir(currDirTemp)

#
#  createTempCase
#    tempcaseを作成する
def createTempCase(currDir):
    global currDirTemp, meshHeaderData
    #currDir内の必要ファイル有無チェック    
    #  mshFile
    mshFile = currDir + os.sep + "FistrModel.msh"
    if len(glob.glob(mshFile)) == 0:
        mshFile = os.getenv("easyIstrPath") + os.sep + "data" + os.sep + "FistrModel_noMesh.msh"
        shutil.copy(mshFile, currDir+os.sep+"FistrModel.msh")
    #  cntFile
    cntFile = currDir + os.sep + "FistrModel.cnt"
    if len(glob.glob(cntFile)) == 0:
        cntFile = os.getenv("easyIstrPath") + os.sep + "data" + os.sep + "FistrModel_master.cnt"
        shutil.copy(cntFile, currDir+os.sep+"FistrModel.cnt")
    #  datFile
    datFile = currDir + os.sep + "hecmw_ctrl.dat"
    if len(glob.glob(datFile)) == 0:
        datFile = os.getenv("easyIstrPath") + os.sep + "data" + os.sep + "hecmw_ctrl.dat"
        shutil.copy(datFile, currDir+os.sep+"hecmw_ctrl.dat")
    #meshFile作成
    f = open(currDir + os.sep + "FistrModel.msh", encoding="utf-8")
    lines = f.readlines()
    f.close()
    #case内容を作成
    meshHeaderData = pyFistr.getHeaderNumData(lines)
    createTempCaseFromMeshData(currDir, lines, meshHeaderData)

#  createTempCaseFiles
#    必要ファイルのみtempCase内に作成する
def createTempCaseFiles(currDir, lines):
    #mshFile作成
    #  行を省略
    lines = shrinkMeshLines(lines)
    f = open(currDirTemp + os.sep + "FistrModel.msh", "w", encoding="utf-8")
    conts = "".join(lines)
    f.write(conts)
    #cntFile作成
    f = open(currDir + os.sep + "FistrModel.cnt", encoding="utf-8")
    lines = f.readlines()
    f.close()
    #  等分布荷重を削除
    lines = shrinkCntLines(lines)
    f = open(currDirTemp + os.sep + "FistrModel.cnt", "w", encoding="utf-8")
    conts = "".join(lines)
    f.write(conts)
    f.close()
    #datFile作成
    fileName = currDir + os.sep + "hecmw_ctrl.dat"
    shutil.copy(fileName, currDirTemp)

#
#  createTempCaseFromOnlyMeshData
#    meshHeaderDataからtempCaseを作成する
#    tempCaseDateは更新しない
def createTempCaseFromOnlyMeshData(currDir, lines, meshHeader):
    global currDirTemp, meshHeaderData
    #dataを取得
    meshHeaderData = meshHeader
    [meshCont, ampNames, initialNames] = getFistrModelMeshData(currDir)
    [ngrps, allNgrpNames] = delnd.getNgrpData(meshHeaderData)
    [overlapNames, dummy_otherNames] = delnd.getOverlapNgrpNames(ngrps, allNgrpNames)
    overlapNames.sort()
    #tempCase内にファイルを作成
    createTempCaseFiles(currDir, lines)
    #tempCaseのtimeStampを更新しない
    tempCaseDate = os.path.getmtime(currDirTemp + os.sep + "FistrModel.cnt") - 1.0
    createCaseCont(currDir, meshCont, ampNames, initialNames, overlapNames, tempCaseDate)

#
#  createTempCaseFromMeshData
#    meshHeaderDataからtempCaseを作成する
#    tempCaseDateを更新する
def createTempCaseFromMeshData(currDir, lines, meshHeader):
    global currDirTemp, meshHeaderData
    #dataを取得
    meshHeaderData = meshHeader
    [meshCont, ampNames, initialNames] = getFistrModelMeshData(currDir)
    [ngrps, allNgrpNames] = delnd.getNgrpData(meshHeaderData)
    [overlapNames, dummy_otherNames] = delnd.getOverlapNgrpNames(ngrps, allNgrpNames)
    overlapNames.sort()
    #meshDataからtempCaseを作成する
    createTempCaseFiles(currDir, lines)
    #tempCaseDateを更新
    tempCaseDate = os.path.getmtime(currDirTemp + os.sep + "FistrModel.cnt") + 1.0
    createCaseCont(currDir, meshCont, ampNames, initialNames, overlapNames, tempCaseDate)

#
#  createCaseCont
#    case内容を作成
def createCaseCont(currDir, meshCont, ampNames, initialNames, overlapNames, tempCaseDate):
    dataDict = {}
    dataDict["currDir"] = currDir
    dataDict["meshCont"] = meshCont
    dataDict["ampNames"] = ampNames
    dataDict["initialNames"] = initialNames
    dataDict["overlapNGRP"] = overlapNames
    dataDict["tempCaseDate"] = tempCaseDate
    saveCaseContDict(dataDict)

#
#  saveCaseContDict
#    dict形式のdataを保存する
def saveCaseContDict(dataDict):
    copyTempFiles.currDirTemp = currDirTemp
    copyTempFiles.currDir = currDir
    copyTempFiles.saveCaseContDict(dataDict)


#  shrinkMeshLines
#    meshを省略する
def shrinkMeshLines(lines):
    headerData = pyFistr.getHeaderData(lines)
    newHeaderData = []
    for headerCont in headerData:
        keyword = deleteSp(headerCont[0]).split(",")[0]
        if keyword in shrinkKeywords:
            #shrinkする
            newHeader = [headerCont[0], headerCont[1][:10]]
        else:
            newHeader = headerCont
        newHeaderData.append(newHeader)
    lines = []
    for headerCont in newHeaderData:
        lines += [headerCont[0]]
        lines += headerCont[1]
    return lines

#  shrinkCntLines
#    cntを省略する
#    CLOADのforceType=trueForceの場合、節点No部分を削除する
def shrinkCntLines(lines):
    newLines = []
    flag = 0
    for line in lines:
        if line[0] == "!":
            words = deleteSp(line).split(",")
            if words[0] == "!CLOAD":
                forceType = pyFistr.getValName(line, "forceType")
                if forceType == "trueForce":
                    flag = 1
            else:
                flag = 0
            newLines.append(line)
        else:
            if flag == 1:
                words = deleteSp(line).split(",")
                if "0" <= words[0][0] and words[0][0] <= "9":
                    pass
                else:
                    newLines.append(line)
            else:
                newLines.append(line)
    return newLines

#
#  copyOtherFiles
#    その他fileをコピーする（currDir -> tempDirへコピー）
def copyOtherFiles(tempDir, currDir):
    files = glob.glob(currDir+os.sep+"*")
    copyFiles = []
    for name in files:
        fileType = name.split(".")[-1]
        fileName = name.split(os.sep)[-1]
        if ( fileName[:len("FistrModel")] == "FistrModel"
                or fileName[:len("FSTR.")] == "FSTR."
                or fileName[0] < "0"                        #隠しfile
                or fileName == "hecmw_ctrl.dat"
                or fileName == "hecmw_part_ctrl.dat"
                or fileName == "meshConts"
                or fileName == "run"
                or fileType == "unv"
                or fileType == "inp"
                or fileType == "vtk"
                or fileType == "log"
                or fileType == "pdf"
                or fileType == "bat" ):
            #コピーしない
            pass
        else:
            if os.path.isfile(name) == True:
                copyFiles.append(name)
    #コピーファイル数を20以下に限定
    for name in copyFiles[:20]:
        shutil.copy(name, tempDir)

#
#  getCurrDirFromTempFolder
#    tempFolderからcurrDirを取得する
def getCurrDirFromTempFolder():
    try:
        meshConts = getMeshContsFromTempFolder()
        currDir = meshConts["currDir"]
    except:
        currDir = os.getenv("HOME")
        saveIstrData(["currDir " + currDir])
    return currDir

#
#  getMeshContsFromTempFolder
#    tempFolderからその内容を取得する
def getMeshContsFromTempFolder():
    copyTempFiles.currDirTemp = currDirTemp
    copyTempFiles.currDir = currDir
    meshConts = copyTempFiles.getMeshContsFromTempFolder()
    return meshConts

#
#  setMeshContsToTempFolder
#    「meshConts」ファイルに必要な値を保存する
#    [[<item>, <value>],..]
def setMeshContsToTempFolder(itemValues):
    dataDict = getMeshContsFromTempFolder()
    for [item, value] in itemValues:
        dataDict[item] = value
    saveCaseContDict(dataDict)

#
#  copyFilesFromTempToCurrDir
#    tempフォルダ内fileをcurrDirに転送
def copyFilesFromTempToCurrDir():
    copyTempFiles.copyFilesFromTempToCurrDir(currDirTemp, currDir)

#  copyCntFromTempToCurrDir
#    temp内のcntファイルに等分布荷重を追加しcurrDirに保存する
def copyCntFromTempToCurrDir():
    copyTempFiles.currDirTemp = currDirTemp
    copyTempFiles.currDir = currDir
    copyTempFiles.copyCntFromTempToCurrDir()

#  copyMshFromTempToCurrDir
#    temp内のmshファイルから実mshを作成しcurrDirに保存する
def copyMshFromTempToCurrDir():
    copyTempFiles.currDirTemp = currDirTemp
    copyTempFiles.currDir = currDir
    copyTempFiles.copyMshFromTempToCurrDir()

#
#  deleteSp
#    空白とCRを削除して返す
def deleteSp(line):
    line = line.replace(" ", "")
    line = line.replace("\n", "")
    return line

#  readFistrModelMsh
#    meshファイルを読み込み
def readFistrModelMsh():
    fileName = currDir + os.sep + "FistrModel.msh"
    f=open(fileName, encoding="utf-8"); lines=f.readlines(); f.close()
    return lines

#  readFistrModelCnt
#    cntファイルを読み込み
def readFistrModelCnt():
    fileName = currDir + os.sep + "FistrModel.cnt"
    if len(glob.glob(fileName)) == 0:
        return []
    f=open(fileName, encoding="utf-8"); lines=f.readlines(); f.close()
    return lines

#  writeFistrModelMshHeader
#    meshHeaderDataの書き込み
def writeFistrModelMshHeader():
    lines = pyFistr.createLinesFistrModelMshHeader(meshHeaderData)
    writeFistrModelMsh(lines)

#  writeFistrModelMsh
#    meshファイルの書き込み
def writeFistrModelMsh(lines):
    fileName = currDir + os.sep + "FistrModel.msh"
    f=open(fileName, "w", encoding="utf-8")
    if lines[0][-2:] == "\r\n":
        for line in lines:
            f.write(line[:-2] + "\n")
    else:
        cont = "".join(lines)
        f.write(cont)
    f.close()

#  writeFistrModelCnt
#    cntファイルの書き込み
def writeFistrModelCnt(lines):
    fileName = currDir + os.sep + "FistrModel.cnt"
    f=open(fileName, "w", encoding="utf-8")
    for line in lines:
        if line[-2:] == "\r\n":
            line = line[:-2] + "\n"
        f.write(line)
    f.close()

#  readHecmwCtrlDat
#    hecmw_ctrl.datファイルの読み込み
def readHecmwCtrlDat():
    fileName = currDir + os.sep + "hecmw_ctrl.dat"
    f=open(fileName, encoding="utf-8"); lines=f.readlines(); f.close()
    return lines

#  writeHecmwCtrlDat
#    hecmw_ctrl.datファイルの書き込み
def writeHecmwCtrlDat(lines):
    fileName = currDir + os.sep + "hecmw_ctrl.dat"
    f=open(fileName, "w", encoding="utf-8")
    for line in lines:
        if line[-2:] == "\r\n":
            line = line[:-2] + "\n"
        f.write(line)
    f.close()


if __name__ == "__main__":
    import gettext
    gettext.install("app") # replace with the appropriate catalog name
    _ = gettext.gettext

    app = windowApp()
    app.main()

        
